<?php

/**
 * This is the model class for table "{{mas_pricing_group}}".
 *
 * The followings are the available columns in table '{{mas_pricing_group}}':
 * @property integer $id
 * @property string $pricing_group
 * @property double $percentage
 * string $isActive
 * @property string $addition_deduction
 */
class MasPricingGroup extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return '{{mas_pricing_group}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('pricing_group, percentage, addition_deduction', 'required'),
            array('pricing_group', 'unique', 'on' => 'add'),
            array('id', 'numerical', 'integerOnly' => true),
            array('percentage', 'numerical'),
            array('pricing_group', 'length', 'max' => 255),
            array('addition_deduction,isActive', 'length', 'max' => 1),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, pricing_group,isActive,percentage, addition_deduction', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'pricing_group' => 'Pricing Group',
            'percentage' => 'Percentage',
            'addition_deduction' => 'Addition Deduction',
            'isActive' => 'Is Active',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('pricing_group', $this->pricing_group, true);
        $criteria->compare('percentage', $this->percentage);
        $criteria->compare('addition_deduction', $this->addition_deduction, true);
        $criteria->compare('isActive', $this->isActive, true);

        return new CActiveDataProvider($this, array(
            'pagination' => array(
                'pageSize' => 5,
            ),
            'criteria' => $criteria,
            'sort' => array(
                'defaultOrder' => 't.pricing_group ASC',
            ),
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return MasPricingGroup the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public static function getPricingGroup() {

        $condition = 'isActive =  "Y"';
        $model = self::model()->findAll(array('condition' => $condition));
        return CHtml::listData($model, 'id', 'pricing_group');
    }

}
