<?php

class DocumentController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array(),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('download','DeleteDocument'
                ),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionDownload()
    {
        $id=Yii::app()->request->getParam('id');
        $document=Document::model()->findByPK($id);
        $this->downloadFile($document->document_name,'/upload/documents/');
    }
    public function actionDeleteDocument($id)
    {
        Document::model()->findByPK($id)->delete();
        
    }
 
}