<?php

class ExportController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('print', 'Company', 'purchaseReportRcptOfPayment', 'reportInventory', 'reportMinRequirement', 'PrintReceiptofPayment',
                    'MissingList', 'activityReport', 'salesReportLead', 'salesReportQuotes', 'customerReport', 'SalesLedger', 'allocatematerial',
                    'salesReportPurchaseCreditNote', 'salesReportPurchaseInvoice', 'salesReportPurchaseMaterialreceipt', 'salesReportPurchaseOrder',
                    'salesReportDeliveryNote', 'salesReportOrder', 'salesReportInvoice', 'salesReportRcptOfPayment', 'salesReportCreditNote',
                    'SalesStatement', 'PurchaseLedger', 'PurchaseStatement', 'Test', 'grossProfit', 'pricingGroup', 'SotckMovementReport', 'SotckMovementHistoryReport',
                    'ReportNonStock', 'contactReport', 'createExcel', 'createExcelForSalesOrder','UserDetails'
                ),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionMissingList() {
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $modelName = Yii::app()->request->getParam('modelName');
        $id = (int) Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $modelName.="Item";
        $criteria = new CDbCriteria();
        $criteria->with = array('parent.file', 'parent');
        $criteria->group = "product_id";
        $criteria->order = "product_id";
        $criteria->addCondition("file.current_process_status = 'Q' OR file.current_process_status = 'O' OR file.current_process_status = 'PD' OR file.current_process_status = 'PI'", 'AND');
        $criteria->select = array('*', 'SUM(quantity) AS item_qty');
        if ($id > 0) {
            $criteria->addCondition("parent.id=" . $id, 'AND');
            $models = $modelName::model()->findAll($criteria);
            $file_data = $models[0]->parent->file->status . ' : ' . $models[0]->parent->file_id . '/' . $models[0]->parent->id;
        } else {
            $models = $modelName::model()->findAll($criteria);
            $file_data = " ALL OPEN " . $models[0]->parent->file->status . 'S';
        }
        $content = '<h3>LIST OF ITEMS TO BE ORDERED FOR ' . strtoupper($file_data) . '</h3>';
        $content .= '<table class="table_grid">
            <tr>
            <th>No.</th>
            <th>Part No.</th>
            <th>Description</th>
            <th>Brand/Class</th>
            <th>Avail.Qty.</th>
            <th>Req.Qty.</th>   
            <th>Open.PO.Qty.</th> 
            <th>To be Purchased.</th>
            </tr>
            ';
        $j = 0;
        foreach ($models as $item) {
            //echo "here";
            //if ($model->parent->file->current_process_status == "Q" || $model->parent->file->current_process_status == "O") {
            //$file_data = $model->file->status . ' : ' . $model->file_id . '/' . $model->id;
            //foreach ($model->items as $i => $item) {
            $thisProduct = Store::model()->findByPK($item->product_id);
            $allocatedQuantityForThis = 0;
            if ($id > 0) {
                $allocond = "product_id=" . $thisProduct->id;
                $allocond .= " AND file_id=" . $item->parent->file_id;
                $allocatedQuantityForThis = @AllocatedMaterial::model()->find($allocond)->count;
            }

            $availableQty = ($thisProduct->total_quantity + floatval($allocatedQuantityForThis)) - $thisProduct->total_allocated_quantity;
            if ($availableQty < $item->item_qty) {
                $qty_to_be_purchased = $item->item_qty - ($availableQty + $thisProduct->po_quantity) > 0 ? $item->item_qty - ($availableQty + $thisProduct->po_quantity) : 0;
                $content .= '<tr>
            <td>' . ++$j . '</td>
            <td class="cell-left">' . $thisProduct->part_number . '</td>
            <td class="cell-left">' . $thisProduct->description . '</td>
            <td class="cell-left">' . $thisProduct->productclass->brand . '</td>
            <td class="cell-right">' . Yii::app()->numberFormatter->formatDecimal($availableQty) . '</td>
            <td class="cell-right">' . Yii::app()->numberFormatter->formatDecimal($item->item_qty) . '</td>  
            <td class="cell-right">' . Yii::app()->numberFormatter->formatDecimal($thisProduct->po_quantity) . '</td>  ,
            <td class="cell-right">' . Yii::app()->numberFormatter->formatDecimal($qty_to_be_purchased) . '</td>      
            </tr>
            ';
                //}
                //}
            }
        }
        $content .= '</table>';
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.missinglist', array('content' => $content), true));
        $mPDF1->Output('List-of-materials-that-needs-to-be-ordered', 'I');
    }

    public function actionReportNonStock() {
        $model = new Store;
        $this->report($model, 'inventory-report-list-nonstock', 'pdf_for_list');
    }

//    public function actionPrintReceiptofPayment() {
//        ini_set("memory_limit", "128G");
//        ini_set('max_execution_time', 1000);
//        $modelName = Yii::app()->request->getParam('modelName');
//        $this->pageTitle = 'print-' . $modelName;
//        $view = Yii::app()->request->getParam('view');
//        $id = (int) Yii::app()->request->getParam('id');
//        $model = new $modelName;
//        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
//        $mPDF1->SetWatermarkImage(Yii::app()->baseUrl . '/images/logo/200150_' . MasCompany::model()->findbyPK(Yii::app()->user->master_user_company_id)->company_logo);
//        $mPDF1->showWatermarkImage = true;
//        $mPDF1->watermarkImageAlpha = 0.09;
//        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
//        $mPDF1->WriteHTML($stylesheet, 1);
//        $model = $modelName::model()->findByPk($id);
//        $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model), true));
//        $mPDF1->Output($view, 'I');
//    }

     public function actionPrintReceiptofPayment() {
        $file_id = Yii::app()->request->getParam('file_id');
        $modelName = Yii::app()->request->getParam('modelName');
        $view = Yii::app()->request->getParam('view');
        $id = (int) Yii::app()->request->getParam('id');
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $this->pageTitle = 'print-' . $modelName;
        $model = new $modelName;
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->SetWatermarkImage(Yii::app()->baseUrl . '/images/logo/200150_' . MasCompany::model()->findbyPK(Yii::app()->user->master_user_company_id)->company_logo);
        $mPDF1->showWatermarkImage = true;
        $mPDF1->watermarkImageAlpha = 0.09;
        $mPDF1->SetDisplayMode('fullpage');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        if (in_array($modelName, array(
                    "ReceivedInvoices",
                ))) {
            $model = Invoice::model()->findByPk($id);
            $modelReceivedInvoices = $modelName::model()->findAll(array('condition' => 'invoice_id=' . $id));
            $product_items = "";
            $notes = "";
            $remarks = "";
            $k = 0;
            foreach ($modelReceivedInvoices as $eachItem) {
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '">
                <td >' . (++$k) . '</td>';
                $product_items .= '<td class = "cell-left">' . $eachItem->invoice_id . '</td>';
                switch ($eachItem->recpt->mode_of_payment) {
                    case 'BT':
                        $product_items .= '<td class = "cell-center">' . "Bank transfer" . '</td>';
                        break;
                    case 'C':
                        $product_items .= '<td class = "cell-center">' . "Cash" . '</td>';
                        break;
                    case 'CH':
                        $product_items .= '<td class = "cell-center">' . "Cheque" . '</td>';
                        break;
                }
                $product_items .= '<td class = "cell-center">' . $eachItem->recpt->ref_number . '</td>';
                $product_items .= '<td class = "cell-center">' . $eachItem->recpt->received_date . '</td>';
                $product_items .= '<td class = "cell-right">' . $eachItem->received_amt . '</td>';
                '</tr>';
                
                $notes .= '<tr class = "' . $class . '">';
                    $notes .= '<td class = "cell-left">' . $eachItem->recpt->notes . '</td>';
                    '</tr>';
                $remarks .= '<tr class = "' . $class . '">';
                    $remarks .= '<td class = "cell-left">' . $eachItem->recpt->remarks . '</td>';
                    '</tr>';
                $receipt_id .= $eachItem->rcpt_id.",";
            }
            $receipt_id = rtrim($receipt_id,",");        
            $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model, 'product_items' => $product_items,'notes' => $notes,'remarks' => $remarks,'receipt_id' => $receipt_id), true));
        }
        $mPDF1->Output($view, 'I');
    }
     public function actionPrint() {
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $modelCustom = CustomChanges::model()->find();
        $custom_changes = CJSON::decode($modelCustom->changes);
        $modelName = Yii::app()->request->getParam('modelName');
//$this->setPageTitle('print-'.$modelName);
        $this->pageTitle = 'print-' . $modelName;
        $view = Yii::app()->request->getParam('view');
        $searchterm = trim(Yii::app()->request->getParam('searchterm'));
        $id = (int) Yii::app()->request->getParam('id');
        $vendor = (int) Yii::app()->request->getParam('vendor');
        $model = new $modelName;
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->SetWatermarkImage(Yii::app()->baseUrl . '/images/logo/200150_' . MasCompany::model()->findbyPK(Yii::app()->user->master_user_company_id)->company_logo);
        $mPDF1->showWatermarkImage = true;
        $mPDF1->watermarkImageAlpha = 0.09;
        //$mPDF1->SetWatermarkText(MasCompany::model()->findByPK(Yii::app()->user->master_user_company_id)->company_name);
        //$mPDF1->showWatermarkText = true;
        //$mPDF1->watermark_font = 'DejaVuSansCondensed';
        //$mPDF1->watermarkTextAlpha = 0.05;
        //$mPDF1->SetProtection(array('print'));
        $mPDF1->SetDisplayMode('fullpage');
        //$mPDF1 = Yii::app()->ePdf->mpdf('','', 0, '', 15, 15, 16, 16, 9, 9, 'P');

        if ($modelName == "PriceGroupProductRelation" || $id == 0) { // printing list of details
            $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_list.css');
            $mPDF1->WriteHTML($stylesheet, 1);
            $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model, 'searchterm' => $searchterm, 'id' => $id), true));
        } else {
            $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
            $mPDF1->WriteHTML($stylesheet, 1);
            $model = $modelName::model()->findByPk($id);
            /* ---- inventory and production ---- */
            if (in_array($modelName, array("ProductionBillofmaterial",
                        "ProductionOrder",
                        "ProductionGoodsIssue",
                        "ProductionGoodsReceipt",
                        "InventoryGoodsIssue",
                        "InventoryGoodsReceipt"))) {
                $itemModel = $modelName . 'Item';
                $modelitem = new $itemModel;
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
                $modelitem->{$refer_id} = $id;
                $model = $modelName::model()->with('items')->findByPK($id, array('order' => 'items.id ASC'));
                $product_items = "";
                if (in_array($modelName, array("ProductionGoodsReceipt"))) {
                    $class = $class == "odd" ? "even" : "odd";
                    $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $model->items->product->part_number . '</td>
            <td class = "cell-left">' . nl2br($model->items->description) . '</td>
            <td class = "cell-center">' . $model->items->unit . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($model->items->quantity)) . '</td>
            <td class = "cell-center">' . $model->items->amount . '</td>
            </tr>';
                } else {
                    foreach ($model->items as $i => $eachItem) {
                        if (in_array($modelName, array("InventoryGoodsIssue", "InventoryGoodsReceipt"))) {
                            $class = $class == "odd" ? "even" : "odd";
                            $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->product->part_number . '</td>
            <td class = "cell-left">' . nl2br($eachItem->description) . '</td>
            <td class = "cell-center">' . $eachItem->picked_qty . '</td>
            <td class = "cell-center">' . $eachItem->product->unit->symbol . '</td>
            </tr>';
                        } else {
                            $class = $class == "odd" ? "even" : "odd";
                            $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->product->part_number . '</td>
            <td class = "cell-left">' . nl2br($eachItem->description) . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($eachItem->quantity)) . '</td>
            </tr>';
                        }
                    }
                }
                $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array(
                            'model' => $model,
                            'product_items' => $product_items), true));
            }
            /* ---^ inventory and production ^--- */ else {
                if (!in_array($modelName, array("Lead"))) {
                    $itemModel = $modelName . 'Item';
                    $modelitem = new $itemModel;
                    $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
                    $modelitem->{$refer_id} = $id;
                    if (in_array($modelName, array(
                                "PurchasingInvoice",
                                "Quotes",
                                "Order",
                                "Invoice",
                                "PurchasingOrder"))) {
                        $model = $modelName::model()->with('items')->findByPK($id, array('order' => 'items.id ASC'));
                        $product_items = "";
                        $k = 0;
                        foreach ($model->items as $i => $eachItem) {
                            if ($eachItem->quantity != 0) {
                                if (in_array($modelName, array("PurchasingInvoice", "Quotes", "Order", "Invoice"))) {
                                    if (in_array($modelName, array("Quotes", "Order", "Invoice"))) {
                                        $eachItem->rate+=($eachItem->addition_amount / $eachItem->quantity);
                                        $eachItem->rate-=($eachItem->deduction_amount / $eachItem->quantity);
                                        $eachItem->net_amount = $eachItem->rate * $eachItem->quantity;
                                    }
                                    $class = $class == "odd" ? "even" : "odd";
                                    $product_items .= '<tr class = "' . $class . '">
            <td >' . (++$k) . '</td>
            <td class = "cell-left">' . $eachItem->product->part_number . '</td>';

                                    $product_items .= '<td class = "cell-left">' . nl2br($eachItem->description) . '</td>';

                                    if ((int) $custom_changes['need_brand_in_sop_print_out'] && in_array($modelName, array("Quotes", "Order", "Invoice"))) {
                                        $product_items .= '<td class = "cell-center">' . $eachItem->product->productclass->brand . '</td>';
                                    }
                                    $product_items .= '<td class = "cell-right">' . preg_replace('/\s\d+\.00/', '', floatval($eachItem->quantity)) . '</td>
            <td class = "cell-center">' . $eachItem->product->unit->symbol . '</td>';
                                  /*  if (in_array($modelName, array("Quotes"))) {
                                        $total_available_qty = $eachItem->product->total_quantity - $eachItem->product->total_allocated_quantity;
                                        if ($model->materials_allocated == "Y") {
                                            $allocatedQtyForThisItem = AllocatedMaterial::model()->find('product_id = ' . $eachItem->product_id . ' AND file_id = ' . $model->file_id)->count;
                                            $total_available_qty+=$allocatedQtyForThisItem;
                                        }
                                        $total_available_qty = ($total_available_qty <= 0) ? 0 : $total_available_qty;
                                        $product_items .= '<td class = "cell-right">' . (($total_available_qty < $eachItem->quantity) ? preg_replace('/\s\d+\.00/', '', floatval($total_available_qty)) : preg_replace('/\s\d+\.00/', '', floatval($eachItem->quantity)) ) . '</td>';
                                    }*/
                                    if (in_array($modelName, array("Invoice"))) {
                                    //$product_items .= '<td class = "cell-right">' . sprintf("%2.2f", $eachItem->ordered_value) . '</td>
                     $product_items .= '<td class = "cell-right">' . sprintf( Yii::app()->numberFormatter->formatCurrency($eachItem->ordered_value,"")) . '</td>
                         <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency(($eachItem->invoiced - $eachItem->amount), "") . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->amount, "") . '</td>
                
            </tr>';
                                    }
                                    else{
                                       //  $product_items .= '<td class = "cell-right">' . sprintf("%2.2f", $eachItem->rate) . '</td>
                           $product_items .= '<td class = "cell-right">' . sprintf( Yii::app()->numberFormatter->formatCurrency($eachItem->rate,"")) . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, "") . '</td>
            </tr>';
                                    }
                                } else if (in_array($modelName, array("PurchasingOrder"))) {
                                    $class = $class == "odd" ? "even" : "odd";
                                    $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->product->part_number . '</td>
            <td class = "cell-left">' . nl2br($eachItem->description) . '</td>
            <td class = "cell-right">' . preg_replace('/\s\d+\.00/', '', floatval($eachItem->quantity)) . '</td>
            <td class = "cell-center">' . $eachItem->product->unit->symbol . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->amount, "") . '</td>
            </tr>';
                                }
                            }
                        }
//if (!in_array($modelName, array("Invoice"))) {
                        if (in_array($modelName, array("Quotes")))
                            $additions = '';
                        $colspan = in_array($modelName, array("PurchasingOrder", "PurchasingInvoice")) ? 6 : (in_array($modelName, array("Quotes")) ? 7 : 7);
                        if(in_array($modelName, array("Invoice"))){
                           $colspan = 8; 
                        }
                        if (!(int) $custom_changes['need_brand_in_sop_print_out'] && in_array($modelName, array("Quotes", "Order", "Invoice", "PurchasingInvoice")))
                            $colspan-=1;
                        foreach ($model->adItems as $i => $eachItem) {
                            if (($eachItem->calculated_value) > 0) {
//$class = $class == "odd" ? "even" : "odd";

                                $additions .= '<tr>
            <td colspan = "' . $colspan . '" class = "cell-right" >' . (!empty($eachItem->particular) ? $eachItem->particular : "Additions") . '</td>
            <td colspan = "1" class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
            </tr>';
                            }
                        }
                        $deductions = '';
                        foreach ($model->dedItems as $i => $eachItem) {
                            if ($eachItem->calculated_value > 0) {
//$class = $class == "odd" ? "even" : "odd";
                                $deductions .= '<tr>
            <td colspan = "' . $colspan . '" class = "cell-right" >' . (!empty($eachItem->particular) ? $eachItem->particular : 'Deduction') . '</td>
            <td colspan = "1" class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
            </tr>';
                            }
                        }
//}
// $this->renderPartial('application.views.front.' . $view, array('model' => $model, 'product_items' => $product_items, 'additions' => $additions, 'deductions' => $deductions));
                        $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model, 'product_items' => $product_items, 'additions' => $additions, 'deductions' => $deductions, 'custom_changes' => $custom_changes), true));
                    }
                    else
                        $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model, 'modelitem' => $modelitem, 'vendor' => $vendor), true));
                }
                else
                    $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model), true));
            }
        }
       /* if (in_array($modelName, array("Quotes", "Order"))) {
            if ($model->file->is_approved == "N")
                die("Pending approval");
        }*/

        //$mPDF1->setFooter('{DATE j-m-Y}|{PAGENO}/{nb}|' . $modelName, 'O|E');
        //$mPDF1->setFooter('{PAGENO} / {nbpg}');
        $mPDF1->Output($view, 'I');
    }
    public function report($model, $htmlTemplate, $css, $html_prepared = null, $title = null) {
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/' . $css . '.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        //print_r($this->renderPartial('application.views.front.pdf.reports.' . $htmlTemplate, array('model' => $model, 'product_items' => $html_prepared, 'title' => $title),true));
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.reports.' . $htmlTemplate, array('model' => $model, 'product_items' => $html_prepared, 'title' => $title), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionCompany() {
        $model = new Company;
        $model->attributes = $_POST['Company'];
        $this->report($model, 'company-list', 'pdf_for_list');
    }

    public function actionCustomerReport() {
        $model = new Company;
        $model->genral_industry = $_POST['customer_industry'];
        $model->billing_country = $_POST['customer_country'];
        $model->company_type = $_POST['customer_customer_type'];

        $this->report($model, 'company-list', 'pdf_for_list');
    }
    public function actionUserDetails() {
        $model = new User;
        $this->report($model, 'userdetails-list', 'pdf_for_list');
    }

    public function actionContactReport() {
        $model = new CompanyContact;
        $model->company_id = $_POST['customer_name'];
        if (!empty($model->company_id))
            $this->report($model, 'contact-list', 'pdf_for_list');
        else
            $this->report($model, 'contact-list-all', 'pdf_for_list');;
    }

    public function actionActivityReport() {
        $model = new Activity;
        $model->searchstartdate = $_POST['activity_start_date'];
        $model->searchenddate = $_POST['activity_end_date'];
        $model->crm_user_id = $_POST['activity_owner'];
        $model->typ_of_activity = $_POST['type_of_activity'];
        $this->report($model, 'activity-list', 'pdf_for_list');
    }

    public function actionSalesReportQuotes() {
        $model = new Quotes;
        $model->searchstartdate = $_POST['quotation_start_date'];
        $model->searchenddate = $_POST['quotation_end_date'];
        $model->company_id = $_POST['quotation_company'];
        $model->sales_group = $_POST['quotation_sales_group'];
        $model->status = $_POST['quotation_status'];
        //$model->lead_owner_id = $_POST['quotation_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_quotes_show_all']) ? $model->lead_owner_id = $_POST['quotation_lead_owner'] : $model->lead_owner_id = Yii::app()->user->id;
        $model->value = $_POST['quotation_value'];
        $model->country = $_POST['quotation_country'];
        $model->probability = $_POST['quotation_probability'];
        $this->report($model, 'salesquotation-list', 'pdf_for_list');
    }

    public function actionSalesReportLead() {
        $model = new Lead;
        $model->searchstartdate = $_POST['lead_start_date'];
        $model->searchenddate = $_POST['lead_end_date'];
        $model->company_id = $_POST['lead_company'];
        $model->status = $_POST['lead_status'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_lead_show_all']) ? $model->lead_owner_id = $_POST['lead_lead_owner'] : $model->lead_owner_id = Yii::app()->user->id;
        //print_r($_POST['lead_status']);
        // print_r();
        //
        //die("xxx");
        $model->country = $_POST['lead_country'];
        $this->report($model, 'saleslead-list', 'pdf_for_list');
    }

    public function actionSotckMovementHistoryReport() {
        $model = new InvoiceItem;
        $model->searchstartdate = date('Y-m-d', strtotime($_POST['stock_movement_history_start_date']));
        $model->searchenddate = date('Y-m-d', strtotime($_POST['stock_movement_history_end_date']));
        $model->product_id = Store::model()->find(array('condition' => 'part_number="' . $_POST['inventory_part_no11'] . '"'))->id;
        if (!empty($model->searchstartdate) && !empty($model->searchenddate) && !empty($model->product_id)) {
            $item_sales = InvoiceItem::model()->with('invoice')->findAll(array('condition' => 'product_id=' . $model->product_id . ' AND invoice.invoice_date BETWEEN  "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"', 'order' => 'invoice_date DESC'));
            $item_po = PurchasingInvoiceItem::model()->with('purchasinginvoice')->findAll(array('condition' => 'product_id=' . $model->product_id . ' AND purchasinginvoice.invoice_date BETWEEN  "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"', 'order' => 'invoice_date DESC'));
            $product_items = '<table class="table_grid">
            <tr>
            <th>No.</th>
            <th>Order No.</th>
            <th>Sales/Purchase.</th>
            <th>Date.</th>
            <th>Company Name.</th>
            <th>Qty Ordered .</th>
            <th>Rate.</th>
            <th>Value.</th>
            <th>CN/DN Qty.</th>
            </tr>';
            $k = 0;
            foreach ($item_sales as $i => $eachItem) {
                //$credited_item=Creditnote::model()->with('parent')->findAll(array('condition'=>'product_id='.$eachItem->product_id.' AND parent.invoice_id='.$eachItem->invoice_id));
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(cr.returned_quantity) AS credited_qty FROM `crm_creditnote_item` AS cr JOIN `crm_creditnote` AS parent ON cr.creditnote_id=parent.id WHERE product_id=" . $eachItem->product_id . " AND parent.invoice_id=" . $eachItem->invoice_id);
                $result = $command->queryScalar();
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '"> 
            <td >' . ($k + 1) . '</td>
            <td class = "cell-left">' . $eachItem->invoice->file->order->id . '</td>
            <td class = "cell-center">' . Sales . '</td>
            <td class = "cell-center">' . $eachItem->invoice->file->order->order_date . '</td>
            <td class = "cell-left">' . $eachItem->invoice->file->company->company_name . '</td>   
            <td class = "cell-right">' . $eachItem->quantity . '</td> 
            <td class = "cell-right">' . $eachItem->rate . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($eachItem->rate * $eachItem->quantity) . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($result) . '</td>
            </tr>';
                $k++;
            }
            foreach ($item_po as $i => $eachItem) {
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(returned_quantity) AS credited_qty FROM `crm_purchasingcredit_item` AS db JOIN `crm_purchasingcredit` AS parent ON db.purchasingcredit_id=parent.id WHERE product_id=" . $eachItem->product_id . " AND parent.purchasing_invoice_id=" . $eachItem->purchasing_invoice_id);
                $result = $command->queryScalar();
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '">
            <td >' . ($k + 1) . '</td>
            <td class = "cell-left">' . $eachItem->purchasinginvoice->file->purchaseorder->id . '</td>
            <td class = "cell-center">' . Purchase . '</td>
            <td class = "cell-center">' . $eachItem->purchasinginvoice->invoice_date . '</td>  
            <td class = "cell-left">' . $eachItem->purchasinginvoice->file->company->company_name . '</td>   
            <td class = "cell-right">' . $eachItem->quantity . '</td> 
            <td class = "cell-right">' . $eachItem->rate . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($eachItem->rate * $eachItem->quantity) . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($result) . '</td>
            </tr>';
                $k++;
            }
            $product_items .='</table>';
            $this->report($model, 'stockmovementhistory-list', 'pdf_for_list', $product_items);
        }
        else
            die("Please choose Part Number/start date/end date");
    }

    public function actionSotckMovementHistoryReport1() {
        $model = new InvoiceItem;
        $model->searchstartdate = date('Y-m-d', strtotime($_POST['stock_movement_history_start_date']));
        $model->searchenddate = date('Y-m-d', strtotime($_POST['stock_movement_history_end_date']));
        $model->product_id = Store::model()->find(array('condition' => 'part_number="' . $_POST['inventory_part_no11'] . '"'))->id;
        if (!empty($model->searchstartdate) && !empty($model->searchenddate) && !empty($model->product_id)) {
            //$item_sales = InvoiceItem::model()->with('invoice')->findAll(array('condition' => 'product_id=' . $model->product_id . ' AND invoice.invoice_date BETWEEN  "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"'));
            // $item_po = PurchasingInvoiceItem::model()->with('purchasinginvoice')->findAll(array('condition' => 'product_id=' . $model->product_id . ' AND purchasinginvoice.invoice_date BETWEEN  "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"'));
            $connection = Yii::app()->db;
            /* $command = $connection->createCommand(
              "SELECT * FROM `crm_invoice_item` AS s_item JOIN `crm_purchasinginvoice_item` AS p_item JOIN `crm_invoice` AS s_i ON s_i.id=s_item.invoice_id JOIN `crm_purchasinginvoice` AS p_i ON p_i.id=p_item.purchasing_invoice_id WHERE((p_item.product_id=".$model->product_id." AND s_i.invoice_date BETWEEN '".$model->searchstartdate."' AND '".$model->searchenddate."') OR (p_item.product_id=".$model->product_id." AND p_i.invoice_date BETWEEN '".$model->searchstartdate."' AND '".$model->searchenddate."'))
              ORDER BY p_i.invoice_date,s_i.invoice_date"); */
            //$result=$command->queryScalar();
            //$sql = "SELECT * FROM `crm_store` AS s LEFT JOIN `crm_invoice_item` AS s_item ON s_item.product_id=s.id LEFT JOIN `crm_purchasinginvoice_item` AS p_item ON p_item.product_id=s.id JOIN `crm_invoice` AS s_i ON s_i.id=s_item.invoice_id JOIN `crm_purchasinginvoice` AS p_i ON p_i.id=p_item.purchasing_invoice_id WHERE s.id=".$model->product_id." AND ((s_i.invoice_date BETWEEN '".$model->searchstartdate."' AND '".$model->searchenddate."') OR (p_i.invoice_date BETWEEN '".$model->searchstartdate."' AND '".$model->searchenddate."')) ORDER BY p_i.invoice_date,s_i.invoice_date";
            $command = $connection->createCommand("SELECT * FROM `crm_store` AS s LEFT JOIN `crm_invoice_item` AS s_item ON s_item.product_id=s.id LEFT JOIN `crm_purchasinginvoice_item` AS p_item ON p_item.product_id=s.id LEFT JOIN `crm_invoice` AS s_i ON s_i.id=s_item.invoice_id LEFT JOIN `crm_purchasinginvoice` AS p_i ON p_i.id=p_item.purchasing_invoice_id WHERE s.id=30354 AND ((s_i.invoice_date BETWEEN '2013-12-01' AND '2014-04-16') OR (p_i.invoice_date BETWEEN '2013-12-01' AND '2014-04-16')) ORDER BY p_i.invoice_date,s_i.invoice_date");
            $item = $command->queryAll();
            //print_r($item);
            //die();
            $product_items = '<table class="table_grid">
            <tr>
            <th>No.</th>
            <th>File No.</th>
            <th>Sales/Purchase.</th>
            <th>Date.</th>
            <th>Company Name.</th>
            <th>Qty Ordered .</th>
            <th>Rate.</th>
            <th>Value.</th>
            <th>CN/DN Qty.</th>
            </tr>';
            foreach ($item_sales as $i => $eachItem) {
                //$credited_item=Creditnote::model()->with('parent')->findAll(array('condition'=>'product_id='.$eachItem->product_id.' AND parent.invoice_id='.$eachItem->invoice_id));
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(cr.returned_quantity) AS credited_qty FROM `crm_creditnote_item` AS cr JOIN `crm_creditnote` AS parent ON cr.creditnote_id=parent.id WHERE product_id=" . $eachItem->product_id . " AND parent.invoice_id=" . $eachItem->invoice_id);
                $result = $command->queryScalar();
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '"> 
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->invoice->file_id . '</td>
            <td class = "cell-center">' . Sales . '</td>
            <td class = "cell-center">' . $eachItem->invoice->file->order->order_date . '</td>
            <td class = "cell-left">' . $eachItem->invoice->file->company->company_name . '</td>   
            <td class = "cell-right">' . $eachItem->quantity . '</td> 
            <td class = "cell-right">' . $eachItem->rate . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($eachItem->rate * $eachItem->quantity) . '</td>
            <td class = "cell-right">' . $result . '</td>
            </tr>';
            }
            foreach ($item_po as $i => $eachItem) {
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(returned_quantity) AS credited_qty FROM `crm_purchasingcredit_item` AS db JOIN `crm_purchasingcredit` AS parent ON db.purchasingcredit_id=parent.id WHERE product_id=" . $eachItem->product_id . " AND parent.purchasing_invoice_id=" . $eachItem->purchasing_invoice_id);
                $result = $command->queryScalar();
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->purchasinginvoice->file_id . '</td>
            <td class = "cell-center">' . Purchase . '</td>
            <td class = "cell-center">' . $eachItem->purchasinginvoice->invoice_date . '</td>  
            <td class = "cell-left">' . $eachItem->purchasinginvoice->file->company->company_name . '</td>   
            <td class = "cell-center">' . $eachItem->quantity . '</td> 
            <td class = "cell-right">' . $eachItem->rate . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($eachItem->rate * $eachItem->quantity) . '</td>
            <td class = "cell-right">' . $result . '</td>
            </tr>';
            }
            $product_items .='</table>';
            $this->report($model, 'stockmovementhistory-list', 'pdf_for_list', $product_items);
        }
        else
            die("Please choose Product Class/start date/end date");
    }

    public function actionSotckMovementReport() {
        $model = new Store;
        $model->searchstartdate = date('Y-m-d', strtotime($_POST['stock_movement_start_date']));
        $model->searchenddate = date('Y-m-d', strtotime($_POST['stock_movement_end_date']));
        $model->product_class_id = $_POST['stockmovement_product_class'];
        if (!empty($model->searchstartdate) && !empty($model->searchenddate) && !empty($model->product_class_id)) {
            $items = Store::model()->findAll(array('condition' => 'product_class_id=' . $model->product_class_id, 'order' => 'part_number'));
            $product_items = '<table class="table_grid">
            <tr>
            <th>No.</th>
            <th>Part No.</th>
            <th>Description.</th>
            <th>Tot.Qty.</th>
            <th>Unit.</th>
            <th>Rate.</th>
            <th>Value.</th>
            <th>PO.Qty.</th>   
            <th>Sold.Qty.</th> 
            </tr>';
            foreach ($items as $i => $eachItem) {
                $condition = 'pmItems.product_id=' . $eachItem->id . ' AND pm.mrv_receipt_date BETWEEN "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"';
                $qcchecked = Yii::app()->db->createCommand()
                        ->select('sum(pmItems.qcchecked_quantity) as qc_qty')
                        ->from('{{purchasing_material_receipt}} pm')
                        ->join('{{purchasing_material_receipt_item}} pmItems', 'pm.id=pmItems.purchasing_materialreceipt_id')
                        ->where($condition)
                        ->queryRow();
                //$po_qty = $qcchecked['qc_qty'];
                $condition1 = 'DlyItems.product_id=' . $eachItem->id . ' AND Dly.delivery_date BETWEEN "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"';
                $delivered = Yii::app()->db->createCommand()
                        ->select('sum(DlyItems.picked_qty) as dly_qty')
                        ->from('{{delivery_note}} Dly')
                        ->join('{{delivery_item}} DlyItems', 'Dly.id=DlyItems.delivery_note_id')
                        ->where($condition1)
                        ->queryRow();
                //$so_qty = $delivered['dly_qty'];
                $condition2 = 'crItems.product_id=' . $eachItem->id . ' AND cr.credit_date BETWEEN "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"';
                $credit_qty = Yii::app()->db->createCommand()
                        ->select('sum(crItems.returned_quantity) as cr_qty')
                        ->from('{{creditnote}} cr')
                        ->join('{{creditnote_item}} crItems', 'cr.id=crItems.creditnote_id')
                        ->where($condition2)
                        ->queryRow();
                $condition3 = 'dbItems.product_id=' . $eachItem->id . ' AND db.credit_date BETWEEN "' . $model->searchstartdate . '" AND "' . $model->searchenddate . '"';
                $debit_qty = Yii::app()->db->createCommand()
                        ->select('sum(dbItems.returned_quantity) as db_qty')
                        ->from('{{purchasingcredit}} db')
                        ->join('{{purchasingcredit_item}} dbItems', 'db.id=dbItems.purchasingcredit_id')
                        ->where($condition3)
                        ->queryRow();
                $po_qty = $qcchecked['qc_qty'] - $debit_qty['db_qty'];
                $so_qty = $delivered['dly_qty'] - $credit_qty['cr_qty'];

                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '"> 
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->part_number . '</td>
            <td class = "cell-left">' . $eachItem->description . '</td> 
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal((count($eachItem->location) > 0 ? $eachItem->total_quantity : "0")) . '</td>
            <td class = "cell-center">' . $eachItem->unit->symbol . '</td>    
            <td class = "cell-right">' . $eachItem->rate . '</td>   
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal((count($eachItem->location) > 0 ? $eachItem->total_quantity * $eachItem->rate : "0")) . '</td> 
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($po_qty) . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatDecimal($so_qty) . '</td>
            </tr>';
            }
            $product_items .='</table>';
            $this->report($model, 'stockmovement-list', 'pdf_for_list', $product_items);
        }
        else
            die("Please choose Product Class/start date/end date");
    }

    public function actionPricingGroup1() {
        $model = new PriceGroupProductRelation;
        $model->pricing_product_class_id = $_POST['rpt_productclass'];
        $this->report($model, 'pricinggroup-list', 'pdf_for_list');
    }

    public function actionPricingGroup() {
        $model = new PriceGroupProductRelation;
        $model->pricing_product_class_id = $_POST['rpt_productclass'];
        //$this->report($model, 'pricinggroup-list', 'pdf_for_list');
        if (!empty($_POST['rpt_productclass'])) {
            ini_set("memory_limit", "128G");
            ini_set('max_execution_time', 1000);
            $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
            $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_list.css');
            $mPDF1->WriteHTML($stylesheet, 1);
            $item = PriceGroupProductRelation::model()->with('store')->findAll(array('condition' => 'pricing_product_class_id=' . $_POST['rpt_productclass'], 'group' => 'store_id', 'order' => 'store.part_number'));
            foreach ($item as $i => $eachitem) {
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '">
            <td class="cell-left">' . $eachitem->store->part_number . '</td>';
                if ((int) Yii::app()->user->havePermissionOn['inventory_price_list_view_internal']) {
                    $i_items = PricingGroup::model()->findAll(array('condition' => 'type="I"'));
                    foreach ($i_items as $each_internal_item)
                        $product_items .='<td class="cell-right">' . PriceGroupProductRelation::model()->with('priceGrp')->find(array('condition' => 'pricing_product_class_id=' . $eachitem->pricing_product_class_id . ' AND price_group_id=' . $each_internal_item->id . ' AND store_id=' . $eachitem->store_id))->rate . '</td>';
                }
                $s_items = PricingGroup::model()->findAll(array('condition' => 'type="S"'));
                foreach ($s_items as $each_sale_item) {
                    $product_items .='<td class="cell-right">' . PriceGroupProductRelation::model()->with('priceGrp')->find(array('condition' => 'pricing_product_class_id=' . $eachitem->pricing_product_class_id . ' AND price_group_id=' . $each_sale_item->id . ' AND store_id=' . $eachitem->store_id))->rate . '</td>';
                }
                $product_items .='</tr>';
            }
            $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.reports.pricinggroup-list', array('model' => $model, 'product_items' => $product_items, 'internalpricing' => $i_items, 'salespricing' => $s_items), true));
            $mPDF1->Output('PRICELIST', 'I');
        }
        else
            die("Please choose Product Class");
    }

    public function actionSalesReportOrder() {
        $model = new Order;
        $condition = array();
        $model->searchstartdate = $_POST['order_start_date'];
        $model->searchenddate = $_POST['order_end_date'];
        $model->company_id = $_POST['order_company'];
        $model->sales_group = $_POST['order_sales_group'];
        $model->status = $_POST['order_status'];
        // $model->lead_owner_id = $_POST['order_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_order_show_all']) ? $model->lead_owner_id = $_POST['order_lead_owner'] : $model->lead_owner_id = Yii::app()->user->id;
        $model->value = $_POST['order_value'];
        $model->country = $_POST['order_country'];
        if (!empty($model->company_id))
            $condition[] = 't.company_id="' . $model->company_id . '"';
        if (!empty($model->sales_group))
            $condition[] = 'sales_group="' . $model->sales_group . '"';
        if (!empty($model->lead_owner_id))
            $condition[] = 'lead_owner_id="' . $model->lead_owner_id . '"';
        if (!empty($model->country))
            $condition[] = 'company.billing_country="' . $model->country . '"';
        if (!empty($model->value))
            $condition[] = 'grand_total<="' . $model->value . '"';
        if (!empty($model->status)) {
            switch ($model->status) {
                case 'P':
                    $condition[] = 'file.current_process_status="O"';
                    break;
                case 'D':
                case 'PD':
                    $condition[] = 'file.current_process_status<>"O"';
                    break;
            }
        }
        if (is_array($condition))
            $condition = implode(' AND ', $condition);
        if (!empty($condition))
            $condition .=" AND file.own_company_id=" . Yii::app()->user->master_user_company_id . " AND file.own_branch_id=" . Yii::app()->user->master_user_branch_id;
        else
            $condition = "file.own_company_id=" . Yii::app()->user->master_user_company_id . " AND file.own_branch_id=" . Yii::app()->user->master_user_branch_id;
        if (!empty($_POST['order_start_date']) && !empty($_POST['order_end_date']))
            $condition .=" AND order_date BETWEEN '" . $model->searchstartdate . "' AND '" . $model->searchenddate . "'";

        $order = Order::model()->with('file', 'file.company')->findAll(array('condition' => $condition, 'order' => 'order_date DESC'));
        $product_items = '<table class="table_grid">
            <tr>
            <th>No.</th>
            <th>Ord. No.</th>
            <th>Company.</th>
            <th>Lead Owner.</th>
            <th>Ord. Dt.</th>
            <th>Dly. Dt.</th>
            <th>Curr.</th>
            <th>Value.</th>   
            <th>Value(BC).</th> 
            </tr>';
        $total = 0;
        $i = 0;
        foreach ($order as $eachItem) {
            $show_row = 1;
            if (!empty($model->status)) {
                $show_row = 0;
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(d_item.picked_qty) FROM `crm_delivery_item` AS d_item JOIN `crm_delivery_note` AS d ON d.id=d_item.delivery_note_id JOIN `crm_master_file` AS mf ON mf.id=d.file_id WHERE d.file_id=" . $eachItem->file_id);
                $delivered_qty = $command->queryScalar();
                $command1 = $connection->createCommand("SELECT SUM(quantity) FROM `crm_order_item` AS o_item JOIN `crm_order` AS o ON o.id=o_item.order_id WHERE o.id=" . $eachItem->id);
                $orderd_qty = $command1->queryScalar();
                switch ($model->status) {
                    case 'P':
                        $show_row = 1;
                        break;
                    case 'D':
                        if ($delivered_qty == $orderd_qty)
                            $show_row = 1;
                        break;
                    case 'PD':
                        if ($delivered_qty < $orderd_qty)
                            $show_row = 1;
                        break;
                }
            }
            if ($show_row == 1) {
                $class = $class == "odd" ? "even" : "odd";
                $product_items .= '<tr class = "' . $class . '"> 
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $eachItem->id . '</td>
            <td class = "cell-left">' . $eachItem->company->company_name . '</td> 
            <td class = "cell-left">' . $eachItem->file->leadowner->Fullname . '</td>
            <td>' . $eachItem->order_date . '</td>    
            <td>' . $eachItem->delivery_date . '</td>   
            <td>' . $eachItem->currencyname->currency_code . '</td> 
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->grand_total, "") . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->grand_total * $eachItem->exchange_rate, "") . '</td>
            </tr>';
                $total +=$eachItem->grand_total * $eachItem->exchange_rate;
                $i++;
            }
        }
        $class = $class == "odd" ? "even" : "odd";
        $product_items .='<tr class = "' . $class . '"><td ></td><td ></td><td ></td><td ></td><td ></td><td ></td><td ></td><td ></td><td class = "cell-right"><b>' . Yii::app()->numberFormatter->formatCurrency($total, "") . '</b></td></tr>';
        $product_items .='</table>';
        $this->report($model, 'salesorder-list', 'pdf_for_list', $product_items);
    }

    public function actionSalesReportOrder1() {
        $model = new Order;
        $model->searchstartdate = $_POST['order_start_date'];
        $model->searchenddate = $_POST['order_end_date'];
        $model->company_id = $_POST['order_company'];
        $model->sales_group = $_POST['order_sales_group'];
        $model->status = $_POST['order_status'];
        // $model->lead_owner_id = $_POST['order_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_order_show_all']) ? $model->lead_owner_id = $_POST['order_lead_owner'] : $model->lead_owner_id = Yii::app()->user->id;
        $model->value = $_POST['order_value'];
        $model->country = $_POST['order_country'];
        $this->report($model, 'salesorder-list', 'pdf_for_list');
    }

    public function actionSalesReportInvoice() {
        $model = new Invoice;
        $model->searchstartdate = $_POST['invoice_start_date'];
        $model->searchenddate = $_POST['invoice_end_date'];
        $model->company_id = $_POST['invoice_company'];
        $model->sales_group = $_POST['invoice_sales_group'];
        //$model->lead_owner = $_POST['invoice_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_invoice_show_all']) ? $model->lead_owner = $_POST['invoice_lead_owner'] : $model->lead_owner = Yii::app()->user->id;
        $model->value = $_POST['invoice_value'];
        $model->country = $_POST['invoice_country'];
        $this->report($model, 'salesinvoice-list', 'pdf_for_list');
    }

    public function actionGrossProfit() {
        $model = new Invoice;
        $model->searchstartdate = $_POST['invoice_gp_start_date'];
        $model->searchenddate = $_POST['invoice_gp_end_date'];
        $model->company_id = $_POST['invoice_gp_company'];
        $model->sales_group = $_POST['invoice_gp_sales_group'];
        // $model->lead_owner = $_POST['invoice_gp_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_gross_profit_show_all']) ? $model->lead_owner = $_POST['invoice_gp_lead_owner'] : $model->lead_owner = Yii::app()->user->id;
        $model->value = $_POST['invoice_gp_value'];
        $model->country = $_POST['invoice_gp_country'];
        $this->report($model, 'grossprofit-list', 'pdf_for_list');
    }

    public function actionSalesReportCreditNote() {
        $model = new Creditnote;
        $model->searchstartdate = $_POST['creditnote_start_date'];
        $model->searchenddate = $_POST['creditnote_end_date'];
        $model->company_id = $_POST['creditnote_company'];
        $model->sales_group = $_POST['creditnote_sales_group'];
        //$model->lead_owner = $_POST['creditnote_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_creditnote_show_all']) ? $model->lead_owner = $_POST['invoice_lead_owner'] : $model->lead_owner = Yii::app()->user->id;
        $model->value = $_POST['creditnote_value'];
        $model->country = $_POST['creditnote_country'];
        $this->report($model, 'salescreditnote-list', 'pdf_for_list');
    }

    public function actionSalesReportDeliveryNote() {
        $model = new DeliveryNote;
        $model->searchstartdate = $_POST['deliverynote_start_date'];
        $model->searchenddate = $_POST['deliverynote_end_date'];
        $model->company_id = $_POST['deliverynote_company'];
        $model->country = $_POST['deliverynote_country'];
        $model->shipped_by = $_POST['deliverynote_shipped_by'];
        $this->report($model, 'salesdeliverynote-list', 'pdf_for_list');
    }

    public function actionSalesReportRcptOfPayment() {
        $model = new ReceivedInvoices;
        $model->searchstartdate = $_POST['receiptofpayment_start_date'];
        $model->searchenddate = $_POST['receiptofpayment_end_date'];
        $model->company_id = $_POST['receiptofpayment_company'];
        $model->mode_of_payment = $_POST['sales_mode_of_payment'];
        $model->realisation_date_from = $_POST['receiptofpayment_realisation_date_from'];
        $model->realisation_date_to = $_POST['receiptofpayment_realisation_date_to'];
        $this->report($model, 'salesreceiptofpayment-list', 'pdf_for_list');
    }

    public function actionSalesReportPurchaseOrder() {
        $model = new PurchasingOrder;
        $model->searchstartdate = $_POST['purchaseorder_start_date'];
        $model->searchenddate = $_POST['purchaseorder_end_date'];
        $model->vendor_id = $_POST['purchaseorder_company'];
        $model->project = $_POST['purchaseorder_project'];
        $model->value = $_POST['purchaseorder_value'];
        $model->country = $_POST['purchaseorder_country'];
        $this->report($model, 'purchaseorder-list', 'pdf_for_list');
    }

    public function actionSalesReportPurchaseMaterialreceipt() {
        $model = new PurchasingMaterialreceipt;
        $model->searchstartdate = $_POST['purchasematerialreceipt_start_date'];
        $model->searchenddate = $_POST['purchasematerialreceipt_end_date'];
        $model->vendor_id = $_POST['purchasematerialreceipt_company'];
        $model->project = $_POST['purchasematerialreceipt_project'];
        $model->country = $_POST['purchasematerialreceipt_country'];
        $this->report($model, 'purchasematerialreceipt-list', 'pdf_for_list');
    }

    public function actionSalesReportPurchaseInvoice() {
        $model = new PurchasingInvoice;
        $model->searchstartdate = $_POST['purchaseinvoice_start_date'];
        $model->searchenddate = $_POST['purchaseinvoice_end_date'];
        $model->vendor_id = $_POST['purchaseinvoice_company'];
        $model->project = $_POST['purchaseinvoice_project'];
        $model->country = $_POST['purchaseinvoice_country'];
        $model->value = $_POST['purchaseinvoice_value'];
        $this->report($model, 'purchaseinvoice-list', 'pdf_for_list');
    }

    public function actionSalesReportPurchaseCreditNote() {
        $model = new Purchasingcredit;
        $model->searchstartdate = $_POST['purchasecreditnote_start_date'];
        $model->searchenddate = $_POST['purchasecreditnote_end_date'];
        $model->vendor_id = $_POST['purchasecreditnote_company'];
        $model->project = $_POST['purchasecreditnote_project'];
        $model->country = $_POST['purchasecreditnote_country'];
        $model->value = $_POST['purchasecreditnote_value'];
        $this->report($model, 'purchasecreditnote-list', 'pdf_for_list');
    }

    public function actionPurchaseReportRcptOfPayment() {
        $model = new PaidInvoices;
        $model->searchstartdate = $_POST['purchase_receiptofpayment_start_date'];
        $model->searchenddate = $_POST['purchase_receiptofpayment_end_date'];
        $model->company_id = $_POST['purchase_receiptofpayment_company'];
        $model->mode_of_payment = $_POST['purchase_mode_of_payment'];
        $model->realisation_date_from = $_POST['purchase_receiptofpayment_realisation_date_from'];
        $model->realisation_date_to = $_POST['purchase_receiptofpayment_realisation_date_to'];
        $this->report($model, 'purchasereceiptofpayment-list', 'pdf_for_list');
    }

    public function actionReportInventory() {
        $model = new Store;
        $model->product_class = $_POST['inventory_product_class'];
        $model->description = $_POST['inventory_description'];
        $model->generic_name = $_POST['inventory_genericname'];
        $model->warehouse = $_POST['inventory_warehouse'];
        $model->from_part_no = $_POST['inventory_part_no1'];
        $model->to_part_no = $_POST['inventory_part_no2'];
        $model->from_bin = $_POST['inventory_bin1'];
        $model->to_bin = $_POST['inventory_bin2'];

        $model->not_include_zero_qty = $_POST['not_include_zero_qty'];
        //$model->from_rack = $_POST['inventory_rack1'];
        //$model->to_rack = $_POST['inventory_rack2'];

        $this->report($model, 'inventory-report-list', 'pdf_for_list');
    }

    public function actionReportMinRequirement() {
        $model = new ProductLocation;
        $this->report($model, 'min-requirement-report-list', 'pdf_for_list');
    }

    public function actionAllocatematerial($from = null) {
        if ($from != null) {
            if ($from == "searchbycustomer")
                $allocateditems = AllocatedMaterial::model()->with(file)->findAll('file.company_id = :company_id', array('company_id' => (int) $_POST['materialallocation_search_company_id']));
            else if ($from == "searchbyproduct")
                $allocateditems = AllocatedMaterial::model()->findAll('product_id = :product_id', array('product_id' => (int) $_POST['AllocatedMaterial']['product_id']));
        }
        else
            $allocateditems = AllocatedMaterial::model()->findAll('file_id = :ID', array(':ID' => (int) $_POST['AllocatedMaterial']['file_id']));
        $product_items = "";
        foreach ($allocateditems as $eachallocatedmaterial) {
            if ($eachallocatedmaterial->allocated_from == "O")
                $modelName = "Order";
            else if ($eachallocatedmaterial->allocated_from == "Q")
                $modelName = "Quotes";
            $model = $modelName::model()->find('file_id = :file_id', array(':file_id' => $eachallocatedmaterial->file_id));
            $itemModel = $modelName . 'Item';
            $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
            $modelitem = $itemModel::model()->find('product_id = :p_id AND ' . $refer_id . ' = :refer_id', array(':p_id' => $eachallocatedmaterial->product_id, ':refer_id' => $model->id));
            $remaining_qty = $modelitem->quantity - $eachallocatedmaterial->count;
            $freequantity = $modelitem->product->total_quantity - $modelitem->product->total_allocated_quantity;
            if ($remaining_qty > $freequantity)
                $balancedqty = $remaining_qty - $freequantity;
            else
                $balancedqty = 0;
            $class = $class == "odd" ? "even" : "odd";
            if ($from == "searchbyproduct") {
                $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $model->id . '</td>
            <td class = "cell-left">' . $model->file_id . '</td>
            <td class = "cell-left">' . $model->file->status . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($modelitem->quantity)) . '</td>
            <td class = "cell-center">' . $eachallocatedmaterial->count . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($freequantity)) . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($balancedqty)) . '</td>
            <td class = "cell-left">' . $modelitem->product->unit->symbol . '</td>
            </tr>';
                $i++;
            } else {
                $product_items .= '<tr class = "' . $class . '">
            <td >' . ($i + 1) . '</td>
            <td class = "cell-left">' . $modelitem->product->part_number . '</td>
            <td class = "cell-left">' . nl2br($modelitem->description) . '</td>
            <td class = "cell-left">' . $model->file->status . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($modelitem->quantity)) . '</td>
            <td class = "cell-center">' . $eachallocatedmaterial->count . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($freequantity)) . '</td>
            <td class = "cell-center">' . preg_replace('/\s\d+\.00/', '', floatval($balancedqty)) . '</td>
            <td class = "cell-left">' . $modelitem->product->unit->symbol . '</td>
            </tr>';
                $i++;
            }
        }
        if ($from != null) {
            if ($from == "searchbycustomer") {
                $model = Company::model()->findByPK((int) $_POST['materialallocation_search_company_id']);
                $this->report($model, 'materialallocation-customerwise', 'pdf_for_single', $product_items);
            } else if ($from == "searchbyproduct") {
                $model = Store::model()->findByPK((int) $_POST['AllocatedMaterial']['product_id']);
                $this->report($model, 'materialallocation-productwise', 'pdf_for_single', $product_items);
            }
        }
        else
            $this->report($model, 'materialallocation-filewise', 'pdf_for_single', $product_items);
    }

    function check_in_range($start_date, $end_date, $date_from_user) {
        $start_ts = strtotime($start_date);
        $end_ts = strtotime($end_date);
        $user_ts = strtotime($date_from_user);
        return (($user_ts >= $start_ts) && ($user_ts <= $end_ts));
    }

    //finance reports
    public function actionSalesLedger() {
        $searchstartdate = $_POST['ledger_start_date'];
        $searchenddate = $_POST['ledger_end_date'];
        $company_id = $_POST['ledger_customer'];
        if (!empty($company_id) && !empty($searchstartdate) && !empty($searchenddate)) {
            $criteria = new CDbCriteria;
            $criteria->with = array('file', 'processedInvoice', 'processedInvoice.recpt');
            //$criteria->together = false;
            $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
            $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
            $criteria->addCondition('file.company_id=' . $company_id, 'AND');
            $criteria->order = "t.invoice_date DESC,recpt.received_date DESC";
            $invoices = Invoice::model()->findAll($criteria);

            $criteria2 = new CDbCriteria;
            $criteria2->with = array('file');
            $criteria2->addCondition('file.company_id=' . $company_id . ' AND t.invoice_date < "' . $searchstartdate . '"');
            $allInvoicesTillStartDate = Invoice::model()->with('file')->findAll($criteria2);
            foreach ($allInvoicesTillStartDate as $eachInvoice) {
                $opening_balance+=($eachInvoice->grand_total - floatval($eachInvoice->returnedAmount) - floatval($eachInvoice->receivedAmount)) * $eachInvoice->file->order->exchange_rate;
            }

            $trs = array();
            $tds = array();
            $total_debit = $opening_balance;
            $status = $opening_balance > 0 ? 'Payment' : 'Sales';
            $total_columns = 8;
            $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
            $trs[] = '<tr>
                            <th width="5%">Date</th>
                            <th width="10%">Particulars</th>
                            <th width="5%">File</th>                            
                            <th width="5%">Due On</th>
                            <th width="5%">Mode</th>
                            <th width="10%">Ref.No.</th>
                            <th width="10%">Debit</th>
                            <th width="10%">Credit</th>
                        </tr>';
            $trs[] = '<tr class="even">
            <td class="cell-center" >' . $searchstartdate . '</td>
                            <td colspan="' . ($total_columns - 3) . '" class="cell-center" >' . $status . ' Opening Balance</td>
                            <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($opening_balance, "") . '</td>
                                <td ></td>
                        </tr>';
            foreach ($invoices as $i => $eachInvoice) {
                $mode_of_payment = ReceivedInvoices::model()->find(array('condition' => 'invoice_id=' . $eachInvoice->id))->recpt->mode;
                if ($this->check_in_range($searchstartdate, $searchenddate, $eachInvoice->invoice_date)) {
                    $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                    $total_debit+=$eachInvoice->grand_total * $eachInvoice->file->order->exchange_rate;
                    $tds = '<td>' . $eachInvoice->invoice_date . '</td>';
                    $tds .= '<td class="cell-left"> Sales</td>';
                    $tds.='<td class="cell-left">' . $eachInvoice->file->id . '/' . $eachInvoice->id . '</td>';
                    $tds.='<td class="cell-left">' . date('Y-m-d', strtotime($eachInvoice->invoice_date) + (24 * 24 * 60 * $eachInvoice->paymentTerm->no_of_days)) . '</td>';
                    $tds.='<td class="cell-left">' . $mode_of_payment . '</td>';
                    $tds.='<td>' . $eachInvoice->reference . '</td>';
                    $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total * $eachInvoice->file->order->exchange_rate, "") . '</td>';
                    $tds.='<td>-</td>';
                    $trs[] = '<tr>' . $tds . '</tr>';
                }

                foreach ($eachInvoice->processedInvoice as $pInvoice) {
                    if ($this->check_in_range($searchstartdate, $searchenddate, $pInvoice->recpt->received_date)) {
                        $total_credit+=$pInvoice->received_amt * $eachInvoice->file->order->exchange_rate;
                        $tds = '<td>' . $pInvoice->recpt->received_date . '</td>';
                        $tds .= '<td class="cell-left"> Payment</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->invoice->file->id . '/' . $pInvoice->id . '</td>';
                        $tds.='<td class="cell-left">' . date('Y-m-d', strtotime($pInvoice->invoice->invoice_date) + (24 * 24 * 60 * $pInvoice->invoice->paymentTerm->no_of_days)) . '</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->recpt->mode . '</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->recpt->ref_number . '</td>';
                        $tds.='<td>-</td>';
                        $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($pInvoice->received_amt * $eachInvoice->file->order->exchange_rate, "") . '</td>';
                        $trs[] = '<tr>' . $tds . '</tr>';
                    }
                }
            }
            $trs[] = '<tr>
            <td colspan="' . ($total_columns - 2) . '"></td>
                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_debit, "") . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_credit, "") . '</td></tr>';
            $closing_balance = ($total_debit - $total_credit);
            $status = $closing_balance > 0 ? 'Payment' : 'Sales';
            $trs[] = '<tr class="even">
                            <td colspan="' . ($total_columns - 2) . '" class="cell-center" >' . $status . ' Closing Balance</td>
                            <td colspan="' . ($total_columns - 6) . ' " class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($closing_balance, "") . '</td>
                        </tr>';
            $trs[] = '<tr class="even">
                            <td colspan="' . ($total_columns - 1) . '" class="cell-right" ><strong>' . Yii::app()->numberFormatter->formatCurrency($total_debit, "") . '</strong></td>
                            <td class="cell-right"><strong>' . Yii::app()->numberFormatter->formatCurrency($total_credit + $closing_balance, "") . '</strong></td>
                        </tr>';
            $html_prepared = implode('', $trs);
            $this->report($invoices[0], 'ledger', 'pdf_for_single', $html_prepared, 'CUSTOMER LEDGER');
        } else {
            if (!empty($searchstartdate) && !empty($searchenddate) && $company_id == null) {
                $criteria = new CDbCriteria;
                $criteria->with = array('file', 'file.company', 'processedInvoice', 'processedInvoice.recpt');
                $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
                $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
                $criteria->group = "t.company_id";
                // $criteria->order = "t.invoice_date DESC";
                $criteria->order = "company.company_name ASC";
                $invoicesGroupByCompany = Invoice::model()->findAll($criteria);
                $trs = array();
                $total_columns = 4;
                $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
                $trs[] = '<tr>
                            <th width="10%">SL No.</th>
                            <th width="10%">Company Name</th>
                            <th width="10%">Debit</th>
                            <th width="10%">Credit</th>
                        </tr>';
                $k = 1;
                $totaldebit = 0;
                $totalcredit = 0;
                foreach ($invoicesGroupByCompany as $eachCompany) {
                    if ($eachCompany->company->company_name != null) {
                        $tds = null;
                        $total_debit = 0;
                        $total_credit = 0;
                        $opening_balance = 0;

                        $criteria2 = new CDbCriteria;
                        $criteria2->with = array('file', 'processedInvoice', 'processedInvoice.recpt');
                        //$criteria->together = false;
                        $criteria2->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
                        $criteria2->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
                        $criteria2->addCondition('file.company_id=' . $eachCompany->company_id, 'AND');
                        $criteria2->order = "t.invoice_date,recpt.received_date";
                        $invoices = Invoice::model()->findAll($criteria2);


                        $criteria3 = new CDbCriteria;
                        $criteria3->with = array('file');
                        $criteria3->addCondition('file.company_id=' . $eachCompany->company_id . ' AND t.invoice_date < "' . $searchstartdate . '"');
                        $allInvoicesTillStartDate = Invoice::model()->with('file')->findAll($criteria3);

                        foreach ($allInvoicesTillStartDate as $eachInvoice)
                            $opening_balance+=$eachInvoice->grand_total - floatval($eachInvoice->returnedAmount) - floatval($eachInvoice->receivedAmount);

                        $total_debit = $opening_balance;
                        $status = $opening_balance > 0 ? 'Payment' : 'Sales';
                        foreach ($invoices as $i => $eachInvoice) {
                            foreach ($eachInvoice->processedInvoice as $pInvoice)
                                if ($this->check_in_range($searchstartdate, $searchenddate, $pInvoice->recpt->received_date))
                                    $total_credit+=$pInvoice->received_amt * $eachInvoice->file->order->exchange_rate;
                            if ($this->check_in_range($searchstartdate, $searchenddate, $eachInvoice->invoice_date)) {
                                $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                                $total_debit+=$eachInvoice->grand_total * $eachInvoice->file->order->exchange_rate;
                            }
                        }

                        $tds .= '<td class="cell-left">' . $k . '</td>';
                        $tds .= '<td class="cell-left">' . $eachInvoice->company->company_name . '</td>';
                        //$tds .= '<td>' . $eachInvoice->invoice_date . '</td>';
                        $tds .='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_debit - $total_credit, "") . '</td>';
                        $tds .='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_credit, "") . '</td>';
                        $trs[] = '<tr>' . $tds . '</tr>';
                        $k++;
                        $totaldebit += ($total_debit - $total_credit);
                        $totalcredit += $total_credit;
                    }
                }
                $trs[] = '<tr><td></td><td></td><td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($totaldebit, "") . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($totalcredit, "") . '</td>
                    </tr>';
                $html_prepared = implode('', $trs);
                $this->report($invoicesGroupByCompany[0], 'ledger-all', 'pdf_for_single', $html_prepared, 'CUSTOMER LEDGER');
            }
            else
                die("Please choose company/start date/end date");
        }
    }

    public function actionPurchaseLedger() {
        $searchstartdate = $_POST['purchase_ledger_start_date'];
        $searchenddate = $_POST['purchase_ledger_end_date'];
        $company_id = $_POST['purchase_ledger_customer'];

        if (!empty($company_id) && !empty($searchstartdate) && !empty($searchenddate)) {
            $criteria = new CDbCriteria;
            $criteria->with = array('file', 'paidInvoice', 'paidInvoice.recpt');
            //$criteria->together = false;
            $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
            $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
            $criteria->addCondition('file.company_id=' . $company_id, 'AND');
            $criteria->order = "t.invoice_date DESC,recpt.received_date DESC";
            $invoices = PurchasingInvoice::model()->findAll($criteria);

            $criteria2 = new CDbCriteria;
            $criteria2->with = array('file');
            $criteria2->addCondition('file.company_id=' . $company_id . ' AND t.invoice_date < "' . $searchstartdate . '"');
            $allInvoicesTillStartDate = PurchasingInvoice::model()->with('file')->findAll($criteria2);
            foreach ($allInvoicesTillStartDate as $eachInvoice) {
                $opening_balance+=($eachInvoice->grand_total - floatval($eachInvoice->returnedAmount) - floatval($eachInvoice->receivedAmount)) * $eachInvoice->file->purchaseorder->exchange_rate;
            }

            $trs = array();
            $tds = array();
            $total_debit = $opening_balance;
            $status = $opening_balance > 0 ? 'Payment' : 'Sales';
            $total_columns = 8;
            $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
            $trs[] = '<tr>
                            <th width="5%">Date</th>
                            <th width="15%">Particulars</th>
                            <th width="10%">File</th>
                            <th width="5%">Due On</th>
                            <th width="5%">Mode</th>
                            <th width="10%">Ref.No.</th>
                            <th width="10%">Debit</th>
                            <th width="10%">Credit</th>
                        </tr>';
            $trs[] = '<tr class="even">
            <td class="cell-center" >' . $searchstartdate . '</td>
                            <td colspan="' . ($total_columns - 3) . '" class="cell-center" >' . $status . ' Opening Balance</td>
                            <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($opening_balance, "") . '</td>
                                <td ></td>
                        </tr>';
            foreach ($invoices as $i => $eachInvoice) {
                $mode_of_payment = ReceivedInvoices::model()->find(array('condition' => 'invoice_id=' . $eachInvoice->id))->recpt->mode;
                $reference = ReceivedInvoices::model()->find(array('condition' => 'invoice_id=' . $eachInvoice->id))->recpt->ref_number;
                if ($this->check_in_range($searchstartdate, $searchenddate, $eachInvoice->invoice_date)) {
                    $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                    $total_debit+=$eachInvoice->grand_total * $eachInvoice->file->purchaseorder->exchange_rate;
                    $tds = '<td>' . $eachInvoice->invoice_date . '</td>';
                    $tds .= '<td class="cell-left"> Sales</td>';
                    $tds.='<td class="cell-left">' . $eachInvoice->file->id . '/' . $eachInvoice->id . '</td>';
                    $tds.='<td class="cell-left">' . date('Y-m-d', strtotime($eachInvoice->invoice_date) + (24 * 24 * 60 * $eachInvoice->paymentTerm->no_of_days)) . '</td>';
                    $tds.='<td class="cell-left">' . $mode_of_payment . '</td>';
                    $tds.='<td>' . $reference . '</td>';
                    $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total * $eachInvoice->file->purchaseorder->exchange_rate, "") . '</td>';
                    $tds.='<td>-</td>';
                    $trs[] = '<tr>' . $tds . '</tr>';
                }

                foreach ($eachInvoice->paidInvoice as $pInvoice) {
                    if ($this->check_in_range($searchstartdate, $searchenddate, $pInvoice->recpt->received_date)) {
                        $total_credit+=$pInvoice->received_amt * $eachInvoice->file->purchaseorder->exchange_rate;
                        $tds = '<td>' . $pInvoice->recpt->received_date . '</td>';
                        $tds .= '<td class="cell-left">Payment</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->invoice->file->id . '/' . $pInvoice->id . '</td>';
                        $tds.='<td class="cell-left">' . date('Y-m-d', strtotime($pInvoice->invoice->invoice_date) + (24 * 24 * 60 * $pInvoice->invoice->paymentTerm->no_of_days)) . '</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->recpt->mode . '</td>';
                        $tds.='<td class="cell-left">' . $pInvoice->recpt->ref_number . '</td>';
                        $tds.='<td>-</td>';
                        $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($pInvoice->received_amt * $eachInvoice->file->purchaseorder->exchange_rate, "") . '</td>';
                        $trs[] = '<tr>' . $tds . '</tr>';
                    }
                }
            }
            $trs[] = '<tr>
            <td colspan="' . ($total_columns - 2) . '"></td>
                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_debit, "") . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_credit, "") . '</td></tr>';
            $closing_balance = ($total_debit - $total_credit);
            $status = $closing_balance > 0 ? 'Payment' : 'Sales';
            $trs[] = '<tr class="even">
                            <td colspan="' . ($total_columns - 2) . '" class="cell-center" >' . $status . ' Closing Balance</td>
                            <td colspan="' . ($total_columns - 6) . ' " class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($closing_balance, "") . '</td>
                        </tr>';
            $trs[] = '<tr class="even">
                            <td colspan="' . ($total_columns - 1) . '" class="cell-right" ><strong>' . Yii::app()->numberFormatter->formatCurrency($total_debit, "") . '</strong></td>
                            <td class="cell-right"><strong>' . Yii::app()->numberFormatter->formatCurrency($total_credit + $closing_balance, "") . '</strong></td>
                        </tr>';
            $html_prepared = implode('', $trs);
            $this->report($invoices[0], 'ledger', 'pdf_for_single', $html_prepared, 'PURCHASE LEDGER');
        } else {
            if (!empty($searchstartdate) && !empty($searchenddate) && $company_id == null) {
                $criteria = new CDbCriteria;
                $criteria->with = array('file', 'file.company', 'paidInvoice', 'paidInvoice.recpt');
                $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
                $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
                $criteria->group = "t.vendor_id";
                $criteria->order = "company.company_name ASC";
                $invoicesGroupByCompany = PurchasingInvoice::model()->findAll($criteria);
                $trs = array();
                $total_columns = 4;
                $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
                $trs[] = '<tr>
                            <th width="10%">SL No.</th>
                            <th width="10%">Company Name</th>
                            <th width="10%">Debit</th>
                            <th width="10%">Credit</th>
                        </tr>';
                $k = 1;
                $totaldebit = 0;
                $totalcredit = 0;
                foreach ($invoicesGroupByCompany as $eachCompany) {
                    $tds = null;
                    $total_debit = 0;
                    $total_credit = 0;
                    $opening_balance = 0;
                    $criteria2 = new CDbCriteria;
                    $criteria2->with = array('file', 'paidInvoice', 'paidInvoice.recpt');
                    //$criteria->together = false;
                    $criteria2->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
                    $criteria2->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
                    $criteria2->addCondition('file.company_id=' . $eachCompany->vendor_id, 'AND');
                    $criteria2->order = "t.invoice_date,recpt.received_date";
                    $invoices = PurchasingInvoice::model()->findAll($criteria2);
                    $criteria3 = new CDbCriteria;
                    $criteria3->with = array('file');
                    $criteria3->addCondition('file.company_id=' . $eachCompany->vendor_id . ' AND t.invoice_date < "' . $searchstartdate . '"');
                    $allInvoicesTillStartDate = PurchasingInvoice::model()->with('file')->findAll($criteria3);

                    foreach ($allInvoicesTillStartDate as $eachInvoice)
                        $opening_balance+=$eachInvoice->grand_total - floatval($eachInvoice->returnedAmount) - floatval($eachInvoice->receivedAmount);

                    $total_debit = $opening_balance;
                    $status = $opening_balance > 0 ? 'Payment' : 'Sales';
                    foreach ($invoices as $i => $eachInvoice) {
                        foreach ($eachInvoice->paidInvoice as $pInvoice)
                            if ($this->check_in_range($searchstartdate, $searchenddate, $pInvoice->recpt->received_date))
                                $total_credit+=$pInvoice->received_amt;
                        if ($this->check_in_range($searchstartdate, $searchenddate, $eachInvoice->invoice_date)) {
                            $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                            $total_debit+=$eachInvoice->grand_total;
                        }
                    }

                    $tds .= '<td class="cell-left">' . $k . '</td>';
                    $tds .= '<td class="cell-left">' . $eachCompany->vendor->company_name . '</td>';
                    //$tds .= '<td>' . $eachInvoice->invoice_date . '</td>';
                    $tds .='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_debit - $total_credit, "") . '</td>';
                    $tds .='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_credit, "") . '</td>';
                    $trs[] = '<tr>' . $tds . '</tr>';
                    $k++;
                    $totaldebit += ($total_debit - $total_credit);
                    $totalcredit += $total_credit;
                }
                $trs[] = '<tr><td></td><td></td><td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($totaldebit, "") . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($totalcredit, "") . '</td>
                    </tr>';
                $html_prepared = implode('', $trs);
                $this->report($invoicesGroupByCompany[0], 'ledger-all', 'pdf_for_single', $html_prepared, 'PURCHASE LEDGER');
            }
            else
                die("Please choose company/start date/end date");
        }
    }

    public function actionSalesStatement() {
        $searchstartdate = $_POST['statement_start_date'];
        $searchenddate = $_POST['statement_end_date'];
        $company_id = $_POST['statement_customer'];

        if (!empty($company_id) && !empty($searchstartdate) && !empty($searchenddate)) {
            $criteria = new CDbCriteria;
            $criteria->with = array('file', 'processedInvoice.recpt');
            $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
            $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
            $criteria->addCondition('file.company_id=' . $company_id, 'AND');
            $criteria->order = "t.invoice_date DESC,recpt.received_date DESC";
            $invoices = Invoice::model()->findAll($criteria);

            $trs = array();
            $tds = array();
            $total_inv_amnt = 0;
            $total_pend_amnt = 0;
            $total_columns = 6;
            $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
            $trs[] = '<tr>
                            <th width="10%">Date</th>
                            <th width="15%">File No/Inv.No</th>
                            <th width="10%">Inv.Amt.</th> 
                            <th width="10%">Inv.Amt(BC).</th>                            
                            <th width="10%">Pend.Amt(BC)</th>
                            <th width="10%">Due On</th>
                        </tr>';
            foreach ($invoices as $i => $eachInvoice) {
                //if ($this->check_in_range($searchstartdate, $searchenddate, $eachInvoice->invoice_date)) {
                $due_on = date('Y-m-d', strtotime($eachInvoice->invoice_date . ' + ' . $eachInvoice->paymentTerm->no_of_days . ' days'));
                $over_dues = ceil((strtotime(date('Y-m-d')) - strtotime($due_on)) / (60 * 60 * 24));
                $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                $total_inv_amnt+=$eachInvoice->grand_total * $eachInvoice->file->order->exchange_rate;
                $rcvd_amnt = $eachInvoice->receivedAmount;
                $pend_amnt = $eachInvoice->grand_total - $rcvd_amnt;
                $total_pend_amnt+=$pend_amnt * $eachInvoice->file->order->exchange_rate;
                $tds = '<td>' . $eachInvoice->invoice_date . '</td>';
                $tds.='<td class="cell-left">' . $eachInvoice->file->id . '/' . $eachInvoice->id . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total, "") . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total * $eachInvoice->file->order->exchange_rate, "") . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($pend_amnt * $eachInvoice->file->order->exchange_rate, "") . '</td>';
                $tds.='<td>' . $due_on . '</td>';
                //$tds.='<td class="cell-right">' . ($over_dues > 0 ? $over_dues : "") . '</td>';
                $trs[] = '<tr>' . $tds . '</tr>';
            }
            $trs[] = '<tr>
              <td colspan="' . ($total_columns - 3) . '"></td>
              <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_inv_amnt, "") . '</td>
              <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_pend_amnt, "") . '</td><td colspan="1"></td></tr>';

            $html_prepared = implode('', $trs);
            $this->report($invoices[0], 'statement', 'pdf_for_single', $html_prepared, 'CUSTOMER STATEMENT');
        }
        else
            die("Please choose company/start date/end date");
    }

    public function actionPurchaseStatement() {
        $searchstartdate = $_POST['purchase_statement_start_date'];
        $searchenddate = $_POST['purchase_statement_end_date'];
        $company_id = $_POST['purchase_statement_customer'];

        if (!empty($company_id) && !empty($searchstartdate) && !empty($searchenddate)) {
            $criteria = new CDbCriteria;
            $criteria->with = array('file', 'paidInvoice.recpt');
            //$criteria->together = false;
            $criteria->addBetweenCondition('invoice_date', $searchstartdate, $searchenddate);
            $criteria->addBetweenCondition('recpt.received_date', $searchstartdate, $searchenddate, 'OR');
            $criteria->addCondition('file.company_id=' . $company_id, 'AND');
            $criteria->order = "t.invoice_date DESC,recpt.received_date DESC";
            $invoices = PurchasingInvoice::model()->findAll($criteria);
            $trs = array();
            $tds = array();
            $total_inv_amnt = 0;
            $total_pend_amnt = 0;
            $total_columns = 5;
            $trs[] = '<tr><td></td><td colspan="' . ($total_columns - 2) . '"><strong>From ' . date('d-M-Y', strtotime($searchstartdate)) . ' To ' . date('d-M-Y', strtotime($searchenddate)) . '</strong><td></tr>';
            $trs[] = '<tr>
                            <th width="10%">Date</th>
                            <th width="15%">File No/Inv.No</th>
                            <th width="10%">Inv.Amt.</th> 
                            <th width="10%">Inv.Amt(BC).</th>                            
                            <th width="10%">Pend.Amt(BC)</th>
                        </tr>';
            foreach ($invoices as $i => $eachInvoice) {
                $due_on = date('Y-m-d', strtotime($eachInvoice->invoice_date . ' + ' . $eachInvoice->paymentTerm->no_of_days . ' days'));
                $over_dues = ceil((strtotime(date('Y-m-d')) - strtotime($due_on)) / (60 * 60 * 24));
                $eachInvoice->grand_total-=floatval($eachInvoice->returnedAmount);
                $total_inv_amnt+=$eachInvoice->grand_total * $eachInvoice->file->purchaseorder->exchange_rate;
                $rcvd_amnt = $eachInvoice->receivedAmount;
                $pend_amnt = $eachInvoice->grand_total - $rcvd_amnt;
                $total_pend_amnt+=$pend_amnt * $eachInvoice->file->purchaseorder->exchange_rate;
                $tds = '<td>' . $eachInvoice->invoice_date . '</td>';
                $tds.='<td class="cell-left">' . $eachInvoice->file->id . '/' . $eachInvoice->id . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total, "") . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachInvoice->grand_total * $eachInvoice->file->purchaseorder->exchange_rate, "") . '</td>';
                $tds.='<td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($pend_amnt * $eachInvoice->file->purchaseorder->exchange_rate, "") . '</td>';
                // $tds.='<td>' . $due_on . '</td>'; 
//                $tds.='<td class="cell-right">' . ($over_dues > 0 ? $over_dues : "") . '</td>';
                $trs[] = '<tr>' . $tds . '</tr>';
            }
            $trs[] = '<tr>
              <td colspan="' . ($total_columns - 3) . '"></td>
              <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_inv_amnt, "") . '</td>
              <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($total_pend_amnt, "") . '</td><td colspan="1"></td></tr>';

            $html_prepared = implode('', $trs);
            $this->report($invoices[0], 'statement', 'pdf_for_single', $html_prepared, 'PURCHASE STATEMENT');
        }
        else
            die("Please choose company/start date/end date");
    }

    public function actionCreateExcel() {
        Yii::import('ext.phpexcel.XPHPExcel');
        $objPHPExcel = XPHPExcel::createPHPExcel();
        $objPHPExcel->getProperties()->setCreator("Cumulus ERP")
                ->setLastModifiedBy("Cumulus ERP")
                ->setTitle("Office 2007 XLSX Test Document")
                ->setSubject("Office 2007 XLSX Test Document")
                ->setDescription("Test document for Office 2007 XLSX, generated using PHP classes.")
                ->setKeywords("office 2007 openxml php")
                ->setCategory("Test result file");

        if (!empty($_POST['customer_name'])) {
            $model = Company::model()->findByPk($_POST['customer_name']);
            $modelItems = CompanyContact::model()->findAll(array('condition' => 'company_id=' . $_POST['customer_name']));
            $objPHPExcel->getActiveSheet()->mergeCells("A1:F1")
                    ->setCellValue('A1', "LIST OF CONTACTS")
                    ->getStyle('A1')->getAlignment()
                    ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
            $objPHPExcel->getActiveSheet()->getStyle("A1:F1")->applyFromArray(array("font" => array("bold" => true)));
            $objPHPExcel->getActiveSheet()->getStyle("A1:F1")->getFont()->setSize(20);
            $objPHPExcel->getActiveSheet()->mergeCells("A2:F2")
                    ->setCellValue('A2', strtoupper($model->company_name))
                    ->getStyle('A2')->getAlignment()
                    ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
            $objPHPExcel->getActiveSheet()->mergeCells("A3:F3")->setCellValue('A3', nl2br(strip_tags($model->billingAddress)));
            $objPHPExcel->getActiveSheet()->mergeCells("A4:F4")->setCellValue('A4', 'Tel:  ' . $model->genral_phno);
            $objPHPExcel->getActiveSheet()->getStyle("A1:F4")->applyFromArray(array("font" => array("bold" => true)));

            //Set labels in excel file
            $objPHPExcel->getActiveSheet()->setCellValue('A5', "No.");
            $objPHPExcel->getActiveSheet()->setCellValue('B5', "Contact Name");
            $objPHPExcel->getActiveSheet()->setCellValue('C5', "City");
            $objPHPExcel->getActiveSheet()->setCellValue('D5', "Country");
            $objPHPExcel->getActiveSheet()->setCellValue('E5', "Mobile");
            $objPHPExcel->getActiveSheet()->setCellValue('F5', "Email");
            $objPHPExcel->getActiveSheet()->getStyle("A5:F5")->applyFromArray(array("font" => array("bold" => true)));

            //Setting Auto Width:
            $objPHPExcel->getActiveSheet()->getColumnDimension("A")->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension("B")->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension("C")->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension("D")->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension("E")->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension("F")->setAutoSize(true);

            //Adding an auto filter to a range of cells: 
            // $objPHPExcel->getActiveSheet()->setAutoFilter("A5:F5");


            $i = 6;
            foreach ($modelItems as $record) {
                //Set value for each cell
                $objPHPExcel->getActiveSheet()->setCellValue('A' . $i, $i - 5);
                $objPHPExcel->getActiveSheet()->getStyle('A' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $objPHPExcel->getActiveSheet()->setCellValue('B' . $i, $record->fullname);
                $objPHPExcel->getActiveSheet()->getStyle('B' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $objPHPExcel->getActiveSheet()->setCellValue('C' . $i, $record->company->billing_city);
                $objPHPExcel->getActiveSheet()->getStyle('C' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $objPHPExcel->getActiveSheet()->setCellValue('D' . $i, $record->company->countryBilling->country_name);
                $objPHPExcel->getActiveSheet()->getStyle('D' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $objPHPExcel->getActiveSheet()->setCellValue('E' . $i, $record->mobile1);
                $objPHPExcel->getActiveSheet()->getStyle('E' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $objPHPExcel->getActiveSheet()->setCellValue('F' . $i, $record->email1);
                $objPHPExcel->getActiveSheet()->getStyle('F' . $i)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                $i++;
            }
        } else {
            //$model = Company::model()->findAll(array('limit' => 100));
            $model = Company::model()->findAll();
            $objPHPExcel->getActiveSheet()->mergeCells("A1:G1")
                    ->setCellValue('A1', "LIST OF CONTACTS")
                    ->getStyle('A1')->getAlignment()
                    ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
            $objPHPExcel->getActiveSheet()->getStyle("A1:G1")->applyFromArray(array("font" => array("bold" => true)));
            $objPHPExcel->getActiveSheet()->getStyle("A1:G1")->getFont()->setSize(20);
            $j = 2;
            $k = 1;
            $i = 6;
            foreach ($model as $eachmodel) {
                $modelItems = CompanyContact::model()->findAll(array('condition' => 'company_id=' . $eachmodel->id));
                if ($modelItems != null) {
                    $objPHPExcel->getActiveSheet()->setCellValue('A' . $j, $k);
                    $objPHPExcel->getActiveSheet()->mergeCells("B" . $j . ":G" . $j)
                            ->setCellValue("B" . $j, strtoupper($eachmodel->company_name))
                            ->getStyle("B" . $j)->getAlignment()
                            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                    $objPHPExcel->getActiveSheet()->mergeCells("B" . ($j + 1) . ":G" . ($j + 1))->setCellValue('B' . ($j + 1), strip_tags($eachmodel->billingAddress));
                    $objPHPExcel->getActiveSheet()->mergeCells("B" . ($j + 2) . ":G" . ($j + 2))->setCellValue('B' . ($j + 2), 'Tel:  ' . $eachmodel->genral_phno);
                    $objPHPExcel->getActiveSheet()->getStyle("B" . $j . ":G" . ($j + 2))->applyFromArray(array("font" => array("bold" => true)));

                    //Set labels in excel file
                    $objPHPExcel->getActiveSheet()->setCellValue('B' . ($j + 3), "No.");
                    $objPHPExcel->getActiveSheet()->setCellValue('C' . ($j + 3), "Contact Name");
                    $objPHPExcel->getActiveSheet()->setCellValue('D' . ($j + 3), "City");
                    $objPHPExcel->getActiveSheet()->setCellValue('E' . ($j + 3), "Country");
                    $objPHPExcel->getActiveSheet()->setCellValue('F' . ($j + 3), "Mobile");
                    $objPHPExcel->getActiveSheet()->setCellValue('G' . ($j + 3), "Email");
                    $objPHPExcel->getActiveSheet()->getStyle("B" . ($j + 3) . ":G" . ($j + 3))->applyFromArray(array("font" => array("bold" => true)));

                    //Setting Auto Width:
                    $objPHPExcel->getActiveSheet()->getColumnDimension("A")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("B")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("C")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("D")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("E")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("F")->setAutoSize(true);
                    $objPHPExcel->getActiveSheet()->getColumnDimension("G")->setAutoSize(true);

                    //Adding an auto filter to a range of cells: 
                    // $objPHPExcel->getActiveSheet()->setAutoFilter("A5:F5");
                    foreach ($modelItems as $l => $record) {
                        //Set value for each cell
                        $objPHPExcel->getActiveSheet()->setCellValue('B' . ($j + 4 + $l), ($l + 1));
                        $objPHPExcel->getActiveSheet()->getStyle('B' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $objPHPExcel->getActiveSheet()->setCellValue('C' . ($j + 4 + $l), $record->fullname);
                        $objPHPExcel->getActiveSheet()->getStyle('C' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $objPHPExcel->getActiveSheet()->setCellValue('D' . ($j + 4 + $l), $record->company->billing_city);
                        $objPHPExcel->getActiveSheet()->getStyle('D' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $objPHPExcel->getActiveSheet()->setCellValue('E' . ($j + 4 + $l), $record->company->countryBilling->country_name);
                        $objPHPExcel->getActiveSheet()->getStyle('E' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $objPHPExcel->getActiveSheet()->setCellValue('F' . ($j + 4 + $l), $record->mobile1);
                        $objPHPExcel->getActiveSheet()->getStyle('F' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $objPHPExcel->getActiveSheet()->setCellValue('G' . ($j + 4 + $l), $record->email1);
                        $objPHPExcel->getActiveSheet()->getStyle('G' . ($j + 4 + $l))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                    }
                }
                $j = $j + 4 + $l + 1;
                $k++;
            }
        }

// Rename worksheet
        $objPHPExcel->getActiveSheet()->setTitle('List of Contacts');


// Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $objPHPExcel->setActiveSheetIndex(0);


// Redirect output to a client’s web browser (Excel5)
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="contacts.xls"');
        header('Cache-Control: max-age=0');
// If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

// If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
        Yii::app()->end();
    }

    public function actionCreateExcelForSalesOrder() {
        $model = new Order;
        $condition = array();
        $model->searchstartdate = $_POST['order_start_date'];
        $model->searchenddate = $_POST['order_end_date'];
        $model->company_id = $_POST['order_company'];
        $model->sales_group = $_POST['order_sales_group'];
        $model->status = $_POST['order_status'];
        // $model->lead_owner_id = $_POST['order_lead_owner'];
        ((int) Yii::app()->user->havePermissionOn['sop_reports_order_show_all']) ? $model->lead_owner_id = $_POST['order_lead_owner'] : $model->lead_owner_id = Yii::app()->user->id;
        $model->value = $_POST['order_value'];
        $model->country = $_POST['order_country'];
        if (!empty($model->company_id))
            $condition[] = 't.company_id="' . $model->company_id . '"';
        if (!empty($model->sales_group))
            $condition[] = 'sales_group="' . $model->sales_group . '"';
        if (!empty($model->lead_owner_id))
            $condition[] = 'lead_owner_id="' . $model->lead_owner_id . '"';
        if (!empty($model->country))
            $condition[] = 'company.billing_country="' . $model->country . '"';
        if (!empty($model->value))
            $condition[] = 'grand_total<="' . $model->value . '"';
        if (!empty($model->status)) {
            switch ($model->status) {
                case 'P':
                    $condition[] = 'file.current_process_status="O"';
                    break;
                case 'D':
                    $condition[] = 'file.current_process_status<>"O"';
                    break;
            }
        }
        if (is_array($condition))
            $condition = implode(' AND ', $condition);
        if (!empty($condition))
            $condition .=" AND file.own_company_id=" . Yii::app()->user->master_user_company_id . " AND file.own_branch_id=" . Yii::app()->user->master_user_branch_id;
        else
            $condition = "file.own_company_id=" . Yii::app()->user->master_user_company_id . " AND file.own_branch_id=" . Yii::app()->user->master_user_branch_id;
        if (!empty($_POST['order_start_date']) && !empty($_POST['order_end_date']))
            $condotin.=" AND order_date BETWEEN '" . $model->searchstartdate . "' AND '" . $model->searchenddate . "'";

        $order = Order::model()->with('file', 'file.company')->findAll(array('condition' => $condition, 'order' => 'order_date DESC'));
        $header = array("No.", "Ord. No.", "Company.", "Lead Owner.", "Ord. Dt.", "Dly. Dt.", "Curr.", "Value.", "Value(BC).");
        $total = 0;
        $i = 0;
        foreach ($order as $eachItem) {
            $show_row = 1;
            if (!empty($model->status)) {
                $show_row = 0;
                $connection = Yii::app()->db;
                $command = $connection->createCommand("SELECT SUM(d_item.picked_qty) FROM `crm_delivery_item` AS d_item JOIN `crm_delivery_note` AS d ON d.id=d_item.delivery_note_id JOIN `crm_master_file` AS mf ON mf.id=d.file_id WHERE d.file_id=" . $eachItem->file_id);
                $delivered_qty = $command->queryScalar();
                $command1 = $connection->createCommand("SELECT SUM(quantity) FROM `crm_order_item` AS o_item JOIN `crm_order` AS o ON o.id=o_item.order_id WHERE o.id=" . $eachItem->id);
                $orderd_qty = $command1->queryScalar();
                switch ($model->status) {
                    case 'P':
                        $show_row = 1;
                        break;
                    case 'D':
                        if ($delivered_qty == $orderd_qty)
                            $show_row = 1;
                        break;
                    case 'PD':
                        if ($delivered_qty < $orderd_qty)
                            $show_row = 1;
                        break;
                }
            }
            $row = array();
            if ($show_row == 1) {
                $row[$i + 1] = array($i + 1, $eachItem->id, $eachItem->company->company_name, $eachItem->file->leadowner->Fullname, $eachItem->order_date, $eachItem->delivery_date, $eachItem->currencyname->currency_code, Yii::app()->numberFormatter->formatCurrency($eachItem->grand_total, ""), Yii::app()->numberFormatter->formatCurrency($eachItem->grand_total * $eachItem->exchange_rate, ""));
                $total +=$eachItem->grand_total * $eachItem->exchange_rate;
                $i++;
            }
        }
        $this->export($header, $row, $title = "LIST OF CONTACTS");
    }

    public function export($header, $row, $title) {
        Yii::import('ext.phpexcel.XPHPExcel');
        $objPHPExcel = XPHPExcel::createPHPExcel();
        $objPHPExcel->getProperties()->setCreator("Cumulus ERP")
                ->setLastModifiedBy("Cumulus ERP")
                ->setTitle("Office 2007 XLSX Test Document")
                ->setSubject("Office 2007 XLSX Test Document")
                ->setDescription("Test document for Office 2007 XLSX, generated using PHP classes.")
                ->setKeywords("office 2007 openxml php")
                ->setCategory("Test result file");

        //setting title
        $objPHPExcel->getActiveSheet()->mergeCells("A1:" . chr(count($header) + 65) . "1")
                ->setCellValue('A1', $title)
                ->getStyle('A1')->getAlignment()
                ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle("A1:" . chr(count($header) + 65) . "1")->applyFromArray(array("font" => array("bold" => true)));
        $objPHPExcel->getActiveSheet()->getStyle("A1:" . chr(count($header) + 65) . "1")->getFont()->setSize(20);

        //setting header
        $char = 65;
        foreach ($header as $p => $eachheader) {
            $objPHPExcel->getActiveSheet()->setCellValue(chr($char + $p) . 2, $eachheader);
            $objPHPExcel->getActiveSheet()->getColumnDimension(chr($char + $p))->setAutoSize(true);
        }
        $objPHPExcel->getActiveSheet()->getStyle(chr($char) . ":" . chr($char + $p))->applyFromArray(array("font" => array("bold" => true)));

        //setting rows
        $j = 3;
        $char = 65;
        foreach ($row as $q => $eachrow) {
            foreach ($eachrow as $r => $eachrowItem)
                $objPHPExcel->getActiveSheet()->setCellValue(chr($char + $r) . $j, $eachrowItem);
            $j++;
        }
        // Rename worksheet
        $objPHPExcel->getActiveSheet()->setTitle('List of Contacts');


// Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $objPHPExcel->setActiveSheetIndex(0);


// Redirect output to a client’s web browser (Excel5)
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="contacts.xls"');
        header('Cache-Control: max-age=0');
// If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

// If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
        Yii::app()->end();
    }

}