<?php

class InventoryController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('MaterialDistribution', 'SaveInventoryTransfer', 'GetGoodsReceipt', 'GetGoodsIssue', 'SaveGoodsReceipt', 'SaveInventoryGoodsIssue',
                    'Getbinbyrackwise', 'Getwarehousefortransfer', 'Gettax', 'GetUnit', 'Getrack', 'Getbin', 'Getwarehouse', 'Savematerialmovementissue', 'Deallocate',
                    'Getlocationdetails', 'SaveLocationDetails', 'GetInventoryItem', 'Setinventryitem', 'SaveInventoryItem', 'StoreData'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionStoreData($session_set = false) {
        $jsonData = array();
        if (isset($_POST['stock_id']) && (int) $_POST['stock_id'] > 0) {
            $stockModel = Store::model()->findByPK($_POST['stock_id']);
            if (isset($_POST['warehouse_id']) && (int) $_POST['warehouse_id'] > 0) {
                $warehouseModel = ProductLocation::model()->find('warehouse_id=:warehouse_id', array(':warehouse_id' => $_POST['warehouse_id']));
                $jsonData['ware_house_name'] = $warehouseModel->warehouse->name;
                $tot = Yii::app()->db->createCommand()
                        ->select('sum(quantity) as total_quantity')
                        ->from('{{product_location}}')
                        ->where('warehouse_id = ' . $_POST['warehouse_id'] . ' AND stock_id=' . $_POST['stock_id'])
                        ->queryRow();
                $jsonData['total_quantity'] = floatval($tot['total_quantity']);
            }
            else
                $jsonData['total_quantity'] = $stockModel->total_quantity;
            if ($stockModel != NULL) {
                $jsonData['stock'] = $stockModel;
                $jsonData['total_allocated_quantity'] = $stockModel->total_allocated_quantity;
                $jsonData['inventory'] = $stockModel->inventory;
                $jsonData['product_locations'] = $stockModel->location;
                if ($session_set)
                    Yii::app()->session['stock_id'] = (int) $_POST['stock_id'];
            }
        }
        echo CJSON::encode($jsonData);
    }

    public function actionSaveInventoryItem() {
        $model_store = new Store;
        $model_inventory = new InventoryItems;
        $model_location = new ProductLocation;
        if (isset($_POST['Store']) /* && isset($_POST['InventoryItems']) && isset($_POST['ProductLocation']) */) {
            if ((int) @$_POST['Store']['id'] > 0) {
                $model_store = Store::model()->findByPK((int) @$_POST['Store']['id']);
                if ($model_store->isProductHasHistory)
                    $_POST['Store']['rate'] = $model_store->rate;
            }
            $model_store->attributes = $_POST['Store'];
            $model_store->crm_user_id = Yii::app()->user->id;
            $model_store->scenario = $scenario = ((int) @$_POST['Store']['id'] == 0) ? 'add' : 'update';
            $valid = $model_store->validate();
            if ($model_store->non_stock_item == "N") {
                $model_inventory->attributes = $_POST['InventoryItems'];
                $valid = $valid && $model_inventory->validate();
                if ($scenario == "add") {
                    $model_location->attributes = $_POST['ProductLocation'];
                    $model_location->quantity = 0;
                    $valid = $valid && $model_location->validate();
                }
            }
            if ($valid) {
                $model_store->company_id = Yii::app()->user->master_user_company_id;
                $model_store->company_branch_id = Yii::app()->user->master_user_branch_id;
                if ((int) $model_store->product_class_id == 0) {//means new product class
                    $_POST['ProductClass']['product_class'] = $model_store->product_class;
                    $modelProductClass = ProductClass::model()->find('product_class="' . $model_store->product_class . '"');
                    if ($modelProductClass == null)
                        $modelProductClass = $this->commonSave('ProductClass', true);
                    $model_store->product_class_id = $modelProductClass->id;
                }
                $model_store->save();
                $model_store->refresh();

                $temp_p = new PriceGroupProductRelation();
                $baseGroup = PricingGroup::model()->find('isBasePricingGroup="Y" AND type="I"');
                if ($baseGroup == null) {
                    $baseGroup = new PricingGroup;
                    $baseGroup->isBasePricingGroup = "Y";
                    $baseGroup->type = "I";
                    $baseGroup->pricing_group = "Base Cost Price Group";
                    $baseGroup->company_id = Yii::app()->user->master_user_company_id;
                    $baseGroup->company_branch_id = Yii::app()->user->master_user_branch_id;
                    $baseGroup->save(false);
                }
                $p = PriceGroupProductRelation::model()->find('price_group_id=:price_group_id AND store_id=:store_id', array(
                    ':price_group_id' => $baseGroup->id, ':store_id' => $model_store->id
                ));
                if ($p == null) {
                    $temp_p->price_group_id = $baseGroup->id;
                    $temp_p->pricing_product_class_id = $model_store->product_class_id;
                    $temp_p->store_id = $model_store->id;
                    $temp_p->rate = $model_store->rate;
                    $temp_p->save(false);
                }
                PricingGroup::reCalculatePricing($model_store->id);

                $jsonData['store'] = $model_store;
                if ($model_store->non_stock_item == "N") {
                    $model_inventory->stock_id = $model_location->stock_id = $model_store->id;
                    if ($scenario == "add") {
                        $model_location->company_branch_id = Yii::app()->user->master_user_branch_id;
                        $model_location->save();
                        $model_location->refresh();
                        $jsonData['LocationDetails'] = $model_location;
                        $model_inventory->default_warehouse_id = $model_location->id;
                    }
                    ($scenario == "add") ?
                                    $model_inventory->save() :
                                    $model_inventory->updateByPk($model_store->id, $model_inventory->attributes);
                    $model_inventory->refresh();
                    $jsonData['InventoryItems'] = $model_inventory;
                }
                $jsonData['status'] = 'success';
                Yii::app()->session['stock_id'] = $model_store->id;
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            } else {
                if ($model_store->non_stock_item == "N") {
                    $error = CActiveForm::validate(array($model_store, $model_inventory, $model_location), '', false);
                }
                else
                    $error = CActiveForm::validate($model_store, '', false);
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionSetinventryitem() {
        Yii::app()->session['inventry_item_id'] = (int) $_POST['id'];
        Yii::app()->end();
    }

    public function actionGetInventoryItem() {
        $jsondata['store'] = Store::model()->with('inventory')->findByPk((int) $_POST['id']);
        $jsondata['unit'] = Unit::model()->findbypk($jsondata['store']->unit_id);
        $jsondata['country'] = MasCountry::model()->findbypk($jsondata['store']->country);
        $jsondata['tax'] = MasInvTax::model()->findbypk($jsondata['store']->tax_code);
        $jsondata['taxdetails'] = $jsondata['tax']->tax_code . ':' . $jsondata['tax']->percentage . '%';
        $jsondata['inventoryitem'] = $jsondata['store']->inventory;
        $jsondata['total_qty'] = $jsondata['store']->non_stock_item == "Y" ? 1 : $jsondata['store']->total_quantity;
        $jsondata['productclass'] = $jsondata['store']->productclass;
        $jsondata['open_rate_for_edit'] = $jsondata['store']->IsProductHasHistory;
        Yii::app()->session['stock_id'] = (int) $_POST['id'];
        echo CJSON::encode($jsondata);
    }

    public function actionSaveLocationDetails() {
        if (($_POST['ProductLocation']['quantity'] ) > 0)
            $_POST['ProductLocation']['quantity'] = $_POST['ProductLocation']['quantity'];
        else
            $_POST['ProductLocation']['quantity'] = 0;
        $row = ProductLocation::model()->find('stock_id=:stock_id AND warehouse_id=:warehouse_id', array(':stock_id' => $_POST['ProductLocation']['stock_id'], ':warehouse_id' => $_POST['ProductLocation']['warehouse_id']));
        if ($row != NULL) {
            $_POST['ProductLocation']['id'] = $row->id;
            $_POST['ProductLocation']['quantity'] = $row->quantity;
        }
        $this->commonSave('ProductLocation');
    }

    public function actionGetlocationdetails() {
        $jsonData['location'] = ProductLocation::model()->findByPk((int) $_POST['id']);
        $jsonData['warehouse'] = MasInvWarehouse::model()->findbypk($jsonData['location']->warehouse_id);
        $jsonData['rack'] = MasInvRack::model()->findbypk($jsonData['location']->rack);
        $jsonData['bin'] = MasInvBin::model()->findbypk($jsonData['location']->bin);
        $stock_id = $jsonData['location']->stock_id;
        Yii::app()->session['stock_id'] = (int) $stock_id;
        $store_data = Store::model()->findByPk((int) $stock_id);
        $jsonData['total_value'] = $store_data->total_value;
        $jsonData['status'] = 'success';
        echo CJSON::encode($jsonData);
    }

    public function actionDeallocate($id) {
        AllocatedMaterial::model()->deleteByPK((int) $id);
    }

    public function actionSavematerialmovementissue() {

        echo "not ready";
    }

    public function actionGetwarehouse() {
        $this->autocompleteData('MasInvWarehouse', array('name'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actionGetbin() {
        $this->autocompleteData('MasInvBin', array('name'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actionGetrack() {
        $this->autocompleteData('MasInvRack', array('name'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actionGetUnit() {
        $this->autocompleteData('Unit', array('unit_name'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actionGettax() {
        // $this->autocompleteData('MasInvTax', array('tax_code'), $_GET['term'], false, Yii::app()->user->master_user_company_id, Yii::app()->user->master_user_branch_id);
        $data = array();
        $tax_term = $_GET['term'];
        $model = new MasInvTax;
        $condition = ' tax_code LIKE "%' . $tax_term . '%"';
        $condition .=' AND company_id=' . Yii::app()->user->master_user_company_id;
        // $condition .=' AND company_branch_id=' . Yii::app()->user->master_user_branch_id;
        $model = $model->findAll(array('condition' => $condition));
        $i = 0;
        foreach ($model as $eachModel) {
            $data[$i]['value'] = $eachModel->id;
            $data[$i]['label'] = $eachModel->tax_code . ':' . $eachModel->percentage . '%';
            $i++;
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionGetwarehousefortransfer() {
        $data = array();
        $warehouse_term = $_GET['term'];
        $product_id = $_GET['product_id'];
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $_GET['product_id']));

        $warehouse_ids = array();
        foreach ($warehouses as $warehouse) {
            $warehouse_ids[] = $warehouse->warehouse_id;
        }
        $model = new MasInvWarehouse;
        $condition = ' name LIKE "%' . $warehouse_term . '%"';
        $condition .=' AND company_id=' . Yii::app()->user->master_user_company_id;
        // $condition .=' AND company_branch_id=' . Yii::app()->user->master_user_branch_id;
        $model = $model->findAll(array('condition' => $condition));
        $i = 0;
        foreach ($model as $eachModel) {
            if (in_array($eachModel->id, $warehouse_ids)) {
                $data[$i]['value'] = $eachModel->id;
                $data[$i]['label'] = $eachModel->name;
            }
            $i++;
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionGetbinbyrackwise() {
        $data = array();
        $bin_term = $_GET['term'];
        $rack_id = $_GET['rack_id'];
        // $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id'=>$_GET['product_id']));
//         $warehouse_ids = array();
//         foreach($warehouses as $warehouse){
//             $warehouse_ids[] = $warehouse->warehouse_id;
//         }        
        $model = new MasInvBin;
        $condition = ' name LIKE "%' . $bin_term . '%"';
        $condition .=' AND rack_id=' . $rack_id;
        $condition .=' AND company_id=' . Yii::app()->user->master_user_company_id;
        // $condition .=' AND company_branch_id=' . Yii::app()->user->master_user_branch_id;
        $model = $model->findAll(array('condition' => $condition));
        $i = 0;
        foreach ($model as $eachModel) {
            $data[$i]['value'] = $eachModel->id;
            $data[$i]['label'] = $eachModel->name;
            $i++;
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionSaveInventoryGoodsIssue($modelName = "InventoryGoodsIssue", $from = "I_GI") {
        if (isset($_POST["InventoryGoodsIssue"])) {
            $model = new $modelName;
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $itemModel = $modelName . 'Item';
            $other_errors = array();
            foreach ($attributes_items as $i => $item) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
                $thisProduct = Store::model()->findByPK($attributes_items[$i]['product_id']);
                if ((int) $_POST['InventoryGoodsIssue']['id'] == 0) {
                    //if ($thisProduct->rate != 0) {
                        $availableQty = $thisProduct->total_quantity - $thisProduct->total_allocated_quantity;
                        if ($availableQty < $attributes_items[$i]['picked_qty']) {
                            $other_errors[] = "Item " . $thisProduct->part_number . " available only " . $availableQty . ' Nos.';
                            $valid = false;
                        }
                   /* } else {
                        $other_errors[] = "Item " . $thisProduct->part_number . " is not available ";
                        $valid = false;
                    }*/
                }
            }

            if ($model->validate() && $valid) { // after validation saving the whole data
                $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
                // $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                if ((int) $_POST['InventoryGoodsIssue']['id'] != 0)
                    $model->id = $_POST['InventoryGoodsIssue']['id'];
                if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one             
                    $model->save();
                else {
                    $model->updateByPK($model->id, $model->attributes);
                    $item = $itemModel::model()->findAll($refer_id . '=:id', array(':id' => $model->id));
                    foreach ($item as $eachItem)
                        $this->IncreaseCountFromInventory($eachItem);
                    //WorkingProgress::model()->deleteAll('production_goods_issue_id=:id', array(':id' => $model->id));
                    $itemModel::model()->deleteAll($refer_id . '=:id', array(':id' => $model->id));
                }
                $itemorderd = $picked = $itempicked = 0;
                foreach ($modelItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    // $this->WorkingProgress($eachItem, $model);
                    $this->ReduceCountFromInventory($eachItem);
                }
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error3 = array();
                $error4 = array();
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function IncreaseCountFromInventory($purchaseItem) {
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $purchaseItem['product_id']));
        foreach ($warehouses as $eachWareHouse) {
            $eachWareHouse->quantity += $purchaseItem->picked_qty;
            $eachWareHouse->save();
            break;
        }
    }

    public function ReduceCountFromInventory($purchaseItem) {
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $purchaseItem['product_id']));
        foreach ($warehouses as $eachWareHouse) {
            if ($purchaseItem['picked_qty'] < $eachWareHouse->quantity) {
                $eachWareHouse->quantity -= $purchaseItem['picked_qty'];
                $purchaseItem['picked_qty'] = 0;
                $eachWareHouse->save();
                break;
            } else {
                $purchaseItem['picked_qty']-=$eachWareHouse->quantity;
                $eachWareHouse->quantity = 0;
                $eachWareHouse->save();
            }
        }
    }

    public function ReduceGoodsReceiptInInventory($eachItem) {
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $purchaseItem[0]['product_id']));
        foreach ($warehouses as $eachWareHouse) {
            if ($purchaseItem[0]['picked_qty'] < $eachWareHouse->quantity) {
                $eachWareHouse->quantity -= $purchaseItem[0]['picked_qty'];
                $purchaseItem[0]['picked_qty'] = 0;
                $eachWareHouse->save();
                break;
            } else {
                $purchaseItem[0]['picked_qty']-=$eachWareHouse->quantity;
                $eachWareHouse->quantity = 0;
                $eachWareHouse->save();
            }
        }
    }

    public function actionSaveGoodsReceipt($modelName = "InventoryGoodsReceipt", $from = "I_GR") {
        $model = new $modelName;
        $attributes_main = $_POST[$modelName];
        $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
        $model->attributes = $attributes_main;
        $model->crm_user_id = Yii::app()->user->id;
        $valid = true;
        $itemModel = $modelName . 'Item';
        $other_errors = array();
        foreach ($attributes_items as $i => $item) {
            $modelItem[$i] = new $itemModel;
            $modelItem[$i]->attributes = $attributes_items[$i];
            $valid = $modelItem[$i]->validate() && $valid;
        }
        if ($model->validate() && $valid) { // after validation saving the whole data
            $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
            $this->documents($model->file_id, $from);
            $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
            $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
            if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one
                $model->save();
            else {
                $model->updateByPK($model->id, $model->attributes);
                $item = $itemModel::model()->findAll($refer_id . '=:id', array(':id' => $model->id));
                // foreach ($item as $eachItem)
                $this->ReduceGoodsReceiptInInventory($item);
                //WorkingProgress::model()->deleteAll('production_goods_issue_id=:id', array(':id' => $model->id));
                $itemModel::model()->deleteAll($refer_id . '=:id', array(':id' => $model->id));
            }
            $itemorderd = $picked = $itempicked = $grand_total = 0;
            foreach ($modelItem as $eachItem) {
                $eachItem->{$refer_id} = $model->id;
                $eachItem->save(false);
                $this->IncreaseCountFromInventory($eachItem);
            }
            $jsonData['file'] = $model->file;
            $jsonData['model'] = $model;
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
            //Yii::app()->end();
        } else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
            $error3 = array();
            $error4 = array();
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
            if ($error != '[]')
                echo $error;
        }
    }

    public function actionGetGoodsIssue() {
        $jsondata['model'] = InventoryGoodsIssue::model()->findByPk((int) $_POST['id']);
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $items = InventoryGoodsIssueItem::model()->findAll('inventory_goods_issue_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array('value' => $model->picked_qty)) .
                    CHtml::error($model, "[$i]picked_qty") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->unit)) .
                    CHtml::error($model, "[$i]unit") . '</td>                          
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#inventoryGoodsIssue_item_table"), this);')) . '</td>
           </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function actionGetGoodsReceipt() {
        $jsondata['model'] = InventoryGoodsReceipt::model()->findByPk((int) $_POST['id']);
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $items = InventoryGoodsReceiptItem::model()->findAll('inventory_goods_receipt_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array('value' => $model->picked_qty)) .
                    CHtml::error($model, "[$i]picked_qty") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->unit)) .
                    CHtml::error($model, "[$i]unit") . '</td>                          
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#inventoryGoodsReceipt_item_table"), this);')) . '</td>
           </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function actionSaveInventoryTransfer() {
        if (isset($_POST['InventoryTransfer'])) {
            $model = new InventoryTransfer;
            $model->attributes = $_POST['InventoryTransfer'];
            if ($model->validate()) {
                if ($model->from_warehouse_id != $model->to_warehouse_id) {
                    $tot = Yii::app()->db->createCommand()
                            ->select('sum(quantity) as total_quantity')
                            ->from('{{product_location}}')
                            ->where('warehouse_id = ' . (int) $model->from_warehouse_id . ' AND stock_id=' . (int) $model->stock_id)
                            ->queryRow();
                    $towarehouserow = ProductLocation::model()->find('stock_id=:stock_id AND warehouse_id=:warehouse_id', array(':stock_id' => $model->stock_id, ':warehouse_id' => $model->to_warehouse_id));
                    if ($tot['total_quantity'] >= $model->quantity) {
                        $from = ProductLocation::model()->find('warehouse_id=:warehouse_id AND stock_id=:stock_id', array(
                            ':warehouse_id' => $model->from_warehouse_id,
                            ':stock_id' => $model->stock_id
                        ));

                        $transferable_quantity = $model->quantity;
                        if ($from->quantity >= $transferable_quantity) {
                            $new_quantity = $from->quantity - $transferable_quantity;
                            ProductLocation::model()->updateByPK($from->id, array('quantity' => $new_quantity));
                            $add_quantity = $towarehouserow->quantity + $transferable_quantity;

                            if ($towarehouserow != null)
                                ProductLocation::model()->updateByPK($towarehouserow->id, array('quantity' => $add_quantity));
                            else {
                                $modelProductLocation = new ProductLocation;
                                $modelProductLocation->stock_id = $model->stock_id;
                                $modelProductLocation->warehouse_id = $model->to_warehouse_id;
                                $modelProductLocation->quantity = $transferable_quantity;
                                $modelProductLocation->company_branch_id = Yii::app()->user->master_user_branch_id;
                                $modelProductLocation->save(false);
                            }
                            $model->transfer_date = date('Y-m-d');
                            $model->save();
                            $jsonData['status'] = 'success';
                            echo CJSON::encode($jsonData);
                        }
                    } else {
                        $jsonData['status'] = 'error';
                        $jsonData['errorQ'] = 'Transferable quantity is greater than actual quantity(Only ' . $tot['total_quantity'] . ' available in from warehouse)';
                        echo CJSON::encode($jsonData);
                    }
                } else {
                    $jsonData['status'] = 'error';
                    $jsonData['errorQ'] = 'You can not transfer items between same warehouses, please select different warehouses!';
                    echo CJSON::encode($jsonData);
                }
            } else {
                $error = CActiveForm::validate($model, '', false);
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionMaterialDistribution() {
        if (isset($_POST['InventoryMaterialDistribution'])) {
            $model = new InventoryMaterialDistribution;
            $model->attributes = $_POST['InventoryMaterialDistribution'];
            $model->done_by = Yii::app()->user->id;
            $model->done_date = date('Y-m-d');
            if ($model->validate()) {


                $total_available_quantity = Yii::app()->db->createCommand()
                        ->select('sum(quantity) as total_quantity')
                        ->from('{{product_location}}')
                        ->where('warehouse_id = ' . (int) $model->from_warehouse_id . ' AND stock_id=' . (int) $model->from_store_id)
                        ->queryRow();

                if ($total_available_quantity['total_quantity'] >= $model->from_quantity) {

                    //to item needs to decresed by one
                    $from = ProductLocation::model()->with('stock')->find('warehouse_id=:warehouse_id AND stock_id=:stock_id', array(':warehouse_id' => $model->from_warehouse_id, ':stock_id' => $model->from_store_id));
                    $new_quantity = $from->quantity - $model->from_quantity;
                    ProductLocation::model()->updateByPK($from->id, array('quantity' => $new_quantity));
                    //to item needs to decresed by one^


                    $strore_destination = Store::model()->findByPK($model->to_store_id);
                    $from_value = $model->from_quantity * $from->stock->rate; //10pcs value
                    $from_rate = $from_value / $model->quantity;

                    $total_existing_value = $strore_destination->total_quantity * $strore_destination->rate;
                    $total_distributed_value = ($model->quantity / $from_rate) * $model->quantity;
                    $strore_destination->rate = ($total_existing_value + $total_distributed_value) / ($strore_destination->total_quantity + $model->quantity);
                    $strore_destination->save(false);
                    //from item needs to add by quantity, and rate to be adjusted
                    $towarehouserow = ProductLocation::model()->with('stock')->find('stock_id=:stock_id AND warehouse_id=:warehouse_id', array(':stock_id' => $model->to_store_id, ':warehouse_id' => $model->to_warehouse_id));
                    if ($towarehouserow != null) {
                        $model->quantity += $towarehouserow->quantity;
                        ProductLocation::model()->updateByPK($towarehouserow->id, array('quantity' => $model->quantity));
                    } else {
                        $modelProductLocation = new ProductLocation;
                        $modelProductLocation->stock_id = $model->to_store_id;
                        $modelProductLocation->warehouse_id = $model->to_warehouse_id;
                        $modelProductLocation->quantity = $model->quantity;
                        $modelProductLocation->company_branch_id = Yii::app()->user->master_user_branch_id;
                        $modelProductLocation->save(false);
                    }

                    $model->save();
                    $jsonData['status'] = 'success';
                } else {
                    $jsonData['error'] = 'Sorry item is not available now';
                }
            } else {
                echo CActiveForm::validate($model, '', false);
                Yii::app()->end();
            }
            echo CJSON::encode($jsonData);
            Yii::app()->end();
        }
    }

}