<?php

class PurchasingController extends Controller {
    /* ^########################################### Purchasing Requisition ############################################^ */

    public function actionSaveRequisition() {
        if (isset($_POST["PurchasingRequisition"])) {
            $this->saveSopPurchase("PurchasingRequisition", "P_R");
        }
    }

    public function actionGetRequisition() {
        $this->getData("PurchasingRequisition", $table = "purchasingRequisition");
    }

    public function actionConvertRequisition() {
        $this->getData("PurchasingRequisition", $table = "purchasingEnquiry", $to = "PurchasingEnquiry", $convert = true);
    }

    /* ^########################################### Purchasing Requisition ############################################^ */
    /* ^########################################### Purchasing Enquiry ############################################^ */

    public function actionSaveEnquiry($modelName = "PurchasingEnquiry", $from = "P_E") {
        if (isset($_POST["PurchasingEnquiry"])) {
            if (is_array($_POST["PurchasingEnquiry"]["vendor_id"]))
                $_POST["PurchasingEnquiry"]["vendor_id"] = implode(',', $_POST["PurchasingEnquiry"]["vendor_id"]);
            $this->saveSopPurchase("PurchasingEnquiry", "P_E");
            if ($_POST["PurchasingEnquiry"]["send_email"] == "N")
                $this->sendemail();
        }
    }

    public function sendemail() {
        

           
        // $vendor = Company::model()->findByPk($_POST["PurchasingEnquiry"]["vendor_id"]);
        $mastercompany = MasCompany::model()->findByPk(Yii::app()->user->master_user_company_id);
        //$_POST["PurchasingEnquiry"]["vendor_id"] = CJSON::decode($_POST["PurchasingEnquiry"]["vendor_id"]);
        $_POST["PurchasingEnquiry"]["vendor_id"] = explode(',', $_POST["PurchasingEnquiry"]["vendor_id"]);
        foreach ($_POST["PurchasingEnquiry"]["vendor_id"] as $id) {
            $vendor = Company::model()->findByPk($id);
            $mailContent = array();
            $model = new PurchasingEnquiryItem;
            $mailContent['body'] = "<p>Hi Administrator</p>
                        <p>An Enquiry came from " . $mastercompany->company_name . "</p>
                        <p>Enquiry Date: " . $eachitem['enquiry_date'] . "</p>
                        <p>Enquiry Details: " . $eachitem['note'] . "</p>
                        <b><p>Product Details:";
            foreach ($_POST["PurchasingEnquiryItem"] as $eachitem) {
                $mailContent['body'].=
                        '  <tr>
            <th>Sl No</th><th>Product</th><th>Description</th><th>Required Qty</th></tr><tr>
            <td  class="cell-center><label>' . ($i + 1) . '</label></td>
            <td  class="cell-center><label>' . $eachitem['product_name'] . '</label></td>
            <td  class="cell-center><label>' . $eachitem['description'] . '</label></td>
            <td  class="cell-center><label>' . preg_replace('/\s\d+\.00/', '', floatval($eachitem['quantity'])) . '</label></td></tr>';
            }
            $message = new YiiMailMessage;
            $message->view = 'emailTemp';
            $message->setBody(array('mailContent' => $mailContent), 'text/html');
            $message->subject = 'Purchasing Enquiry';
            $message->from = 'noreply@cumuluscrm.us';
            //$message->addTo($vendor->general_email); 
            $message->addTo("remyapmbluesky@gmail.com");
            Yii::app()->mail->send($message);
        }
    }

    public function actionConvertEnquiry() {
        $this->getData("PurchasingEnquiry", $table = "purchasingOrder", $to = "PurchasingOrder", $convert = true);
    }

    public function actionGetEnquiry() {
        $this->getData("PurchasingEnquiry", $table = "purchasingEnquiry");
    }

    /* ^########################################### Purchasing Enquiry ############################################^ */
    /* ^########################################### Purchasing order ############################################^ */

    public function actionSavePurchasingorder($modelName = "PurchasingOrder", $from = "P_O") {
        if (isset($_POST["PurchasingOrder"])) {
            if ((int) $_POST["PurchasingOrder"]["file_id"] != 0) {
                $masterfile = MasterFile::model()->findByPK((int) $_POST["PurchasingOrder"]["file_id"]);
                if ($masterfile->current_process_status != 'P_O') {
                    if ($masterfile->current_process_status != 'P_E') {
                        $jsonArrray['saveerror'] = "Saving not possible";
                        echo CJSON::encode($jsonArrray);
                        Yii::app()->end();
                    }
                }
            }
            $model = new $modelName;
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
            $attributes_additions = @$_POST[$modelName . 'Addition'];
            $attributes_deductions = @$_POST[$modelName . 'Deduction'];
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $itemModel = $modelName . 'Item';
            $other_errors = array();
            foreach ($attributes_items as $i => $item) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
                if ($attributes_items[$i]['product_id'] == 0) {
                    $other_errors[] = "There is a new product in the purchase order(line number:" . ($i + 1) . ").First enter the product details in inventory.Then select the product";
                    $valid = false;
                }
                if (Store::model()->findByPk($attributes_items[$i]['product_id'])->non_stock_item == "Y") {
                    $other_errors[] = "There is a Non Stock Item in the purchase order(Item:" . Store::model()->findByPk($attributes_items[$i]['product_id'])->part_number . " line number:" . ($i + 1) . ").Please Avoid Purchasing Non Stock Item";
                    $valid = false;
                }
            }
            $itemAdditionModel = $modelName . 'Addition';
            $itemDeductionModel = $modelName . 'Deduction';
            foreach ($attributes_additions as $i => $item) {
                $modelAdditionItem[$i] = new $itemAdditionModel;
                $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
                $valid = $modelAdditionItem[$i]->validate() && $valid;
            }
            foreach ($attributes_deductions as $i => $item) {
                $modelDeductionItem[$i] = new $itemDeductionModel;
                $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
                $valid = $modelDeductionItem[$i]->validate() && $valid;
            }
            if ($model->validate() && $valid) { // after validation saving the whole data
                $company_id = 0;
                if ($model->hasAttribute('vendor_id') && !empty($model->vendor_id))
                    $company_id = $model->vendor_id;
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, $company_id, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
                $this->documents($model->file_id, $from);
                $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                if ((int) $model->id == 0)
                    $model->save();
                else {
                    $model->updateByPK($model->id, $model->attributes);
                    $itemModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemAdditionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemDeductionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                }
                $model->refresh();
                $grand_total = 0;
                foreach ($modelItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->amount;
                }
                foreach ($modelAdditionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->calculated_value;
                }
                foreach ($modelDeductionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total -= $eachItem->calculated_value;
                }
                $model->updateByPk($model->id, array('grand_total' => $grand_total));
                if (in_array($modelName, array("PurchasingOrder")))
                    $this->masterFile($model->file_id, $model->file->current_process_status, $model->file->file_title, $model->file->company_id, $model->file->lead_owner_id, "Y");
                $requisition = PurchasingRequisition::model()->find(array('condition' => 'file_id=' . (int) $_POST["PurchasingOrder"]["file_id"]));
                if ($requisition != null && !in_array($requisition->status, array("C")))
                    $requisition->updateByPk($requisition->id, array('status' => 'C'));
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error3 = array();
                $error4 = array();
                if (in_array($modelName, array("Quotes", "Order"))) {
                    $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);
                    $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
                }
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetConnectedFiles() {
        $this->getFiles(array("O", "Q"));
    }

    public function actionConnectedFiles() {
        $jsonArrray['file'] = MasterFile::model()->findByPK((int) $_POST['connected_file_id']);
        echo CJSON::encode($jsonArrray);
    }

    public function actionVendordetails() {
        $jsonArrray['vendor'] = Company::model()->findByPK((int) $_POST['vendor_id']);
        $jsonArrray['paymentterm'] = $jsonArrray['vendor']->paymentTerm;
        if ($jsonArrray['vendor']->currency != 0)
            $jsonArrray['currency'] = MasCurrency::model()->findByPk($jsonArrray['vendor']->currency);
        else
            $jsonArrray['currency'] = '';
        $contact = CompanyContact::model()->findAll('company_id=:ID', array(':ID' => (int) $_POST['vendor_id']));
        $contact = CHtml::listData($contact, 'id', 'person_name');
        foreach ($contact as $value => $name)
            $jsonArrray['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        if (is_array($jsonArrray['contacts']))
            $jsonArrray['contacts'] = implode('', $jsonArrray['contacts']);

        $condition = 'isActive =  "Y" ';
        $currencylist1 = MasCurrency::model()->findAll(array('condition' => $condition, 'order' => 'currency'));
        $currencylist1 = CHtml::listData($currencylist1, 'id', 'currency');
        foreach ($currencylist1 as $value => $name)
            $jsonArrray['currencylist'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        if (is_array($jsonArrray['currencylist']))
            $jsonArrray['currencylist'] = implode('', $jsonArrray['currencylist']);

        echo CJSON::encode($jsonArrray);
    }

    public function actionGetVendors() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'company.isActive =  "Y" and companyType.type in ("V") AND (company.company_name like "%' . $_GET['term'] . '%")';
            $condition .=' AND own_company_id=' . Yii::app()->user->master_user_company_id . ' AND own_branch_id=' . Yii::app()->user->master_user_branch_id;
            $model = CompanyTypeRelation::model()->with(array('companyType', 'company'))->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->company_id;
                $data_array[$i]['label'] = $eachModel->company->company_name;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionPurchaseorder() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'file.current_process_status in ("P_O","P_MR","P_PI")';
            $model = PurchasingOrder::model()->with(array('file', 'materialReceipt'))->findAll(array('condition' => $condition, 'order' => 't.id DESC'));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->id;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionGetproject() {
        $this->autocompleteData('MasProject', array('project_title'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actionProjectdetails() {
        $jsonArrray['project'] = MasProject::model()->findByPK((int) $_POST['project']);
        echo CJSON::encode($jsonArrray);
    }

    public function actionGetPurchasingorder() {
        $this->getData("PurchasingOrder", $table = "purchasingOrder");
    }

    public function actionPurchaseorderdetails() {
        $jsondata['model'] = PurchasingOrder::model()->find('id=:p_id', array(':p_id' => (int) $_POST['po_id']));
        $items = PurchasingOrderItem::model()->findAll('purchasing_order_id=:ID', array(':ID' => $jsondata['model']->id));
        $jsondata['vendor'] = Company::model()->findByPk($jsondata['model']->vendor_id);
        $jsondata['model_items'] = '';
        foreach ($items as $i => $model) {
            $product = Store::model()->findByPk($model->product_id);
            $unit = Unit::model()->findByPk($product->unit_id);
            $temp = new PurchasingMaterialreceiptItem;
            $temp->attributes = $model->attributes;
            $model = $temp; // replace qcchecked_quantity by received qty
            $condition = 'pm.po_id=' . (int) $_POST['po_id'] . ' AND pmItems.product_id=' . $model->product_id;
            $itemDelivered = Yii::app()->db->createCommand()
                    ->select('sum(pmItems.qcchecked_quantity) as qc_qty')
                    ->from('{{purchasing_material_receipt}} pm')
                    ->join('{{purchasing_material_receipt_item}} pmItems', 'pm.id=pmItems.purchasing_materialreceipt_id')
                    ->where($condition)
                    ->queryRow();
            /* $itemDelivered = Yii::app()->db->createCommand()
              ->select('sum(pmItems.received_quantity) as rcv_qty')
              ->from('{{purchasing_material_receipt}} pm')
              ->join('{{purchasing_material_receipt_item}} pmItems', 'pm.id=pmItems.purchasing_materialreceipt_id')
              ->where($condition)
              ->queryRow(); */
            $remainigquantity = $model->quantity - $itemDelivered['qc_qty'];

            if ($remainigquantity > 0) {
                $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td class="cell-left">' . $product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array('readonly' => true, 'class' => 'description product-search', 'value' => $product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array('readonly' => true, 'class' => 'description')) . '</td>
            <td>' . preg_replace('/\s\d+\.00/', '', floatval($model->quantity)) . CHtml::activeHiddenField($model, "[$i]quantity", array('readonly' => true, 'value' => $model->quantity, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)',)) . '</td>
           <td>' . preg_replace('/\s\d+\.00/', '', floatval($remainigquantity)) . CHtml::activeHiddenField($model, "[$i]remaining_quantity", array('value' => $remainigquantity, 'readonly' => true, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)',)) . '</td>
            <td>' . $unit->unit_name . CHtml::activeHiddenField($model, "[$i]unit", array('readonly' => true, 'value' => $unit->unit_name)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]received_quantity", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'this.value = checkQCCheckedQuantity(event,this.value,' . $remainigquantity . ')')) . '</td>
            <td>' . preg_replace('/\s\d+\.00/', '', floatval($model->qcchecked_quantity)) . CHtml::activeHiddenField($model, "[$i]qcchecked_quantity", array('readonly' => true)) . '</td>            
            <td>' . CHtml::activeTextField($model, "[$i]country_of_origin") . '</td>
           <td>' . CHtml::activeDropDownList($model, "[$i]warehouse", MasInvWarehouse::getWarehouses(), array('options' => array($product->inventory->default_warehouse_id => array('selected' => true)), 'style' => 'width:70px !important;')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]incomming_shipment_ref") . '</td>
           </tr>';
            }
        }
        echo CJSON::encode($jsondata);
    }

    /* <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#purchasingMaterialreceipt_item_table"), this);')) . '</td> */

    /* ^########################################### Purchasing Materialreceipt ############################################^ */

    public function actionSaveMaterialreceipt($from = "P_MR") {
        if (isset($_POST["PurchasingMaterialreceipt"])) {
            //print_r($_POST["PurchasingMaterialreceiptItem"]);
            //die();
            $model = new PurchasingMaterialreceipt;
            $attributes_main = $_POST["PurchasingMaterialreceipt"];
            $attributes_items = isset($_POST["PurchasingMaterialreceiptItem"]) ? $_POST["PurchasingMaterialreceiptItem"] : array(0);
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $other_errors = array();
            foreach ($attributes_items as $i => $item) {
                if ($attributes_items[$i]['product_id'] != null) {
                    $modelItem[$i] = new PurchasingMaterialreceiptItem;
                    $modelItem[$i]->attributes = $attributes_items[$i];
                    $valid = $modelItem[$i]->validate() && $valid;
                    if ((int) $attributes_items[$i]['received_quantity'] <= (int) $attributes_items[$i]['remaining_quantity'])
                        $valid = $valid && true;
                    else {
                        if ($attributes_items[$i]['qcchecked_quantity'] != 0)
                            $other_errors[] = "Quality check Quantity Error on " . $attributes_items[$i]['product_name'] . ".Enter material received count correctly";
                        else
                            $other_errors[] = "Received Quantity must be less than Balance Quantity ";
                        $valid = $valid && false;
                    }
                    if ($attributes_items[$i]['received_quantity'] < $attributes_items[$i]['qcchecked_quantity']) {
                        $other_errors[] = "QC Quantity must be less than Received Quantity ";
                        $valid = $valid && false;
                    }
                }
            }
            if ((int) $_POST['PurchasingMaterialreceipt']['id'] != 0) { //material recipt editing is not happening
                $materialreceipt = PurchasingMaterialreceipt::model()->findByPk((int) $_POST['PurchasingMaterialreceipt']['id']);
                if ($materialreceipt->qcchecked == 'Y') {
                    $other_errors[] = "Editing Material receipt after quality check is not possible";
                    $valid = false;
                } else if ((int) $_POST['PurchasingMaterialreceipt']['qc']) {
                    $model->scenario = 'qualitycheck';
                }
            }
            if ($model->validate() && $valid) {
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                if ((int) $_POST['PurchasingMaterialreceipt']['id'] != 0)
                    $model->id = $_POST['PurchasingMaterialreceipt']['id'];
                if ((int) $model->id == 0) {
                    $model->save();
                } else {
                    $qcstatus = PurchasingMaterialreceipt::model()->findByPk($model->id);
                    $model->updateByPK($model->id, $model->attributes);
                    PurchasingMaterialreceiptItem::model()->deleteAll('purchasing_materialreceipt_id=:id', array(':id' => $model->id));
                }
                $itemorderd = $itemqcchecked = $qc = 0;
                foreach ($modelItem as $eachItem) {
                    $eachItem->{'purchasing_materialreceipt_id'} = $model->id;
                    $itemorderd+=$eachItem->quantity;
                    $eachItem->save(false); //replace qcchecked_quantity by received qty
                    $condition = 'pm.po_id=' . $model->po_id . ' AND pmItems.product_id=' . $eachItem->product_id;
                    $qcchecked = Yii::app()->db->createCommand()
                            ->select('sum(pmItems.qcchecked_quantity) as qc_qty')
                            ->from('{{purchasing_material_receipt}} pm')
                            ->join('{{purchasing_material_receipt_item}} pmItems', 'pm.id=pmItems.purchasing_materialreceipt_id')
                            ->where($condition)
                            ->queryRow();
                    $itemqcchecked+=$qcchecked['qc_qty'];
                    if ($eachItem->qcchecked_quantity != 0 && $qcstatus->qcchecked != 'Y') {
                        $qc = 1;
                        $this->inventoryUpdate($eachItem);
                    }
                }
                if ($qc == 1)
                    $model->updateByPk($model->id, array('qcchecked' => 'Y'));
                $total_orderd_quantity_for_this_po = $model->purchaseorder->netQuantity;
                if ($total_orderd_quantity_for_this_po <= $itemqcchecked)
                    $this->masterFile($model->file_id, "M_R");
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            }
            else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function inventoryUpdate($purchaseItem) { //calling from actionSaveMaterialreceipt
        if ($purchaseItem->product_id != 0) {
            $product = Store::model()->findByPk($purchaseItem->product_id);
            if ($product != null) {
                $productlocation = ProductLocation::model()->find(array('condition' => 'stock_id=:stockID AND warehouse_id=:warehouseID', 'params' => array(':stockID' => $purchaseItem->product_id, ':warehouseID' => $purchaseItem->warehouse)));
                if ($productlocation != null) {
                    //new rate calculation
                    $purchaseorder = PurchasingOrder::model()->findByPk($purchaseItem->purchasingmatrialreceipt->po_id);
                    if ($purchaseorder->netTotal > 0) {
                        $addition_deduction = InventorySettings::model()->find()->include_freight_in_average_costing == "Y" ?
                                ($purchaseorder->adTotal - $purchaseorder->dedTotal) : 0;
                        $purchasedproduct = PurchasingOrderItem::model()->find(array('condition' =>
                            'product_id=:product_id AND purchasing_order_id=:po_id',
                            'params' => array(':product_id' => $purchaseItem->product_id, ':po_id' => $purchaseItem->purchasingmatrialreceipt->po_id)));
                        $productpercentage = $purchasedproduct->amount / $purchaseorder->netTotal;
                        $addition_deduction_by_product = $productpercentage * $addition_deduction;
                        $amount = $purchasedproduct->amount + $addition_deduction_by_product;
                        $rate = $amount / $purchasedproduct->quantity;
                        $rate *=$purchaseorder->exchange_rate;

                        $newtotal_value = $rate * $purchaseItem->qcchecked_quantity + $product->total_quantity * $product->rate;

                        $newrate = ($product->total_quantity > 0) ? ($newtotal_value / ($product->total_quantity + $purchaseItem->qcchecked_quantity)) : $rate;
                        $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value));
                        $arrayToBeUpdated['quantity'] = $purchaseItem->qcchecked_quantity + $productlocation->quantity;
                        $productlocation->updateByPk($productlocation->id, $arrayToBeUpdated);
                        PricingGroup::reCalculatePricing($product->id);
                    }
                } else {
                    $productLocation = new ProductLocation;
                    $productLocation->stock_id = $purchaseItem->product_id;
                    $productLocation->warehouse_id = $purchaseItem->warehouse;
                    $productLocation->company_branch_id = Yii::app()->user->master_user_branch_id;
                    $productLocation->quantity = $purchaseItem->qcchecked_quantity;
                    $productLocation->save(false);
                }
            }
        }
    }

    public function updateInventory($purchaseItem) { //called from actionSavePurchasingCredit
        $product = Store::model()->findByPk($purchaseItem->product_id);
        $purchasinginvoice = PurchasingInvoice::model()->findByPk($purchaseItem->purchasecredit->purchasing_invoice_id);
        $materialitem = PurchasingMaterialreceiptItem::model()->find(array('condition' => 'purchasing_materialreceipt_id=:ID AND product_id=:product_id', 'params' => array(':ID' => $purchaseItem->purchasing_materialreceipt_id, ':product_id' => $purchaseItem->product_id)));
        $productlocation = ProductLocation::model()->find(array('condition' => 'stock_id=:stockID AND warehouse_id=:warehouseID', 'params' => array(':stockID' => $purchaseItem->product_id, ':warehouseID' => $materialitem->warehouse)));
        if ($productlocation != null && ($productlocation->quantity != 0 || $product->rate != 0)) {
            $rate = $purchasinginvoice->exchange_rate * $purchaseItem->rate;
            $newtotal_value = $product->total_quantity * $product->rate - $rate * $purchaseItem->returned_quantity;
            $newcount = $product->total_quantity - $purchaseItem->returned_quantity;
            $newrate = $newtotal_value / $newcount;
            $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value));
            $arrayToBeUpdated['quantity'] = $productlocation->quantity - $purchaseItem->returned_quantity;
            $productlocation->updateByPk($productlocation->id, $arrayToBeUpdated);
            PricingGroup::reCalculatePricing($product->id);
        }
    }

    public function actionGetMaterialreceipt() {
        $this->getData("PurchasingMaterialreceipt", $table = "purchasingMaterialreceipt");
    }

    public function actionFetchMaterialreceipt() {
        foreach ($_POST['mrv_no'] as $eachDNote)
            $mrv_nos[] = $eachDNote['value'];
        $selected_mrv_nos = implode(',', $mrv_nos);
        $purchaseorder = PurchasingOrder::model()->with('items')->find(array('condition' => 'file_id=' . (int) $_POST['file_id'], 'order' => 'items.id ASC'));
        $addition_deduction = InventorySettings::model()->find()->include_freight_in_average_costing == "Y" ? ($purchaseorder->adTotal - $purchaseorder->dedTotal) : 0;
        $modelPurchasingOrderItems = PurchasingOrderItem::model()->with('purchaseorder')->findAll(array('condition' => 'purchaseorder.file_id=' . (int) $_POST['file_id']));
        $jsonData = array();
        $jsonData['materialreceipts'] = $selected_mrv_nos;
        $jsonData['lastmaterialreceipts'] = PurchasingMaterialreceipt::model()->findByPk(end($mrv_nos));
        $total = 0;
        $jsonData['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Product</th>
            <th>Description</th>
            <th>Qty</th> 
            <th>Unit</th>
            <th>Rate</th>
            <th>Amount</th>
            <th>Additions</th>
            <th>Deductions</th>
            <th>Net</th>
            <th></th>
        </tr>';

        $i = 0;
        foreach ($modelPurchasingOrderItems as $j => $eachItem) {
            $model = new PurchasingInvoiceItem;
            $model->attributes = $eachItem->attributes;
            $model->quantity = PurchasingMaterialreceiptItem::model()->findBySql('select SUM(`qcchecked_quantity`) as `quantity` 
                from {{purchasing_material_receipt_item}}
                where product_id=' . $model->product_id . ' AND purchasing_materialreceipt_id in (' . $selected_mrv_nos . ')', array())->quantity;
            $model->quantity = $model->quantity > 0 ? $model->quantity : 0;
            if ($model->quantity != 0) {
                $temp_amount = $eachItem->rate * $model->quantity;
                $productpercentage = ($purchaseorder->netTotal > 0) ? ($temp_amount / $purchaseorder->netTotal) : 0;
                $addition_deduction_by_product = $productpercentage * $addition_deduction;
                $addition = $deduction = 0;
                if ($addition_deduction_by_product > 0)
                    $addition = $addition_deduction_by_product;
                else
                    $deduction = $addition_deduction_by_product;
                $model->amount = number_format($model->rate * $model->quantity, 2, '.', '');
                $model->net_amount = $model->amount + $addition - $deduction;
                $total += $model->net_amount;
                $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
                $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description', 'readonly' => 'true', 'value' => $model->product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description', 'readonly' => 'true', 'value' => $model->product->description)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('class' => 'cell-center', 'readonly' => 'true')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right amount-field to_be_calculated',
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                        CHtml::error($model, "[$i]rate") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'cell-right amount-field',
                            'onkeypress' => 'return isNumberKey(event)')) .
                        CHtml::error($model, "[$i]amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]addition_percentage", array('class' => 'cell-right',
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                        CHtml::error($model, "[$i]addition_percentage")
                        . ' ' . CHtml::activeTextField($model, "[$i]addition_amount", array('class' => 'cell-right additions', 'value' => $addition, 'readonly' => true)) .
                        CHtml::error($model, "[$i]addition_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]deduction_percentage", array('class' => 'cell-right',
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                        CHtml::error($model, "[$i]deduction_percentage")
                        . ' ' . CHtml::activeTextField($model, "[$i]deduction_amount", array('class' => 'cell-right deductions', 'value' => $deduction, 'readonly' => true)) .
                        CHtml::error($model, "[$i]deduction_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'cell-right amount-field', 'readonly' => true, 'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                        CHtml::error($model, "[$i]net_amount") . '</td>
                            </tr>';
                $jsonData['total'] +=$model->net_amount;
                $i++;
            }
        }
        //echo adItems
        $jsonData['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">' . $total . '</h2></td>
        </tr>';
        $addition = ($purchaseorder->netTotal > 0) ? (number_format(($total / $purchaseorder->netTotal) * $purchaseorder->adTotal, 2, '.', '')) : 0;
        $deduction = ($purchaseorder->netTotal > 0) ? (number_format(($total / $purchaseorder->netTotal) * $purchaseorder->dedTotal, 2, '.', '')) : 0;
        $jsonData['addition'] = '';
        $modelAddition = new PurchasingInvoiceAddition;
        foreach ($purchaseorder->adItems as $i => $eachAddition) {
            $eachAddition->calculated_value = ($purchaseorder->netTotal > 0) ? (number_format(($total / $purchaseorder->netTotal) * $eachAddition->calculated_value, 2, '.', '')) : 0;
            $eachAddition->particular_value = (!is_numeric($eachAddition->particular_value)) ? $eachAddition->particular_value : $eachAddition->calculated_value;
            $jsonData['addition'].='<tr><td></td><td colspan="10" class="cell-right">Additions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#purchasingInvoice_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($modelAddition, "[$i]particular", array('value' => $eachAddition->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($modelAddition, "[$i]particular_value", array('value' => $eachAddition->particular_value,
                        'onkeyup' => 'calculateValues($(\'#purchasingInvoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($modelAddition, "[$i]calculated_value", array('value' => $eachAddition->calculated_value, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#purchasingInvoice_final_add_table\'), this)')) .
                    '</span></td></tr>';
        }
        $jsonData['deduction'] = '';
        $modelDeduction = new PurchasingInvoiceDeduction;
        foreach ($purchaseorder->dedItems as $i => $eachDeduction) {
            $eachDeduction->calculated_value = ($purchaseorder->netTotal > 0) ? (number_format(($total / $purchaseorder->netTotal) * $eachDeduction->calculated_value, 2, '.', '')) : 0;
            $eachDeduction->particular_value = (!is_numeric($eachAddition->particular_value)) ? $eachDeduction->particular_value : $eachDeduction->calculated_value;
            $jsonData['deduction'].='<tr><td></td><td colspan="10" class="cell-right">Deductions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#purchasingInvoice_final_ded_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($modelDeduction, "[0]particular", array('value' => $eachDeduction->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($modelDeduction, "[0]particular_value", array('value' => $eachDeduction->particular_value,
                        'onkeyup' => 'calculateValues($(\'#purchasingInvoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($modelDeduction, "[0]calculated_value", array('value' => $eachDeduction->calculated_value, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#purchasingInvoice_final_ded_table\'), this)')) .
                    '</span></td></tr>';
        }

        $gd_total = number_format($total + $addition - $deduction, 2, '.', '');
        $jsonData['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $gd_total . '</h1></td>
        </tr>';
        echo CJSON::encode($jsonData);
    }

    /* ^########################################### Purchasing Materialreceipt ############################################^ */
    /* ^########################################### Purchasing Invoice ############################################^ */

    public function actionSavePurchasingInvoice($modelName = "PurchasingInvoice", $from = "P_PI") {
        if (isset($_POST["PurchasingInvoice"])) {
            //print_r($_POST["PurchasingInvoice"]);
            //die();
            $model = new PurchasingInvoice;
            $model->attributes = $_POST["PurchasingInvoice"];
            $attributes_items = $_POST['PurchasingInvoiceItem'];
            $attributes_additions = @$_POST['PurchasingInvoiceAddition'];
            $attributes_deductions = @$_POST['PurchasingInvoiceDeduction'];
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            foreach ($attributes_items as $i => $item) {
                $modelItem[$i] = new PurchasingInvoiceItem;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
            }

            foreach ($attributes_additions as $i => $item) {
                $modelAdditionItem[$i] = new PurchasingInvoiceAddition;
                $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
                $valid = $modelAdditionItem[$i]->validate() && $valid;
            }

            foreach ($attributes_deductions as $i => $item) {
                $modelDeductionItem[$i] = new PurchasingInvoiceDeduction;
                $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
                $valid = $modelDeductionItem[$i]->validate() && $valid;
            }

            if ($model->validate() && $valid) {
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
                $this->documents($model->file_id, $from);
                if ((int) $_POST['PurchasingInvoice']['invoice_table_id'] == 0) {
                    $model->save();
                } else {
                    //$model->id = PurchasingInvoice::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                    $model->id = (int) $_POST['PurchasingInvoice']['invoice_table_id'];
                    $model->updateByPK($model->id, $model->attributes);
                    PurchasingInvoiceItem::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    PurchasingInvoiceAddition::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    PurchasingInvoiceDeduction::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                }
                $model->refresh();
                $grand_total = $picked_qty = $actual_qty = $invoiced_qty = 0;
                foreach ($modelItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $invoiced_qty+=$eachItem->quantity;
                    $grand_total += $eachItem->net_amount;
                }

                foreach ($modelAdditionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->calculated_value;
                }
                foreach ($modelDeductionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total -= $eachItem->calculated_value;
                }
                PurchasingMaterialreceipt::model()->updateAll(array('invoiced' => 'Y'), 'id in (' . $model->materialreceived . ')');
                // print_r($model);
                //die("xxx");
                $model->updateByPk($model->id, array('grand_total' => $grand_total));
                $orderedQuantity = $model->file->purchaseorder->netQuantity;
                $invoices = $model->file->purchaseinvoice;
                $inoicedQantity = 0;
                foreach ($invoices as $eachInvoice)
                    $inoicedQantity+=$eachInvoice->netQuantity;
                // print_r($orderedQuantity);
                // print_r("xxxxx");
                //print_r($inoicedQantity);
                // die();

                if ($orderedQuantity == $inoicedQantity)
                    $this->masterFile($model->file_id, "P_I");

                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);

                $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);
                $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetPurchaseInvoice() {
        $jsondata['model'] = PurchasingInvoice::model()->findByPk((int) $_POST['id']);
        $jsondata['paymentterms'] = MasPaymentTerm::model()->findByPK($jsondata['model']->payment_terms);
        $jsondata['vendor'] = $jsondata['model']->vendor;
        $jsondata['file'] = $jsondata['model']->file;
        if ($jsondata['model']->currency != null)
            $jsondata['currency'] = MasCurrency::model()->findByPK($jsondata['model']->currency);
        $items = $jsondata['model']->items;
        $modelAdItems = $jsondata['model']->adItems;
        $modelDedItems = $jsondata['model']->dedItems;
        $jsondata['model_items'] = '';
        $jsondata['total'] = 0;
        $jsondata['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Product</th>
            <th>Description</th>
            <th>Qty</th> 
            <th>Unit</th>
            <th>Rate</th>
            <th>Amount</th>
            <th>Additions</th>
            <th>Deductions</th>
            <th>Net</th>
            <th></th>
        </tr>';
        foreach ($items as $i => $model) {
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
            $jsondata['model_items'] .= '
            <tr> <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'tooltipster description product-search', 'value' => $model->product->part_number, 'title' => 'Select product')) .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description', 'value' => $model->product->description)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right to_be_calculated amount-field', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'cell-right amount-field', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]addition_percentage", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                    ' ' . CHtml::activeTextField($model, "[$i]addition_amount", array('class' => 'cell-right additions', 'readonly' => true)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]deduction_percentage", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));')) .
                    ' ' . CHtml::activeTextField($model, "[$i]deduction_amount", array('class' => 'cell-right deductions', 'readonly' => true)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'cell-right amount-field', 'readonly' => true)) . '</td>
        </tr>';
            $jsondata['total']+=$model->net_amount;
        }
        /* <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#purchasingInvoice_item_table"), this);')) . '</td> */

        $jsondata['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">' . $jsondata['total'] . '</h2></td>
        </tr>';
        $jsondata['model_addition_items'] = "";
        foreach ($modelAdItems as $i => $model) {
            $jsondata['model_addition_items'].='<tr><td></td><td colspan="10" class="cell-right">Additions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#purchasingInvoice_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::error($model, "[$i]paricular") .
                    CHtml::activeTextField($model, "[$i]particular_value", array(
                        'onkeyup' => 'calculateValues($(\'#purchasingInvoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#purchasingInvoice_final_add_table\'), this)')) .
                    '</span></td></tr>';
        }
        $jsondata['model_deduction_items'] = "";
        foreach ($modelDedItems as $i => $model) {
            $jsondata['model_deduction_items'].='<tr><td></td><td colspan="10" class="cell-right">Deductions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#purchasingInvoice_final_ded_table"))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($model, "[$i]particular_value", array('onkeyup' => 'calculateValues($("#purchasingInvoice_item_table"));',
                        'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#purchasingInvoice_final_ded_table"), this)')) . ' ' .
                    '</span></td></tr>';
        }
        $gd_total = $jsondata['model']->grand_total;
        $jsondata['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $gd_total . '</h1></td>
        </tr>';
        echo CJSON::encode($jsondata);
        Yii::app()->end();
    }

    public function actionSelectpurchasingorderforinvoice() {
        $purchaseorder = PurchasingOrder::model()->findByPK((int) $_POST['po_id']);
        if (isset($_POST['needed_model'])) {
            $masterFile = MasterFile::model()->findByPK($purchaseorder->file_id);
            $jsonData['file'] = $masterFile;
            $jsonData[$_POST['needed_model']] = $masterFile->{$_POST['needed_model']};
            $jsonData['vendor'] = Company::model()->findByPK($jsonData[$_POST['needed_model']]->vendor_id);
            $jsonData['currency'] = MasCurrency::model()->findByPK($jsonData[$_POST['needed_model']]->currency);
            $jsonData['paymentterms'] = MasPaymentTerm::model()->findByPK($jsonData[$_POST['needed_model']]->payment_terms);
            echo CJSON::encode($jsonData);
        }
    }

    public function actionGetPurchasingInvoiceDetails($file_id = 0) {

        $invoice = PurchasingInvoice::model()->findByPK((int) $_POST['model_id']);
        if (isset($_POST['byvendor']))
            Yii::app()->session['file_id'] = $file_id == 0 ? $invoice->file_id : $file_id;
        else
            Yii::app()->session['file_id'] = $file_id == 0 ? (int) $_POST['file_id'] : $file_id;
        if (isset($_POST['needed_model'])) {
            $masterFile = MasterFile::model()->findByPK(Yii::app()->session['file_id']);
            $jsonData['file'] = $masterFile;
            if (isset($_POST['model_id']))
                $jsonData[$_POST['needed_model']] = PurchasingInvoice::model()->findByPK((int) $_POST['model_id']);
            else
                $jsonData[$_POST['needed_model']] = $masterFile->{$_POST['needed_model']};
            $jsonData['vendor'] = Company::model()->findByPK($jsonData[$_POST['needed_model']]->vendor_id);
            if (in_array($_POST['needed_model'], array("purchaseorder"))) {
                $jsonData['currency'] = MasCurrency::model()->findByPK($jsonData[$_POST['needed_model']]->currency);
                $jsonData['paymentterms'] = MasPaymentTerm::model()->findByPK($jsonData[$_POST['needed_model']]->payment_terms);
            }
            if (in_array($_POST['needed_model'], array("purchaseinvoice"))) {
                $criteria = new CDbCriteria();
                $criteria->addInCondition("purchasing_materialreceipt_id", explode(',', $jsonData[$_POST['needed_model']]->materialreceived));
                $items = PurchasingMaterialreceiptItem::model()->findAll($criteria);
                $jsonData['model_items'] = '';
                foreach ($items as $i => $model) {
                    //$purchasedproduct = PurchasingOrderItem::model()->find(array('condition' => 'product_id=:product_id AND purchasing_order_id=:po_id', 'params' => array(':product_id' => $model->product_id, ':po_id' => $model->purchasingmatrialreceipt->po_id)));
                    //$productrate = PurchasingInvoiceItem::model()->find(array('condition' => 'product_id=:product_id AND purchasing_invoice_id=:inv_id', 'params' => array(':product_id' => $model->product_id, ':inv_id' => $invoice->id)));
                    $temp = new PurchasingcreditItem;
                    $temp->attributes = $model->attributes;
                    $temp->purchased_quantity = $model->qcchecked_quantity;
                    $temp->description = $model->description;
                    $model = $temp;
                    $product = Store::model()->findByPk($model->product_id);
                    //$unit = Unit::model()->findByPk($product->unit_id);
                    $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]purchasing_materialreceipt_id", array('readonly' => true, 'value' => $model->purchasing_materialreceipt_id)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description', 'readonly' => true, 'value' => $product->part_number)) . CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description', 'readonly' => true, 'value' => $model->description)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]warehouse_name", array('readonly' => true, 'value' => $model->warehousename->name)) .
                            CHtml::activeHiddenField($model, "[$i]warehouse", array('readonly' => true, 'value' => $model->warehouse)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]purchased_quantity", array('class' => 'cell-center', 'value' => preg_replace('/\s\d+\.00/', '', floatval($model->purchased_quantity)), 'readonly' => true,)) . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]returned_quantity", array('class' => 'cell-center', 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculatecrediteamount($("#purchasingcredit_item_table"));')) . '</td> 
           <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right to_be_calculated', 'value' => $product->rate, 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculatecrediteamount($("#purchasingcredit_item_table"));')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)) . '</td>
            <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#purchasingcredit_item_table"), this);')) . '</td>
            </tr>';
                }
            }
            echo CJSON::encode($jsonData);
        }
    }

    /* ^########################################### Purchasing Invoice ############################################^ */
    /* ^########################################### Common function for getting details of form in case of editing ############################################^ */

    public function getData($modelName, $table, $to = null, $convert = false) {
        $itemModel = $modelName . 'Item';
        $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
        $jsondata['model'] = $modelName::model()->with(items)->findByPk((int) $_POST['id'], array('order' => 'items.id ASC'));
        if (in_array($modelName, array("PurchasingRequisition")))
            $jsondata['employee'] = User::model()->findByPk($jsondata['model']->crm_user_id);
        if (in_array($modelName, array("PurchasingEnquiry", "PurchasingRequisition"))) {
            $jsondata['vendorlist'] = explode(',', $jsondata['model']->vendor_id);
        }
        if (in_array($modelName, array("PurchasingOrder", "PurchasingMaterialreceipt")))
            $jsondata['vendor'] = Company::model()->findByPk($jsondata['model']->vendor_id);

        if (in_array($modelName, array("PurchasingOrder"))) {
            if ($jsondata['model']->project != 0)
                $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
            else
                $jsondata['project'] = '';
            $jsondata['paymenttermdetails'] = MasPaymentTerm::model()->findByPK($jsondata['model']->payment_terms);
            $jsondata['payemntterm'] = $jsondata['paymenttermdetails']->payment_code . ':' . $jsondata['paymenttermdetails']->payment_terms;
            $jsondata['currency'] = MasCurrency::model()->findByPK($jsondata['model']->currency);
            $jsondata['shippingby'] = MasShipping::model()->findByPK($jsondata['model']->shipping_by);
        }
        $data = CHtml::listData((CompanyContact::model()->findAll('company_id=:ID', array(':ID' => $jsondata['model']->vendor_id))), 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsondata['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        if (is_array($jsondata['contacts']))
            $jsondata['contacts'] = implode('', $jsondata['contacts']);

        $jsondata['file'] = '';
        $jsondata['file'] = MasterFile::model()->findByPk($jsondata['model']->file_id);
        $items = $itemModel::model()->findAll(array('condition' => $refer_id . '=' . $jsondata['model']->id, 'order' => 'id ASC'));
        $jsondata['model_items'] = '';
        $jsondata['total'] = 0;
        foreach ($items as $i => $model) {
            $product = Store::model()->findByPk($model->product_id);
            $unit = Unit::model()->findByPk($product->unit_id);
            if ($convert) {
                $modelitem = $to . 'Item';
                $temp = new $modelitem;
                $temp->attributes = $model->attributes;
                $model = $temp;
            }
            //edit for PurchasingEnquiry", "PurchasingRequisition\/
            if (in_array($modelName, array("PurchasingEnquiry", "PurchasingRequisition")) && !in_array($to, array("PurchasingOrder"))) {
                $jsondata['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                            'value' => $product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array(
                            'class' => 'description description-textarea tooltipster',
                            'style' => 'height:20px;width:90%;max-width:90%;',
                            'title' => 'Add Description here',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('value' => preg_replace('/\s\d+\.00/', '', floatval($model->quantity)))) . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->product->unit->symbol)) . '</td>  
            <td>' . CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $table . '_item_table"), this);', 'title' => 'Remove this item'))
                        . '</td>
            </tr>';
            }

            //convert from PurchasingEnquiry to PurchasingOrder\/
            else if (in_array($modelName, array("PurchasingEnquiry")) && in_array($to, array("PurchasingOrder"))) {
                $model->rate = $model->product->rate;
                $model->amount = $model->quantity * $model->rate;
                $jsondata['total'] +=$model->amount;
                $jsondata['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                            'value' => $product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . CHtml::link('<i class="icon-info-sign"><div class="triangle-right left purchase-helper"></div></i>', 'javascript:;', array('class' => 'purchase-helper-trigger', 'title' => 'Purchase Helper')) .
                        CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '</td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array(
                            'class' => 'description description-textarea tooltipster',
                            'style' => 'height:20px;width:90%;max-width:90%;',
                            'title' => 'Add Description here',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                            'class' => 'cell-center amount-field',
                            'onkeypress' => 'return isNumberKey(event)',
                            'value' => preg_replace('/\s\d+\.00/', '', floatval($model->quantity)),
                            'onkeyup' => 'calculateValues($("#purchasingOrder_item_table"));'
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right amount-field', 'value' => 0.00,
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#purchasingOrder_item_table"));')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'amount-field cell-right',
                            'readonly' => true)) . '</td>
           <td>' . CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $table . '_item_table"), this);', 'title' => 'Remove this item'))
                        . '</td>
          </tr>';
            }

            //edit section for PurchasingOrder\/
            else if (in_array($modelName, array("PurchasingOrder")) && !in_array($to, array("PurchasingOrder"))) {
                $model->amount = $model->quantity * $model->rate;
                $jsondata['total'] +=$model->amount;
                $jsondata['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                            'value' => $product->part_number)) . CHtml::activeHiddenField($model, "[$i]product_id") .
                        CHtml::link('<i class="icon-info-sign"><div class="triangle-right left purchase-helper"></div></i>', 'javascript:;', array('class' => 'purchase-helper-trigger', 'title' => 'Purchase Helper')) .
                        CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '</td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array(
                            'class' => 'description description-textarea tooltipster',
                            'style' => 'height:20px;width:90%;max-width:90%;',
                            'title' => 'Add Description here',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                            'class' => 'cell-center amount-field',
                            'onkeypress' => 'return isNumberKey(event)',
                            'value' => preg_replace('/\s\d+\.00/', '', floatval($model->quantity)),
                            'onkeyup' => 'calculateValues($("#purchasingOrder_item_table"));'
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right amount-field', 'value' => $model->rate,
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#purchasingOrder_item_table"));')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'cell-right amount-field',
                            'onkeypress' => 'return isNumberKey(event)',
                            'readonly' => true)) . '</td>
           <td>' . CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $table . '_item_table"), this);', 'title' => 'Remove this item'))
                        . '</td>
          </tr>';
            }

            //edit section for PurchasingMaterialreceipt
            else if (in_array($modelName, array("PurchasingMaterialreceipt"))) {
                $condition = 'pm.po_id=' . (int) $jsondata['model']->po_id . ' AND pmItems.product_id=' . $model->product_id;
                $remainigquantity = $model->quantity;
                $itemDelivered = Yii::app()->db->createCommand()
                        ->select('sum(pmItems.qcchecked_quantity) as qc_qty')
                        ->from('{{purchasing_material_receipt}} pm')
                        ->join('{{purchasing_material_receipt_item}} pmItems', 'pm.id=pmItems.purchasing_materialreceipt_id')
                        ->where($condition)
                        ->queryRow();
                if ($itemDelivered['qc_qty'] != 0)
                    $remainigquantity = $model->quantity - $itemDelivered['qc_qty'];
                $jsondata['vendor'] = Company::model()->findByPk($jsondata['model']->vendor_id);
                $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td class="cell-left">' . $product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array('readonly' => true, 'class' => 'description product-search materialrecepthide',
                            'value' => $product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array('readonly' => true, 'class' => 'description materialrecepthide')) . '</td>
            <td>' . preg_replace('/\s\d+\.00/', '', floatval($model->quantity)) . CHtml::activeHiddenField($model, "[$i]quantity", array(
                            'readonly' => true,
                            'value' => preg_replace('/\s\d+\.00/', '', floatval($model->quantity)),
                            'class' => 'cell-center materialrecepthide',
                            'onkeypress' => 'return isNumberKey(event)',
                        )) . '</td>
          <td>' . $remainigquantity . CHtml::activeHiddenField($model, "[$i]remaining_quantity", array(
                            'readonly' => true,
                            'value' => preg_replace('/\s\d+\.00/', '', floatval($remainigquantity)),
                            'class' => 'cell-center materialrecepthide',
                            'onkeypress' => 'return isNumberKey(event)',
                        )) . '</td>
            <td>' . $unit->symbol . CHtml::activeHiddenField($model, "[$i]unit", array('readonly' => true, 'value' => $unit->symbol, 'class' => 'materialrecepthide')) .
                        CHtml::error($model, "[$i]unit") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]received_quantity", array('value' => preg_replace('/\s\d+\.00/', '', floatval($model->received_quantity)), 'class' => 'materialrecepthide', 'onkeyup' => 'this.value = checkQCCheckedQuantity(event,this.value,' . $remainigquantity . ')')) .
                        CHtml::error($model, "[$i]received_quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]qcchecked_quantity", array('value' => preg_replace('/\s\d+\.00/', '', floatval($model->qcchecked_quantity)), 'class' => 'qccheckhide', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'this.value = checkQCCheckedQuantity(event,this.value,' . $model->received_quantity . ')')) .
                        CHtml::error($model, "[$i]qcchecked_quantity") . '</td>            
            <td>' . CHtml::activeTextField($model, "[$i]country_of_origin", array('value' => $model->country_of_origin, 'class' => 'materialrecepthide')) .
                        CHtml::error($model, "[$i]country_of_origin") . '</td>
            <td>' . CHtml::activeDropDownList($model, "[$i]warehouse", MasInvWarehouse::getWarehouses(), array('options' => array($model->warehouse => array('selected' => true)), 'style' => 'width:70px !important;')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]incomming_shipment_ref", array('value' => $model->incomming_shipment_ref, 'class' => 'materialrecepthide')) .
                        CHtml::error($model, "[$i]incomming_shipment_ref") . '</td>
            </tr>';
            }
        }

        //additions and deductions for PurchasingOrder\/
        if (in_array($modelName, array("PurchasingOrder"))) {
            $modelAdItems = $jsondata['model']->adItems;
            $modelDedItems = $jsondata['model']->dedItems;
            $jsondata['model_addition_items'] = "";
            $jsondata['total'] = $jsondata['model']->netTotal;
            foreach ($modelAdItems as $i => $model) {
                $jsondata['model_addition_items'].='<tr><td class="cell-right">Additions<span>' .
                        CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#purchasingOrder_final_add_table\'))', 'class' => 'btn')) . ' ' .
                        '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                        CHtml::error($model, "[$i]paricular") .
                        CHtml::activeTextField($model, "[$i]particular_value", array(
                            'onkeyup' => 'calculateValues($(\'#purchasingOrder_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                        CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#purchasingOrder_final_add_table\'), this)')) .
                        '</span></td></tr>';
            }
            $jsondata['model_deduction_items'] = "";
            foreach ($modelDedItems as $i => $model) {
                $jsondata['model_deduction_items'].='<tr><td class="cell-right">Deductions<span>' .
                        CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#purchasingOrder_final_ded_table"))', 'class' => 'btn')) . ' ' .
                        '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                        CHtml::activeTextField($model, "[$i]particular_value", array('onkeyup' => 'calculateValues($("#purchasingOrder_item_table"));',
                            'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                        CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#purchasingOrder_final_ded_table"), this)')) . ' ' .
                        '</span></td></tr>';
            }
        }
        echo CJSON::encode($jsondata);
    }

    public function actionPurchasedFiles() {
        // $this->getFiles(array("M_R", "P_PI"));
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'isActive="Y" AND current_process_status in ("M_R","P_MR","P_PI")';
            $model = MasterFile::model()->with('purchaseorder')->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->id . ':' . $eachModel->purchaseorder->id;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionPurchasedInvoices() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'isActive="Y" AND current_process_status in ("P_I", "P_C")';
            $model = MasterFile::model()->findAll(array('condition' => $condition));
            $i = 0;
            /* foreach ($model as $eachModel) {
              $data_array[$i]['value'] = $eachModel->id;
              $data_array[$i]['label'] = $eachModel->id . ':' . $eachModel->purchaseinvoice->id;
              $i++;
              } */
            foreach ($model as $eachModel) {
                foreach ($eachModel->purchaseinvoice as $invoices) {
                    $data_array[$i]['value'] = $eachModel->id;
                    $data_array[$i]['model_id'] = $invoices->id;
                    $data_array[$i++]['label'] = $eachModel->id . ':' . $invoices->id;
                }
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionSavePurchasingCredit() {
        if (isset($_POST["Purchasingcredit"])) {
            $from = "P_C";
            $model = new Purchasingcredit;
            $attributes_main = $_POST["Purchasingcredit"];
            $attributes_items = isset($_POST['PurchasingcreditItem']) ? $_POST['PurchasingcreditItem'] : array(0);
            $model->scenario = 'add';
            if ((int) @$attributes_main['id'] > 0)
                $model->scenario = 'update';
            $model->attributes = $attributes_main;
            $model->Iscreditnote_or_goodsreturn = $_POST['Purchasingcredit']['Iscreditnote_or_goodsreturn'] == 'Y' ? 'Y' : 'N';
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            if ($_POST['Purchasingcredit']['Iscreditnote_or_goodsreturn'] == 'Y')
                foreach ($attributes_items as $i => $item) {
                    $modelItem[$i] = new PurchasingcreditItem;
                    $modelItem[$i]->attributes = $attributes_items[$i];
                    $valid = $modelItem[$i]->validate() && $valid;
                }
            if ($model->validate() && $valid) { // after validation saving the whole data
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                if ($_POST['Purchasingcredit']['id'] == 0)// if id 0 means its a new record, otherwise needs to update the existing one
                    $model->save();
                else {
                    $model->id = $_POST['Purchasingcredit']['id'];
                    $model->updateByPK($model->id, $model->attributes);
                    $credtitems = PurchasingcreditItem::model()->findAll('purchasingcredit_id=:id', array(':id' => $model->id));
                    foreach ($credtitems as $Item) {
                        $purchasinginvoice = PurchasingInvoice::model()->findByPk($Item->purchasecredit->purchasing_invoice_id);
                        $product = Store::model()->findByPk($Item->product_id);
                        $materialitem = PurchasingMaterialreceiptItem::model()->find(array('condition' => 'purchasing_materialreceipt_id=:ID AND product_id=:product_id', 'params' => array(':ID' => $Item->purchasing_materialreceipt_id, ':product_id' => $Item->product_id)));
                        $productlocation = ProductLocation::model()->find(array('condition' => 'stock_id=:stockID AND warehouse_id=:warehouseID', 'params' => array(':stockID' => $Item->product_id, ':warehouseID' => $materialitem->warehouse)));
                        if ($productlocation != null && ($productlocation->quantity != 0 || $product->rate != 0)) {
                            $rate = $purchasinginvoice->exchange_rate * $Item->rate;
                            $newtotal_value = $product->total_quantity * $product->rate + $rate * $Item->returned_quantity;
                            // $newtotal_value = $product->total_value + $rate* $Item->returned_quantity;
                            //$newtotal_value = $product->total_value +$Item->rate * $Item->returned_quantity;
                            $newcount = $product->total_quantity + $Item->returned_quantity;
                            $newrate = $newtotal_value / $newcount;
                            $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value));
                            $arrayToBeUpdated['quantity'] = $productlocation->quantity + $Item->returned_quantity;
                            $productlocation->updateByPk($productlocation->id, $arrayToBeUpdated);
                        }
                    }
                    PurchasingcreditItem::model()->deleteAll('purchasingcredit_id=:id', array(':id' => $model->id));
                }
                $model->refresh();
                $total = 0;
                if ($_POST['Purchasingcredit']['Iscreditnote_or_goodsreturn'] == 'Y') {
                    foreach ($modelItem as $eachItem) {
                        $eachItem->{'purchasingcredit_id'} = $model->id;
                        $eachItem->save(false);
                        $total+=$eachItem->net_amount;
                        $this->updateInventory($eachItem);
                    }
                    $model->updateByPk($model->id, array('credited_amount' => $total));
                }
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error3 = array();
                $error4 = array();
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetpurchasingcredits() {
        // $this->getData("Purchasingcredit", $table = "purchasingcredit"); 
        $jsonData['model'] = Purchasingcredit::model()->findByPK((int) $_POST['id']);
        $jsonData['vendor'] = $jsonData['model']->vendor;
        $items = $jsonData['model']->items;
        if ($jsonData['model']->Iscreditnote_or_goodsreturn == 'Y') {
            $jsonData['model_items'] = '';
            $jsonData['total'] = 0;
            foreach ($items as $i => $model) {
                $productrate = PurchasingInvoiceItem::model()->find(array('condition' => 'product_id=:product_id AND purchasing_invoice_id=:inv_id', 'params' => array(':product_id' => $model->product_id, ':inv_id' => $jsonData['model']->purchasing_invoice_id)));
                $product = Store::model()->findByPk($model->product_id);
                $unit = Unit::model()->findByPk($product->unit_id);
                $jsonData['model_items'] .= '
           <tr>
            <td><label>' . ($i + 1) . '</label></td>
             <td>' . CHtml::activeTextField($model, "[$i]purchasing_materialreceipt_id", array('readonly' => true, 'value' => $model->purchasing_materialreceipt_id)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description', 'readonly' => true, 'value' => $product->part_number)) . CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description', 'readonly' => true, 'value' => $model->description)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]warehouse", array('readonly' => true, 'value' => $model->warehouse)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]purchased_quantity", array('class' => 'cell-center', 'value' => preg_replace('/\s\d+\.00/', '', floatval($model->purchased_quantity)), 'readonly' => true,)) . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]returned_quantity", array('class' => 'cell-center', 'class' => 'cell-center', 'value' => preg_replace('/\s\d+\.00/', '', floatval($model->returned_quantity)), 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculatecrediteamount($("#purchasingcredit_item_table"));')) . '</td> 
           <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'cell-right to_be_calculated', 'value' => $productrate->rate, 'onkeypress' => 'return isNumberKey(event)')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'value' => $model->net_amount, 'readonly' => true)) . '</td>
            <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#purchasingcredit_item_table"), this);')) . '</td>
            </tr>';
            }
        }
        echo CJSON::encode($jsonData);
        Yii::app()->end();
    }

    public function actionTest() {
        $this->renderPartial('application.views.front.printlayouts.order-single');
    }

    public function actionExportrequisition() {
        $model = new PurchasingRequisition;
        $view = 'printlayouts.purchasingrequisition-list';
        //$model = Company::model()->findAll();
        //$this->pdf($model, 'printlayouts.company-list');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        # Load a stylesheet
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/forpdf.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        # renderPartial (only 'view' of current controller)
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model), true));
        # Renders image
        //$mPDF1->WriteHTML(CHtml::image(Yii::getPathOfAlias('webroot.css') . '/bg.gif'));
        # Outputs ready PDF
        $mPDF1->Output();
    }

    public function actionGetAllocatedFiles() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'allocatedMaterials.id>0 AND t.id  LIKE "%' . $_GET['term'] . '%"';
            $model = MasterFile::model()->with('allocatedMaterials')->findAll(array('condition' => $condition, 'order' => 't.id DESC'));
            // AllocatedMaterial::model()->with(file)->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->id . ':' . $eachModel->file_title;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionGetVendorlist() {
        $data = Company::getVendors(array("V"));
        foreach ($data as $value => $name) {
            $jsondata['vendor'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
            $jsondata['vendor1'][] = $value;
        }
        $jsondata['vendor'] = implode('', $jsondata['vendor']);
        echo CJSON::encode($jsondata);
    }

    public function actionSavePayment() {
        if (isset($_POST['RcptOfPayment'])) {
            $modelRcptOfPayment = new RcptOfPayment();
            $modelRcptOfPayment->attributes = $_POST['RcptOfPayment'];
            $modelRcptOfPayment->own_company_id = Yii::app()->user->master_user_company_id;
            $modelRcptOfPayment->own_branch_id = Yii::app()->user->master_user_branch_id;
            $i = 0;
            $valid = 0;
            if (isset($_POST['received_amt'])) {
                $valid = $modelRcptOfPayment->validate();
                foreach ($_POST['received_amt'] as $invoice_id => $received_amt) {
                    if ($received_amt > 0) {
                        $modelPaidInvoices[$i] = new PaidInvoices;
                        $modelPaidInvoices[$i]->invoice_id = $invoice_id;
                        $modelPaidInvoices[$i]->received_amt = $received_amt;
                        $valid = $valid && $modelPaidInvoices[$i]->validate();
                        $i++;
                    }
                }
            }
            if ($valid && isset($modelPaidInvoices)) {
                $modelRcptOfPayment->save();
                $modelRcptOfPayment->refresh();
                foreach ($modelPaidInvoices as $eachPaidInvoice) {
                    $eachPaidInvoice->rcpt_id = $modelRcptOfPayment->id;
                    $eachPaidInvoice->save();
                    $modelInvoice = PurchasingInvoice::model()->findByPk($eachPaidInvoice->invoice_id);
                    if ($eachPaidInvoice->invoice->receivedAmount >= $modelInvoice->grand_total) {
                        // $arrayToBeUpdated['paid'] =  "Y";
                        //$modelInvoice->updateByPk($modelInvoice->id, $arrayToBeUpdated);
                        $modelInvoice->paid = "Y";
                        $modelInvoice->save();
                    }
                }
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($modelRcptOfPayment, '', false), true);
                if (!isset($modelPaidInvoices))
                    $modelPaidInvoices = new PaidInvoices;
                $error2 = json_decode(CActiveForm::validateTabular($modelPaidInvoices, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionFetchPaymentHistory() {
        if (isset($_GET['invoice_id']) && (int) $_GET['invoice_id'] > 0) {
            $modelReceivedInvoices = PaidInvoices::model()->with('recpt')->findAll(array(
                'condition' => 'invoice_id=' . (int) $_GET['invoice_id'],
                'order' => 'recpt.received_date DESC',
                    //'limit'=>'5',
            ));
            $history = "<div style='height:100px; overflow:scroll;'>
                <table style='width:100%;' class='table-grid'><tr><th>Rcpt No.</th><th>Date.</th><th>Realisation Date.</th><th>Payment Mode.</th><th>Ref.No.</th><th>Rcvd Amt.</th><th>Notes.</th><th>Remarks.</th>";
            foreach ($modelReceivedInvoices as $eachReceivedInvoice) {
                $history .= "<tr><td>" . $eachReceivedInvoice->recpt->id . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->received_date . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->realisation_date . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->mode_of_payment . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->ref_number . "</td>
                        <td class='cell-right'>" . Yii::app()->numberFormatter->formatCurrency($eachReceivedInvoice->received_amt, "") . "</td>
                        <td class='cell-left'>" . $eachReceivedInvoice->recpt->notes . "</td>
                        <td class='cell-left'>" . $eachReceivedInvoice->recpt->remarks . "</td></tr>";
            }
            $history .="</table></div>";

            echo json_encode(array('row' => '<tr class="toggle"><td   colspan="9">' . $history . '</td></tr>'));
        }
    }

}

?>