<?php

class ShyniController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('FetchFile', 'previousFileDetails', 'test', 'OrderDetails','InvoiceDetails','DeliveryDetails'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionTest() {
        die("here");
    }

    public function getRfqDetails($file_id) {
        $rfq = FormRfqGeneral::model()->find(array('condition' => 'file_id=' . $file_id));
        $rfq_type = $rfq->formRfqType;
        $jsonData = array();
        $jsonData['rfq']['capacity'] = $rfq->formRfqRo->ro_capacity;
        if ($rfq_type->sea_water_ro > 0) {
            $jsonData['rfq']['sea']['process'] = "Sea Water";
        } else if ($rfq_type->blackish_water_ro > 0) {

            $jsonData['rfq']['sea']['process'] = "blackish Water";
        } else if ($rfq_type->tse_ro > 0) {

            $jsonData['rfq']['sea']['process'] = "Tse Water";
        } else if ($rfq_type->high_brackish_water_ro > 0) {

            $jsonData['rfq']['sea']['process'] = "Brackish Water";
        } else if ($rfq_type->river_water_treatment_plant_wtp > 0) {

            $jsonData['rfq']['waste']['process'] = "river water";
        } 
        /*else if ($rfq_type->industrial_waste_treatment_plane_etp > 0) {

            $jsonData['rfq']['waste']['process'] = "industrial waste water";
        } 
          else if ($rfq_type->mbbr > 0) {
         

            $jsonData['rfq']['waste']['process'] = "mbbr";
        } else if ($rfq_type->mbr > 0) {

            $jsonData['rfq']['waste']['process'] = "mbr";
        } else if ($rfq_type->greywater_system > 0) {

            $jsonData['rfq']['misc']['process'] = "grey water";
        } else if ($rfq_type->saf_system > 0) {

            $jsonData['rfq']['misc']['process'] = "Saf System";
        } */
         else if ($rfq_type->demin_system > 0) {
         

            $jsonData['rfq']['misc']['process'] = "Demin System";
        } else if ($rfq_type->softner > 0) {

            $jsonData['rfq']['misc']['process'] = "softner";
        } else if ($rfq_type->filteration_system > 0) {

            $jsonData['rfq']['misc']['process'] = "filteration system";
        } else if ($rfq_type->miscellaneous > 0) {

            $jsonData['rfq']['misc']['process'] = "miscellaneous";
        }
        return $jsonData;
    }

    public function actionPreviousFileDetails() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $jsonData['masterfile'] = $masterFile;
        $jsonData['lead'] = $masterFile->lead;
        // $jsonData['company'] = $masterFile->lead->company;
        // $jsonData['companycontact'] = $masterFile->lead->companycontact;
        //company details
        $jsonData['company'] = $masterFile->company;
        $jsonData['paymentterm'] = $jsonData['company']->paymentTerm;
        $jsonData['currency'] = $masterFile->company->currency0;

        // $data=Company::getCompanies();
        $data = CHtml::listData($masterFile->company, 'id', 'company_name');
        foreach ($data as $value => $name)
            $jsonData['companylist'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['companylist'] = implode('', $jsonData['companylist']);

        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        echo CJSON::encode($jsonData);
    }

    public function actionOrderDetails() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $jsonData['masterfile'] = $masterFile;
        $jsonData['quotes'] = Quotes::model()->find(array('condition' => 'file_id=' . $file_id));
        $jsonData['lead'] = $masterFile->lead;
        $jsonData['company'] = $masterFile->company;
        $jsonData['paymentterm'] = $jsonData['company']->paymentTerm;
        $jsonData['currency'] = $masterFile->company->currency;
        $data = CHtml::listData($masterFile->company, 'id', 'company_name');
        foreach ($data as $value => $name)
            $jsonData['companylist'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['companylist'] = implode('', $jsonData['companylist']);
        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        $quotes = Quotes::model()->with('items')->find(array('condition' => 'file_id=' . $file_id));
        $items = $quotes->items;
        $jsonData['file'] = $quotes->file;
        $modelAdItems = $quotes->adItems;
        $modelDedItems = $quotes->dedItems;
        $quotesororder = "order";
        foreach ($items as $i => $model) {
            $temp = new OrderItem;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
            $jsonData['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array(
                        'value' => $model->product->part_number,
                        'class' => 'tooltipster description product-search',
                        'onClick' => 'js:auto_complete2("Order", ' . $i . ');',
                        'title' => 'Select product'
                    )) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") .
                    CHtml::link('<i class="icon-info-sign"><div class="triangle-right left quotation-helper"></div></i>', 'javascript:;', array('class' => 'quotation-helper-trigger', 'title' => 'Quotation Helper'))
                    . CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '
                    </td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array('class' => 'description description-textarea',
                        'style' => 'height:20px;width:90%;max-width:90%;',
                        'title' => 'Add Description here',
                        'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                    )) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                        'class' => 'cell-center',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));'
                    )) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) .
                    CHtml::error($model, "[$i]unit") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'amount-field  cell-right to_be_calculated',
                        'onkeypress' => 'return isNumberKey(event)',
                        'readonly' => (($model->rate) > 0),
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]rate") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'amount-field cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'readonly' => true)) .
                    CHtml::error($model, "[$i]amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]addition_percentage", array('class' => 'cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]addition_percentage")
                    . ' ' . CHtml::activeTextField($model, "[$i]addition_amount", array('class' => 'cell-right additions', 'readonly' => true)) .
                    CHtml::error($model, "[$i]addition_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]deduction_percentage", array('class' => 'cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]deduction_percentage")
                    . ' ' . CHtml::activeTextField($model, "[$i]deduction_amount", array('class' => 'cell-right deductions', 'readonly' => true)) .
                    CHtml::error($model, "[$i]deduction_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'amount-field cell-right', 'readonly' => true)) .
                    CHtml::error($model, "[$i]net_amount") . '</td>
            <td>' . CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                    CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $quotesororder . '_item_table"), this);')) .
                    '</td>
        </tr>';
            $jsonData['total']+=$model->net_amount;
        }
        $jsonData['grand_total'] = $jsonData['total'];
        $jsonData['model_addition_items'] = "";
        foreach ($modelAdItems as $i => $model) {
            $temp = new OrderAddition;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $jsonData['model_addition_items'].='<tr><td class="cell-right">Additions <span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#' . $quotesororder . '_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($model, "[$i]particular_value", array(
                        'onkeyup' => 'calculateValues($(\'#' . $quotesororder . '_item_table\'));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#order_final_add_table"), this)'));
            '</span></td></tr>';
            $jsonData['grand_total'] +=$model->calculated_value;
        }
        $jsonData['model_deduction_items'] = "";
        foreach ($modelDedItems as $i => $model) {
            $temp = new OrderDeduction;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $jsonData['model_deduction_items'].='<tr><td class="cell-right">Deductions <span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#' . $quotesororder . '_final_ded_table"))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::error($model, "[$i]particular") .
                    CHtml::activeTextField($model, "[$i]particular_value", array('onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#order_final_ded_table"), this)'));
            '</span></td></tr>';
            $jsonData['grand_total'] -=$model->calculated_value;
        }
        $jsonData['company'] = $jsonData['file']->company;
        $jsonData['company']['billing_address'] = str_replace("<br/>", "\n", $jsonData['company']->billingAddress);
        $jsonData['company']['shipping_address'] = str_replace("<br/>", "\n", $jsonData['company']->shippingAddress);
        echo CJSON::encode($jsonData);
        Yii::app()->end();
    }
    
       public function actionInvoiceDetails() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $jsonData['masterfile'] = $masterFile;
        $jsonData['order'] = Order::model()->find(array('condition' => 'file_id=' . $file_id));
        $jsonData['lead'] = $masterFile->lead;
        $jsonData['company'] = $masterFile->company;
        $jsonData['paymentterm'] = $jsonData['company']->paymentTerm;
        $jsonData['currency'] = $masterFile->company->currency;
        $data = CHtml::listData($masterFile->company, 'id', 'company_name');
        foreach ($data as $value => $name)
            $jsonData['companylist'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['companylist'] = implode('', $jsonData['companylist']);
        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        $order = Order::model()->with('items')->find(array('condition' => 'file_id=' . $file_id));
        $items = $order->items;
        $jsonData['file'] = $order->file;
        $modelAdItems = $order->adItems;
        $modelDedItems = $order->dedItems;
        $invoiceorder = "invoice";
        
        $invoice = Invoice::model()->find(array('condition' => 'file_id=' . $file_id .' ORDER BY id DESC'));
        $invoiceitems = $invoice->items;
        $jsonData['file'] = $invoice->file;
        $modelIncoiceAdItems = $invoice->adItems;
        $modelInvoiceDedItems = $invoice->dedItems;
        $invoice = "invoice";
        
        $current_status=$masterFile['current_process_status'];
     
        foreach ($items as $i => $model) {
            
            $temp = new InvoiceItem;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity)); 
            $invoiceitems = InvoiceItem::model()->find(array('condition' => 'item_no=' . $model->item_no .' ORDER BY id DESC'));
            if($invoiceitems['net_rate']!=$invoiceitems['invoiced'] || empty($invoiceitems)){
            $jsonData['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array(
                        'value' => $model->product->part_number,
                        'class' => 'tooltipster description product-search',
                        'onClick' => 'js:auto_complete2("Order", ' . $i . ');',
                        'title' => 'Select product'
                    )) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]item_no") .
                    CHtml::activeHiddenField($model, "[$i]ordered_value",array("value" => $model->rate)) .
                   // CHtml::link('<i class="icon-info-sign"><div class="triangle-right left quotation-helper"></div></i>', 'javascript:;', array('class' => 'quotation-helper-trigger', 'title' => 'Quotation Helper'))
                   // . CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '
                   ' </td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array('class' => 'description description-textarea',
                        'style' => 'height:20px;width:90%;max-width:90%;',
                        'title' => 'Add Description here',
                        'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                    )) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                        'class' => 'cell-center',
                        'readonly' => true,
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $invoiceorder . '_item_table"));'
                    )) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) .
                    CHtml::error($model, "[$i]unit") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'amount-field  cell-right to_be_calculated','value' => (($model->amount)),
                        'readonly' => true,
                        )) .
                    CHtml::error($model, "[$i]rate") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'amount-field  cell-right to_be_calculated','value' => $model->getRemaining($model->item_no),
                        'onkeypress' => 'return isNumberKey(event)',
                         'readonly' => (($model->amount) == $model->getInvoiced($model->item_no)),
                        'onkeyup' => 'calculateTotalValues($("#' . $invoiceorder . '_item_table"));'
                
                )) .
                    CHtml::error($model, "[$i]amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]invoiced", array('class' => 'amount-field  cell-right to_be_calculated','readonly' => true, 'value' => $model->getInvoiced($model->item_no))) .
                    CHtml::error($model, "[$i]invoiced") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]pending", array('class' => 'amount-field  cell-right to_be_calculated','readonly' => true, 'value' => $model->getRemaining($model->item_no))) .
                        
                       
                    CHtml::error($model, "[$i]pending") .  '</td>
            
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('value' => $model->getRemaining($model->item_no),'class' => 'amount-field cell-right', 'readonly' => true)) .
                    CHtml::error($model, "[$i]net_amount") . '</td>
            <td>' . 
                    //CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                    //CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $invoiceorder . '_item_table"), this);')) .
                   
                    '</td>
        </tr>';
           if($model->getRemaining($model->item_no))
               $jsonData['total']+=$model->getRemaining($model->item_no);
           else
            $jsonData['total']+=$model->net_amount;
        }
        $jsonData['grand_total'] = $jsonData['total'];
        $jsonData['model_addition_items'] = "";
        foreach ($modelAdItems as $i => $model) {
            $temp = new InvoiceAddition;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $jsonData['model_addition_items'].='<tr><td class="cell-right">Additions <span>' .
                    CHtml::activeHiddenField($model, "[$i]addition_item_no") .
                    CHtml::activeHiddenField($model, "[$i]total_addition_value") .
                    //CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#' . $invoiceorder . '_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($model, "[$i]particular_value", array('value'=>$model->getAdditionValue($model->addition_item_no),
                        'onkeyup' => 'calculateTotalValues($(\'#' . $invoiceorder . '_item_table\'));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('value'=>$model->getAdditionValue($model->addition_item_no),'readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#order_final_add_table"), this)'));
            '</span></td></tr>';
            $jsonData['grand_total'] +=$model->getAdditionValue($model->addition_item_no);
        }
        $jsonData['model_deduction_items'] = "";
        foreach ($modelDedItems as $i => $model) {
            $temp = new InvoiceDeduction;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $jsonData['model_deduction_items'].='<tr><td class="cell-right">Deductions <span>' .
                    CHtml::activeHiddenField($model, "[$i]deduction_item_no") .
                    CHtml::activeHiddenField($model, "[$i]total_deduction_value") .
                    //CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#' . $invoiceorder . '_final_ded_table"))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::error($model, "[$i]particular") .
                    CHtml::activeTextField($model, "[$i]particular_value", array('value'=>$model->getDeductionValue($model->deduction_item_no),
                        'onkeyup' => 'calculateTotalValues($("#' . $invoiceorder . '_item_table"));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('value'=>$model->getDeductionValue($model->deduction_item_no),'readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#order_final_ded_table"), this)'));
            '</span></td></tr>';
            $jsonData['grand_total'] -=$model->getDeductionValue($model->deduction_item_no);
        }
        //$jsonData['company'] = $jsonData['file']->company;
       // $jsonData['company']['billing_address'] = str_replace("<br/>", "\n", $jsonData['company']->billingAddress);
        //$jsonData['company']['shipping_address'] = str_replace("<br/>", "\n", $jsonData['company']->shippingAddress);
        }
        echo CJSON::encode($jsonData);
        
        Yii::app()->end();
    }
    
       public function actionDeliveryDetails() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $jsonData['masterfile'] = $masterFile;
        $jsonData['order'] = Order::model()->find(array('condition' => 'file_id=' . $file_id));
        $jsonData['lead'] = $masterFile->lead;
        $jsonData['company'] = $masterFile->company;
        $jsonData['paymentterm'] = $jsonData['company']->paymentTerm;
        $jsonData['currency'] = $masterFile->company->currency;
        $data = CHtml::listData($masterFile->company, 'id', 'company_name');
        foreach ($data as $value => $name)
            $jsonData['companylist'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['companylist'] = implode('', $jsonData['companylist']);
        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        $order = Order::model()->with('items')->find(array('condition' => 'file_id=' . $file_id));
        $items = $order->items;
        $jsonData['file'] = $order->file;
        $deliveryorder = "delivery";
        foreach ($items as $i => $model) {
            $temp = new DeliveryNoteItem;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
            $deliveryitems = DeliveryNoteItem::model()->find(array('condition' => 'item_no=' . $model->item_no .' ORDER BY id DESC'));
            if($deliveryitems['quantity']!=$deliveryitems['delivered'] || empty($deliveryitems)){
            $jsonData['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array(
                        'value' => $model->product->part_number,
                        'class' => 'tooltipster description product-search',
                        'onClick' => 'js:auto_complete2("Order", ' . $i . ');',
                        'title' => 'Select product'
                    )) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") .
                     CHtml::activeHiddenField($model, "[$i]item_no") .
                    CHtml::activeHiddenField($model, "[$i]pending") .
                   // CHtml::link('<i class="icon-info-sign"><div class="triangle-right left quotation-helper"></div></i>', 'javascript:;', array('class' => 'quotation-helper-trigger', 'title' => 'Quotation Helper'))
                   // . CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '
                   ' </td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array('class' => 'description description-textarea',
                        'style' => 'height:20px;width:90%;max-width:90%;',
                        'title' => 'Add Description here',
                        'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                    )) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                        'readonly' => true,
                        'class' => 'cell-center',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $deliveryorder . '_item_table"));'
                    )) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) .
                    CHtml::error($model, "[$i]unit") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array(
                        'class' => 'cell-center',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateQuantity($("#' . $deliveryorder . '_item_table"));'
                    )) .
                    CHtml::error($model, "[$i]picked_qty") . '</td>
           <td>' . CHtml::activeTextField($model, "[$i]delivered", array(
                        'readonly' => true,
                        'value' => $model->getDelivered($model->item_no)
                    )) .
                    CHtml::error($model, "[$i]delivered") . '</td>         
           <td>' . CHtml::activeTextField($model, "[$i]weight", array()) .
                   CHtml::error($model, "[$i]weight") . '</td>
           <td>' . CHtml::activeTextField($model, "[$i]volume", array()) .
                   CHtml::error($model, "[$i]volume") . '</td>
        </tr>';
            }  
        }
        $jsonData['company'] = $jsonData['file']->company;
        $jsonData['company']['billing_address'] = str_replace("<br/>", "\n", $jsonData['company']->billingAddress);
        $jsonData['company']['shipping_address'] = str_replace("<br/>", "\n", $jsonData['company']->shippingAddress);
        echo CJSON::encode($jsonData);
        Yii::app()->end();
    }
    
    
    public function actionFetchFile() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $quotes = Quotes::model()->find(array('condition' => 'file_id=' . $file_id));
        $order = Order::model()->find(array('condition' => 'file_id=' . $file_id));
        $rfqGeneral = FormRfqGeneral::model()->find(array('condition' => 'file_id=' . $file_id));
        $rfqDate = FormRfqDate::model()->find(array('condition' => 'form_rfq_id=' . $rfqGeneral->id));
        $jsonData['general'] = $masterFile;
        $jsonData['quotes'] = $quotes;
        $jsonData['order'] = $order;
        $jsonData['rfqGeneral'] = $rfqGeneral;
        $jsonData['rfqType'] = $rfqGeneral->formRfqType; 
        $jsonData['rfqWtd'] = $rfqGeneral->formRfqWtd; 
        $jsonData['rfqWwtpStp'] = $rfqGeneral->formRfqWwtpStp; 
        $jsonData['rfqMisc'] = $rfqGeneral->formRfqMisc;
        $jsonData['rfqDate'] = $rfqGeneral->formRfqDate;
        $jsonData['rfqRo'] = $rfqGeneral->formRfqRo;
        $jsonData['company'] = $masterFile->company;
        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');

        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
         $jsonData['contacts'] = implode('', $jsonData['contacts']);

        if (count($masterFile->rfq) > 0)
            $jsonData = array_merge($jsonData, $this->getRfqDetails($file_id));

        echo CJSON::encode($jsonData);
    }
    
    

}