<?php

class SopController extends Controller {

    public function accessRules() {

        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover', 'Invoice', 'Delivery','OrderedFiles','upload'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Lead', 'Quotation', 'Order'
                ),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {

        return array('accessControl'); // perform access control for CRUD operations
    }
    public function actionOrderedFiles() {
        $this->getFiles(array("O", "PD", "PI", "C"), array('is_approved' => "Y"));
    }
    public function actionLead() {

        $modelLead = new Lead;
        $id = $_POST['Lead']['id'];
        $lead_id = (int) Yii::app()->request->getParam('id');
        $flag = (int) Yii::app()->request->getParam('flag');

        if ($lead_id) {
            $modelLead = $modelLead->findByPK($lead_id);
            $modelLead->lead_owner_id = $modelLead->file->lead_owner_id;
            $modelLead->scenario = 'update';
        }
        if (isset($_POST['Lead'])) {
            if ((int) $_POST['Lead']['id'] > 0) {
                $modelLead = $modelLead->findByPK($_POST['Lead']['id']);
              //  $modelLead->lead_owner_id = $modelLead->file->lead_owner_id;
                 $modelLead->lead_owner_id = $_POST['Lead']['lead_owner_id'];
                $modelLead->scenario = 'update';
            }
            $modelLead->attributes = $_POST['Lead'];
            $modelLead->lead_owner_id = $_POST['Lead']['lead_owner_id'];
            $modelLead->created_date = date('Y-m-d H:i:s a', time());
            $modelLead->form_id = 1;
            $modelLead->crm_user_id = Yii::app()->user->id;
            $valid = $modelLead->validate();
            if ($valid) {
                if(($id && $modelLead->file->current_process_status == "L") || !$id)
                $modelLead->file_id = $this->masterFile((int) $modelLead->file_id, 'L', 1, $modelLead->title, $modelLead->company_id, $modelLead->lead_owner_id,"N");

                $modelLead->save();
                $modelLead->refresh();
                $lead_id = $modelLead->id;
                $jsonData['file'] = $modelLead->file;
                $jsonData['lead'] = $modelLead;
                 $this->documents($modelLead->file_id, 'L');
                $jsonData['status'] = 'success';
                //((int) $_POST['Lead']['id'] == 0) ? $this->actionNotification($modelLead, "Lead", false, "New Lead:" . $modelLead->file_id . '/' . $modelLead->id) : '';

                echo CJSON::encode($jsonData);
            } else {
                $error = CActiveForm::validate($modelLead, '', false);
                if ($error != '[]')
                    echo $error;
            }
            Yii::app()->end();
        }
        if ($modelLead->file_id > 0)
            Yii::app()->session['file_id'] = $modelLead->file_id;

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//sop/lead/_leadform', array(
            'modelLead' => $modelLead,'flag' => $flag,
            'lead_id' => (int) $lead_id
                ), false, true);
    }

    public function actionQuotation() {
        $modelQuote = new Quotes;
        $modelQuoteItems = array(new QuotesItem);
        $modelQuoteAdditions = array(new QuotesAddition);
        $modelQuoteDeductions = array(new QuotesDeduction);
        $id = $_POST['Quotes']['id'];
        $quotes_id = (int) Yii::app()->request->getParam('id');
        $duplicate = (int) Yii::app()->request->getParam('duplicate');
        $flag = (int) Yii::app()->request->getParam('flag');

        if ($quotes_id) {
            $modelQuote = $modelQuote->findByPK($quotes_id);
            $modelQuoteItems = $modelQuote->items;
            $modelQuoteAdditions = count($modelQuote->adItems) > 0 ? $modelQuote->adItems : $modelQuoteAdditions;
            $modelQuoteDeductions = count($modelQuote->dedItems) > 0 ? $modelQuote->dedItems : $modelQuoteDeductions;
        }

        if (isset($_POST['Quotes'])) {
            if ((int) $_POST['Quotes']['id'] > 0) {
                $modelQuote = $modelQuote->findByPK($_POST['Quotes']['id']);
                $modelQuote->scenario = 'update';
            }
            $modelQuote->attributes = $_POST['Quotes'];
            $modelQuote->expected_order_date = $_POST['Quotes']['expected_order_date'];
            $modelQuote->form_id = 3;
            $modelQuote->created_date = date('Y-m-d H:i:s  a', time());
            $modelQuote->crm_user_id = Yii::app()->user->id;
            $modelQuote->materials_allocated = (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") ? "Y" : "N";

            $valid = $modelQuote->validate();

            if (is_array($_POST['QuotesItem'])) {
                foreach ($_POST['QuotesItem'] as $i => $item) {
                    if (!empty($item['product_id'])) {
                        $modelQuoteItems[$i] = new QuotesItem;
                        $modelQuoteItems[$i]->attributes = $_POST['QuotesItem'][$i];
                        $valid = $modelQuoteItems[$i]->validate() && $valid;
                    }
                }
            }

            $valid = $valid && is_array($modelQuoteItems);
            $modelsToBeValidated = array($modelQuote, $modelQuoteItems);
            if (is_array($_POST['QuotesAddition'])) {
                foreach ($_POST['QuotesAddition'] as $i => $item) {
                    $modelQuoteAdditions[$i] = new QuotesAddition;
                    $modelQuoteAdditions[$i]->attributes = $_POST['QuotesAddition'][$i];
                    $valid = $modelQuoteAdditions[$i]->validate() && $valid;
                }

                $modelsToBeValidated[] = $modelQuoteAdditions;
            }

            if (is_array($_POST['QuotesDeduction'])) {
                foreach ($_POST['QuotesDeduction'] as $i => $item) {
                    $modelQuoteDeductions[$i] = new QuotesDeduction;
                    $modelQuoteDeductions[$i]->attributes = $_POST['QuotesDeduction'][$i];
                    $valid = $modelQuoteDeductions[$i]->validate() && $valid;
                }

                $modelsToBeValidated[] = $modelQuoteDeductions;
            }

            if ($valid) {
                $grand_total = 0;
                if(!$id)
                $modelQuote->file_id = $this->masterFile((int) @$modelQuote->file_id, 'Q', 3, $modelQuote->title, $modelQuote->company_id, $modelQuote->lead_owner_id);

                $modelQuote->save();
                $modelQuote->refresh();
                $quotes_id = $modelQuote->id;
                QuotesItem::model()->deleteAll('quotes_id=:refer_id', array(':refer_id' => $modelQuote->id));
                QuotesAddition::model()->deleteAll('quotes_id=:refer_id', array(':refer_id' => $modelQuote->id));
                QuotesDeduction::model()->deleteAll('quotes_id=:refer_id', array(':refer_id' => $modelQuote->id));
                AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $modelQuote->file_id));
                foreach ($modelQuoteItems as $eachModel) {
                    $eachModel->quotes_id = $quotes_id;
                    $eachModel->save();
                    $grand_total += $eachModel->net_amount;
                    if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                        $storeModel = Store::model()->findByPK($eachModel->product_id);
                        if ($storeModel->non_stock_item == "N") {
                            $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachModel->quantity;
                            if ($shoratge <= 0) {
                                $jsonData['shoratage'] .= "Item " . $eachModel->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                            }
                            else
                                $shoratge = 0;
                            $modelAllocatedMaterial = new AllocatedMaterial;
                            if (($t = AllocatedMaterial::model()->find('file_id=' . $modelQuote->file_id . ' AND product_id=' . $eachModel->product_id)) != null) {

                                $modelAllocatedMaterial = $t;
                            }

                            $modelAllocatedMaterial->product_id = $eachModel->product_id;
                            $modelAllocatedMaterial->file_id = $modelQuote->file_id;
                            $modelAllocatedMaterial->count = ($eachModel->quantity + $shoratge);
                            $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                            $modelCustom = CustomChanges::model()->find();
                            $custom_changes = CJSON::decode($modelCustom->changes);
                            if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                if ($modelQuote->qtn_validity > $end_date)
                                    $modelAllocatedMaterial->allocation_end_date = $end_date;
                                else
                                    $modelAllocatedMaterial->allocation_end_date = $modelQuote->qtn_validity;
                                $modelAllocatedMaterial->save(false);
                            }
                            else
                                $modelAllocatedMaterial->allocation_end_date = $modelQuote->qtn_validity;
                            $modelAllocatedMaterial->allocated_from = "Q";
                            $modelAllocatedMaterial->save(false);
                        }
                    }
                }

                foreach ($modelQuoteAdditions as $eachModel) {
                    $eachModel->quotes_id = $quotes_id;
                    $eachModel->save();
                    $grand_total += $eachModel->calculated_value;
                }

                foreach ($modelQuoteDeductions as $eachModel) {
                    $eachModel->quotes_id = $quotes_id;
                    $eachModel->save();
                    $grand_total += $eachModel->calculated_value;
                }
                $modelQuote->updateByPk($modelQuote->id, array('grand_total' => $grand_total));
                 $this->documents($modelQuote->file_id, 'Q');
                 $jsonData['file'] = $modelQuote->file;
                 $jsonData['quotation'] = $modelQuote;
                 $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($modelQuote, '', false), true);
                if (is_array($modelQuoteItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelQuoteItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error3 = json_decode(CActiveForm::validateTabular($modelQuoteAdditions, '', false), true);
                $error4 = json_decode(CActiveForm::validateTabular($modelQuoteDeductions, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4));
                if ($error != '[]')
                    echo $error;
            }

            Yii::app()->end();
        }

        if ($modelQuote->file_id > 0)
            Yii::app()->session['file_id'] = $modelQuote->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//sop/quotation/_quotesform', array(
            'modelQuote' => $modelQuote,'flag' => $flag,
            'modelQuoteItems' => $modelQuoteItems,
            'modelQuoteAdditions' => $modelQuoteAdditions,
            'modelQuoteDeductions' => $modelQuoteDeductions,
            'quotes_id' => (int) $quotes_id,
            'duplicate' => $duplicate
                ), false, true);
    }

    public function actionOrder() {
        $modelOrder = new Order;
        $modelOrderItems = array(new OrderItem);
        $modelOrderAdditions = array(new OrderAddition);
        $modelOrderDeductions = array(new OrderDeduction);
         $id = $_POST['Order']['id'];
        $order_id = (int) Yii::app()->request->getParam('id');
        $duplicate = (int) Yii::app()->request->getParam('duplicate');
        $flag = (int) Yii::app()->request->getParam('flag');
        if ($order_id) {
            $modelOrder = $modelOrder->findByPK($order_id);
            $modelOrderItems = $modelOrder->items;
            $modelOrderAdditions = count($modelOrder->adItems) > 0 ? $modelOrder->adItems : $modelOrderAdditions;
            $modelOrderDeductions = count($modelOrder->dedItems) > 0 ? $modelOrder->dedItems : $modelOrderDeductions;
            $modelOrder->scenario = 'update';
        }
        if (isset($_POST['Order'])) {
            if ((int) $_POST['Order']['id'] > 0) {
                $modelOrder = $modelOrder->findByPK($_POST['Order']['id']);
                $modelOrder->scenario = 'update';
            }
            $modelOrder->attributes = $_POST['Order'];
            $modelOrder->form_id = 4;
            $modelOrder->created_date = date('Y-m-d H:i:s a', time());
            $modelOrder->crm_user_id = Yii::app()->user->id;
            $modelOrder->materials_allocated = (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") ? "Y" : "N";
            $valid = $modelOrder->validate();

            if (is_array($_POST['OrderItem'])) {
                foreach ($_POST['OrderItem'] as $i => $item) {
                    if (!empty($item['product_id'])) {
                        $modelOrderItems[$i] = new OrderItem;
                        $modelOrderItems[$i]->attributes = $_POST['OrderItem'][$i];
                        $modelOrderItems[$i]->item_no = $_POST['Order'][file_id].($i+1);
                        $valid = $modelOrderItems[$i]->validate() && $valid;
                    }
                }
            }
            $valid = $valid && is_array($modelOrderItems);
            $modelsToBeValidated = array($modelOrder, $modelOrderItems);
            if (is_array($_POST['OrderAddition'])) {
                foreach ($_POST['OrderAddition'] as $i => $item) {
                    $modelOrderAdditions[$i] = new OrderAddition;
                    $modelOrderAdditions[$i]->attributes = $_POST['OrderAddition'][$i];
                    $modelOrderAdditions[$i]->addition_item_no = $_POST['Order'][file_id].($i+1);
                    $modelOrderAdditions[$i]->total_addition_value = $_POST['OrderAddition'][$i]['calculated_value'];
                    $valid = $modelOrderAdditions[$i]->validate() && $valid;
                }

                $modelsToBeValidated[] = $modelOrderAdditions;
            }

            if (is_array($_POST['OrderDeduction'])) {
                foreach ($_POST['OrderDeduction'] as $i => $item) {
                    $modelOrderDeductions[$i] = new OrderDeduction;
                    $modelOrderDeductions[$i]->attributes = $_POST['OrderDeduction'][$i];
                    $modelOrderDeductions[$i]->deduction_item_no = $_POST['Order'][file_id].($i+1);
                    $modelOrderDeductions[$i]->total_deduction_value = $_POST['OrderDeduction'][$i]['calculated_value'];
                    $valid = $modelOrderDeductions[$i]->validate() && $valid;
                }

                $modelsToBeValidated[] = $modelOrderDeductions;
            }

            if ($valid) {
                $grand_total = 0;
                if(!$id)
                $modelOrder->file_id = $this->masterFile((int) @$modelOrder->file_id, 'O', 4, $modelOrder->title, $modelOrder->company_id, $modelOrder->lead_owner_id);

                $modelOrder->save();
                $modelOrder->refresh();
                $order_id = $modelOrder->id;
                OrderItem::model()->deleteAll('order_id=:refer_id', array(':refer_id' => $modelOrder->id));
                OrderAddition::model()->deleteAll('order_id=:refer_id', array(':refer_id' => $modelOrder->id));
                OrderDeduction::model()->deleteAll('order_id=:refer_id', array(':refer_id' => $modelOrder->id));
                AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $modelOrder->file_id));
                foreach ($modelOrderItems as $eachModel) {
                    $eachModel->order_id = $order_id;
                    $eachModel->save();
                    $grand_total += $eachModel->net_amount;
                    if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                        $storeModel = Store::model()->findByPK($eachModel->product_id);
                        if ($storeModel->non_stock_item == "N") {
                            $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachModel->quantity;

                            if ($shoratge <= 0) {
                                $jsonData['shoratage'] .= "Item " . $eachModel->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                            }
                            else
                                $shoratge = 0;
                            $modelAllocatedMaterial = new AllocatedMaterial;
                            if (($t = AllocatedMaterial::model()->find('file_id=' . $modelOrder->file_id . ' AND product_id=' . $eachModel->product_id)) != null) {
                                $modelAllocatedMaterial = $t;
                            }
                            $modelAllocatedMaterial->product_id = $eachModel->product_id;
                            $modelAllocatedMaterial->file_id = $modelOrder->file_id;
                            $modelAllocatedMaterial->count = ($eachModel->quantity + $shoratge);
                            $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                            $modelCustom = CustomChanges::model()->find();
                            $custom_changes = CJSON::decode($modelCustom->changes);
                            if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                if ($modelOrder->qtn_validity > $end_date)
                                    $modelAllocatedMaterial->allocation_end_date = $end_date;
                                else
                                    $modelAllocatedMaterial->allocation_end_date = $modelOrder->delivery_date;
                                $modelAllocatedMaterial->save(false);
                            }
                            else
                                $modelAllocatedMaterial->allocation_end_date = $modelOrder->delivery_date;
                            $modelAllocatedMaterial->allocated_from = "O";
                            $modelAllocatedMaterial->save(false);
                        }
                    }
                }

                foreach ($modelOrderAdditions as $eachModel) {
                    $eachModel->order_id = $order_id;
                    $eachModel->save();
                    $grand_total += $eachModel->calculated_value;
                }

                foreach ($modelOrderDeductions as $eachModel) {
                    $eachModel->order_id = $order_id;
                    $eachModel->save();
                    $grand_total -= $eachModel->calculated_value;
                }
                $modelOrder->updateByPk($modelOrder->id, array('grand_total' => $grand_total));
                 $this->documents($modelOrder->file_id, 'O');
                 $jsonData['file'] = $modelQuote->file;
                 $jsonData['order'] = $modelOrder;
                 $jsonData['status'] = 'success';

                //calculating pending amount

                $files = MasterFile::model()->findAll(array('condition' => 'company_id=' . (int) $modelOrder->company_id . ' AND(current_process_status="D" OR current_process_status="PD" OR current_process_status="I" OR current_process_status="PI") '));

                $amount_pending = 0;

                foreach ($files as $eachFile) {
                    $amount_pending += $eachFile->order->grand_total;
                    foreach ($eachFile->invoices as $eachInvoice)
                        $amount_pending += ($eachInvoice->grand_total - $eachInvoice->receivedAmount);
                }

                if ($amount_pending > $eachFile->company->credit_limit) {

                    $jsonData['creditlimit'] .= "A pending of " . $amount_pending . " need to collect from " . $eachFile->company->company_name;

                    //send a mail to branch head here
                }

                echo CJSON::encode($jsonData);
            } else {

                $error1 = json_decode(CActiveForm::validate($modelOrder, '', false), true);
                if (is_array($modelOrderItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelOrderItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error3 = json_decode(CActiveForm::validateTabular($modelOrderAdditions, '', false), true);
                $error4 = json_decode(CActiveForm::validateTabular($modelOrderDeductions, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4));
                if ($error != '[]')
                    echo $error;
            }

            Yii::app()->end();
        }

        if ($modelOrder->file_id > 0)
            Yii::app()->session['file_id'] = $modelOrder->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//sop/order/_orderform', array(
            'modelOrder' => $modelOrder,'flag' => $flag,
            'modelOrderItems' => $modelOrderItems,
            'modelOrderAdditions' => $modelOrderAdditions,
            'modelOrderDeductions' => $modelOrderDeductions,
            'order_id' => (int) $order_id,
            'duplicate' => $duplicate
                ), false, true);
    }

    public function actionInvoice($current_form_status="PI") {
        $modelInvoice = new Invoice;
        $modelInvoiceItem = array(new InvoiceItem);
        $modelInvoiceAddition = array(new InvoiceAddition);
        $modelInvoiceDeduction = array(new InvoiceDeduction);
//print_r($modelInvoiceItem);die();
        $id = $_POST['Invoice']['id'];
        $invoice_id = (int) Yii::app()->request->getParam('id');
        $duplicate  = (int) Yii::app()->request->getParam('duplicate');
        $flag = (int) Yii::app()->request->getParam('flag');
        if ($invoice_id) {
            $modelInvoice = $modelInvoice->findByPK($invoice_id);
            $modelInvoiceItem = $modelInvoice->items;
            $modelInvoiceAddition = count($modelInvoice->adItems) > 0 ? $modelInvoice->adItems : $modelInvoiceAddition;
            $modelInvoiceDeduction = count($modelInvoice->dedItems) > 0 ? $modelInvoice->dedItems : $modelInvoiceDeduction;
            $modelInvoice->scenario = 'update';
        }

        if (isset($_POST['Invoice'])) {
            $grandTotal = 0;
            $orderGrandTotal = Order::model()->find(array('condition' => 'file_id=' . $_POST['Invoice']['file_id']));
            $invoiceGranTotal = Invoice::model()->findAll(array('condition' => 'order_id=' . $_POST['Invoice']['order_id']));
            $invoiceNo = Invoice::model()->find(array('condition' => 'order_id=' . $_POST['Invoice']['order_id'].' AND file_id='.$_POST['Invoice']['file_id'].'  order by id DESC'));
            foreach($invoiceGranTotal as $eachinvoiceGranTotal){
                $grandTotal = $grandTotal+$eachinvoiceGranTotal['grand_total'];
            }
            $grandTotal = $grandTotal+$_POST['grandotal']; 
            if ($grandTotal <= $orderGrandTotal['grand_total']) {
                if ((int) $_POST['Invoice']['id'] > 0) {
                    $modelInvoice = $modelInvoice->findByPK($_POST['Invoice']['id']);
                    $modelInvoice->scenario = 'update';
                }
                $modelInvoice->attributes = $_POST['Invoice'];
                $modelInvoice->form_id = 13;
                $modelInvoice->created_date = date('Y-m-d H:i:s a', time());
                $modelInvoice->crm_user_id = Yii::app()->user->id;
                if($invoiceNo){
                   $modelInvoice->invoice_no =  $invoiceNo->invoice_no + 1;
                }
                else{
                    $modelInvoice->invoice_no = 1;
                }
                //$modelInvoice->materials_allocated = (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") ? "Y" : "N";

                $valid = $modelInvoice->validate();
                if (is_array($_POST['InvoiceItem'])) {
                   
                    foreach ($_POST['InvoiceItem'] as $i => $item) {
                        if (!empty($item['product_id'])) {
                            
                            if($_POST['InvoiceItem'][$i]['quantity']*$_POST['InvoiceItem'][$i]['rate'] != $_POST['InvoiceItem'][$i]['invoiced'] ){
                            $modelInvoiceItem[$i] = new InvoiceItem;
                            $modelInvoiceItem[$i]->attributes = $_POST['InvoiceItem'][$i];
                            $modelInvoiceItem[$i]->net_rate = $_POST['InvoiceItem'][$i]['rate'];
                            $itemno =  $_POST['InvoiceItem'][$i]['item_no'];
                            $item_no = InvoiceItem::model()->find(array('condition' => 'item_no=' .$itemno .'  order by id DESC'));
                           
                           if($item_no){
                            $modelInvoiceItem[$i]->invoiced = $item_no['invoiced']+$_POST['InvoiceItem'][$i]['amount'];
                            $modelInvoiceItem[$i]->pending = $item_no['pending']-$_POST['InvoiceItem'][$i]['amount'];
                            if($modelInvoiceItem[$i]->invoiced == $modelInvoiceItem[$i]->net_rate){
                                 $modelInvoiceItem[$i]->item_invoice_status = "Y";
                                }
                            }
                            else{
                                $modelInvoiceItem[$i]->invoiced = $_POST['InvoiceItem'][$i]['amount'];
                                $modelInvoiceItem[$i]->pending = $modelInvoiceItem[$i]->net_rate-$_POST['InvoiceItem'][$i]['amount'];
                                if($modelInvoiceItem[$i]->invoiced == $modelInvoiceItem[$i]->net_rate){
                                 $modelInvoiceItem[$i]->item_invoice_status = "Y";
                                }
                            }
                            $valid = $modelInvoiceItem[$i]->validate() && $valid;
                            }
                        }
                    }
                }

                $valid = $valid && is_array($modelInvoiceItem);
                $modelsToBeValidated = array($modelInvoice, $modelInvoiceItem);
                if (is_array($_POST['InvoiceAddition'])) {
                    foreach ($_POST['InvoiceAddition'] as $i => $item) {
                        $modelInvoiceAddition[$i] = new InvoiceAddition;
                        $modelInvoiceAddition[$i]->attributes = $_POST['InvoiceAddition'][$i];
                        $modelInvoiceAddition[$i]->total_addition_value = $_POST['InvoiceAddition'][$i]['total_addition_value'];
                        $valid = $modelInvoiceAddition[$i]->validate() && $valid;
                    }
                    $modelsToBeValidated[] = $modelInvoiceAddition;
                }
                if (is_array($_POST['InvoiceDeduction'])) {
                    foreach ($_POST['InvoiceDeduction'] as $i => $item) {
                        $modelInvoiceDeduction[$i] = new InvoiceDeduction;
                        $modelInvoiceDeduction[$i]->attributes = $_POST['InvoiceDeduction'][$i];
                        $modelInvoiceDeduction[$i]->total_deduction_value = $_POST['InvoiceDeduction'][$i]['total_deduction_value'];
                        $valid = $modelInvoiceDeduction[$i]->validate() && $valid;
                    }

                    $modelsToBeValidated[] = $modelInvoiceDeduction;
                }
                 
                if ($valid) {
                    $grand_total = 0;
                    $modelInvoice->save(); 
                    $modelInvoice->refresh();
                    $invoice_id = $modelInvoice->id;
                    //InvoiceItem::model()->deleteAll('invoice_id=:refer_id', array(':refer_id' => $modelInvoice->id));
                   // InvoiceAddition::model()->deleteAll('invoice_id=:refer_id', array(':refer_id' => $modelInvoice->id));
                    //InvoiceDeduction::model()->deleteAll('invoice_id=:refer_id', array(':refer_id' => $modelInvoice->id));
                    AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $modelInvoice->file_id));
                    foreach ($modelInvoiceItem as $eachModel) {
                        $eachModel->invoice_id = $invoice_id;
                        $eachModel->save();
                        $grand_total += $eachModel->net_amount;
                        if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                            $storeModel = Store::model()->findByPK($eachModel->product_id);
                            if ($storeModel->non_stock_item == "N") {
                                $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachModel->quantity;
                                if ($shoratge <= 0) {
                                    $jsonData['shoratage'] .= "Item " . $eachModel->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                                }
                                else
                                    $shoratge = 0;
                                $modelAllocatedMaterial = new AllocatedMaterial;
                                if (($t = AllocatedMaterial::model()->find('file_id=' . $modelInvoice->file_id . ' AND product_id=' . $eachModel->product_id)) != null) {

                                    $modelAllocatedMaterial = $t;
                                }
                                $modelAllocatedMaterial->product_id = $eachModel->product_id;
                                $modelAllocatedMaterial->file_id = $modelInvoice->file_id;
                                $modelAllocatedMaterial->count = ($eachModel->quantity + $shoratge);
                                $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                                $modelCustom = CustomChanges::model()->find();
                                $custom_changes = CJSON::decode($modelCustom->changes);
                                if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                    $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                    if ($modelInvoice->qtn_validity > $end_date)
                                        $modelAllocatedMaterial->allocation_end_date = $end_date;
                                    else
                                        $modelAllocatedMaterial->allocation_end_date = $modelInvoice->delivery_date;
                                    $modelAllocatedMaterial->save(false);
                                }
                                else
                                    $modelAllocatedMaterial->allocation_end_date = $modelInvoice->delivery_date;
                                $modelAllocatedMaterial->allocated_from = "I";
                                $modelAllocatedMaterial->save(false);
                            }
                        }
                    }
                    foreach ($modelInvoiceAddition as $eachModel) {
                        $eachModel->invoice_id = $invoice_id;
                        $eachModel->save();
                        $grand_total += $eachModel->calculated_value;
                    }
                   
                    foreach ($modelInvoiceDeduction as $eachModel) {
                        $eachModel->invoice_id = $invoice_id;
                        $eachModel->save();
                        $grand_total -= $eachModel->calculated_value;
                    }
                    $modelInvoice->updateByPk($modelInvoice->id, array('grand_total' => $grand_total));
                    $modelInvoice->title = $_POST['Invoice']['title'];
                    $modelInvoice->lead_owner = $_POST['Invoice']['lead_owner_id'];
                    $invoiceItemStatus =  InvoiceItem::model()->count(array('condition' => 'invoice_id=' .$invoice_id ));
                    $invoiceItemStatusCount =  InvoiceItem::model()->count(array('condition' => 'invoice_id=' .$invoice_id.' AND item_invoice_status="Y"' ));
                    if($invoiceItemStatus==$invoiceItemStatusCount){
                        $current_form_status="I";
                    }
                   
                    $modelInvoice->file_id = $this->masterFile((int) @$modelInvoice->file_id, $current_form_status, '13', $modelInvoice->title, $modelInvoice->company_id, $modelInvoice->lead_owner);
                    $jsonData['file'] = $modelInvoice->file;
                    $jsonData['invoice'] = $modelInvoice;
                    $jsonData['status'] = 'success';
                    $files = MasterFile::model()->findAll(array('condition' => 'company_id=' . (int) $modelInvoice->company_id . ' AND(current_process_status="D" OR current_process_status="PD" OR current_process_status="I" OR current_process_status="PI") '));

                    $amount_pending = 0;
                    foreach ($files as $eachFile) {
                        $amount_pending += $eachFile->order->grand_total;
                        foreach ($eachFile->invoices as $eachInvoice)
                            $amount_pending += ($eachInvoice->grand_total - $eachInvoice->receivedAmount);
                    }
                    if ($amount_pending > $eachFile->company->credit_limit) {
                        $jsonData['creditlimit'] .= "A pending of " . $amount_pending . " need to collect from " . $eachFile->company->company_name;

                        //send a mail to branch head here
                    }
                    echo CJSON::encode($jsonData);
                } else {

                    $error1 = json_decode(CActiveForm::validate($modelInvoice, '', false), true);
                    if (is_array($modelInvoiceItem))
                        $error2 = json_decode(CActiveForm::validateTabular($modelInvoiceItem, '', false), true);
                    else
                        $error2[] = "Please add atleast one line item";

                    $error3 = json_decode(CActiveForm::validateTabular($modelInvoiceAddition, '', false), true);
                    $error4 = json_decode(CActiveForm::validateTabular($modelInvoiceDeduction, '', false), true);
                    $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4));

                    if ($error != '[]')
                        echo $error;
                }
            }
            else {
                $jsonData['error'] = "Invoice grand total shouldn't be greater than ordered value";
                echo CJSON::encode($jsonData);
            }
            Yii::app()->end();
        }

        if ($modelInvoice->file_id > 0)
            Yii::app()->session['file_id'] = $modelInvoice->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//sop/invoices/_invoiceform', array(
            'modelInvoice' => $modelInvoice,'flag' => $flag,
            'modelInvoiceItem' => $modelInvoiceItem,
            'modelInvoiceAddition' => $modelInvoiceAddition,
            'modelInvoiceDeduction' => $modelInvoiceDeduction,
            'invoice_id' => (int) $invoice_id,
            'duplicate' => $duplicate
                ), false, true);
    }

    public function actionDelivery($current_form_status="PD",$delivery_status="partial") {

        $modelDeliveryNote = new DeliveryNote;
        $modelDeliveryNoteItem = array(new DeliveryNoteItem);
        //print_r($modelDeliveryItem);die();
        $delivery_id = (int) Yii::app()->request->getParam('id');
        $duplicate = (int) Yii::app()->request->getParam('duplicate');
        $flag = (int) Yii::app()->request->getParam('flag');
        if ($delivery_id) {
            $modelDeliveryNote = $modelDeliveryNote->findByPK($delivery_id);
            $modelDeliveryNoteItem = $modelDeliveryNote->items;
            $modelDeliveryNote->scenario = 'update';
        }

        if (isset($_POST['DeliveryNote'])) {
            $orderGrandTotal = Order::model()->find(array('condition' => 'file_id=' . $_POST['DeliveryNote']['file_id']));
           
                if ((int) $_POST['DeliveryNote']['id'] > 0) {
                    $modelDeliveryNote = $modelDeliveryNote->findByPK($_POST['Delivery']['id']);
                    $modelDeliveryNote->scenario = 'update';
                }

                $modelDeliveryNote->attributes = $_POST['DeliveryNote'];
                $modelDeliveryNote->form_id = 14;
                $modelDeliveryNote->created_date = date('Y-m-d H:i:s a', time());
                $modelDeliveryNote->crm_user_id = Yii::app()->user->id;
                //$modelInvoice->materials_allocated = (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") ? "Y" : "N";

                $valid = $modelDeliveryNote->validate();
                if (is_array($_POST['DeliveryNoteItem'])) {
                    foreach ($_POST['DeliveryNoteItem'] as $i => $item) {
                        if (!empty($item['product_id'])) {
                            $modelDeliveryNoteItem[$i] = new DeliveryNoteItem;
                            $modelDeliveryNoteItem[$i]->attributes = $_POST['DeliveryNoteItem'][$i];
                            $itemno =  $_POST['DeliveryNoteItem'][$i]['item_no'];
                            $item_no = DeliveryNoteItem::model()->find(array('condition' => 'item_no=' .$itemno .'  order by id DESC'));
                           
                           if($item_no){
                            $modelDeliveryNoteItem[$i]->delivered = $item_no['delivered']+$_POST['DeliveryNoteItem'][$i]['picked_qty'];
                            $modelDeliveryNoteItem[$i]->pending = $item_no['pending']-$_POST['DeliveryNoteItem'][$i]['picked_qty'];
                            if($modelDeliveryNoteItem[$i]->delivered == $modelDeliveryNoteItem[$i]->quantity){
                                 $modelDeliveryNoteItem[$i]->item_delivery_status = "Y";
                                }
                            }
                            else{
                                $modelDeliveryNoteItem[$i]->delivered = $_POST['DeliveryNoteItem'][$i]['picked_qty'];
                                $modelDeliveryNoteItem[$i]->pending = $modelDeliveryNoteItem[$i]->quantity-$_POST['DeliveryNoteItem'][$i]['picked_qty'];
                                if($modelDeliveryNoteItem[$i]->delivered == $modelDeliveryNoteItem[$i]->quantity){
                                 $modelDeliveryNoteItem[$i]->item_delivery_status = "Y";
                                }
                            }
                            $valid = $modelDeliveryNoteItem[$i]->validate() && $valid;
                        }
                    }
                }

                $valid = $valid && is_array($modelDeliveryNoteItem);
                $modelsToBeValidated = array($modelDeliveryNote, $modelDeliveryNoteItem);

                if ($valid) {
                    $grand_total = 0;
                    $modelDeliveryNote->file_id = $this->masterFile((int) @$modelDeliveryNote->file_id, 'I', '13', $modelDeliveryNote->title, $modelDeliveryNote->company_id, "$modelDeliveryNote->lead_owner_id");

                    $modelDeliveryNote->save();
                    $modelDeliveryNote->refresh();
                    $delivery_id = $modelDeliveryNote->id;
                    //DeliveryItem::model()->deleteAll('delivery_note_id=:refer_id', array(':refer_id' => $modelDeliveryNote->id));
                    AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $modelDeliveryNote->file_id));
                    foreach ($modelDeliveryNoteItem as $eachModel) {
                        $eachModel->delivery_note_id = $delivery_id;
                        $eachModel->save();
                        if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                            $storeModel = Store::model()->findByPK($eachModel->product_id);
                            if ($storeModel->non_stock_item == "N") {
                                $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachModel->quantity;
                                if ($shoratge <= 0) {
                                    $jsonData['shoratage'] .= "Item " . $eachModel->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                                }
                                else
                                    $shoratge = 0;
                                $modelAllocatedMaterial = new AllocatedMaterial;
                                if (($t = AllocatedMaterial::model()->find('file_id=' . $modelDeliveryNote->file_id . ' AND product_id=' . $eachModel->product_id)) != null) {

                                    $modelAllocatedMaterial = $t;
                                }
                                $modelAllocatedMaterial->product_id = $eachModel->product_id;
                                $modelAllocatedMaterial->file_id = $modelDeliveryNote->file_id;
                                $modelAllocatedMaterial->count = ($eachModel->quantity + $shoratge);
                                $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                                $modelCustom = CustomChanges::model()->find();
                                $custom_changes = CJSON::decode($modelCustom->changes);
                                if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                    $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                    if ($modelDeliveryNote->qtn_validity > $end_date)
                                        $modelAllocatedMaterial->allocation_end_date = $end_date;
                                    else
                                        $modelAllocatedMaterial->allocation_end_date = $modelDeliveryNote->delivery_date;
                                    $modelAllocatedMaterial->save(false);
                                }
                                else
                                    $modelAllocatedMaterial->allocation_end_date = $modelDeliveryNote->delivery_date;
                                $modelAllocatedMaterial->allocated_from = "I";
                                $modelAllocatedMaterial->save(false);
                            }
                        }
                    }
                    $deliveryItemStatus =  DeliveryNoteItem::model()->count(array('condition' => 'delivery_note_id=' .$delivery_id ));
                    $deliveryItemStatusCount =  DeliveryNoteItem::model()->count(array('condition' => 'delivery_note_id=' .$delivery_id.' AND item_delivery_status="Y"' ));
                    if($deliveryItemStatus==$deliveryItemStatusCount){
                        $current_form_status="D";
                        $delivery_status = "complete";
                    }
                    
                    $modelDeliveryNote->file_id = $this->masterFile((int) @$modelDeliveryNote->file_id, $current_form_status, '14', $modelDeliveryNote->title, $modelDeliveryNote->company_id);
                    $modelDeliveryNote->updateByPk($delivery_id, array('delivery_status' => $delivery_status));
                    $jsonData['file'] = $modelDeliveryNote->file;
                    $jsonData['delivery'] = $modelDeliveryNote;
                    $jsonData['status'] = 'success';
                    $files = MasterFile::model()->findAll(array('condition' => 'company_id=' . (int) $modelDeliveryNote->company_id . ' AND(current_process_status="D" OR current_process_status="PD" OR current_process_status="I" OR current_process_status="PI") '));

                    $amount_pending = 0;
                    foreach ($files as $eachFile) {
                        $amount_pending += $eachFile->order->grand_total;
                        foreach ($eachFile->invoices as $eachDelivery)
                            $amount_pending += ($eachDelivery->grand_total - $eachDelivery->receivedAmount);
                    }
                    if ($amount_pending > $eachFile->company->credit_limit) {
                        $jsonData['creditlimit'] .= "A pending of " . $amount_pending . " need to collect from " . $eachFile->company->company_name;

                        //send a mail to branch head here
                    }
                    echo CJSON::encode($jsonData);
                } else {

                    $error1 = json_decode(CActiveForm::validate($modelDeliveryNote, '', false), true);
                    if (is_array($modelDeliveryNoteItem))
                        $error2 = json_decode(CActiveForm::validateTabular($modelDeliveryNoteItem, '', false), true);
                    else
                        $error2[] = "Please add atleast one line item";

                    
                    $error = CJSON::encode(array_merge_recursive($error1, $error2));

                    if ($error != '[]')
                        echo $error;
                }
            
            Yii::app()->end();
        }

        if ($modelDeliveryNote->file_id > 0)
            Yii::app()->session['file_id'] = $modelDeliveryNote->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//sop/delivery/_deliveryform', array(
            'modelDeliveryNote' => $modelDeliveryNote,'flag' => $flag,
            'modelDeliveryNoteItem' => $modelDeliveryNoteItem,
            'delivery_id' => (int) $delivery_id,
            'duplicate' => $duplicate
                ), false, true);
    }

}