<?php

/**
 * This is the model class for table "crm_form_boq_item_schedule".
 *
 * The followings are the available columns in table 'crm_form_boq_item_schedule':
 * @property integer $id
 * @property string $category_name
 * @property integer $file_no
 * @property integer $form_boq_id
 */
class FormBoqItemSchedule extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'crm_form_boq_item_schedule';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			//array('category_name, file_no, form_boq_id', 'required'),
			array('file_no, form_boq_id,category_id', 'numerical', 'integerOnly'=>true),
			array('schedule_name', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, schedule_name, file_no, form_boq_id', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'schedule_name' => 'Category Name For Current File',
			'file_no' => 'File No',
			'form_boq_id' => 'Form Boq',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('schedule_name',$this->schedule_name,true);
		$criteria->compare('file_no',$this->file_no);
		$criteria->compare('form_boq_id',$this->form_boq_id);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return FormBoqItemSchedule the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
        public  function getSchedule($file_id){
          $model = self::model()->findAll(array('condition'=>'file_no='.$file_id));
         return CHtml::listData($model, 'id','schedule_name');
        }
        public  function getCategory($boq_file_id){
            $criteria=new CDbCriteria;
            if($boq_file_id)
                $criteria->addCondition('file_no='.$boq_file_id);

            return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
        }
        
}
