<?php

/**
 * This is the model class for table "crm_form_boq_recommended_spare_parts".
 *
 * The followings are the available columns in table 'crm_form_boq_recommended_spare_parts':
 * @property integer $id
 * @property string $tag_no
 * @property string $equipment_description
 * @property string $spare_description
 * @property string $quantity
 * @property string $remarks
 * @property string $created_date
 */
class FormBoqRecommendedSpareParts extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{form_boq_recommended_spare_parts}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			//array('tag_no, equipment_description, spare_description, quantity, remarks, created_date', 'required'),
			array('id,form_boq_id', 'numerical', 'integerOnly'=>true),
			array('tag_no, equipment_description, spare_description, quantity, remarks', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, tag_no, equipment_description, spare_description, quantity, remarks, created_date', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'tag_no' => 'Tag No',
			'equipment_description' => 'Equipment Description',
			'spare_description' => 'Spare Description',
			'quantity' => 'Quantity',
			'remarks' => 'Remarks',
			'created_date' => 'Created Date',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('tag_no',$this->tag_no,true);
		$criteria->compare('equipment_description',$this->equipment_description,true);
		$criteria->compare('spare_description',$this->spare_description,true);
		$criteria->compare('quantity',$this->quantity,true);
		$criteria->compare('remarks',$this->remarks,true);
		$criteria->compare('created_date',$this->created_date,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return CrmFormBoqRecommendedSpareParts the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
