<?php

/**
 * This is the model class for table "{{form_ho_scope}}".
 *
 * The followings are the available columns in table '{{form_ho_scope}}':
 * @property integer $form_ho_id
 * @property integer $supply
 * @property integer $supply_exfactory
 * @property integer $supply_fabrication
 * @property integer $delivery
 * @property integer $delivery_fob
 * @property integer $delivery_cfr
 * @property integer $delivery_cfa
 * @property integer $delivery_cif
 * @property integer $delivery_others
 * @property integer $installation
 * @property integer $installation_pact_team
 * @property integer $installation_supervision
 * @property integer $commisioning
 * @property integer $commisioning_pact_team
 * @property integer $commisioning_supervision
 */
class FormHoScope extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return '{{form_ho_scope}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('maintenance_pact_team,maintenance_supervision,delivery_ex_work,delivery_d_d,form_ho_id, design, engineering, supply_fabrication, delivery, delivery_fob, delivery_cfr, delivery_cfa, delivery_cif, delivery_others, installation, installation_pact_team, installation_supervision, commisioning, commisioning_pact_team, commisioning_supervision', 'safe'),
            array('maintenance_pact_team,maintenance_supervision,form_ho_id, design, engineering, supply_fabrication, delivery, delivery_fob, delivery_cfr, delivery_cfa, delivery_cif,  installation, installation_pact_team, installation_supervision, commisioning, commisioning_pact_team, commisioning_supervision', 'numerical', 'integerOnly' => true),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('form_ho_id, design, engineering, supply_fabrication, delivery, delivery_fob, delivery_cfr, delivery_cfa, delivery_cif, delivery_others, installation, installation_pact_team, installation_supervision, commisioning, commisioning_pact_team, commisioning_supervision', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'form_ho_id' => 'Form Ho',
            'design' => 'Design',
            'engineering' => 'Engineering',
            'supply_fabrication' => 'Fabrication',
            'delivery' => 'Delivery',
            'delivery_ex_work' => 'Ex-Work',
            'delivery_d_d' => 'Door to Door',
            'delivery_fob' => 'FOB',
            'delivery_cfr' => 'CFR',
            'delivery_cfa' => 'CFA',
            'delivery_cif' => 'CIF',
            'delivery_others' => 'Others',
            'installation' => 'Installation',
            'installation_pact_team' => 'PACT Team',
            'installation_supervision' => 'Supervision',
            'commisioning' => 'Commissioning',
            'commisioning_pact_team' => 'PACT Team',
            'commisioning_supervision' => 'Supervision',
            'maintenance_pact_team' => 'PACT Team',
            'maintenance_supervision' => 'Supervision'
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('form_ho_id', $this->form_ho_id);
        $criteria->compare('design', $this->design);
        $criteria->compare('engineering', $this->engineering);
        $criteria->compare('supply_fabrication', $this->supply_fabrication);
        $criteria->compare('delivery', $this->delivery);
        $criteria->compare('delivery_fob', $this->delivery_fob);
        $criteria->compare('delivery_cfr', $this->delivery_cfr);
        $criteria->compare('delivery_cfa', $this->delivery_cfa);
        $criteria->compare('delivery_cif', $this->delivery_cif);
        $criteria->compare('delivery_others', $this->delivery_others);
        $criteria->compare('installation', $this->installation);
        $criteria->compare('installation_pact_team', $this->installation_pact_team);
        $criteria->compare('installation_supervision', $this->installation_supervision);
        $criteria->compare('commisioning', $this->commisioning);
        $criteria->compare('commisioning_pact_team', $this->commisioning_pact_team);
        $criteria->compare('commisioning_supervision', $this->commisioning_supervision);
        
        $criteria->compare('maintenance_pact_team', $this->maintenance_pact_team);
        $criteria->compare('maintenance_supervision', $this->maintenance_supervision);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return FormHoScope the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
