<?php

/**
 * This is the model class for table "{{form_ho_type}}".
 *
 * The followings are the available columns in table '{{form_ho_type}}':
 * @property integer $form_rfq_id
 * @property integer $water_treatment
 * @property string $water_treatment_process
 * @property string $water_treatment_capacity
 * @property integer $waste_water_treatment
 * @property string $waste_water_treatment_process
 * @property string $waste_water_capacity
 * @property integer $skid
 * @property integer $containerized
 * @property integer $custom_built_at_site
 */
class FormHoType extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return '{{form_ho_type}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('form_ho_id, water_treatment, water_treatment_process, water_treatment_capacity, waste_water_treatment, 
                            waste_water_treatment_process, waste_water_capacity, skid, containerized, custom_built_at_site,water_treatment_wtp,
                            water_treatment_desalination,water_treatment_uf,water_treatment_demin,water_treatment_others,waste_water_treatment_sbr,
                            waste_water_treatment_mbbr,waste_water_treatment_saf,waste_water_treatment_mbr,waste_water_treatment_extended_areation,
                            waste_water_treatment_others,water_treatment_filteration_softner,waste_water_treatment_grey_water,desalination_swro,desalination_bwro,desalination_hbro
                            ', 'safe'),
            array('form_ho_id, water_treatment, waste_water_treatment, skid, containerized, custom_built_at_site,
                water_treatment_filteration_softner,waste_water_treatment_grey_water', 'numerical', 'integerOnly' => true),
            array('water_treatment_process, water_treatment_capacity, waste_water_treatment_process, waste_water_capacity', 'length', 'max' => 255),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('form_ho_id, water_treatment, water_treatment_process, water_treatment_capacity, waste_water_treatment, waste_water_treatment_process, waste_water_capacity, skid, containerized, custom_built_at_site', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'form_ho_id' => 'Form Rfq',
            'water_treatment' => 'Water Treatment',
            'water_treatment_process' => 'Process',
            'water_treatment_capacity' => 'Capacity',
            'waste_water_treatment' => 'Waste Water Treatment',
            'waste_water_treatment_process' => 'Process',
            'waste_water_capacity' => 'Capacity',
            'skid' => 'Skid',
            'containerized' => 'Containerized',
            'custom_built_at_site' => 'Custom Built at Site',
            'water_treatment_wtp' => 'WTP',
            'water_treatment_desalination' => 'Desalination',
            'water_treatment_uf' => 'UF',
            'water_treatment_demin' => 'Demin',
            'water_treatment_filteration_softner'=>'Fileteration/Softner',
            'water_treatment_others' => 'Others',
            'waste_water_treatment_sbr' => 'SBR',
            'waste_water_treatment_mbbr' => 'MBBR',
            'waste_water_treatment_saf' => 'SAF',
            'waste_water_treatment_mbr' => 'MBR',
            'waste_water_treatment_extended_areation' => 'Extended Areation',
            'waste_water_treatment_others' => 'Others',
            'waste_water_treatment_grey_water'=>'Grey Water',
            'desalination_swro' => 'SWRO',
            'desalination_bwro' => 'BWRO',
            'desalination_hbro' => 'HBRO',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('form_ho_id', $this->form_ho_id);
        $criteria->compare('water_treatment', $this->water_treatment);
        $criteria->compare('water_treatment_process', $this->water_treatment_process, true);
        $criteria->compare('water_treatment_capacity', $this->water_treatment_capacity, true);
        $criteria->compare('waste_water_treatment', $this->waste_water_treatment);
        $criteria->compare('waste_water_treatment_process', $this->waste_water_treatment_process, true);
        $criteria->compare('waste_water_capacity', $this->waste_water_capacity, true);
        $criteria->compare('skid', $this->skid);
        $criteria->compare('containerized', $this->containerized);
        $criteria->compare('custom_built_at_site', $this->custom_built_at_site);
        $criteria->compare('water_treatment_filteration_softner', $this->water_treatment_filteration_softner);
        $criteria->compare('waste_water_treatment_grey_water', $this->waste_water_treatment_grey_water);
        

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return FormHoType the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
