<?php

/**
 * This is the model class for table "{{form_rfq_type}}".
 *
 * The followings are the available columns in table '{{form_rfq_type}}':

 * @property integer $form_rfq_id
 * @property integer $sea_water_ro
 * @property integer $blackish_water_ro
 * @property integer $river_water_treatment_plant_wtp
 * @property integer $industrial_waste_treatment_plane_etp
 * @property integer $mbbr
 * @property integer $mbr
 * @property integer $greywater_system
 * @property integer $saf_system
 * @property integer $demin_system
 * @property integer $softner
 * @property integer $miscellaneous
 */
class FormRfqType extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return '{{form_rfq_type}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('notes,filteration_system,desalination, river_water_treatment_plant_wtp, municipal,industrial, demin_system, softner, miscellaneous', 'safe'),
            array('form_rfq_id, sea_water_ro, blackish_water_ro, river_water_treatment_plant_wtp, municipal,industrial, demin_system, softner, miscellaneous', 'numerical', 'integerOnly' => true),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('form_rfq_id, sea_water_ro, blackish_water_ro, river_water_treatment_plant_wtp, greywater_system, saf_system, demin_system, softner, miscellaneous', 'safe', 'on' => 'search'),
            array('form_rfq_id', 'safe')
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'form_rfq_id' => 'Form Rfq',
            //'sea_water_ro' => 'Desalination (SWRO)',
            //'blackish_water_ro' => 'Desalination (BWRO)',
            'tse_ro' => 'TSE RO',
            //'high_brackish_water_ro'=>'Desalination (HBRO)',
            'desalination' => 'Desalination',
            'river_water_treatment_plant_wtp' => 'River Water Treatment Plant-CWTP',
            'municipal' => 'Municipal',
            'industrial' => 'Industrial',
            'demin_system' => 'Demin',
            'softner' => 'UF',
            'filteration_system' => 'Filteration/Softner',
            'miscellaneous' => 'Miscellaneous',
            'notes' => 'Other Notes'
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;


        $criteria->compare('form_rfq_id', $this->form_rfq_id);
        //$criteria->compare('sea_water_ro', $this->sea_water_ro);
        //$criteria->compare('blackish_water_ro', $this->blackish_water_ro);
        $criteria->compare('river_water_treatment_plant_wtp', $this->river_water_treatment_plant_wtp);
        $criteria->compare('municipal', $this->municipal);
        $criteria->compare('industrial', $this->industrial);
        $criteria->compare('demin_system', $this->demin_system);
        $criteria->compare('softner', $this->softner);
        $criteria->compare('miscellaneous', $this->miscellaneous);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return FormRfqType the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
