<?php

/**
 * This is the model class for table "{{form_rfq_wtd}}".
 *
 * The followings are the available columns in table '{{form_rfq_wtd}}':
 * @property integer $form_rfq_id
 * @property string $capacity
 * @property string $water_source
 * @property string $temperature
 * @property string $ph
 * @property string $bod
 * @property string $tss
 * @property string $tds
 * @property string $conductivity
 * @property string $chlorides
 * @property string $iron
 * @property string $total_hardness
 * @property string $oil_grease
 * @property string $turbidity
 * @property string $any_other
 */
class FormRfqWtd extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{form_rfq_wtd}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('form_rfq_id, capacity, water_source, temperature, ph, bod, tss, tds, conductivity, chlorides, iron,boron,manganese,silica, total_hardness, oil_grease, turbidity, any_other', 'safe'),
			array('form_rfq_id', 'numerical', 'integerOnly'=>true),
			array('capacity, water_source, temperature, ph, bod, tss, tds, conductivity, chlorides, iron,boron,manganese,silica, total_hardness, oil_grease, turbidity, any_other', 'length', 'max'=>100),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('form_rfq_id, capacity, water_source, temperature, ph, bod, tss, tds, conductivity, chlorides, iron,boron,manganese,silica, total_hardness, oil_grease, turbidity, any_other', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'form_rfq_id' => 'Form Rfq',
			'capacity' => 'Capacity',
			'water_source' => 'Source',
			'temperature' => 'Temperature',
			'ph' => 'Ph',
			'bod' => 'BOD',
			'tss' => 'TSS',
			'tds' => 'TDS',
			'conductivity' => 'Conductivity',
			'chlorides' => 'Chlorides',
			'iron' => 'Iron',
                        'boron'=>'Boron',
                        'manganese'=>'Manganese',
                        'silica'=>'Silica',
			'total_hardness' => 'Total Hardness',
			'oil_grease' => 'Oil & Grease',
			'turbidity' => 'Turbidity',
			'any_other' => 'Any Other',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('form_rfq_id',$this->form_rfq_id);
		$criteria->compare('capacity',$this->capacity,true);
		$criteria->compare('water_source',$this->water_source,true);
		$criteria->compare('temperature',$this->temperature,true);
		$criteria->compare('ph',$this->ph,true);
		$criteria->compare('bod',$this->bod,true);
		$criteria->compare('tss',$this->tss,true);
		$criteria->compare('tds',$this->tds,true);
		$criteria->compare('conductivity',$this->conductivity,true);
		$criteria->compare('chlorides',$this->chlorides,true);
		$criteria->compare('iron',$this->iron,true);
                $criteria->compare('boron',$this->boron,true);
                $criteria->compare('manganese',$this->manganese,true);
                $criteria->compare('silica',$this->silica,true);
		$criteria->compare('total_hardness',$this->total_hardness,true);
		$criteria->compare('oil_grease',$this->oil_grease,true);
		$criteria->compare('turbidity',$this->turbidity,true);
		$criteria->compare('any_other',$this->any_other,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return FormRfqWtd the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
