<?php

/**
 * This is the model class for table "{{purchasing_invoice_addition}}".
 *
 * The followings are the available columns in table '{{purchasing_invoice_addition}}':
 * @property integer $id
 * @property integer $order_id
 * @property string $particular
 * @property string $particular_value
 * @property double $calculated_value
 */
class InvoiceAddition extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{invoice_addition}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			//array('particular, particular_value, calculated_value', 'required'),
			array('invoice_id,addition_item_no', 'numerical', 'integerOnly'=>true),
			array('calculated_value,total_addition_value', 'numerical'),
			array('particular', 'length', 'max'=>255),
			array('particular_value', 'length', 'max'=>50),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, particular, particular_value, calculated_value,total_value', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'particular' => 'Particular',
			'particular_value' => 'Particular Value',
			'calculated_value' => 'Calculated Value',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('particular',$this->particular,true);
		$criteria->compare('particular_value',$this->particular_value,true);
		$criteria->compare('calculated_value',$this->calculated_value);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return PurchasingInvoiceAddition the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
        public function getAdditionValue($addition_item_no) {
        
        $model = self::model()->findAll(array('condition' => 'addition_item_no='.$addition_item_no));
        if($model){
        foreach($model as $eachModel){
            $total_addition_value   = $eachModel->total_addition_value;
            $total_particular_value = $total_particular_value+$eachModel->particular_value;
        }
        $addition = $total_addition_value -$total_particular_value;
            return $addition;
        }
        else{
            $model = OrderAddition::model()->find(array('condition' => 'addition_item_no='.$addition_item_no.'  order by id DESC'));
            return $model->particular_value;
        }
    }
}
