<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("autocomplete-product-for-deallocation", "    
        $('.product-seacrh').autocomplete({
                minLength   : 1,
                source      : function (request, response) { autoCompleteSource(request, response,'" . Yii::app()->createUrl('site/SearchProduct') . "') },
                focus       :function( event, ui ) { $('#allocated_product_search_id').val(ui.item.value); $(this).val( ui.item.label ); return false; },
                change : function(event,ui){  $('#allocated_product_search_id').val((ui.item ? ui.item.value : '')); $(this).val((ui.item ? ui.item.label : '')); },
                select          : function( event, ui ) {
                $.fn.yiiGridView.update('deallocation-productwise-table', {type: 'POST', data: {product_id: $('#allocated_product_search_id').val()}, complete: function(jqXHR, status) {adjustPopup(); }, });
                event.preventDefault(); }
        });        
    ", CClientScript::POS_READY);
?>
<div class = "form-wrap clearfix">
    <div class = "forms-outer">
        <div class = "box-1">
            <ul class="clearfix">
                <li>  
                    <?php echo CHtml::label('Search by Product', 'allocated_product_search'); ?>  
                    <?php echo CHtml::textField('allocated_product_search', '', array('class' => 'product-seacrh')); ?> 
                    <?php echo CHtml::hiddenField('allocated_product_search_id'); ?> 
                </li>
            </ul>          
        </div>
    </div>
</div>
<?php
$model = new AllocatedMaterial;
$this->widget('ext.groupgridview.GroupGridView', array(
    'id' => 'deallocation-productwise-table',
    'itemsCssClass' => 'table_grid deallocation-productwise-table',
    'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
    'dataProvider' => $model->search(),
    'pager' => array(
        'header' => '',
        'firstPageLabel' => '&lt;&lt;',
        'prevPageLabel' => 'Prev',
        'nextPageLabel' => 'Next',
        'lastPageLabel' => '&gt;&gt;',
    ),
    'mergeColumns' => array('file_id','product_id','description','order_no','company','order_date','lead_owner','dlvry_date'),
    'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
    'htmlOptions' => array(),
    'columns' => array(
        array(
            'header' => 'Sl.No.',
            'value' => '$this->grid->dataProvider->pagination->currentPage * $this->grid->dataProvider->pagination->pageSize + ($row+1)',
            'htmlOptions' => array('width' => '1%'),
        ),
        array(
            'header' => 'Product id',
            'name'=>'product_id',
            'value' => '$data->product->part_number',
            'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-center'),
        ),
        array(
            'header' => 'Description',
            'name'=>'description',
            'value' => '$data->product->description',
            'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-left'),
        ),
        array(
            'header' => 'File.No.',
            'name'=>'file_id',
            'value' => '$data->file_id',
            'htmlOptions' => array('width' => '1%'),
        ),
        array(
            'header' => 'Order.No.',
            'name'=>'order_no',
            'value' => '$data->file->order->id',
            'htmlOptions' => array('width' => '1%'),
        ),
        array(
            'header' => 'Customer Name',
            'name'=>'company',
            'value' => '$data->file->order->company->company_name',
            'htmlOptions' => array('width' => '10%','class' => 'cell-left'),
        ),
        array(
            'header' => 'Lead owner',
            'name'=>'lead_owner',
            'value' => '$data->file->leadowner->fullname',
            'htmlOptions' => array('width' => '10%','class' => 'cell-left'),
        ),
        array(
            'header' => 'Order date',
            'name'=>'order_date',
            'value' => '$data->file->order->order_date',
            'htmlOptions' => array('width' => '5%'),
        ),        
        array(
            'header' => 'Delivery date',
            'name'=>'dlvry_date',
            'value' => '$data->file->order->delivery_date',
            'htmlOptions' => array('width' => '1%'),
        ),
        array(
            'header' => 'Ordered Qty.',
            'value' => array($model, 'renderQuantityOrdered'),
            'htmlOptions' => array('style' => 'width: 1%;', 'class' => 'cell-center'),
        ),
        array(
            'header' => 'Allocated Qty.',
            'value' => '$data->count',
            'htmlOptions' => array('style' => 'width: 1%;', 'class' => 'cell-right'),
        ),
        array(
            'header' => 'Free Qty.',
            'value' => array($model, 'renderFreeQuantity'),
            'htmlOptions' => array('style' => 'width: 1%;', 'class' => 'cell-right'),
        ),
        array(
            'header' => 'Qty. to be Purchased',
            'value' => array($model, 'renderQuantityToBePurchased'),
            'htmlOptions' => array('style' => 'width: 1%;', 'class' => 'cell-right'),
        ),
        array
            (
            'class' => 'CButtonColumn',
            'template' => '{deallocate}',
            'htmlOptions' => array('style' => 'width: 1%;', 'class' => 'cell-center'),
            'buttons' => array
                (
                'deallocate' => array
                    (
                    'label' => 'De-Allocate Items',
                    'imageUrl' => Yii::app()->request->baseUrl . '/images/unlock.png',
                    'url' => 'Yii::app()->createUrl("inventory/deallocate", array("id"=>$data->id))',
                    //'visible' => '$data->count > 0',
                    'click' => 'function(){ if(confirm("Are you sure want to deallocate?")) jQuery.ajax({  "type": "get",  "url": $(this).attr("href"), "cache": false,"success": function(data) { $.fn.yiiGridView.update("deallocation-productwise-table", {type: "POST", data: {product_id: $("#allocated_product_search_id").val()}, complete: function(jqXHR, status) {adjustPopup(); }, }); }}); return false;}',
                ),
            ),
        ),
    ),
));
?>