<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("multiselect", "  $('#FormPermission_user_id').chosen();", CClientScript::POS_READY);
?>
<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'forms-manage-permissions',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
        ));
?>  
<div class="forms-outer">
    <div class="box-1">
        <ul class="clearfix">                
            <li  style="width: 25%"><?php echo $form->labelEx($modelFormPermission, 'form_id'); ?> 
                <?php
                echo $form->dropDownList($modelFormPermission, 'form_id', $modelFormPermission->getForms(), array('prompt' => 'select',
                    'ajax' => array(
                        'type' => 'POST', //request type
                        'url' => CController::createUrl('pact/getLevels'),
                        'update' => '#FormPermission_level')
                    , 'class' => 'tooltipster', 'title' => 'Please enter form name'));
                ?>
                <?php echo $form->error($modelFormPermission, 'form_id'); ?>
            </li> 
            <li  style="width: 25%"><?php echo $form->labelEx($modelFormPermission, 'name'); ?> 
                <?php echo $form->textField($modelFormPermission, 'name', array(), array()); ?>
                <?php echo $form->error($modelFormPermission, 'name'); ?>
            </li>
            <li  style="width: 25%"><?php echo $form->labelEx($modelFormPermission, 'level'); ?> 
                <?php echo $form->dropDownList($modelFormPermission, 'level', array(), array('class' => 'tooltipster', 'title' => 'Please enter form name')); ?>
                <?php echo $form->error($modelFormPermission, 'level'); ?>
            </li>
            <li style="width: 100%"><?php echo $form->labelEx($modelFormPermission, 'user_id'); ?> 
                <?php echo $form->dropDownList($modelFormPermission, 'user_id', User::getUser(), array('data-placeholder' => "Choose users from the list", 'class' => 'tooltipster', 'title' => 'Please enter form name', 'multiple' => true)); ?>
                <?php echo $form->error($modelFormPermission, 'user_id'); ?>



            </li>
        </ul>
        <?php
        $url = Yii::app()->createUrl('pact/savePermissions');
        echo CHtml::ajaxSubmitButton('Save', $url, array(
            'dataType' => 'json',
            'type' => 'post',
            'success' => 'function(data) {                            
                            $("#forms-manage-permissions .btn").prop("disabled", false);
                            hideProgress();
                            if(data.status=="success"){                                
                                $(".company-form .success-message").slideDown(); 
                                $.fn.yiiGridView.update("forms-permissions-table");
                                resetForm();
                                notification("Form details saved!","success"); 
                             } else { 
                                $.each(data, function(key, val) { notification(val,"error"); }); 
                            } 
                        }',
            'beforeSend' => 'function(){ 
                                showProgress();
                                $.pnotify_remove_all(); 
                                $("#forms-manage-permissions .btn").prop("disabled", true);  
                                $(".errorMessage").hide(); }'
                ), array('id' => 'mybtn' . rand(), 'class' => 'btn btn-primary'));
        ?>
    </div>

</div>
<?php $this->endWidget(); ?>
<div class="form-wrap clearfix top_table" style="height: 265px;">
    <?php
    $alert = 'Are you sure you want to delete this level of approval?';
    ?>
    <?php
    $this->widget('zii.widgets.grid.CGridView', array(
        'id' => 'forms-permissions-table',
        'itemsCssClass' => 'rt cf',
        //'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
        'template' => '{items}{pager}',
        'dataProvider' => $modelFormPermission->search(),
        'selectableRows' => 1,
        'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
        'pager' => array(
            'header' => '',
            'firstPageLabel' => '&lt;&lt;',
            'prevPageLabel' => 'Prev',
            'nextPageLabel' => 'Next',
            'lastPageLabel' => '&gt;&gt;',
        ),
        'columns' => array(
            array(
                'header' => 'Level',
                'value' => '$data->level',
                'htmlOptions' => array('style' => 'width: 2%;'),
            ),
            array(
                'header' => 'Form',
                'value' => '$data->form->name',
                'htmlOptions' => array('style' => 'width: 10%;'),
            ),
            array(
                'header' => 'Name',
                'value' => '$data->name',
                'htmlOptions' => array('style' => 'width: 20%;'),
            ),
            array(
                'header' => 'Users Assigned',
                'value' => '$data->permittedUsers',
                'htmlOptions' => array('style' => 'width: 40%;'),
            ),
            array(
                'header' => '',
                'class' => 'CButtonColumn',
                'template' => '{edit}{delete}',
                'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-center'),
                'deleteButtonImageUrl' => false,
                'buttons' => array(
                    'edit' => array(
                        'label' => '<i class="icon-edit"></i>',
                        'url' => 'Yii::app()->controller->createUrl("pact/editPermission",array("id"=>$data->primaryKey))',
                        'options' => array(
                            'title' => 'Edit',
                            //'id' => uniqid(),
                            'ajax' => array(
                                'type' => 'POST',
                                'dataType' => 'json',
                                'url' => "js:$(this).attr('href')", // ajax post will use 'url' specified above
                                'success' => 'function(data){
                                    $.each(data.model, function(key, val) { $("#forms-manage-permissions #FormPermission_"+key).val(val); }); 
                                    $("#forms-manage-permissions #FormPermission_user_id").trigger("chosen:updated");
                                    $("#forms-manage-permissions #FormPermission_level").html(data.levels);
                                    
                                    }',
                            ),),
                    ),
                    'delete' => array(
                        'url' => 'Yii::app()->controller->createUrl("pact/deletePerm",array("id"=>$data->primaryKey))',
                        'label' => '<i class="icon-trash"></i>',
                        'options' => array(// this is the 'html' array but we specify the 'ajax' element
                            'title' => 'Delete',
                            'confirm' => $alert,
                            //'id' => uniqid(),
                            'ajax' => array(
                                'type' => 'POST',
                                'url' => "js:$(this).attr('href')", // ajax post will use 'url' specified above
                                'success' => 'function(data){ $.fn.yiiGridView.update("forms-permissions-table"); }',
                            ),
                        ),
                    ),
                ),
            ),
        ),
    ));
    ?>
</div>