<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("invoice-tr-click", " $(document).on('click', '#invoice-table tr td:not(\'.empty\')', function(event) { $('#invoice-table tr').removeClass('active-tr'); $(this).parent().addClass('active-tr'); $('.delivery-grid-buttons .show-after-select').attr('id',$(this).parent().attr('id') ).show();  });  ", CClientScript::POS_END);
?>
<div class="formsbox grid-container" id="invoices-grid-container">
    <div class="form-title">
        <div class="form-title-box">Invoices <?php echo $this->getCompanyNameIfSessionSet(); ?> <?php
            echo CHtml::link('<i class="icon-load-all"></i>', 'javascript:;', array(
                'class' => 'btn btn-mini load-all',
                'title' => 'Load all Invoices'));
            ?></div>
        <div class="btns_wrap delivery-grid-buttons">
            <?php
            echo ((int) Yii::app()->user->havePermissionOn['sop_invoice_add_edit']) ?
                    CHtml::ajaxLink('<i class="icon-plus-sign"></i>', Yii::app()->createUrl('sop/invoice'), array(
                        'beforeSend' => 'js:function(xhr,opts){ showProgress(); $("#ajax_content").find(".invoice_form").remove(); }',
                        'success' => 'js:function(data){ hideProgress(); $("#ajax_content").append(data); openPopup("invoice_form"); } '), array(
                        'id' => 'form-' . uniqid(),
                        'title' => 'Create a new invoice',
                        'class' => 'ajaxlink btn btn-mini'
                            )
                    ) : '';
            ?>
            <?php //echo (((int) Yii::app()->user->havePermissionOn['sop_invoice_add_edit']) || ((int) Yii::app()->user->havePermissionOn['sop_invoice_view'])) ? CHtml::link('<i class="icon-edit"></i>', 'javascript:;', array('class' => 'show-after-select edit-invoice btn btn-mini', 'title' => 'Edit Invoice', 'style' => 'display:none;')) : ''; ?>
            <?php $headerButtons = ((int) Yii::app()->user->havePermissionOn['sop_invoice_print']) ? CHtml::link('<i class="icon-print"></i>', 'javascript:;', array('class' => 'btn btn-mini', 'onclick' => 'exportfunction($("#invoices-grid-container .search-query").val(),"Invoice","pdf.sopinvoice-list");', 'title' => 'Print')) : ''; ?>
        </div>
        <div class="search-outer">
            <div class="input-append">
                <?php
                echo CHtml::textField('search' . rand(), '', array(
                    "onkeyup" => "$.fn.yiiGridView.update('invoice-table', {type: 'GET', data: {inv_search: this.value}});",
                    "class" => "search-query",
                    "placeholder" => "Search by Title,File/Inv. no etc.,"));
                ?>                                
            </div>
        </div>
    </div>
    <div class="form-wrap clearfix">
        <div class="forms-outer">
            <div class="box-1 ">
                <?php
                $this->widget('zii.widgets.grid.CGridView', array(
                    'id' => 'invoice-table',
                    'itemsCssClass' => 'rt cf invoice-table',
                    'rowCssClassExpression' => '$data->color',
                    'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
                    'dataProvider' => $model->search(),
                    'selectableRows' => 1,
                    'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                    'pager' => array(
                        'header' => '',
                        'firstPageLabel' => '&lt;&lt;',
                        'prevPageLabel' => 'Prev',
                        'nextPageLabel' => 'Next',
                        'lastPageLabel' => '&gt;&gt;',
                    ),
                    'columns' => array(
                        array(
                           // 'header' => 'File/Ord/Invoice No.',
                           // 'value' => '$data->file->id."/".$data->file->order->id."/".$data->id',
                             'header' => 'File/Invoice No.',
                             'value' => '$data->file->id."/".$data->id',
                            'htmlOptions' => array('style' => 'width: 14%;'),
                        ),
                        array(
                            'header' => 'Company',
                            'value' => '$data->file->company->company_name_short',
                            //'value' => '$data->file->company->company_name',
                            'htmlOptions' => array('style' => 'width: 18%;'),
                        ),
                        array(
                            'header' => 'Lead Owner',
                            'value' => '$data->file->leadowner->Fullname',
                            'htmlOptions' => array('style' => 'width: 15%;'),
                        ),
                        array(
                            'header' => 'Inv Dt.',
                            'value' => '$data->invoice_date',
                            'htmlOptions' => array('style' => 'width: 2%;'),
                        ),
                        array(
                            'header' => 'Value',
                            'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total,$data->file->order->currency0->currency_code)',
                            'htmlOptions' => array('style' => 'width: 2%;', 'class' => 'cell-right'),
                        ),
                        array(
                            'header' => 'Value(BC)',
                            'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total* $data->exchange_rate,"")',
                            'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right'),
                        ),
                        array(
                            'header' => 'Status',
                            'value' => '$data->status',
                            'htmlOptions' => array('title' => 'File/Item status', 'style' => 'width: 5%;'),
                            'type'=>'raw'
                        ),
                        array(
                            'class' => 'CButtonColumn',
                            'header' => $headerbuttons,
                            //'template' => '<i title="Actions" class="icon-cog"><div style="display:none;" class="triangle-right left">{edit} {mail} {proforma_invoice} {send_for_approval} {approval} {print}</div></i>',
                            'template' => '<i title="Actions" class="icon-cog"><div style="display:none;" class="triangle-right left"> {monitor}   {print}</div></i>',
                            'htmlOptions' => array(
                                'style' => 'width: 1%;',
                                'class' => 'cell-center',
                                'title' => "Actions",
                                'onmouseover' => '$(this).find(\'.triangle-right\').show();',
                                'onmouseout' => '$(this).find(\'.triangle-right\').hide();'
                            ),
                             'buttons' => array
                                (
                               /* 'edit' => array(
                                    'label' => '<i class="icon-white icon-edit"></i>',
                                    'options' => array('title' => 'Edit invoice'),
                                    'url' => 'Yii::app()->controller->createUrl("sop/invoice",array("id"=>$data->primaryKey))',
                                    'click' => 'js:function(){ openFormForEdit($(this).attr(\'href\'),\'invoice_form\'); return false;}',
                                    'visible' => '(int) Yii::app()->user->havePermissionOn[\'sop_invoice_view\'] || (int) Yii::app()->user->havePermissionOn[\'sop_invoice_add_edit\']'
                                    
                                 ),*/
                                  'monitor' => array(
                                    'label' => '<i class="icon-white icon-eye-open"></i>',
                                    'options' => array('title' => 'View'),
                                    'url' => 'Yii::app()->controller->createUrl("sop/invoice",array("id"=>$data->primaryKey,"flag"=>1))',
                                    'click' => 'js:function(){ openFormForEdit($(this).attr(\'href\'),\'invoice_form\'); return false;}',
                                    'visible' => '(int) Yii::app()->user->havePermissionOn[\'sop_invoice_view\']',
                                 
                                ),
                                'send_for_approval' => array(
                                    'label' => '<i class="icon-white icon-bullhorn"></i>',
                                    'options' => array('title' => 'Send for Approval'),
                                    'url' => 'Yii::app()->controller->createUrl("pact/Permissions",array("form_id"=>$data->form_id,"file_id"=>$data->file_id,"refresh_grid"=>"invoice-table"))',
                                    'click' => 'js:function(){ openPermissionForm($(this).attr(\'href\')); return false;}',
                                    //'visible' => 'Yii::app()->controller->getcheckVisible($data->file->lead_owner_id) && $data->file->status =="Order"?1:0',
                                    //'visible' => '$data->file->status =="Order"?1:0',
                                    'visible' => 'Yii::app()->controller->getcheckVisible($data->file->lead_owner_id) && $data->file->status=="Invoice"?1:0',
                                ),
                              /*  'approval' => array(
                                    'label' => '<i class="icon-white icon-thumbs-up"></i>',
                                    'options' => array('title' => 'Approval'),
                                    'url' => 'Yii::app()->controller->createUrl("permission/ApproveForm",array("form_id"=>$data->form_id,"file_id"=>$data->file_id,"refresh_grid"=>"invoice-table"))',
                                    'click' => 'js:function(){ openApprovalForm($(this).attr(\'href\')); return false;}',
                                    'visible' => 'Yii::app()->controller->getcheckApproval($data->form_id,$data->file_id) && $data->file->status =="Invoice"?1:0',
                                ),*/
                                'print' => array(
                                   'label' => '<i class="icon-white icon-print"></i>',
                                    'options' => array('title' => 'Print'),
                                    'visible' => "((int) Yii::app()->user->havePermissionOn['sop_invoice_print'])",
                                    'click' => 'function(){  exportfunction("","Invoice","pdf.sopinvoice-single",$(this).parents("tr").attr("id")); }',
                                ),
                              
                                /*'mail' => array(
                                    'label' => '<i class="icon-white icon-envelope"></i>',
                                    'options' => array('title' => 'Send mail to superiors'),
                                    //'visible' => "((int) Yii::app()->user->havePermissionOn['sop_lead_print'])",
                                    'click' => 'function(){ if(confirm("Are you sure to send mail?")) sendmail($(this).parents("tr").attr("id"),"Invoice"); }',
                                ),*/
                               
                            ),
                        ),
                    ),
                ));
                ?>                
            </div>
        </div>
    </div>
</div>