<?php $cur_date = CTimestamp::formatDate('Y-m-d'); ?>
<div class="form-wrap clearfix">
    <div class="forms-outer">
        <div class="box-1">            
            <ul class="clearfix">
                <li>
                    <?php echo $form->hiddenField($model, 'id'); ?>
                    <?php echo $form->labelEx($model, 'company_id'); ?>
                    <?php
                    echo $form->dropDownList($model, 'company_id', Company::getCompanies(array("C")), array(
                        'class' => 'tooltipster multiselect',
                        'onchange' => 'load_company_details_ajax(this.value,"Lead_company_name")',
                        'multiple' => false,
                        'data-placeholder' => "Choose a customer",
                        'prompt' => 'Choose a customer',
                        'title' => 'Please select company'));
                    ?>                    
                    <?php echo $form->error($model, 'company_id'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'lead_owner_id'); ?> 
                    <?php
                    echo $form->dropDownList($model, 'lead_owner_id', User::getLeadOwners(), array(
                        'title' => 'Select led owner',
                        'class' => 'lead-owner-id tooltipster multiselect',
                        'prompt' => 'Select lead owner',
                        'options' => array(((int) $model->lead_owner_id == 0 ? Yii::app()->user->id : $model->lead_owner_id) => array('selected' => true))
                    ));
                    ?>
                    <?php echo $form->error($model, 'lead_owner_id'); ?>
                </li>
                <li>                   
                    <?php echo $form->labelEx($model, 'contact_id', array('label' => 'Contact')); ?> 
                    <?php
                    echo $form->dropDownList($model, 'contact_id', CompanyContact::getContacts((int) $model->company_id), array('prompt' => '--select--',
                        'ajax' => array(
                            'type' => 'POST',
                            'dataType' => 'json',
                            'url' => CController::createUrl('site/fetchcontactdetails'),
                            'success' => 'function(data){ $("#Lead_email1").val(data.email1); $("#Lead_mobile1").val(data.ph_no+" / "+data.mobile1+" / "+data.mobile2); }',
                            'data' => array('contact_id' => 'js:this.value'),
                    )));
                    ?> 
                    <?php echo $form->error($model, 'contact_id'); ?>
                </li>


                <li>
                    <?php echo $form->labelEx($model, 'title'); ?> 
                    <?php echo $form->textField($model, 'title', array('size' => 60, 'maxlength' => 255)); ?>
                    <?php echo $form->error($model, 'title'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'mobile1'); ?> 
                    <?php echo $form->textField($model, 'mobile1'); ?> 
                    <?php echo $form->error($model, 'mobile1'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'enq_date'); ?> 
                    <?php
                    if($model->enq_date)
                        $date = $model->enq_date;
                    else 
                        $date = $cur_date;
                    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
                        'model' => $model,
                        'attribute' => 'enq_date',
                        'language' => 'en-GB',
                        'options' => array(
                            'showOn' => 'both', // also opens with a button
                            'dateFormat' => 'yy-mm-dd', // format of "2012-12-25"
                            'showOtherMonths' => true, // show dates in other months
                            'selectOtherMonths' => true, // can seelect dates in other months
                            'changeYear' => true, // can change year
                            'changeMonth' => true, // can change month
                            'yearRange' => '2000:2099', // range of year
                            'minDate' => '2000-01-01', // minimum date
                            'maxDate' => '2099-12-31', // maximum date
                            'showButtonPanel' => true, // show button panel
                            //'defaultDate'=>$model->enq_date,
                        ),
                        'htmlOptions' => array(
                            'size' => '10',
                            'maxlength' => '10',
                            'value' => $date,
                        ),
                    ));
                    ?>
                    <?php echo $form->error($model, 'enq_date'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'email1'); ?> 
                    <?php echo $form->textField($model, 'email1'); ?> 
                    <?php echo $form->error($model, 'email1'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'closing_date'); ?>  
                    <?php
                    if($model->closing_date)
                        $date = $model->closing_date;
                    else 
                        $date = $cur_date;
                    
                    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
                        'model' => $model,
                        'attribute' => 'closing_date',
                        'language' => 'en-GB',
                        'options' => array(
                            'showOn' => 'both', // also opens with a button
                            'dateFormat' => 'yy-mm-dd', // format of "2012-12-25"
                            'showOtherMonths' => true, // show dates in other months
                            'selectOtherMonths' => true, // can seelect dates in other months
                            'changeYear' => true, // can change year
                            'changeMonth' => true, // can change month
                            'yearRange' => '2000:2099', // range of year
                            'minDate' => '2000-01-01', // minimum date
                            'maxDate' => '2099-12-31', // maximum date
                            'showButtonPanel' => true, // show button panel
                            //'defaultDate'=> $date,
                        ),
                        'htmlOptions' => array(
                            'size' => '10',
                            'maxlength' => '10',
                            'value' => $date,
                        ),
                    ));
                    ?>                   
                    <?php echo $form->error($model, 'closing_date'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'notes'); ?>
                    <?php echo $form->textArea($model, 'notes', array('rows' => 6, 'cols' => 50)); ?>
                    <?php echo $form->error($model, 'notes'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'status'); ?>                        
                    <?php
                    echo $form->dropDownList($model, 'status', array(
                        /* 'Y' => 'Open',
                          'N' => 'Not reachable',
                          'F' => 'FollowUp Calls',
                          'S' => 'Send Profile',
                          'M' => 'Meet in Person', */
                        'Y' => 'Open',
                        //'O' => 'Open',
                        'C' => 'Closed',
                        'L' => 'Lost' /* 'W' => 'Warm', 'C' => 'Cold', 'H' => 'Hot', 'S' => 'Sale' */));
                    ?>
                    <?php echo $form->error($model, 'status'); ?>
                </li> 
            </ul>
        </div>
    </div>
</div>