<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity {

    private $_id;

    /**
     * Authenticates a user.
     * @return boolean whether authentication succeeds.
     */
    public function authenticate() {
        $username = strtolower($this->username);
        $password = crypt($this->password, $this->password);
        $user = User::model()->find('LOWER(username)=? AND isActive=? ', array($username, 'Y'));
        if ($user === null)
            $this->errorCode = self::ERROR_USERNAME_INVALID;
        else if ($user->password !== $password)
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
        else {
            /* if((UserTypes::model()->findByPk( $user->type_id )->type) == 'admin' || (UserTypes::model()->findByPk( $user->type_id )->type)=='superadmin') // This is admin login
              {
              $this->setStateKeyPrefix('admin_');
              }
              else
              {
              $this->setStateKeyPrefix('front_');
              } */
            $this->_id = $user->id;
            $this->setState('fullname', $user->fullname);
            $this->setState('master_user_company_id', $user->company_id);
            $this->setState('master_user_branch_id', $user->branch_id);
            $this->setState('user_branch', $user->ownBranch->branch_name);
            //$this->setState('company_logo', $user->own_company->company_logo);
            $userGroups = MasUserGroup::model()->findAll('id in (' . $user->user_group_id . ')');
            $permissionArray = array();
            foreach ($userGroups as $eachUserGroup) {
                if (!empty($eachUserGroup->permissions))
                    $permissionArray = CJSON::decode($eachUserGroup->permissions);
            }
            $this->setState('havePermissionOn', array_merge($permissionArray));

            $this->username = $user->username;
            $this->errorCode = self::ERROR_NONE;
        }
        return $this->errorCode == self::ERROR_NONE;
    }

    public function getId() {
        return $this->_id;
    }

}