<?php

class AjaxController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Usergroups', 'GetPricingGroup', 'GetVendors', 'GetExchangeRate', 'GetProductClass', 'LoadPricingGroups', 'Activityajax',
                    'ReCalculatePricing', 'GetCurrencies', 'FillCompanyList', 'SopMonitor', 'GetFileSlashIds', 'FillProfitForm', 'GetNewProductCostPrice',
                    'Approve', 'UnApprove', 'fillProductList', 'QuotationHelper', 'PurchaseHelper', 'StockHelper', 'Company', 'CompanyContact', 'getActivitytype',
                    'PurchaseRptForm', 'SalesRptForm', 'InventoryRptForm', 'MaterialAllocRptForm', 'FinanceRptForm', 'ActivityRptForm', 'CustomerRptForm',
                    'profile', 'ProfileSettings', 'addToInvSingleDv', 'Others', 'incentiveReports', 'activity', 'contactRptForm', 'renderUserGroup','renderUser','UserDetails'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionUsergroups() {
        $term = Yii::app()->request->getQuery('term');
        $datas = MasUserGroup::model()->findAll('group_name like "%' . $term . '%"');
        $lists = array();
        foreach ($datas as $eachData) {
            $lists[] = array(
                'id' => $eachData->id,
                'name' => $eachData->group_name,
                'code' => $eachData->id,
            );
        }
        echo json_encode($lists);
    }

    public function actionGetPricingGroup() {
        $data = array();
        $searchTerm = $_GET['term'];
        $seacrhColumn = array('pricing_group', /* 'percentage', 'addition_deduction' */);
        $model = new PricingGroup;
        if (isset($_GET['term'])) {
            foreach ($seacrhColumn as $eachSearchColumn)
                $condition[] = $eachSearchColumn . ' LIKE "%' . $searchTerm . '%"';
            $condition = implode(' OR ', $condition);
            $condition .=' AND company_id=' . Yii::app()->user->master_user_company_id . ' AND company_branch_id=' . Yii::app()->user->master_user_branch_id;
            $model = $model->findAll(array('condition' => $condition, 'order' => $seacrhColumn[0]));
            $i = 0;
            foreach ($model as $eachModel) {
                $data[$i]['value'] = $eachModel->id;
                $data[$i]['label'] = $eachModel->$seacrhColumn[0] /* . ":" . $eachModel->$seacrhColumn[1] . '% ' . ($eachModel->$seacrhColumn[2] == 'A' ? 'Addition' : 'Deduction') */;
                $i++;
            }
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionFillCompanyList() {
        $types = explode(',', $_POST['types']);
        $company_id = Yii::app()->request->getParam('company_id');
        if ($company_id == 0)
            $company_id = (int) Yii::app()->session['company_id'];
        $data = Company::getCompanies($types);
        //$data['options'] = "<option value=''>Select</option>";
        //$data['options'].= CHtml::tag('option', array('value' => '0'), '-select-', true);
        foreach ($data as $value => $city_name) {
            $data['options'].= CHtml::tag('option', array('value' => $value), CHtml::encode($city_name), true);
        }
        $data['selected'] = $company_id;
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionFillProductList() {

        $nonstockitem = Yii::app()->request->getParam('nonstockitem');
        $data = Store::getAll(false, $nonstockitem);
        $selection = (int) Yii::app()->request->getParam('selection');
        if ($selection > 0)
            $data['selected'] = (int) Yii::app()->request->getParam('selection');
        foreach ($data as $value => $city_name) {
            $data['options'].= CHtml::tag('option', array('value' => $value), CHtml::encode($city_name), true);
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionGetVendors() {
        $data = array();
        $temp = explode(',', $_POST['term']);
        $searchTerm = trim($temp[1]);
        $seacrhColumn = array('company_name');
        $model = new Company;
        if (isset($_POST['term'])) {
            foreach ($seacrhColumn as $eachSearchColumn)
                $condition[] = $eachSearchColumn . ' LIKE "%' . $searchTerm . '%"';
            $condition = implode(' OR ', $condition);
            $condition .=' AND(  t.isActive =  "Y" and companyType.type="V" AND own_company_id=' . Yii::app()->user->master_user_company_id . ' AND own_branch_id=' . Yii::app()->user->master_user_branch_id . ' )';
            $model = $model->with('companyTypeRelation.companyType')->findAll(array('condition' => $condition, 'order' => $seacrhColumn[0]));
            $i = 0;
            foreach ($model as $eachModel) {
                $data[$i] = $eachModel->id . '-' . $eachModel->$seacrhColumn[0];
                $i++;
            }
        }
        echo $condition;
        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actionGetExchangeRate() {
        $currency_code = Yii::app()->request->getParam('currency_code');
        if (!empty($currency_code)) {
            Yii::import('ext.ECurrencyHelper.ECurrencyHelper');
            $cc = new ECurrencyHelper();
            $baseCurrency = User::model()->findByPK(Yii::app()->user->id)->ownBranch->baseCurrency->currency_code;
            echo round($cc->convert($currency_code, $baseCurrency, 1, ECurrencyHelper::USE_YAHOO), 2);
        }
        else
            echo "";
    }

    public function actionGetproductclass() {
        $this->autocompleteData('ProductClass', array('product_class'), $_GET['term'], false);
        Yii::app()->end();
    }

    public function actionLoadPricingGroups() {
        $type = $_POST['type'];
        $group_id = (int) $_POST['group_id'];
        $p = PricingGroup::model()->findByPK($group_id);
        if ($p != null && $p->isBasePricingGroup == "Y" && $type == "S")
            $_POST['type'] = "I";
        if ($group_id > 0)
            $condition = 'parent_id<>' . $group_id . ' AND id<>' . $group_id . ' AND';
        $condition.=' type="' . $_POST['type'] . '"';
        $model = PricingGroup::model()->findAll(array('condition' => $condition, 'order' => 'isBasePricingGroup,pricing_group'));
        $options = CHtml::tag('option', array('value' => "0"), CHtml::encode("No parent"), true);
        foreach ($model as $eachModel)
            $options .= CHtml::tag('option', array('value' => $eachModel->id, 'selected' => ($p->parent_id == $eachModel->id) ? 'selected' : false), CHtml::encode($eachModel->pricing_group), true);
        echo $options;
    }

    public function actionReCalculatePricing($product_id = 0) {
        PricingGroup::reCalculatePricing($product_id);
    }

    public function actionGetCurrencies() {
        $data = MasCurrency::getCurrency();
        $basecurrency_id = MasCompanyBranch::model()->findByPK(Yii::app()->user->master_user_branch_id)->currency_id;
        foreach ($data as $value => $name) {
            $option['value'] = $value;
            $option['selected'] = ($value == $basecurrency_id) ? 'selected' : false;
            $jsondata[] = CHtml::tag('option', $option, CHtml::encode($name), true);
        }
        echo CJSON::encode($jsondata);
    }

    public function actionSopMonitor() {
        $id = $_GET['id'];
        $type = $_GET['type'];
        switch ($type) {
            case 'Order':
                $model = Order::model()->findByPK($id);
                break;
            case 'Quotes':
                $model = Quotes::model()->findByPK($id);
                break;
        }
        $jsondata['model'] = $model;
        $jsondata['company'] = $model->company;
        $jsondata['leadowner'] = $model->file->leadowner->fullname;
        $jsondata['currency'] = $model->currency0->currency;
        $jsondata['contact'] = $model->contact;
        $jsondata['items'] = '<tr>
            <th>Sl No</th>
            <th>Product</th>
            <th>Description</th>
            <th>Qty</th>
            <th>Unit</th>
            <th>Current Stock</th>
            <th>Free Quantity</th>
            <th>Allocated Quatity</th>
        </tr>';
        foreach ($model->items as $i => $eachItem) {
            $openPurchaseOrderedItems = PurchasingOrderItem::model()->with('purchaseorder.file')->findAll('file.current_process_status="P_O" AND product_id=' . $eachItem->product->id);
            $jsondata['items'].='<tr>';
            $show_hide_op = ($openPurchaseOrderedItems != null) ? " " . CHtml::link('<i class="icon-folder-open"></i>', 'javascript:void(0);', array(
                        'title' => 'click here to view open purchases against this item',
                        'onclick' => '$(this).parents("tr").next(".open-p").toggle(); adjustPopup();')) : '';
            $jsondata['items'].='<td>' . ($i + 1) . '</td>';
            $jsondata['items'].='<td>' . $eachItem->product->part_number . $show_hide_op . '</td>';
            $jsondata['items'].='<td>' . $eachItem->description . '</td>';
            $jsondata['items'].='<td>' . $eachItem->quantity . '</td>';
            $jsondata['items'].='<td>' . $eachItem->product->unit->symbol . '</td>';
            $jsondata['items'].='<td>' . $eachItem->product->total_quantity . '</td>';
            $jsondata['items'].='<td>' . ($eachItem->product->total_quantity - $eachItem->product->total_allocated_quantity) . '</td>';
            $allocated_count = AllocatedMaterial::model()->find('product_id=' . $eachItem->product->id . ' AND file_id=' . $eachItem->parent->file_id)->count;
            $jsondata['items'].='<td>' . $allocated_count . '</td>';
            $jsondata['items'].='</tr>';
            if ($openPurchaseOrderedItems != null) {
                $jsondata['items'].='
                <tr class="open-p">
                    <td colspan="8">
                        <table class="table_grid">';

                $jsondata['items'] .= '
                            <tr>
                                <th>PO.No</th>
                                <th>Vendor</th>
                                <th>Qty</th>
                                <th>Order dt.</th>
                                <th>Expected Delivery Dt.</th>
                            </tr>';
                foreach ($openPurchaseOrderedItems as $eachPitem) {
                    $jsondata['items'].='<tr>';
                    $jsondata['items'].='<td>' . $eachPitem->purchasing_order_id . '</td>';
                    $jsondata['items'].='<td>' . $eachPitem->purchaseorder->vendor->company_name . '</td>';
                    $jsondata['items'].='<td>' . $eachPitem->quantity . '</td>';
                    $jsondata['items'].='<td>' . $eachPitem->purchaseorder->order_date . '</td>';
                    $jsondata['items'].='<td>' . $eachPitem->purchaseorder->expected_delivery_date . '</td>';
                    $jsondata['items'].='</tr>';
                }
                $jsondata['items'].='
                        </table>
                    </td>
                </tr>';
            }
        }
        echo CJSON::encode($jsondata);
    }

    public function actionGetFileSlashIds() {
        $files = MasterFile::getFiles(array('Q', 'O', 'PD', 'D', 'PI', 'I'), true);
        $jsondata[] = CHtml::tag('option', array('value' => ''), 'select', true);
        foreach ($files as $eachfile) {
            $option['value'] = $eachfile->id;
            $jsondata[] = CHtml::tag('option', $option, CHtml::encode($eachfile->id . ':' . $eachfile->status), true);
        }
        echo CJSON::encode($jsondata);
    }

    public function actionFillProfitForm() {
        $file_id = Yii::app()->request->getParam('file_id');
        $result = ProfitCalc::profitCalculation($file_id);
        echo CJSON::encode($result);
    }

    public function actionGetNewProductCostPrice() {
        $product_ids = explode(',', Yii::app()->request->getParam('product_ids'));
        $price_group_id = Yii::app()->request->getParam('price_group_id');
        foreach ($product_ids as $eachProductId) {
            $rates[$eachProductId] = PriceGroupProductRelation::model()->find('store_id=' . $eachProductId . ' AND price_group_id=' . $price_group_id)->rate;
        }
        echo CJSON::encode($rates);
    }

    public function actionApprove() {
        ProfitCalc::model()->deleteAll(array('condition' => 'file_id=' . Yii::app()->request->getParam('file_id')));
        $modelProfit = new ProfitCalc;
        $modelProfit->crm_user_id = Yii::app()->user->id;
        $modelProfit->file_id = Yii::app()->request->getParam('file_id');
        $modelProfit->netsellingvalue = Yii::app()->request->getParam('netsellingvalue');
        $modelProfit->netcostvalue = Yii::app()->request->getParam('netcostvalue');
        $pricegroup = (int) Yii::app()->request->getParam('pricegroup');
        if ($pricegroup == 0)
            $pricegroup = PricingGroup::getDefaultPricingGroup("I")->id;
        $modelProfit->save();
        $modelProfit->refresh();
        $modelFile = MasterFile::model()->findByPK(Yii::app()->request->getParam('file_id'));
        //if ($modelFile->is_approved == "N") {
        switch ($modelFile->current_process_status) {
            case 'Q':
                $this->actionNotification($modelFile->quote, "Quotes", false);
                $items = $modelFile->quote->items;
                break;
            case 'O':
                $this->actionNotification($modelFile->order, "Order", false);
                $items = $modelFile->order->items;
            default:
                $items = $modelFile->order->items;
                break;
        }

        ProfitCalcItem::model()->deleteAll(array('condition' => 'profit_calc_id=' . $modelProfit->id));
        ProfitCalcExtra::model()->deleteAll(array('condition' => 'profit_calc_id=' . $modelProfit->id));
        foreach ($items as $eachItem) {
            $profitCalcItem = new ProfitCalcItem;
            $cond = 'price_group_id=' . $pricegroup .
                    ' AND pricing_product_class_id=' . (int) $eachItem->product->product_class_id .
                    ' AND store_id=' . $eachItem->product->id;
            $costrate = PriceGroupProductRelation::model()->find($cond)->rate;
            $profitCalcItem->profit_calc_id = $modelProfit->id;
            $profitCalcItem->product_id = $eachItem->product_id;
            $profitCalcItem->cost_rate = $costrate;
            $profitCalcItem->save();
        }
        parse_str($_POST['footer'], $footer_items);
        //print_r($footer_items);

        foreach ($footer_items['extra'] as $i => $eachExtra) {
            $profitCalcExtra = new ProfitCalcExtra;
            $profitCalcExtra->profit_calc_id = $modelProfit->id;
            $profitCalcExtra->particular = $eachExtra;
            $save = false;
            if (floatval($footer_items['extra_addition'][$i]) > 0) {
                $profitCalcExtra->addition = $footer_items['extra_addition'][$i];
                $save = true;
            } else if (floatval($footer_items['extra_deduction'][$i]) > 0) {
                $profitCalcExtra->deduction = $footer_items['extra_deduction'][$i];
                $save = true;
            }
            if ($save)
                $profitCalcExtra->save(false);
        }


        $modelFile->updateByPK(Yii::app()->request->getParam('file_id'), array('is_approved' => 'Y', 'date_of_approval' => date('Y-m-d'), 'approved_by' => Yii::app()->user->id));
        //}
    }

    public function actionUnApprove() {
        $file_id = Yii::app()->request->getParam('file_id');
        ProfitCalc::model()->deleteAllByAttributes(array('file_id' => $file_id));
        MasterFile::model()->updateByPK($file_id, array('is_approved' => 'N'));
    }

    public function actionQuotationHelper() {
        $id = (int) $_POST['id'];
        $company_id = (int) $_POST['company_id'];
        $quote_helper = OrderItem::model()->with('parent')->together()->findAll(
                array(
                    'condition' => 't.product_id=' . $id . ' AND parent.company_id <> ' . $company_id,
                    'order' => 'company_id', 'limit' => 3
        ));
        $quote_helper = count($quote_helper) < 3 ? array_merge($quote_helper, (QuotesItem::model()->with('parent')->together()->findAll(
                                array(
                                    'condition' => 't.product_id=' . $id . ' AND parent.company_id <> ' . $company_id,
                                    'order' => 'company_id', 'limit' => (3 - count($quote_helper))
                )))) : $quote_helper;
        if ($quote_helper != null) {
            $table1 = "<table class='table-grid'>
                <tr>
                    <td>File No.</td>
                    <td>Date</td>
                    <td>Customer</td>
                    <td>Quantity</td>
                    <td>Rate</td>
                    <td>Status</td>
                    </tr>";
            foreach ($quote_helper as $eachItem) {
                $table1.='<tr><td>' . $eachItem->parent->file->id . '</td>
                    <td>' . date('Y-m-d', strtotime((get_class($eachItem->parent) == "Quotes") ? $eachItem->parent->qtn_date : $eachItem->parent->order_date)) . '</td>
                    <td class="cell-left">' . $eachItem->parent->file->company->company_name . '</td>
                    <td class="cell-center">' . Yii::app()->numberFormatter->formatDecimal($eachItem->quantity) . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                    <td class="cell-center">' . $eachItem->parent->file->status . '</td>
                        </tr>';
            }
            $table1 .= "</table>";
        }

        /* quote helper related to same company */
        $quote_helper = OrderItem::model()->with('parent')->together()->findAll(
                array(
                    'condition' => 't.product_id=' . $id . ' AND parent.company_id = ' . $company_id,
                    'order' => 'company_id', 'limit' => 3
        ));
        $quote_helper = count($quote_helper) < 3 ? array_merge($quote_helper, (QuotesItem::model()->with('parent')->together()->findAll(
                                array(
                                    'condition' => 't.product_id=' . $id . ' AND parent.company_id = ' . $company_id,
                                    'order' => 'company_id', 'limit' => (3 - count($quote_helper))
                )))) : $quote_helper;
        if ($quote_helper != null) {
            $table2 = "<table class='table-grid'>
                <tr>
                    <td>File No.</td>
                    <td>Date</td>
                    <td>Customer</td>
                    <td>Quantity</td>
                    <td>Rate</td>
                    <td>Status</td>
                    </tr>";
            foreach ($quote_helper as $eachItem) {
                $table2.='<tr><td>' . $eachItem->parent->file->id . '</td>
                    <td>' . date('Y-m-d', strtotime((get_class($eachItem->parent) == "Quotes") ? $eachItem->parent->qtn_date : $eachItem->parent->order_date)) . '</td>
                    <td class="cell-left">' . $eachItem->parent->file->company->company_name . '</td>
                    <td class="cell-center">' . Yii::app()->numberFormatter->formatDecimal($eachItem->quantity) . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                    <td class="cell-center">' . $eachItem->parent->file->status . '</td>
                        </tr>';
            }
            $table2 .= "</table>";
        }
        if (empty($table1) && empty($table2))
            echo "No results found!";
        else {
            $out_put = '<table><tr><th colspan=2>ITEM : ' . $quote_helper[0]->product->part_number . '             <i title="click to close" class="icon-off"></i></th></tr><tr>';
            $out_put.=!empty($table1) ? '<td>To Other Companies ' . $table1 . '</td>' : '';
            $out_put.=!empty($table2) ? '<td>To Same Company ' . $table2 . '</td>' : '';
            $out_put.='</tr></table>';
            echo $out_put;
        }
    }

    public function actionPurchaseHelper() {
        $id = (int) $_POST['id'];
        $company_id = (int) $_POST['company_id'];
        $quote_helper = PurchasingOrderItem::model()->with('parent')->together()->findAll(
                array(
                    'condition' => 't.product_id=' . $id . ' AND parent.vendor_id <> ' . $company_id,
                    'order' => 'vendor_id', 'limit' => 3
        ));
        if ($quote_helper != null) {
            $table1 = "<table class='table-grid'>
                <tr>
                    <td>File No.</td>
                    <td>Date</td>
                    <td>Vendor</td>
                    <td>Quantity</td>
                    <td>Rate</td>
                    <td>Status</td>
                    </tr>";
            foreach ($quote_helper as $eachItem) {
                $table1.='<tr><td>' . $eachItem->parent->id . '</td>
                    <td>' . date('Y-m-d', strtotime($eachItem->parent->order_date)) . '</td>
                    <td class="cell-left">' . $eachItem->parent->file->company->company_name . '</td>
                    <td class="cell-center">' . Yii::app()->numberFormatter->formatDecimal($eachItem->quantity) . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                    <td class="cell-center">' . $eachItem->parent->file->status . '</td>
                        </tr>';
            }
            $table1 .= "</table>";
        }

        /* quote helper related to same company */
        $quote_helper = PurchasingOrderItem::model()->with('parent')->together()->findAll(
                array(
                    'condition' => 't.product_id=' . $id . ' AND parent.vendor_id = ' . $company_id,
                    'order' => 'vendor_id', 'limit' => 3
        ));

        if ($quote_helper != null) {
            $table2 = "<table class='table-grid'>
                <tr>
                    <td>File No.</td>
                    <td>Date</td>
                    <td>Vendor</td>
                    <td>Quantity</td>
                    <td>Rate</td>
                    <td>Status</td>
                    </tr>";
            foreach ($quote_helper as $eachItem) {
                $table2.='<tr><td>' . $eachItem->parent->id . '</td>
                    <td>' . date('Y-m-d', strtotime($eachItem->parent->order_date)) . '</td>
                    <td class="cell-left">' . $eachItem->parent->file->company->company_name . '</td>
                    <td class="cell-center">' . Yii::app()->numberFormatter->formatDecimal($eachItem->quantity) . '</td>
                    <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                    <td class="cell-center">' . $eachItem->parent->file->status . '</td>
                        </tr>';
            }
            $table2 .= "</table>";
        }
        if (empty($table1) && empty($table2))
            echo "No results found!";
        else {
            $out_put = '<table><tr><th colspan=2>ITEM : ' . $quote_helper[0]->product->part_number . '             <i title="click to close" class="icon-off"></i></th></tr><tr>';
            $out_put.=!empty($table1) ? '<td>FROM OTHER VENDORS ' . $table1 . '</td>' : '';
            $out_put.=!empty($table2) ? '<td>FROM SAME VENDOR ' . $table2 . '</td>' : '';
            $out_put.='</tr></table>';
            echo $out_put;
        }
        Yii::app()->end();
    }

    public function actionStockHelper() {
        $product_id = Yii::app()->request->getParam('id');
        $modelStore = Store::model()->findByPK($product_id);
        $stockHelper = '<table class="table-grid">';
        $stockHelper .= '<tr><th colspan="2">ITEM ' . ($modelStore->part_number) . '             <i title="click to close" class="icon-off"></i></th></tr>';
        $stockHelper .= '<tr><td class="cell-left">Current stock</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->total_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Free stock</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->total_quantity - $modelStore->total_allocated_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Total SO qty</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->so_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Total PO qty</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->po_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Allocated qty</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->total_allocated_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Total Saleable stock</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->total_quantity - $modelStore->so_quantity)) . '</td></tr>';
        $stockHelper .= '<tr><td class="cell-left">Net stock</td><td>' . preg_replace('/\s\d+\.00/', '', floatval($modelStore->total_quantity - $modelStore->so_quantity + $modelStore->po_quantity)) . '</td></tr>';
        if (((int) Yii::app()->user->havePermissionOn['inventory_view_cost_price_vale'])) {
            $stockHelper .= '<tr><td class="cell-left">Cost rate  </td><td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($modelStore->rate, "") . '</td></tr>';
            $stockHelper .= '<tr><td class="cell-left">Stock Value  </td><td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($modelStore->rate * $modelStore->total_quantity, "") . '</td></tr>';
        }
        $stockHelper .= '<tr><td class="cell-left" colpsan="2"><strong>Locations<strong></td></tr>
            <tr><td class="cell-left" colpsan="2">' . $modelStore->locations . '</td></tr>';

        $stockHelper .= '</table>';
        echo $stockHelper;
    }

    //-//
    public function actionCompany() {
        $model = new Company;
        unset(Yii::app()->session['company_id']);
        if (isset($_POST['id'])) {
            $model = $model->findByPK((int) $_POST['id']);
            Yii::app()->session['company_id'] = $model->id;
        }
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//site/_company_form', array('model' => $model), false, true);
    }

    public function actionCompanyContact() {
        $model = new CompanyContact;
        if (isset($_POST['id'])) {
            $model = $model->findByPK((int) $_POST['id']);
        }
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//site/_contact_form', array('model' => $model), false, true);
    }

    //Report form--------------------------------------------------------
    public function actionPurchaseRptForm() {

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_purchasereportform', array(), false, true);
    }

    public function actionSalesRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_salesreportform', array(), false, true);
    }

    public function actionInventoryRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_inventoryreportform', array(), false, true);
    }

    public function actionMaterialAllocRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_materialallocationform', array(), false, true);
    }

    public function actionFinanceRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_finance_rpt', array(), false, true);
    }

    public function actionActivityRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_activity_rpt', array(), false, true);
    }

    public function actionCustomerRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_customer_rpt', array(), false, true);
    }
    
    public function actionUserDetails() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_userdetails_rpt', array(), false, true);
    }

    public function actionContactRptForm() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_contacts_rpt', array(), false, true);
    }

    public function actionActivityajax() {
        $model2 = new Activity;
        $model3 = new Meeting;
        $selected_internal_participants = $selected_participants = "";
        $participantslist = array();

        //add new activity from contact grid
        if (isset($_POST['id'])) {
            $selected_contact = CompanyContact::model()->findByPK((int) $_POST['id']);
            $model2->company_id = $selected_contact->company_id;
            $model2->contact_id = $selected_contact->id;
            $listofcontacts = CompanyContact::model()->findAll(array('condition' => 'company_id=' . $selected_contact->company_id));
            $list_of_contacts = CHtml::listData($listofcontacts, 'id', 'person_name');
            $participantslist = $list_of_contacts;
        } else { //add new activity from calender
            $list_of_contacts = array('prompt' => '--select--');
        }

        //edit activity
        if (isset($_POST['activity_id'])) {
            $model2 = Activity::model()->findByPk((int) $_POST['activity_id']);
            $model2->company_id = $model2->contact->company_id;
            $list_of_contacts = CHtml::listData($model2->contact->company->companyContacts, 'id', 'person_name');
            $participantslist = $list_of_contacts;
            if ($model2->typ_of_activity == "M") {
                $model3 = Meeting::model()->findByPk($model2->id);
                $selected_internal_participants = array();
                if (!empty($model3->internal_participants)) {
                    $selected_options = explode(',', $model3->internal_participants);
                    foreach ($selected_options as $option)
                        $selected_internal_participants[$option] = array('selected' => 'selected');
                }
                if (!empty($model3->participants)) {
                    $selected_options = explode(',', $model3->participants);
                    foreach ($selected_options as $option)
                        $selected_participants[$option] = array('selected' => 'selected');
                }
            }
        }
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//site/activities/_contact_activity_form', array('model2' => $model2, 'model3' => $model3, 'list_of_contacts' => $list_of_contacts, 'selected_participants' => $selected_participants, 'selected_internal_participants' => $selected_internal_participants, 'participantslist' => $participantslist), false, true);
    }

    public function actionGetActivitytype() {
        if (isset($_POST['id'])) {
            $model = Activity::model()->findByPk((int) $_POST['id']);
            switch ($model->typ_of_activity) {
                case "M":
                    $jsonArrray['activity_type'] = "Meeting";
                    break;
                case "C":
                    $jsonArrray['activity_type'] = "Call";
                    break;
                case "T":
                    $jsonArrray['activity_type'] = "Task";
                    break;
                case "V":
                    $jsonArrray['activity_type'] = "Visit";
                    break;
            }
        }
        echo CJSON::encode($jsonArrray);
    }

    //-----------Reports----------------------------------------

    public function actionProfile() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//master/_profile', array(), false, true);
    }

    public function actionProfileSettings() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//master/_password_setting', array(), false, true);
    }

    public function actionAddToInvSingleDv() {
        $dvid = Yii::app()->request->getParam('dv_id');
        $model = DeliveryNote::model()->findByPK($dvid);
        $jsonData = $this->getFileDetails($model->file->id, 'order');
        $selected_delivery_notes = $model->id;
        $modelOrderItems = $model->file->order->items;
        $jsonData['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Product</th>
            <th>Description</th>
            <th>Qty</th>
            <th>Unit</th>
            <th>Rate</th>
            <th>Amount</th>
            <th>Additions</th>
            <th>Deductions</th>
            <th>Net</th>
        </tr>';
        $jsonData['delivery_ids'] = $selected_delivery_notes;
        $total = 0;
        foreach ($modelOrderItems as $i => $eachItem) {
            $model = new InvoiceItem;
            $model->attributes = $eachItem->attributes;
            $model->quantity = DeliveryNoteItem::model()->findBySql('select SUM(`picked_qty`) as `quantity`
                from {{delivery_item}}
                where product_id=' . $model->product_id . ' AND delivery_note_id in (' . $selected_delivery_notes . ')', array())->quantity;
            if ($model->quantity > 0) {
                $model->quantity = $model->quantity > 0 ? $model->quantity : 0;
                $model->amount = number_format($eachItem->rate * $model->quantity, 2, '.', '');
                $model->addition_amount = $eachItem->amount > 0 ? (number_format(($eachItem->addition_amount / $eachItem->amount) * $model->amount, 2, '.', '')) : 0;
                $model->deduction_amount = $eachItem->amount > 0 ? number_format(($eachItem->deduction_amount / $eachItem->amount) * $model->amount, 2, '.', '') : 0;
                $model->net_amount = number_format($model->amount + $model->addition_amount - $model->deduction_amount, 2, '.', '');
                $total += $model->net_amount;
                $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . $model->product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array('class' => 'description', 'readonly' => 'true', 'value' => $model->product->part_number)) .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array('class' => 'description', 'readonly' => 'true')) . '</td>
            <td>' . $model->quantity . CHtml::activeHiddenField($model, "[$i]quantity", array('class' => 'cell-center', 'readonly' => 'true',)) . '</td>
            <td>' . $model->product->unit->unit_name . CHtml::activeHiddenField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->unit_name)) . '</td>
            <td>' . $model->rate . CHtml::activeHiddenField($model, "[$i]rate", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td>' . $model->amount . CHtml::activeHiddenField($model, "[$i]amount", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]addition_percentage", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#invoice_item_table"));',
                            'readonly' => false)) .
                        CHtml::activeTextField($model, "[$i]addition_amount", array('class' => 'cell-right', 'readonly' => true)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]deduction_percentage", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'calculateValues($("#invoice_item_table"));',
                            'readonly' => false)) .
                        CHtml::activeTextField($model, "[$i]deduction_amount", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            </tr>';
            }
        }
//echo adItems
        $jsonData['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">' . $total . '</h2></td>
        </tr>';
        $addition = ($eachItem->order->netAmount > 0) ? (number_format(($total / $eachItem->order->netAmount) * $eachItem->order->adTotal, 2, '.', '')) : 0;
        $deduction = ($eachItem->order->netAmount > 0) ? (number_format(($total / $eachItem->order->netAmount) * $eachItem->order->dedTotal, 2, '.', '')) : 0;
        $jsonData['addition'] = '';
        $modelAddition = new InvoiceAddition;
        foreach ($eachItem->order->adItems as $i => $eachAddition) {
            $eachAddition->calculated_value = ($eachItem->order->netAmount > 0) ? (number_format(($total / $eachItem->order->netAmount) * $eachAddition->calculated_value, 2, '.', '')) : 0;
            $eachAddition->particular_value = (!is_numeric($eachAddition->particular_value)) ? $eachAddition->particular_value : $eachAddition->calculated_value;
            $jsonData['addition'].='<tr><td class="cell-right">Additions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#invoice_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($modelAddition, "[$i]particular", array('value' => $eachAddition->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($modelAddition, "[$i]particular_value", array('value' => $eachAddition->particular_value,
                        'onkeyup' => 'calculateValues($(\'#invoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($modelAddition, "[$i]calculated_value", array(
                        'readonly' => true,
                        'value' => $eachAddition->calculated_value,
                        'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#invoice_final_add_table\'), this)')) .
                    '</span></td></tr>';
        }
        $jsonData['deduction'] = '';
        $modelDeduction = new InvoiceDeduction;
        foreach ($eachItem->order->dedItems as $i => $eachDeduction) {
            $eachDeduction->calculated_value = ($eachItem->order->netAmount > 0) ? (number_format(($total / $eachItem->order->netAmount) * $eachDeduction->calculated_value, 2, '.', '')) : 0;
            $eachDeduction->particular_value = (!is_numeric($eachDeduction->particular_value)) ? $eachDeduction->particular_value : $eachDeduction->calculated_value;
            $jsonData['deduction'].='<tr><td class="cell-right">Deductions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#invoice_final_ded_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($modelDeduction, "[0]particular", array('value' => $eachDeduction->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($modelDeduction, "[0]particular_value", array('value' => $eachDeduction->particular_value,
                        'onkeyup' => 'calculateValues($(\'#invoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($modelDeduction, "[0]calculated_value", array(
                        'readonly' => true,
                        'value' => $eachDeduction->calculated_value,
                        'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#invoice_final_ded_table\'), this)')) .
                    '</span></td></tr>';
        }
        $gd_total = number_format($total + $addition - $deduction, 2, '.', '');
        $jsonData['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $gd_total . '</h1></td>
        </tr>';
        echo CJSON::encode($jsonData);
    }

    public function report($model, $htmlTemplate, $css, $html_prepared = null, $title = null) {
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/' . $css . '.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.reports.' . $htmlTemplate, array('model' => $model, 'product_items' => $html_prepared, 'title' => $title), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionIncentiveReports() {
        $criteria = new cdbCriteria;

        if (isset($_POST['incentive_file_id']) && (int) $_POST['incentive_file_id'] > 0)
            $criteria->addCondition('t.id=' . (int) $_POST['incentive_file_id'], 'AND');
        else
            $criteria->addCondition('t.current_process_status in ("O","D","PD","I","PI")');
        if (isset($_POST['incentive_lead_lead_owner']) && (int) $_POST['incentive_lead_lead_owner'] > 0)
            $criteria->addCondition('t.lead_owner_id =' . (int) $_POST['incentive_lead_lead_owner'], 'AND');
        else {
            if ((int) Yii::app()->user->havePermissionOn['sop_incentive'])
                $criteria->addCondition('t.lead_owner_id > 0', 'AND');
            else
                $criteria->addCondition('t.lead_owner_id = ' . Yii::app()->user->id);
        }
        $criteria->addCondition('is_approved="Y"', 'AND');
        $criteria->order = "t.id DESC";
        $dataProvider = new CActiveDataProvider('MasterFile', array(
            'criteria' => $criteria,
            'pagination' => false,
        ));
        $this->report($dataProvider, 'incentives-list', 'pdf_for_list');
    }

    public function actionOthers() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//reports/_others', array(), false, true);
    }

    public function actionRenderUserGroup() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//master/_usergroupform', array(), false, true);
    }
    
    public function actionrenderUser() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//master/_userform', array(), false, true);
    }
    

    public function actionActivity() {
        $data_array = array();
        $month = (isset($_POST['month']) && (int) $_POST['month'] > 0) ? $_POST['month'] : date('m');
        /* $modelOrders = Activity::model()->with('user')->findAll(array(
          'select' => ' t.crm_user_id',
          'condition' => 't.own_company_id =' . Yii::app()->user->master_user_company_id . ' AND
          t.own_branch_id=' . Yii::app()->user->master_user_branch_id,
          'order' => 'user.first_name',
          'group' => 't.crm_user_id')); */
        $users = User::model()->findAll();
        foreach ($users as $eachuser) {
            $data['M'][] = floatval(Activity::model()->count('crm_user_id=' . $eachuser->id . ' AND typ_of_activity="M"'));
            $data['T'][] = floatval(Activity::model()->count('crm_user_id=' . $eachuser->id . ' AND typ_of_activity="T"'));
            $data['V'][] = floatval(Activity::model()->count('crm_user_id=' . $eachuser->id . ' AND typ_of_activity="V"'));
            $data['C'][] = floatval(Activity::model()->count('crm_user_id=' . $eachuser->id . ' AND typ_of_activity="C"'));
            $data_array['cats'][] = $eachuser->first_name;
        }
        $data_array['x0'] = array('name' => 'Meeting', 'data' => $data['M']);
        $data_array['x1'] = array('name' => 'Quotes', 'data' => $data['T']);
        $data_array['x2'] = array('Visit' => 'Orders', 'data' => $data['V']);
        $data_array['x3'] = array('Call' => 'Orders', 'data' => $data['C']);
        echo CJSON::encode($data_array);
    }

}