<?php

class PermissionController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('ApproveForm','ApprovePrequoteForm','Permissions', 'ApprovalNotification', 'notificationForDepartments'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionApproveForm() {
        $model0 = new FormApproval;
        $form_id = (int) $_REQUEST['form_id'];
        $file_id = (int) $_REQUEST['file_id'];
        $refresh_grid = $_REQUEST['refresh_grid'];
        /* $temp = FormApproval::model()->find(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id . ' AND approved_or_unapproved_by=' . Yii::app()->user->id));
          if (count($temp) > 0)
          $model0 = $temp; */
        if (isset($_POST['FormApproval'])) {
            $i = 0;
            $validate = true;
            $userId = array();
            $user_id = FormPermission::model()->findAll(array('condition' => 'form_id=' . $form_id, 'select' => 'user_id,level', 'order' => 'level ASC'));
          // date_default_timezone_set('Asia/Dubai');
            foreach ($user_id as $eachUser_id) {
                $userId = unserialize($eachUser_id['user_id']);
                if (in_array(Yii::app()->user->id, $userId)) {
                    $model1[$i] = new FormApproval;
                    $model1[$i]->attributes = $_POST['FormApproval'];
                    $model1[$i]->form_id = $form_id;
                    $model1[$i]->file_id = $file_id;
                    $model1[$i]->level = $eachUser_id['level'];
                    $model1[$i]->arrived_req_for_approval = "A";
                    $model1[$i]->date_of_approval = date('Y-m-d H:i:s a', time());
                    $model1[$i]->created_date = date('Y-m-d H:i:s a', time());
                    $model1[$i]->approved_or_unapproved_by = Yii::app()->user->id;
                    $validate = $validate && $model1[$i]->validate();
                    $i++;
                }
            }
            if ($validate && is_array($model1)) {
                //FormApproval::model()->deleteAll(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id . ' AND approved_or_unapproved_by=' . Yii::app()->user->id));
                foreach ($model1 as $eachItem)
                    $eachItem->save();
                //$model0->refresh();
                echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($model0, '', false);
                if ($error != '[]')
                    echo $error;
            }
             $maxLevel = Yii::app()->db->createCommand()
                    ->select('max(level)')
                    ->from('crm_form_permission')
                    ->where('form_id='.$form_id)
                    ->queryScalar();
            $condition0 = 'form_id ='.$form_id.' AND level=' . $maxLevel . ' AND is_approved="Y"';
            $approved = FormApproval::model()->findAll(array('condition' => $condition0, 'select' => 'file_id'));
            if($approved){
                MasterFile::model()->updateAll(array('is_approved'=>"Y"),'current_form_id=' . $form_id . ' AND id=' . $file_id);
            }
            Yii::app()->end();
        }
        $history = FormApproval::model()->findAll(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id));
        
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/_form_approval', array('model' => $model0, 'form_id' => $form_id, 'file_id' => $file_id, 'history' => $history,'refresh_grid'=>$refresh_grid,'flag'=>1), false, true);
    }

    public function actionApprovePrequoteForm() {
        $model0 = new FormApproval;
        $form_id = (int) $_REQUEST['form_id'];
        $file_id = (int) $_REQUEST['file_id'];
        $refresh_grid = $_REQUEST['refresh_grid'];
     
        if (isset($_POST['FormApproval'])) {
            $i = 0;
            $validate = true;
                    $model1 = new FormApproval;
                    $model1->attributes = $_POST['FormApproval'];
                    $model1->form_id = $form_id;
                    $model1->file_id = $file_id;
                    $model1->level = $eachUser_id['level'];
                    $model1->arrived_req_for_approval = "A";
                    $model1->date_of_approval = date('Y-m-d H:i:s a', time());
                    $model1->created_date = date('Y-m-d H:i:s a', time());
                    $model1->approved_or_unapproved_by = Yii::app()->user->id;
                    $validate = $validate && $model1->validate();
            if ($validate && $model1) {
                    $model1->save();
                echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($model0, '', false);
                if ($error != '[]')
                    echo $error;
            }
             
                MasterFile::model()->updateAll(array('is_approved'=>"Y"),'current_form_id=' . $form_id . ' AND id=' . $file_id);
            
            Yii::app()->end();
        }
        $history = FormApproval::model()->findAll(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id));
        
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/_form_approval', array('model' => $model0, 'form_id' => $form_id, 'file_id' => $file_id, 'history' => $history,'refresh_grid'=>$refresh_grid,'flag'=>0), false, true);
    }
    public function sendNotification($mail_ids, $subject, $msg_to_send) {
        //$mail_ids = array_unique($mail_ids);/* to add */
        $mail_ids = "liju.bluesky@gmail.com"; /* to remove */
        // foreach ($mail_ids as $eachemail) {/* to add */
        $message = new YiiMailMessage();
        $message->view = 'approvalnotification';
        $regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/';
        // if (!empty($eachemail) && preg_match($regex, $eachemail)) {/* to add */
        // $message->addTo($eachemail);/* to add */
        $message->addTo($mail_ids); /* to remove */
        //$message->addTo("arun.kumar@mailbluesky.com");
        $message->subject = $subject;
        $message->from = Yii::app()->params['adminEmail'];
        $message->setBody(array('msg_to_send' => $msg_to_send), 'text/html');
        Yii::app()->mail->send($message);
        
        //}/* to add */
        /*         * ************************** */
        //}/* to add */
    }

    public function actionApprovalNotification() {
        $model0 = new FormApproval;
        $form_id = (int) $_REQUEST['form_id'];
        $file_id = (int) $_REQUEST['file_id'];
        $level = (int) $_REQUEST['level'];
        $model0->form_id = $form_id;
        $model0->file_id = $file_id;
        $model0->level = $level;
        $model0->date_send_for_approval = date('Y-m-d H:i:s a', time());
        $model0->approved_or_unapproved_by = Yii::app()->user->id;
        $model0->created_date = date('Y-m-d H:i:s a', time());
        $model0->save(false);

        $message = '<table width="100%" border="0" cellspacing="0" cellpadding="5" style="font-family:tahoma;font-size:12px; padding: 10px;">
                        <tr>
                            <td width="339">An approval request has been generated for File :' . $file_id . '</td>
                            <td width="341"><?php echo $msg_to_send; ?></td>
                        </tr>
                        <tr>
                            <td width="339">File</td>
                            <td width="341">' . $file_id . '/' . $form_id . '</td>
                        </tr>
                        <tr>
                            <td width="339">Form status</td>
                            <td width="341">' . $model0->form->name . '</td>
                        </tr>
                        <tr>
                            <td width="339">Sales Manager/Lead owner</td>
                            <td width="341">' . $model0->file->leadowner->fullname . '</td>
                        </tr>
                        <tr>
                            <td width="339">Date</td>
                            <td width="341">' . $model0->date_send_for_approval . '</td>
                        </tr>
                    </table>';
        $user_id = FormPermission::model()->findAll(array('condition' => 'level=' . $level . ' AND form_id=' . $form_id, 'select' => 'user_id,level'));
        foreach ($user_id as $eachUser_id) {
            $userId = unserialize($eachUser_id['user_id']);
            foreach ($userId as $eachUserId) {
                $user = User::model()->findBypk($eachUserId);
                //$emails = explode(";", trim($user->email));/* to add */
                $emails = "liju.bluesky@gmail.com"; /* to remove */
                if (!is_array($emails))
                //$emails = array($user->email);/* to add */
                    $emails = "liju.bluesky@gmail.com"; /* to remove */
                $this->sendNotification($emails, "Approval Request", $message);
            }
        }
        echo CJSON::encode(array('status' => 'success'));
        Yii::app()->end();
    }

    public function actionNotificationForDepartments() {


        $form_id = (int) $_REQUEST['form_id'];
        $file_id = (int) $_REQUEST['file_id'];
        $department_id = (int) $_REQUEST['department_id'];

        /*$model0 = new FormApproval;
        $model0->form_id = $form_id;
        $model0->file_id = $file_id;
        $model0->level = $department_id;
        $model0->date_send_for_approval = date('Y-m-d h:m:s');
        $model0->approved_or_unapproved_by = Yii::app()->user->id;
        $model0->arrived_req_for_approval = "N";
        $model0->save(false);*/

        $model1 = new Notification;
        $model1->form_id = $form_id;
        $model1->file_id = $file_id;
        $model1->level = $department_id;
        $model1->date_send_for_notification =  date('Y-m-d H:i:s a', time());
        $model1->created_date = date('Y-m-d H:i:s a', time());
        $model1->notification_by = Yii::app()->user->id;
        $model1->arrived_req_for_notification = "N";
        $model1->save(false);

        $modelForm = Form::model()->findByPK($form_id);
        $modelFile = MasterFile::model()->findByPK($file_id);
        $depatrment = PactDepartment::model()->findByPk($department_id);
        $message = '<table width="100%" border="0" cellspacing="0" cellpadding="5" style="font-family:tahoma;font-size:12px; padding: 10px;">
                        <tr>
                            <td width="339">A Notification has been generated for File :' . $file_id . '</td>
                            <td width="341"><?php echo $msg_to_send; ?></td>
                        </tr>
                        <tr>
                            <td width="339">File</td>
                            <td width="341">' . $file_id . '/' . $form_id . '</td>
                        </tr>
                        <tr>
                            <td width="339">Form status</td>
                            <td width="341">' . $modelForm->name . '</td>
                        </tr>
                        <tr>
                            <td width="339">Sales Manager/Lead owner</td>
                            <td width="341">' . $modelFile->leadowner->fullname . '</td>
                        </tr>
                    </table>';
        $userId = unserialize($depatrment['user_ids']);
        foreach ($userId as $eachUserId) {
            $user = User::model()->findBypk($eachUserId);
            //$emails = explode(";", trim($user->email));/* to add */
            $emails = "liju.bluesky@gmail.com"; /* to remove */
            if (!is_array($emails))
            //$emails = array($user->email);/* to add */
                $emails = "liju.bluesky@gmail.com"; /* to remove */
            $this->sendNotification($emails, "Notification", $message);
        }
        echo CJSON::encode(array('status' => 'success'));
        
        Yii::app()->end();
    }

}