<?php

class ProductionController extends Controller {

    public function actionFetchBillofMaterial() {
        $jsondata['model'] = Store::model()->findByPk((int) $_POST['product_id']);
        $jsondata['unit'] = $jsondata['model']->unit;
        echo CJSON::encode($jsondata);
    }

    public function actionFetchbillofmaterialitems() {
        $billofmaterial = ProductionBillofmaterial::model()->find(array('condition' => 'product_id=' . (int) $_POST['product_id']));
        if ($billofmaterial != null) {
            $jsondata['billofmaterial'] = $billofmaterial;
            $items = ProductionBillofmaterialItem::model()->findAll('production_billofmaterial_id=:ID', array(':ID' => $billofmaterial->id));
            foreach ($items as $i => $model) {
                $newquantity = $model->quantity * ((int) $_POST['quantity'] / $billofmaterial->quantity);
                $temp = new ProductionOrderItem;
                $temp->attributes = $model->attributes;
                $model = $temp;
                $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                            'value' => $model->product->part_number)) .
                        CHtml::error($model, "[$i]product_id") .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description')) .
                        CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('value' => $newquantity, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculatePurchaseOrder($("#productionOrder_item_table"));')) .
                        CHtml::error($model, "[$i]quantity") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->product->unit->symbol)) .
                        CHtml::error($model, "[$i]unit") . '</td> 
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('value' => $model->product->rate), array('class' => 'cell-right ', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculatePurchaseOrder($("#productionOrder_item_table"));')) .
                        CHtml::error($model, "[$i]rate") . '</td> 
           <td>' . CHtml::activeTextField($model, "[$i]amount", array('value' => $newquantity * $model->product->rate, 'class' => 'cell-right description', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)) .
                        CHtml::error($model, "[$i]amount") . '</td>                             
            <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionBillofmaterial_item_table"), this);')) . '</td>
            </tr>';
            }
        }
        else
            $jsondata['billofmaterial'] = "";
        echo CJSON::encode($jsondata);
    }

    public function actionFetchProduct() {
        $jsondata['model'] = Store::model()->findByPk((int) $_POST['product_id']);
        $jsondata['unit'] = $jsondata['model']->unit;
        $billofmaterial = ProductionBillofmaterial::model()->find(array('condition' => 'product_id=' . (int) $_POST['product_id']));
        $jsondata['billofmaterial'] = null;
        if ($billofmaterial != null) {
            $jsondata['billofmaterial'] = $billofmaterial;
            $items = ProductionBillofmaterialItem::model()->findAll('production_billofmaterial_id=:ID', array(':ID' => $billofmaterial->id));
            $jsondata['model_items'] = "";
            foreach ($items as $i => $model) {
                $temp = new ProductionOrderItem;
                $temp->attributes = $model->attributes;
                $model = $temp;
                $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description', 'value' => $model->product->part_number)) .
                        CHtml::error($model, "[$i]product_id") .
                        CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description description-textarea')) .
                        CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('value' => $model->quantity, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#productionOrder_item_table"));')) .
                        CHtml::error($model, "[$i]quantity") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->product->unit->symbol)) .
                        CHtml::error($model, "[$i]unit") . '</td> 
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('value' => $model->product->rate), array('class' => 'amount-field cell-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#productionOrder_item_table"));')) .
                        CHtml::error($model, "[$i]rate") . '</td> 
           <td>' . CHtml::activeTextField($model, "[$i]amount", array('value' => $model->quantity * $model->product->rate, 'class' => 'cell-rightamount-field', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)) .
                        CHtml::error($model, "[$i]amount") . '</td>                             
            <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionOrder_item_table"), this);')) . '</td>
            </tr>';
            }
        }
        else
            $jsondata['billofmaterial'] = null;
        echo CJSON::encode($jsondata);
    }

    public function actionGetProductionOrder() {
        $jsondata['model'] = ProductionOrder::model()->findByPk((int) $_POST['id']);
        $jsondata['file'] = $jsondata['model']->file;
        $jsondata['product'] = $jsondata['model']->product;
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $items = ProductionOrderItem::model()->findAll('production_order_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description description-textarea')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('value' => $model->quantity, 'class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#productionOrder_item_table"));')) .
                    CHtml::error($model, "[$i]quantity") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->unit)) .
                    CHtml::error($model, "[$i]unit") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('value' => $model->rate, 'class' => 'cell-right amount-field', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateValues($("#productionOrder_item_table"));')) .
                    CHtml::error($model, "[$i]rate") . '</td> 
           <td>' . CHtml::activeTextField($model, "[$i]amount", array('value' => $model->amount, 'class' => 'cell-right amount-field', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)) .
                    CHtml::error($model, "[$i]amount") . '</td>                             
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionOrder_item_table"), this);')) . '</td>
           </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function actionGetBillofmaterial() {
        $jsondata['model'] = ProductionBillofmaterial::model()->findByPk((int) $_POST['id']);
        $jsondata['product'] = $jsondata['model']->product;
        $items = ProductionBillofmaterialItem::model()->findAll('production_billofmaterial_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $product = Store::model()->findByPk($model->product_id);
            $unit = Unit::model()->findByPk($product->unit_id);
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('class' => 'description description-textarea')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('value' => $model->quantity)) .
                    CHtml::error($model, "[$i]quantity") . '</td>  
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('value' => $model->product->unit->symbol)) .
                    CHtml::error($model, "[$i]unit") . '</td>  
            <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionBillofmaterial_item_table"), this);')) . '</td>
            </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function actionsaveProductionBillOfMaterial($modelName = "ProductionBillofmaterial", $from = "B_M") {
        $model = new $modelName;
        $attributes_main = $_POST[$modelName];
        $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
        $model->attributes = $attributes_main;
        $model->crm_user_id = Yii::app()->user->id;
        $valid = true;
        $itemModel = $modelName . 'Item';
        $other_errors = array();
        foreach ($attributes_items as $i => $item) {
            $modelItem[$i] = new $itemModel;
            $modelItem[$i]->attributes = $attributes_items[$i];
            $valid = $modelItem[$i]->validate() && $valid;
        }

        if ($model->validate() && $valid) { // after validation saving the whole data
            $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
            $this->documents($model->file_id, $from);
            $model->id = ProductionBillofmaterial::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
            if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one
                $model->save();
            else {
                $model->updateByPK($model->id, $model->attributes);
                $itemModel::model()->deleteAll('production_billofmaterial_id=:id', array(':id' => $model->id));
            }
            foreach ($modelItem as $eachItem) {
                $eachItem->{'production_billofmaterial_id'} = $model->id;
                $eachItem->save(false);
            }
            $jsonData['file'] = $model->file;
            $jsonData['model'] = $model;
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
            //Yii::app()->end();
        } else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
            $error3 = array();
            $error4 = array();
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
            if ($error != '[]')
                echo $error;
        }
    }

    public function actionGetproduct() {
        $sql = 'SELECT product_id FROM crm_production_billofmaterial';
        $bm = Yii::app()->db->createCommand($sql)->queryAll();
        $billofmat = array();
        foreach ($bm as $eachbm)
            $billofmat[] = $eachbm['product_id'];
        $criteria = new CDbCriteria();
        $criteria->compare('part_number', $_GET['term'], true);
        $criteria->addNotInCondition("id", $billofmat);
        $items = Store::model()->findAll($criteria);
        foreach ($items as $eachModel) {
            $data_array[$i]['value'] = $eachModel->id;
            $data_array[$i]['label'] = $eachModel->part_number;
            $i++;
        }

        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionGetbillofmaterialitem() {
        $condition = 'part_number LIKE "%' . $_GET['term'] . '%"';
        $condition .='AND id <>' . (int) $_GET['product'];
        $items = Store::model()->findAll(array('condition' => $condition, 'order' => part_number));
        foreach ($items as $eachModel) {
            $data_array[$i]['value'] = $eachModel->id;
            $data_array[$i]['label'] = $eachModel->part_number;
            $i++;
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionGetCustomer() {
        $this->autocompleteData('Company', 'company_name', $_GET['term'], false);
    }

    public function actionGetProductForProductionOrder() {
        $this->autocompleteData('Store', 'part_number', $_GET['term'], false, Yii::app()->user->master_user_company_id);
    }

    public function actionsaveProductionOrder($modelName = "ProductionOrder", $from = "PR_O") {
        if (isset($_POST["ProductionOrder"])) {
            if ((int) $_POST["ProductionOrder"]["file_id"] != 0) {
                $masterfile = MasterFile::model()->findByPK((int) $_POST["ProductionOrder"]["file_id"]);
                if ($masterfile->current_process_status != 'PR_O') {
                    $jsonArrray['saveerror'] = "Saving not possible";
                    echo CJSON::encode($jsonArrray);
                    Yii::app()->end();
                }
            }
            $model = new $modelName;
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $itemModel = $modelName . 'Item';
            $other_errors = array();
            foreach ($attributes_items as $i => $item) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
            }

            if ($model->validate() && $valid) { // after validation saving the whole data
                $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                $model->id = ProductionOrder::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one
                    $model->save();
                else {
                    $model->updateByPK($model->id, $model->attributes);
                    $itemModel::model()->deleteAll('production_order_id=:id', array(':id' => $model->id));
                }
                foreach ($modelItem as $eachItem) {
                    $eachItem->{'production_order_id'} = $model->id;
                    $eachItem->save(false);
                }
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error3 = array();
                $error4 = array();
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetProductinautocomplete() {
        $jsonData['store'] = Store::model()->with('unit')->findByPK((int) $_POST['product_id']);
        $jsonData['unit'] = $jsonData['store']->unit;
        $jsonData['tax'] = $jsonData['store']->taxCode;
        $jsonData['rate'] = floatval(PriceGroupProductRelation::model()->with('priceGrp.company')->find('store_id=' . $jsonData['store']->id . ' AND company.id=' . Yii::app()->session['company_id'])->rate);
        if ($jsonData['rate'] == 0)
            $jsonData['rate'] = floatval(PriceGroupProductRelation::model()->with('priceGrp')->find('priceGrp.isBasePricingGroup="Y" AND t.store_id=' . $jsonData['store']->id)->rate);

        echo (CJSON::encode($jsonData));
        Yii::app()->end();
    }

    public function actionsaveGoodsIssue($modelName = "ProductionGoodsIssue", $from = "G_I") {
        if (isset($_POST["ProductionGoodsIssue"])) {
            $model = new $modelName;
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $itemModel = $modelName . 'Item';
            $other_errors = array();
            foreach ($attributes_items as $i => $item) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
                $thisProduct = Store::model()->findByPK($attributes_items[$i]['product_id']);
                if ((int) $_POST['ProductionGoodsIssue']['id'] == 0) {
                    if ($thisProduct->rate != 0) {
                        $availableQty = $thisProduct->total_quantity - $thisProduct->total_allocated_quantity;
                        if ($availableQty < $attributes_items[$i]['picked_qty']) {
                            $other_errors[] = "Item " . $thisProduct->part_number . " available only " . $availableQty . ' Nos.';
                            $valid = false;
                        }
                    } else {
                        $other_errors[] = "Item " . $thisProduct->part_number . " is not available ";
                        $valid = false;
                    }
                }
            }

            if ($model->validate() && $valid) { // after validation saving the whole data
                $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
                // $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                if ((int) $_POST['ProductionGoodsIssue']['id'] != 0)
                    $model->id = $_POST['ProductionGoodsIssue']['id'];
                if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one             
                    $model->save();
                else {
                    $model->updateByPK($model->id, $model->attributes);
                    $item = $itemModel::model()->findAll($refer_id . '=:id', array(':id' => $model->id));
                    foreach ($item as $eachItem)
                        $this->IncreaseCountFromInventory($eachItem);
                    WorkingProgress::model()->deleteAll('production_goods_issue_id=:id', array(':id' => $model->id));
                    $itemModel::model()->deleteAll($refer_id . '=:id', array(':id' => $model->id));
                }
                $itemorderd = $picked = $itempicked = 0;
                foreach ($modelItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $product = Store::model()->findByPk($eachItem->product_id);
                    $eachItem->{'amount'} = $product->rate * $eachItem->picked_qty;
                    $itemorderd+=$eachItem->quantity;
                    $eachItem->save(false);
                    $condition = 'pg.production_order_id=' . $model->production_order_id . ' AND pgItems.product_id=' . $eachItem->product_id;
                    $picked = Yii::app()->db->createCommand()
                            ->select('sum(pgItems.picked_qty) as picked_qty')
                            ->from('{{production_goods_issue}} pg')
                            ->join('{{production_goods_issue_item}} pgItems', 'pg.id=pgItems.production_goods_issue_id')
                            ->where($condition)
                            ->queryRow();
                    $itempicked+=$picked['picked_qty'];
                    $this->WorkingProgress($eachItem, $model);
                    $this->ReduceCountFromInventory($eachItem);
                }
                if ($itemorderd <= $itempicked) {
                    $productionordermodel = ProductionOrder::model()->findByPk($model->production_order_id);
                    $arrayToBeUpdated['goods_issue_status'] = 'C';
                    $productionordermodel->updateByPk($productionordermodel->id, $arrayToBeUpdated);
                }
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                $error3 = array();
                $error4 = array();
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetProductionorderforGoodsIssue() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'goods_issue_status =  "P" AND id like "%' . $_GET['term'] . '%"';
            $model = ProductionOrder::model()->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->id;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionFetchProductionorderforGoodsIssue() {
        $jsondata['model'] = ProductionOrder::model()->findByPk((int) $_POST['productionorder_id']);
        $jsondata['product'] = $jsondata['model']->product;
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $items = ProductionOrderItem::model()->findAll('production_order_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $temp = new ProductionGoodsIssueItem;
            $temp->attributes = $model->attributes;
            $model = $temp;
            $condition = 'goodsissue.production_order_id=' . (int) $_POST['productionorder_id'] . ' AND goodsissueItems.product_id=' . $model->product_id;
            $itemIssued = Yii::app()->db->createCommand()
                    ->select('sum(goodsissueItems.picked_qty) as pkd_qty')
                    ->from('{{production_goods_issue}} goodsissue')
                    ->join('{{production_goods_issue_item}} goodsissueItems', 'goodsissue.id=goodsissueItems.production_goods_issue_id')
                    ->where($condition)
                    ->queryRow();
            // $remainigquantity = $model->quantity - $itemIssued['pkd_qty'];
            $remainigquantity = $model->quantity - $itemIssued['pkd_qty'];
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('readonly' => true, 'class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('readonly' => true, 'class' => 'description description-textarea')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('readonly' => true, 'value' => $model->quantity)) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]remaining_quantity", array('value' => $remainigquantity, 'readonly' => true, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)',)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array()) .
                    CHtml::error($model, "[$i]picked_qty") . '</td>     
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->unit)) .
                    CHtml::error($model, "[$i]unit") . '</td>                           
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionOrder_item_table"), this);')) . '</td>
           </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function actionGetGoodsIssue() {
        $jsondata['model'] = ProductionGoodsIssue::model()->findByPk((int) $_POST['id']);
        $jsondata['product'] = $jsondata['model']->product;
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $items = ProductionGoodsIssueItem::model()->findAll('production_goods_issue_id=:ID', array(':ID' => $jsondata['model']->id));
        foreach ($items as $i => $model) {
            $condition = 'goodsissue.production_order_id=' . $jsondata['model']['production_order_id'] . ' AND goodsissueItems.product_id=' . $model->product_id;
            $itemIssued = Yii::app()->db->createCommand()
                    ->select('sum(goodsissueItems.picked_qty) as picked_qty')
                    ->from('{{production_goods_issue}} goodsissue')
                    ->join('{{production_goods_issue_item}} goodsissueItems', 'goodsissue.id=goodsissueItems.production_goods_issue_id')
                    ->where($condition)
                    ->queryRow();
            $remainigquantity = $model->quantity - $itemIssued['picked_qty'];
            $jsondata['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array('readonly' => true, 'class' => 'description product-search',
                        'value' => $model->product->part_number)) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array('readonly' => true, 'class' => 'description description-textarea')) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array('readonly' => true, 'value' => $model->quantity)) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]remaining_quantity", array('value' => $remainigquantity, 'readonly' => true, 'class' => 'cell-center', 'onkeypress' => 'return isNumberKey(event)',)) . '</td>
           <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array('readonly' => true, 'value' => $model->picked_qty, 'onkeyup' => 'this.value = checkQCCheckedQuantity(event,this.value,' . $model->quantity . ')')) .
                    CHtml::error($model, "[$i]picked_qty") . '</td>     
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->unit)) .
                    CHtml::error($model, "[$i]unit") . '</td>                          
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionGoodsIssue_item_table"), this);')) . '</td>
           </tr>';
        }
        echo CJSON::encode($jsondata);
    }

    public function IncreaseCountFromInventory($purchaseItem) {
        $product = Store::model()->findByPk($purchaseItem->product_id);
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $purchaseItem->product_id));
        foreach ($warehouses as $eachWareHouse) {
            $eachWareHouse->quantity += $purchaseItem->picked_qty;
            $eachWareHouse->save();
            break;
        }
        /* $productionorderitem = ProductionOrderItem::model()->find(array('condition' => 'production_order_id=:ID AND product_id=:product_id', 'params' => array(':ID' => $purchaseItem->goodsissue->production_order_id, ':product_id' => $purchaseItem->product_id)));
          $newtotal_value = $product->total_value + $productionorderitem->rate * $purchaseItem->picked_qty;
          //$newcount = ($product->total_value / $product->rate) + $purchaseItem->picked_quantity;
          if ($product->rate != 0)
          $newcount = ($product->total_value / $product->rate) + $purchaseItem->picked_qty;
          else if ($product->total_value != 0)
          $newcount = $product->total_value + $purchaseItem->picked_qty;
          else
          $newcount = $purchaseItem->picked_qty;
          if ($newcount == 0 && $newtotal_value == 0)
          $newrate = 0;
          else if ($newcount == 0 && $newtotal_value != 0)
          $newrate = $newtotal_value;
          else
          $newrate = $newtotal_value / $newcount;
          $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value)); */
    }

    public function ReduceCountFromInventory($purchaseItem) {
        $product = Store::model()->findByPk($purchaseItem->product_id);
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $purchaseItem->product_id));
        foreach ($warehouses as $eachWareHouse) {
            if ($purchaseItem->picked_qty < $eachWareHouse->quantity) {
                $eachWareHouse->quantity -= $purchaseItem->picked_qty;
                $purchaseItem->picked_qty = 0;
                $eachWareHouse->save();
                break;
            } else {
                $purchaseItem->picked_qty-=$eachWareHouse->quantity;
                $eachWareHouse->quantity = 0;
                $eachWareHouse->save();
            }
        }
        /* $productionorderitem = ProductionOrderItem::model()->find(array('condition' => 'production_order_id=:ID AND product_id=:product_id', 'params' => array(':ID' => $purchaseItem->goodsissue->production_order_id, ':product_id' => $purchaseItem->product_id)));
          $newtotal_value = $product->total_value - $productionorderitem->rate * $purchaseItem->picked_qty;
          $newcount = ($product->total_value / $product->rate) - $purchaseItem->picked_qty;
          if ($product->rate != 0)
          $newcount = ($product->total_value / $product->rate) - $purchaseItem->picked_qty;
          else if ($product->total_value != 0)
          $newcount = $product->total_value - $purchaseItem->picked_qty;
          else
          $newcount = 0;
          if ($newcount == 0 && $newtotal_value == 0)
          $newrate = 0;
          else if ($newcount == 0 && $newtotal_value != 0)
          $newrate = $newtotal_value;
          else
          $newrate = $newtotal_value / $newcount;
          $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value)); */
    }

    public function WorkingProgress($purchaseItem, $model) {
        $workingprogress = new WorkingProgress;
        $workingprogress->production_goods_issue_id = $model->id;
        $workingprogress->file_id = $model->file_id;
        $workingprogress->goods_issue_date = $model->goods_issue_date;
        $workingprogress->count = $purchaseItem->picked_qty;
        $workingprogress->product_id = $purchaseItem->product_id;
        $workingprogress->save();
    }

    public function actionGetProductionorderforGoodsReceipt() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'goods_issue_status =  "C" AND file.current_process_status in ("G_I")';
            $model = ProductionOrder::model()->with('file')->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->id;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionFetchProductionorderforGoodsReceipt() {
        $jsondata['model'] = ProductionOrder::model()->findByPk((int) $_POST['productionorder_id']);
        $jsondata['product'] = $jsondata['model']->product;
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $goodsissue = ProductionGoodsIssue::model()->findAll('production_order_id=:ID', array(':ID' => $jsondata['model']->id));
        $totalamount = 0;
        foreach ($goodsissue as $i => $eachgoodsissue) {
            $eachgoodsissueitems = ProductionGoodsIssueItem::model()->findAll('production_goods_issue_id=:ID', array(':ID' => $eachgoodsissue->id));
            foreach ($eachgoodsissueitems as $i => $item)
                $totalamount +=$item->amount;
        }
        $i = 0;
        $rate = $totalamount / $jsondata['model']->quantity;
        $temp = new ProductionGoodsReceiptItem;
        $jsondata['total'] = $totalamount;
        $jsondata['model_items'] = "";
        $jsondata['model_items'] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($temp, "[$i]product_name", array('readonly' => true, 'class' => 'description', 'value' => $jsondata['model']->product->part_number)) .
                CHtml::error($temp, "[$i]product_id") .
                CHtml::activeHiddenField($temp, "[$i]product_id", array('class' => 'description', 'value' => $jsondata['model']->product->id)) . '</td>
            <td>' . CHtml::activeTextField($temp, "[$i]description", array('readonly' => true, 'class' => 'description description-textarea', 'value' => $jsondata['model']->product->description)) .
                CHtml::error($temp, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($temp, "[$i]quantity", array('readonly' => true, 'value' => $jsondata['model']->quantity)) .
                CHtml::error($temp, "[$i]quantity") . '</td> 
           <td>' . CHtml::activeTextField($temp, "[$i]rate", array('readonly' => true, 'class' => 'amount-field', 'value' => $rate)) .
                CHtml::error($temp, "[$i]rate") . '</td>    
            <td>' . CHtml::activeTextField($temp, "[$i]unit", array('readonly' => true, 'value' => $jsondata['model']->product->unit->symbol)) .
                CHtml::error($temp, "[$i]unit") . '</td>  
                        <td>' . CHtml::activeTextField($temp, "[$i]amount", array('readonly' => true, 'class' => 'amount-field', 'value' => $totalamount)) .
                CHtml::error($temp, "[$i]amount") . '</td>    
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionGoodsReceipt_item_table"), this);')) . '</td>
           </tr>';
        echo CJSON::encode($jsondata);
    }

    public function actionSaveGoodsReceipt($modelName = "ProductionGoodsReceipt", $from = "G_R") {
        $model = new $modelName;
        $attributes_main = $_POST[$modelName];
        $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
        $attributes_additions = @$_POST[$modelName . 'Addition'];
        $attributes_deductions = @$_POST[$modelName . 'Deduction'];
        $model->attributes = $attributes_main;
        $model->crm_user_id = Yii::app()->user->id;
        $valid = true;
        $itemModel = $modelName . 'Item';
        $other_errors = array();
        $modelItem = new $itemModel;
        $modelItem->attributes = $attributes_items[0];
        /* $modelItem->product_name = $attributes_items[0]['product_name'];
          $modelItem->product_id = $attributes_items[1]['product_id'];
          $modelItem->description = $attributes_items[2]['description'];
          $modelItem->quantity = $attributes_items[3]['quantity'];
          $modelItem->rate = $attributes_items[4]['rate'];
          $modelItem->unit = $attributes_items[5]['unit'];
          $modelItem->amount = $attributes_items[6]['amount']; */
        $valid = $modelItem->validate() && $valid;
        /* foreach ($attributes_items as $i => $item) {
          $modelItem[$i] = new $itemModel;
          $modelItem[$i]->attributes = $attributes_items[$i];
          $valid = $modelItem[$i]->validate() && $valid;
          } */
        $itemAdditionModel = $modelName . 'Addition';
        $itemDeductionModel = $modelName . 'Deduction';
        foreach ($attributes_additions as $i => $item) {
            $modelAdditionItem[$i] = new $itemAdditionModel;
            $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
            $valid = $modelAdditionItem[$i]->validate() && $valid;
        }
        foreach ($attributes_deductions as $i => $item) {
            $modelDeductionItem[$i] = new $itemDeductionModel;
            $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
            $valid = $modelDeductionItem[$i]->validate() && $valid;
        }
        if ($model->validate() && $valid) { // after validation saving the whole data
            $model->file_id = $this->masterFile($model->file_id, $from, isset($model->title) ? $model->title : 0, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
            $this->documents($model->file_id, $from);
            $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id';
            $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
            if ((int) $model->id == 0) // if id 0 means its a new record, otherwise needs to update the existing one
                $model->save();
            else {
                $model->updateByPK($model->id, $model->attributes);
                $item = $itemModel::model()->findAll($refer_id . '=:id', array(':id' => $model->id));
                // foreach ($item as $eachItem)
                $this->ReduceGoodsReceiptInInventory($item);
                //WorkingProgress::model()->deleteAll('production_goods_issue_id=:id', array(':id' => $model->id));
                $itemModel::model()->deleteAll($refer_id . '=:id', array(':id' => $model->id));
                $itemAdditionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                $itemDeductionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
            }
            $itemorderd = $picked = $itempicked = $grand_total = 0;
            /* foreach ($modelItem as $eachItem) {
              $eachItem->{$refer_id} = $model->id;
              $eachItem->save(false);
              $grand_total += $eachItem->amount;
              // $this->UpdateGoodsReceiptInInventory($eachItem);
              } */
            $modelItem->{$refer_id} = $model->id;
            $modelItem->save(false);
            $grand_total += $modelItem->amount;
            foreach ($modelAdditionItem as $eachItem) {
                $eachItem->{$refer_id} = $model->id;
                $eachItem->save(false);
                $grand_total += $eachItem->calculated_value;
            }
            foreach ($modelDeductionItem as $eachItem) {
                $eachItem->{$refer_id} = $model->id;
                $eachItem->save(false);
                $grand_total -= $eachItem->calculated_value;
            }
            $model->updateByPk($model->id, array('grand_total' => $grand_total));
            $item = $itemModel::model()->findAll($refer_id . '=:id', array(':id' => $model->id));
            $this->UpdateGoodsReceiptInInventory($item);
            $jsonData['file'] = $model->file;
            $jsonData['model'] = $model;
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
            //Yii::app()->end();
        } else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
            $error3 = array();
            $error4 = array();
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
            if ($error != '[]')
                echo $error;
        }
    }

    public function UpdateGoodsReceiptInInventory($eachItem) {
        $product = Store::model()->findByPk($eachItem[0]['product_id']);
        $item = ProductionGoodsReceiptItem::model()->findByPk($eachItem[0]['id']);
        $goodsreceipt = ProductionGoodsReceipt::model()->findByPk($eachItem[0]['production_goods_receipt_id']);
        $eacitemamount = $goodsreceipt->netTotal + $goodsreceipt->adTotal - $goodsreceipt->dedTotal;
        $newtotal_value = $product->total_quantity * $product->rate + $eacitemamount;
        $newcount = $product->total_quantity + $item->quantity;
        if ($newcount == 0 && $newtotal_value == 0)
            $newrate = 0;
        else if ($newcount == 0 && $newtotal_value != 0)
            $newrate = $newtotal_value;
        else
            $newrate = $newtotal_value / $newcount;
        $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value));
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $item->product_id));
        foreach ($warehouses as $eachWareHouse) {
            $eachWareHouse->quantity += $item->quantity;
            $eachWareHouse->save();
            break;
        }
    }

    public function ReduceGoodsReceiptInInventory($eachItem) {
        $product = Store::model()->findByPk($eachItem[0]['product_id']);
        $item = ProductionGoodsReceiptItem::model()->findByPk($eachItem[0]['id']);
        $goodsreceipt = ProductionGoodsReceipt::model()->findByPk($eachItem[0]['production_goods_receipt_id']);
        $eacitemamount = $goodsreceipt->netTotal + $goodsreceipt->adTotal - $goodsreceipt->dedTotal;
        $newtotal_value = $product->total_quantity * $product->rate + $eacitemamount;
        // $newcount = ($product->total_value / $product->rate) - $eachItem->quantity;
        if ($product->rate != 0)
            $newcount = $product->total_quantity - $item->quantity;
        else if ($product->total_value != 0)
            $newcount = $product->total_value - $item->quantity;
        else
            $newcount = 0;
        if ($newcount == 0 && $newtotal_value == 0)
            $newrate = 0;
        else if ($newcount == 0 && $newtotal_value != 0)
            $newrate = $newtotal_value;
        else
            $newrate = $newtotal_value / $newcount;
        $product->updateByPk($product->id, array('rate' => $newrate, 'total_value' => $newtotal_value));
        $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $item->product_id));
        foreach ($warehouses as $eachWareHouse) {
            $eachWareHouse->quantity -= $item->quantity;
            $eachWareHouse->save();
            break;
        }
    }

    public function actionGetGoodsReceipt() {
        $jsondata['model'] = ProductionGoodsReceipt::model()->findByPk((int) $_POST['id']);
        //$jsondata['project'] = $jsondata['model']->project;
        $jsondata['project'] = MasProject::model()->findByPk($jsondata['model']->project);
        $jsondata['customer'] = $jsondata['model']->customer;
        $temp = new ProductionGoodsReceiptItem;
        $i = 0;
        $jsondata['model_items'] = "";
        $items = $jsondata['model']->items;
        $jsondata['model_items'] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($temp, "[$i]product_name", array('readonly' => true, 'class' => 'description product-search',
                    'value' => $items->product->part_number)) .
                CHtml::error($temp, "[$i]product_id") .
                CHtml::activeHiddenField($temp, "[$i]product_id", array('value' => $items->product_id)) . '</td>
            <td>' . CHtml::activeTextField($temp, "[$i]description", array('readonly' => true, 'class' => 'description description-textarea', 'value' => $items->product->description)) .
                CHtml::error($temp, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($temp, "[$i]quantity", array('readonly' => true, 'value' => $items->quantity)) .
                CHtml::error($temp, "[$i]quantity") . '</td>  
            <td>' . CHtml::activeTextField($temp, "[$i]rate", array('readonly' => true, 'class' => 'amount-field', 'value' => $items->rate)) .
                CHtml::error($temp, "[$i]rate") . '</td>  
            <td>' . CHtml::activeTextField($temp, "[$i]unit", array('readonly' => true, 'value' => $items->unit)) .
                CHtml::error($temp, "[$i]unit") . '</td>  
            <td>' . CHtml::activeTextField($temp, "[$i]amount", array('readonly' => true, 'class' => 'amount-field', 'value' => $items->amount)) .
                CHtml::error($temp, "[$i]amount") . '</td>    
           <td>' . CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#productionGoodsReceipt_item_table"), this);')) . '</td>
           </tr>';
        $modelAdItems = $jsondata['model']->adItems;
        $modelDedItems = $jsondata['model']->dedItems;
        $jsondata['model_addition_items'] = "";
        $jsondata['total'] = $jsondata['model']->netTotal;
        $jsondata['grandtotal'] = $jsondata['model']->netTotal + ($jsondata['model']->adTotal - $jsondata['model']->dedTotal);
        foreach ($modelAdItems as $i => $model) {
            $jsondata['model_addition_items'].='<tr><td class="cell-right">Additions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#productionGoodsReceipt_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::error($model, "[$i]paricular") .
                    CHtml::activeTextField($model, "[$i]particular_value", array(
                        'onkeyup' => 'calculateValues($(\'#productionGoodsReceipt_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#productionGoodsReceipt_final_add_table\'), this)')) .
                    '</span></td></tr>';
        }
        $jsondata['model_deduction_items'] = "";
        foreach ($modelDedItems as $i => $model) {
            $jsondata['model_deduction_items'].='<tr><td class="cell-right">Deductions<span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#productionGoodsReceipt_final_ded_table"))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($model, "[$i]particular_value", array('onkeyup' => 'calculateValues($("#productionGoodsReceipt_item_table"));',
                        'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#productionGoodsReceipt_final_ded_table"), this)')) . ' ' .
                    '</span></td></tr>';
        }
        echo CJSON::encode($jsondata);
    }

}

?>
