<?php

class ProfileController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('SaveProfile', 'changePassword'
                ),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionSaveProfile() {
        $model = new User;
        $model_profile = new UserProfile;
        if (isset($_POST['UserProfile'])) {
            $model_profile->scenario = 'saveprofile';
            $model->attributes = $_POST['UserProfile'];
            $model_profile->attributes = $_POST['UserProfile'];
            $model->id = Yii::app()->user->id;
            $model->branch_id = Yii::app()->user->master_user_branch_id;
            $model->company_id = Yii::app()->user->master_user_company_id;
            if ($model_profile->validate()) {
                $model->updateByPK($model->id, $_POST['UserProfile']);
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error = CActiveForm::validate($model_profile, '', false);
                if ($error != '[]')
                    echo $error;
            }
        }
        Yii::app()->end();
    }

    public function actionchangePassword() {
        $model_profile = new UserProfile;
        $model = new User;
        $model->id = Yii::app()->user->id;
        if (isset($_POST['UserProfile'])) {
            $model_profile->scenario = 'password_updation';
            $model_profile->attributes = $_POST['UserProfile'];
            if ($model_profile->validate()) {
                User::model()->updateByPk($model->id, array("password" => crypt($_POST['UserProfile']['newPassword'], $_POST['UserProfile']['newPassword'])));
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error = CActiveForm::validate($model_profile, '', false);
                if ($error != '[]')
                    echo $error;
            }
        }
    }

}

?>
