<?php

class SiteController extends Controller {

    /**
     * Declares class-based actions.
     */
    public function actions() {
        return array(
// captcha action renders the CAPTCHA image displayed on the contact page
            'captcha' => array(
                'class' => 'CCaptchaAction',
                'backColor' => 0xFFFFFF,
            ),
            // page action renders "static" pages stored under 'protected/views/site/pages'
// They can be accessed via: index.php?r=site/page&view=FileName
            'page' => array(
                'class' => 'CViewAction',
            ),
        );
    }

    /**
     * This is the default 'index' action that is invoked
     * when an action is not explicitly requested by users.
     */
    public function actionIndex() {
        if (Yii::app()->request->isAjaxRequest) {
            switch (Yii::app()->request->getParam('ajax')) {
                case 'comanies-table':
                    $this->renderPartial('//site/_companies_grid', array('model' => new Company));
                    break;
                case 'company-pricing-table':
                    $this->renderPartial('//site/_company_form', array('model' => new Company));
                    break;
                case 'contacts-table':
                    $this->renderPartial('//site/_contacts', array('model' => new CompanyContact));
                    break;
                case 'lead-table':
                    $this->renderPartial('//sop/lead/_leaddetails', array('model' => new Lead, 'form_approvel' => new FormApproval));
                    break;
                case 'quotation-table':
                    $this->renderPartial('//sop/quotation/_quotesdetails', array('model' => new Quotes));
                    break;
                case 'order-table':
                    $this->renderPartial('//sop/order/_orderdetails', array('model' => new Order));
                    break;
                case 'delivery-table':
                    $this->renderPartial('//sop/delivery/_deliverydetails', array('model' => new DeliveryNote));
                    break;
                case 'invoice-table':
                    $this->renderPartial('//sop/invoices/_invoicedetails', array('model' => new Invoice));
                    break;
                case 'delivery-sub-table':
                    $this->renderPartial('//site/_invoiceitemsform', array('modelDelivery' => (new DeliveryNote),));
                    break;
                case 'creditnote-table':
                    $this->renderPartial('//site/_creditnotedetails', array('model' => new Creditnote));
                    break;
                case 'invoices-table':
                    $this->renderPartial('//site/_recieptofpaymentform');
                    break;
                case 'documents-tableL':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'L'));
                    break;
                case 'documents-tableQ':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'Q'));
                    break;
                case 'documents-tableO':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'O'));
                    break;
                case 'documents-tableI':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'I'));
                    break;
                case 'documents-tableC':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'C'));
                    break;
                case 'documents-tableB_M':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'B_M'));
                    break;
                case 'documents-tablePR_O':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'PR_O'));
                    break;
                case 'documents-tableG_I':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'G_I'));
                    break;
                case 'documents-tableG_R':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'G_R'));
                    break;
                case 'documents-tableP_R':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'P_R'));
                    break;
                case 'documents-tableP_E':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'P_E'));
                    break;
                case 'documents-tableP_O':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'P_O'));
                    break;
                case 'documents-tableM_R':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'M_R'));
                    break;
                case 'documents-tableP_I':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'P_I'));
                    break;
                case 'documents-tableP_C':
                    $this->renderPartial('//site/_documents', array('form' => $form, 'called_section' => 'P_C'));
                    break;
                case 'requisition-table':
                    $this->renderPartial('//purchasing/_requisitiondetails', array('model' => new PurchasingRequisition));
                    break;
                case 'enquiry-table':
                    $this->renderPartial('//purchasing/_enquirydetails', array('model' => new PurchasingEnquiry));
                    break;
                case 'purchasingorder-table':
                    $this->renderPartial('//purchasing/_purchasingorderdetails', array('model' => new PurchasingOrder));
                    break;
                case 'materialreceipt-table':
                case 'openpurchasingorder-table':
                    $this->renderPartial('//purchasing/_materialreceiptdetails', array('model' => new PurchasingMaterialreceipt));
                    break;
                case 'materialreceiptforqualitycheck-table':
                    $this->renderPartial('//purchasing/_qualitycheckdetails', array('model' => new PurchasingMaterialreceipt));
                    break;
                case 'purchaseorder-for-vendor-table':
                    $this->renderPartial('//purchasing/_materialreceiptform');
                    break;
                case 'purchasinginvoice-for-vendor-table':
                    $this->renderPartial('//purchasing/_purchasinginvoiceform');
                    break;
                case 'purchasecredit-for-vendor-table':
                    $this->renderPartial('//purchasing/_purchasingcreditform');
                    break;
                case 'purchase-invoice-table':
                case 'purchaseorderforinvoice-table':
                    $this->renderPartial('//purchasing/_purchasinginvoicedetails', array('model' => new PurchasingInvoice));
                    break;
                case 'purchasingcredit-table':
                    $this->renderPartial('//purchasing/_purchasingcreditdetails', array('model' => new Purchasingcredit));
                    break;
                case 'materialreceipt-sub-table':
                    $this->renderPartial('//purchasing/_purchasinginvoiceform');
                    break;
                case 'inventory-goodsissue-table':
                    $this->renderPartial('//inventory/_goodsissuedetails', array('model' => new InventoryGoodsIssue));
                    break;
                case 'inventory-goodsreceipt-table':
                    $this->renderPartial('//inventory/_goodsreceiptdetails', array('model' => new InventoryGoodsReceipt));
                    break;
                case 'bank-table':
                    $this->renderPartial('//master/_bankdetails', array('model' => new MasBank));
                    break;
                case 'bin-table':
                    $this->renderPartial('//master/_binform', array('model' => new MasInvBin));
                    break;
                case 'country-table':
                    $this->renderPartial('//master/_countrydetails', array('model' => new MasCountry));
                    break;
                case 'currency-table':
                    $this->renderPartial('//master/_currencydetails', array('model' => new MasCurrency));
                    break;
                case 'industry-table':
                    $this->renderPartial('//master/_industrydetails', array('model' => new MasIndustry));
                    break;
                case 'paymentterm-table':
                    $this->renderPartial('//master/_paymenttermdetails', array('model' => new MasPaymentTerm));
                    break;
                case 'pricinggroup-table':
                    $this->renderPartial('//master/_pricinggroupdetails', array('model' => new PricingGroup));
                    break;
                case 'probability-table':
                    $this->renderPartial('//master/_probabilitydetails', array('model' => new MasProbability));
                    break;
                case 'project-table':
                    $this->renderPartial('//master/_projectdetails', array('model' => new MasProject));
                    break;
                case 'quatationvalidity-table':
                    $this->renderPartial('//master/_quatationvaliditydetails', array('model' => new MasQuotationValidity));
                    break;
                case 'rack-table':
                    $this->renderPartial('//master/_rack_details', array('model' => new MasInvRack));
                    break;
                case 'salesgroup-table':
                    $this->renderPartial('//master/_salesgroupdetails', array('model' => new MasSalesGroup));
                    break;
                case 'shipping-table':
                    $this->renderPartial('//master/_shippingdetails', array('model' => new MasShipping));
                    break;
                case 'status-table':
                    $this->renderPartial('//master/_status_details', array('model' => new MasInvStatus));
                    break;
                case 'tax-table':
                    $this->renderPartial('//master/_tax_details', array('model' => new MasInvTax));
                    break;
                case 'unit-table':
                    $this->renderPartial('//master/_unit_details', array('model' => new Unit));
                    break;
                case 'user-table':
                    $this->renderPartial('//master/_userdetails', array('model' => new User));
                    break;
                case 'user-group-table':
                    $this->renderPartial('//master/_usergroupdetails', array('model' => new User));
                    break;
                case 'warehouse-table':
                    $this->renderPartial('//master/_warehouse_details', array('model' => new MasInvWarehouse));
                    break;
                case 'qtn-close-reason-table':
                    $this->renderPartial('//master/_qtn_close_details', array('model' => new MasQuotationCloseReason));
                    break;
                case 'inventory-transfer-table':
                    $this->renderPartial('//inventory/_transferhistory', array('model' => new InventoryTransfer));
                    break;
                case 'mmi_items-table':
                    $this->renderPartial('//inventory/_material_movement_issue_items', array('model' => new MaterialMovementIssue));
                    break;
                case 'sales-history-table':
                    $this->renderPartial('//inventory/_sales_hisoty', array('model' => new Store));
                    break;
                case 'purchase-history-table':
                    $this->renderPartial('//inventory/_purchasing_history', array('model' => new Store));
                    break;
                case 'contacts-history-table':
                    $this->renderPartial('//site/activities/_contact_history', array('model' => new Activity));
                    break;
                case 'mas_branch-bank-table':
                    $this->renderPartial('//master/_mas_banking');
                    break;
                case 'companybranches-table':
                    $this->renderPartial('//master/_set_company_branch_form');
                    break;
                case 'reports-company':
                    $this->renderPartial('//reports/_customer_rpt');
                    break;
                case 'reports-purchasingrequisition':
                    $this->renderPartial('//reports/_purchasingrequisition_rpt');
                    break;
                case 'reports-based-on-purchasingrequisition-table':
                    $this->renderPartial('//reports/_purchasingrequisition');
                    break;
                case 'reports-based-on-purchasingenquiry-table':
                    $this->renderPartial('//reports/_purchasingenquiry');
                    break;
                case 'reports-based-on-purchasingorder-table':
                    $this->renderPartial('//reports/_purchasingorder');
                    break;
                case 'reports-based-on-purchasingmaterialreceipt-table':
                    $this->renderPartial('//reports/_purchasingmaterialreceipt');
                    break;
                case 'reports-based-on-purchasinginvoice-table':
                    $this->renderPartial('//reports/_purchasinginvoice');
                    break;
                case 'reports-based-on-purchasingcredit-table':
                    $this->renderPartial('//reports/_purchasingcredits');
                    break;
                case 'deallocation-filewwise-table':
                    $this->renderPartial('//inventory/_deallocationfilewise', array('model' => new AllocatedMaterial));
                    break;
                case 'deallocation-productwise-table':
                    $this->renderPartial('//inventory/_deallocationproductwise', array('model' => new AllocatedMaterial));
                    break;
                case 'allocation-report-productwise-table':
                    $this->renderPartial('//reports/_allocationproductwise_report', array('model' => new AllocatedMaterial));
                    break;
                case 'allocation-report-filewwise-table':
                    $this->renderPartial('//reports/_allocationfilewise_report', array('model' => new AllocatedMaterial));
                    break;
                case 'inventory_items-table':
                    $this->renderPartial('//inventory/_inventory_items', array('model' => new Store));
                    break;
                case 'product-warehouse-relation-table':
                    $this->renderPartial('//inventory/_inventory_general_stock_form', array('model' => new ProductLocation));
                    break;
                case 'owner-bank-table':
                    $this->renderPartial('//master/_company_set_banking', array('model_owner' => new OwnerBankDetails));
                    break;
                case 'production-grid-container':
                    $this->renderPartial('//producation/production-bill-of-material');
                    break;
                case 'purchase-history-single-product-table':
                    $this->renderPartial('//inventory/_purchasing_history_form');
                    break;
                case 'sales-history-single-product-table':
                    $this->renderPartial('//inventory/_sales_history_form');
                    break;
                case 'invoice-drilldown-table':
                case 'invoice-drilldown-items-table':
                    $this->renderPartial('//dashboard/sop/_invoice_graph');
                    break;
                case 'inventory-by-class-drilldown-table':
                case 'inventory-by-class-drilldown-items-table':
                    $this->renderPartial('//dashboard/inventory/_inventory_by_class');
                    break;
                case 'requisitionitem-table':
                    $this->renderPartial('//pdf/purchasingrequisition_single-list');
                    break;
                case 'order-table-deallocation-filewwise':
                    $this->renderPartial('//inventory/_deallocationfilewise', array('model_order' => new Order, 'model' => new AllocatedMaterial));
                    break;
                case 'billofmaterial-table':
                    $this->renderPartial('//production/_billofmaterialdetails', array('model' => new ProductionBillofmaterial));
                    break;
                case 'productionorder-table':
                    $this->renderPartial('//production/_productionorderdetails', array('model' => new ProductionOrder));
                    break;
                case 'goodsissue-table':
                    $this->renderPartial('//production/_goodsissuedetails', array('model' => new ProductionGoodsIssue));
                    break;
                case 'goodsreceipt-table':
                    $this->renderPartial('//production/_goodsreceiptdetails', array('model' => new ProductionGoodsReceipt));
                    break;
                case 'inventory-product-class-table':
                    $this->renderPartial('//master/_productclassgrid');
                    break;
                case 'purchase-invoices-payment-table':
                    $this->renderPartial('//purchasing/_paymentof_invoice_form');
                    break;
                
                case 'rfq-grid':
                    $this->renderPartial('//pact/rfq/_rfq_grid',array('model'=>new FormRfqGeneral));
                    break;
                
                case 'prequotation-grid':
                    $this->renderPartial('//pact/prequote/_pre_quotation', array('model' => new PreQuotation));
                    break;
                default :
                    $this->renderPartial('index');
                    break;
            }
        } else {
            $this->render('index');
        }
        $userGroups = MasUserGroup::model()->findAll('id in (' . User::model()->findByPK(Yii::app()->user->id)->user_group_id . ')');
        $permissionArray = array();
        foreach ($userGroups as $eachUserGroup) {
            if (!empty($eachUserGroup->permissions))
                $permissionArray = CJSON::decode($eachUserGroup->permissions);
        }
        Yii::app()->user->havePermissionOn = array_merge($permissionArray);
    }

    /**
     * Displays the contact page
     */
    public function actionContact() {
        $model = new ContactForm;
        if (isset($_POST['ContactForm'])) {
            $model->attributes = $_POST['ContactForm'];
            if ($model->validate()) {
                $name = '=?UTF-8?B?' . base64_encode($model->name) . '?=';
                $subject = '=?UTF-8?B?' . base64_encode($model->subject) . '?=';
                $headers = "From: $name <{$model->email}>\r\n" .
                        "Reply-To: {$model->email}\r\n" .
                        "MIME-Version: 1.0\r\n" .
                        "Content-Type: text/plain; charset=UTF-8";

                mail(Yii::app()->params['adminEmail'], $subject, $model->body, $headers);
                Yii::app()->user->setFlash('contact', 'Thank you for contacting us. We will respond to you as soon as possible.');
                $this->refresh();
            }
        }
        $this->render('contact', array('model' => $model));
    }

    /* ########################################## Arun's section ############################################## */

    /**
     * save company details, receiving post data, retutning json data
     */
    public function actionSavecompany() {
        $type_ids = array();
        if (is_array($_POST['Company']['company_type'])) {
            $type_ids = array_filter($_POST['Company']['company_type']);
            $_POST['Company']['company_type'] = "ok";
        }
        else
            $_POST['Company']['company_type'] = "";
        $_POST['Company']['own_company_id'] = Yii::app()->user->master_user_company_id;
        $_POST['Company']['own_branch_id'] = Yii::app()->user->master_user_branch_id;
        if (!(((int) Yii::app()->user->havePermissionOn['masters_company_finance']))) {
            if ((int) $_POST['Company']['id'] > 0) {
                $company = Company::model()->findByPK((int) $_POST['Company']['id']);
                $_POST['Company']['genral_payment_term'] = $company->genral_payment_term;
                $_POST['Company']['credit_limit'] = $company->credit_limit;
            } else {
                $_POST['Company']['genral_payment_term'] = MasPaymentTerm::model()->find('isBasePaymentTerm="Y"')->id;
                $_POST['Company']['credit_limit'] = 0;
            }
        }
        $model = $this->commonSave('Company', true);
        if ((int) $_POST['Company']['id'] == 0) {
            $user = User::model()->findByPK(Yii::app()->user->id);
            $superiors = $user->getSuperios();
            $message = new YiiMailMessage();
            $message->view = "new_customer";
            //$message->addTo($model->file->leadowner->email);
            $branchhead = MasCompanyBranch::model()->findByPk(Yii::app()->user->master_user_branch_id)->branchhead;
            $message->addTo($branchhead->email);
            if (is_array($superiors))
                foreach ($superiors as $eachOne) {
                    $message->addCc($eachOne->email);
                }
            //$message->addTo("arun.kumar@mailbluesky.com");
            $message->from = 'noreply@cumuluscrm.us';
            $subject = "A new customer's details added by " . $user->fullname;
            $message->setSubject($subject);
            $message->setBody(array('model' => $model), 'text/html');
            Yii::app()->mail->send($message);
        }
        if ((int) Yii::app()->user->havePermissionOn['masters_company_finance']) {
            CompanyPricingGroup::model()->deleteAll('company_id=' . $model->id);
            if (isset($_POST['pricinggroup']) && is_array($_POST['pricinggroup'])) {
                foreach ($_POST['pricinggroup'] as $brand_id => $pricing_group_id) {
                    $pricingGroup = new CompanyPricingGroup;
                    $pricingGroup->company_id = $model->id;
                    $pricingGroup->brand_id = $brand_id;
                    $pricingGroup->pricing_group_id = $pricing_group_id;
                    $pricingGroup->save(false);
                }
            }
        }
        $jsonData['model'] = $model;
        CompanyTypeRelation::model()->deleteAll('company_id=' . $model->id);
        foreach ($type_ids as $type_id) {
            $_POST['CompanyTypeRelation']['company_id'] = $model->id;
            $_POST['CompanyTypeRelation']['type_id'] = $type_id;
            $this->commonSave('CompanyTypeRelation', true);
        }
        if (CompanyContact::model()->count(array('condition' => 'company_id=' . $model->id)) == 0) { //creatinf a default account for this company
            $modelContact = new CompanyContact;
            $modelContact->person_name = 'Sales / Account';
            $modelContact->company_id = $model->id;
            $modelContact->crm_user_id = Yii::app()->user->id;
            $modelContact->save(false);
        }

        $jsonData['status'] = 'success';
        echo CJSON::encode($jsonData);
    }

    /**
     *  get company details, param id of company, retuning json
     */
    public function actionGetCompany() {
//echo CJSON::encode(Company::model()->findByPk((int) $_POST['id']));
        $jsonData['Company'] = Company::model()->findByPk((int) $_POST['id']);
        $jsonData['industry'] = MasIndustry::model()->findByPk($jsonData['Company']->genral_industry);
        $jsonData['paymentterm'] = MasPaymentTerm::model()->findByPk($jsonData['Company']->genral_payment_term);
        $jsonData['paymenttermdetails'] = $jsonData['paymentterm']->payment_code . ':' . $jsonData['paymentterm']->payment_terms;
        $jsonData['billing_country'] = MasCountry::model()->findByPk($jsonData['Company']->billing_country);
        $jsonData['shipping_country'] = MasCountry::model()->findByPk($jsonData['Company']->shipping_country);
        $jsonData['pricnggroup'] = PricingGroup::model()->findByPk($jsonData['Company']->pricing_group);
        $jsonData['pricinggroupdetails'] = $jsonData['pricnggroup']->pricing_group /* . ':' . $jsonData['pricnggroup']->percentage . '%' . ($jsonData['pricnggroup']->addition_deduction == 'A' ? 'Addition' : 'Deduction') */;
        $jsonData['companytype'] = CompanyTypeRelation::model()->findAll('company_id=:company_id', array(':company_id' => $jsonData['Company']->id));

        echo CJSON::encode($jsonData);
    }

    public function actionAutoCompleteCompanies() {
        $this->autocompleteData('Company', array('company_name', 'id'), $_GET['term']);
    }

    /**
     * set selecetd company
     */
    public function actionSetCompany() {
        Yii::app()->session['company_id'] = (int) $_POST['id'];
        $jsonData['company'] = Company::model()->findByPk(Yii::app()->session['company_id']);
        $jsonData['paymentterm'] = MasPaymentTerm::model()->findByPk($jsonData['company']->genral_payment_term);
        $jsonData['paymenttermdetails'] = $jsonData['paymentterm']->payment_code . ':' . $jsonData['paymentterm']->payment_terms;
        $jsonData['status'] = 'success';
        echo CJSON::encode($jsonData);
        Yii::app()->end();
    }

    /**
     * save contact details
     */
    public function actionSavecontact() {
        $this->commonSave('CompanyContact');
    }

    /**
     * load contact details, param id,returning json
     */
    public function actionGetContact() {
        $model = CompanyContact::model()->findByPk((int) $_POST['id']);
        if ($model != null) {
//$model->company_name = $model->company->company_name;
            Yii::app()->session['contact_id'] = $model->id;
            echo CJSON::encode($model->attributes + array('company_name' => $model->company->company_name));
        }
    }

    /**
     * set selected contact
     */
    public function actionSetContact() {
        Yii::app()->session['contact_id'] = (int) $_POST['id'];
        Yii::app()->end();
    }

    /**
     *  save activity, calls & tasks
     */
    public function actionSaveActivity() {
        //  print_r($_POST['Activity']);die();
        $model = new Activity;
        if (isset($_POST['Activity'])) {
            //print_r($_POST['Activity']);
            //die("xxxxx");
            $model->attributes = $_POST['Activity'];
            $_POST['Activity']['crm_user_id'] = Yii::app()->user->id;
            $_POST['Activity']['typ_of_activity'] = $_GET['type'];
            $_POST['Activity']['id'] = (int) $_POST['Activity']['id'];
            $_POST['Activity']['isComplete'] = $_POST['Activity']['isComplete'] != "Y" ? "N" : "Y";
            //if (empty($_POST['Activity']['contact_id'])) 
            // $_POST['Activity']['contact_id'] = Yii::app()->user->id;

            $jsonData['Activity'] = $this->commonSave('Activity', true);
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
            Yii::app()->end();
        }
    }

    /**
     * save meeting
     */
    public function actionSaveMeeting() {
        $model = new Activity;
        $model1 = new Meeting;
        if (isset($_POST['Activity']) && isset($_POST['Meeting'])) {
            $_POST['Activity']['crm_user_id'] = Yii::app()->user->id;
            $_POST['Activity']['typ_of_activity'] = 'M';
            $_POST['Activity']['id'] = (int) $_POST['Activity']['id'];
            $_POST['Activity']['isComplete'] = $_POST['Activity']['isComplete'] != "Y" ? "N" : "Y";
            $_POST['Activity']['date_to_do'] = $_POST['Meeting']['start_date'];
            $model->attributes = $_POST['Activity'];
            $model1->attributes = $_POST['Meeting'];
            if (is_array($model1->participants))
                $model1->participants = $_POST['Meeting']['participants'] = implode(',', $model1->participants);
            if (is_array($model1->internal_participants))
                $model1->internal_participants = $_POST['Meeting']['internal_participants'] = implode(',', $model1->internal_participants);

            //coding for email validation
            $valid = true;
            $other_errors = array();
            $regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/';
            if ($_POST["Meeting"]["send_invite"] == "Y") {
                if (!empty($model->contact_id)) {
                    $contact_person = CompanyContact::model()->findByPk($model->contact_id);
                    $contact_person_mail = $contact_person['email1'];
                    if (!empty($contact_person_mail) && preg_match($regex, $contact_person_mail))
                        $valid = $valid && true;
                    else {
                        $other_errors[] = "Contact Person Mail Id is Invalid";
                        $valid = $valid && false;
                    }
                }
                if (isset($_POST['Meeting']['participants'])) {
                    $participants = CompanyContact::model()->findAll('id in (' . $model1->participants . ')');
                    foreach ($participants as $participant) {
                        if (!empty($participant->email1) && preg_match($regex, $participant->email1))
                            $valid = $valid && true;
                        else {
                            $other_errors[] = "Participants Mail Id is Invalid";
                            $valid = $valid && false;
                            break;
                        }
                    }
                }

                if (isset($_POST['Meeting']['internal_participants'])) {
                    $internal_participants = User::model()->findAll('id in (' . $model1->internal_participants . ')');
                    foreach ($internal_participants as $internalparticipant) {
                        if (!empty($internalparticipant->email) && preg_match($regex, $internalparticipant->email))
                            $valid = $valid && true;
                        else {
                            $other_errors[] = "Internal Participants Mail Id is Invalid";
                            $valid = $valid && false;
                            break;
                        }
                    }
                }

                if ($_POST['Meeting']['additional_participants'] != null) {
                    $additional_participants_mail = explode(',', $_POST['Meeting']['additional_participants']);
                    foreach ($additional_participants_mail as $additionalparticipant) {
                        if (!empty($additionalparticipant) && preg_match($regex, $additionalparticipant))
                            $valid = $valid && true;
                        else {
                            $other_errors[] = "Additional Participants Mail Id is Invalid";
                            $valid = $valid && false;
                            break;
                        }
                    }
                }
            }
            if ($model->validate() && $model1->validate() && $valid) {
                $model = $this->commonSave('Activity', true);
                if ($model1->findByPK($model->id) != null) {
                    $model1->updateByPk($model->id, $_POST['Meeting']);
                } else {
                    $model1->activity_id = $model->id;
                    $model1->save();
                }
                $model->refresh();
                $model1->refresh();
                $jsonData['Activity'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //mail parts wriien by toby
                if ($_POST["Meeting"]["send_invite"] == "Y") {
                    $to = "";
                    if (!empty($model->contact_id)) {
                        $contact_person = CompanyContact::model()->findByPk($model->contact_id);
                        $contact_person_mail = $contact_person['email1'];
                    }
                    if (isset($_POST['Meeting']['participants'])) {
                        $participants = CompanyContact::model()->findAll('id in (' . $model1->participants . ')');
                        foreach ($participants as $participant) {
                            $mail[] = $participant->email1;
                        }
                        $participantsmail = implode(',', $mail);
                    }

                    if (isset($_POST['Meeting']['internal_participants'])) {
                        $internal_participants = User::model()->findAll('id in (' . $model1->internal_participants . ')');
                        foreach ($internal_participants as $internalparticipant) {
                            $int_part_mail[] = $internalparticipant->email;
                        }
                        $internalparticipantsmail = implode(',', $int_part_mail);
                    }

                    if (isset($_POST['Meeting']['additional_participants'])) {
                        if ($_POST['Meeting']['additional_participants'] != null) {
                            $additional_participants_mail = $_POST['Meeting']['additional_participants'];
                        }
                    }
                    $to = $contact_person_mail . ',' . $participantsmail . ',' . $internalparticipantsmail . ',' . $additional_participants_mail;
                    $message = new YiiMailMessage;
                    $message->view = 'meeting_invitation';
                    $message->setBody(array('model' => $model), 'text/html');
                    $message->subject = 'Meeting Invitation';
                    $message->from = "noreply@cumuluscrm.us";
                    //$message->addTo("arun.kumar@mailbluesky.com");
                    //$message->addTo("arun@mailbluesky.com");
                    $to_emails = explode(',', $to);
                    foreach ($to_emails as $eachOne) {
                        if ($eachOne != null)
                            $message->addTo($eachOne);
                    }
                    //Yii::app()->mail->send($message);
                }

                Yii::app()->end();
            } else {
                $error1 = CJSON::decode(CActiveForm::validate(array($model, $model1), '', false));
                $error = CJSON::encode(array_merge_recursive($error1, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    /**
     * calender
     */
    public function actionCalenderBig() {
        $this->renderPartial('//site/_calendar', array(), false, true);
    }

    public function actionCalender() {
        $userModel = User::model()->findByPK(Yii::app()->user->id);
        $group_id_of_logind_user = $userModel->user_group_id;
        $subgroups = MasUserGroup::subGroups($group_id_of_logind_user);
        $criteria = new CDbCriteria;
        if ((int) Yii::app()->user->havePermissionOn['core_view_add_edit_calendar'])
            $criteria->addCondition('crm_user_id=' . Yii::app()->user->id); //isComplete="N" AND 
        if ((int) Yii::app()->user->havePermissionOn['core_view_calender_down_level'] && is_array($subgroups) && count($subgroups) > 0)
            $criteria->addCondition('user.user_group_id in (' . implode(',', $subgroups) . ')', 'OR'); //isComplete="N" AND 
        $activities = Activity::model()->with('user')->findAll($criteria);
        $jasonevents = $jasonevents1 = $jasonevents2 = $jasonevents3 = array();
        foreach ($activities as $i => $eachActivity) {
            if (count($eachActivity->meeting) > 0)
                $jasonevents[$i]['end'] = $eachActivity->meeting->end_date;
            switch ($eachActivity->typ_of_activity) {
                case "C":
                    $type = "Call";
                    $jasonevents[$i]['backgroundColor'] = '#ffbd6a';
                    break;
                case "T":
                    $type = "Task";
                    $jasonevents[$i]['backgroundColor'] = '#5c9ef9';
                    break;
                case "M":
                    $type = "Meeting";
                    $jasonevents[$i]['backgroundColor'] = '#98e857';
                    $jasonevents[$i]['date'] = $jasonevents[$i]['start'] = date('Y-m-d', strtotime($eachActivity->meeting->start_date));
                    $jasonevents[$i]['end'] = date('Y-m-d', strtotime($eachActivity->meeting->end_date));
                    break;
                case "V":
                    $type = "Visit";
                    $jasonevents[$i]['backgroundColor'] = '#BFAAFF';
                    break;
            }
            $jasonevents[$i]['type'] = $type;
            $jasonevents[$i]['url'] = "#";
            if ($eachActivity->typ_of_activity != "M") {
                $jasonevents[$i]['date'] = $jasonevents[$i]['start'] = date('Y-m-d', strtotime($eachActivity->date_to_do));
            } else {
                $eachActivity->date_to_do = $jasonevents[$i]['start'] . " To " . $jasonevents[$i]['end'];
            }
            if (empty($eachActivity->contact_id)) {
                $person = $eachActivity->user->fullname;
                $company = $eachActivity->user->own_company->company_name;
            } else {
                $person = $eachActivity->contact->fullname;
                $company = $eachActivity->contact->company->company_name;
            }
            $jasonevents[$i]['id'] = $eachActivity->id;
            $jasonevents[$i]['title'] = $type; //$type . " - " . $eachActivity->company->company_name;
            $jasonevents[$i]['description'] = "Added by - " . $eachActivity->user->fullname . '<br> 
                    Activity : ' . $type . " <br/> 
                    Person : " . $person . " <br/> 
                    Company : " . $company . '<br/>
                    Date/Time : ' . $eachActivity->date_to_do . '<br/>
                    Notes : ' . $eachActivity->notes;
            $jasonevents[$i]['allDay'] = false;
        }

        $criteria2 = new CDbCriteria;
        $criteria2->addCondition('own_company_id =' . Yii::app()->user->master_user_company_id . ' AND own_branch_id=' . Yii::app()->user->master_user_branch_id, 'AND');
        if ((int) Yii::app()->user->havePermissionOn['core_view_calender_down_level'])
            $criteria2->addCondition(' t.lead_owner_id=' . Yii::app()->user->id . ' OR t.lead_owner_id in (' . implode(',', $userModel->subordinates) . ')', 'AND');
        else
            $criteria2->addCondition(' t.lead_owner_id=' . Yii::app()->user->id, 'AND');
        $files = MasterFile::model()->findAll($criteria2); // need to put condition here
        foreach ($files as $i => $eachFile) {
            if ((int) Yii::app()->user->havePermissionOn['show_leads'] && $eachFile->current_process_status == "L" && $eachFile->lead->status != "L" && $eachFile->lead->status != "C" && (int) Yii::app()->user->havePermissionOn['sop_lead_view']) {
                $jasonevents1['type'] = "SLE";
                $jasonevents1['backgroundColor'] = '#47D1FF'; //'#ff6164';
                $jasonevents1['url'] = "javascript:;";
                $jasonevents1['date'] = $jasonevents1['start'] = date('Y-m-d', strtotime($eachFile->lead->closing_date));
                $jasonevents1['id'] = $eachFile->lead->id;
                $jasonevents1['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents1['description'] = "Lead:" . $eachFile->file_title . '<br/> Lead owner:' . $eachFile->leadowner->fullname . '<br/>Customer:' . $eachFile->company->company_name;
                $jasonevents1['allDay'] = false;
                $jasonevents1['draggable'] = false;
                $jasonevents[] = $jasonevents1;
            }

            if ((int) Yii::app()->user->havePermissionOn['show_quotes'] && $eachFile->current_process_status == "Q" && (int) Yii::app()->user->havePermissionOn['sop_quote_view']) {
                $jasonevents2['type'] = "SQE";
                $jasonevents2['backgroundColor'] = '#3399ff'; //#6ad3ff';
                $jasonevents2['url'] = "javascript:;";
                $jasonevents2['date'] = $jasonevents2['start'] = date('Y-m-d', strtotime($eachFile->quote->qtn_validity));
                $jasonevents2['id'] = $eachFile->quote->id;
                $jasonevents2['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents2['description'] = "Quotation:" . $eachFile->file_title . '<br/>Customer:' . $eachFile->company->company_name;
                $jasonevents2['allDay'] = false;
                $jasonevents[] = $jasonevents2;

                /* $jasonevents2['type'] = "SQE";
                  $jasonevents2['backgroundColor'] = '#cc33ff'; //'#6ad3ff';
                  $jasonevents2['url'] = "#";
                  $jasonevents2['date'] = $jasonevents2['start'] = date('Y-m-d', strtotime($eachFile->quote->expected_order_date));
                  $jasonevents2['id'] = $eachFile->quote->id;
                  $jasonevents2['title'] = $eachFile->quote->id; //$type . " - " . $eachActivity->company->company_name;
                  $jasonevents2['description'] = "Quotation:" . $eachFile->file_title.'<br/>Customer:'.$eachFile->company->company_name;
                  $jasonevents2['allDay'] = false;
                  $jasonevents[] = $jasonevents2; */
            }

            if ((int) Yii::app()->user->havePermissionOn['show_orders'] && $eachFile->current_process_status == "O" && (int) Yii::app()->user->havePermissionOn['sop_order_view']) {
                $jasonevents3['type'] = "SOD";
                $jasonevents3['backgroundColor'] = '#1919e8'; //'#fced89';
                $jasonevents3['url'] = "#";
                $jasonevents3['date'] = $jasonevents3['start'] = date('Y-m-d', strtotime($eachFile->order->delivery_date));
                $jasonevents3['id'] = $eachFile->order->id;
                $jasonevents3['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents3['description'] = "Order:" . $eachFile->file_title . '<br/>Customer:' . $eachFile->company->company_name;
                $jasonevents3['allDay'] = false;
                $jasonevents[] = $jasonevents3;
            }
            if ((int) Yii::app()->user->havePermissionOn['show_invoices'] && $eachFile->current_process_status == "I" && (int) Yii::app()->user->havePermissionOn['sop_invoice_view'])
                foreach ($eachFile->invoices as $eachInvoice) {
                    $jasonevents3['type'] = "SIP";
                    $jasonevents3['backgroundColor'] = '#ff0000'; //'#f4a1d2';
                    $jasonevents3['url'] = "#";
                    $jasonevents3['date'] = $jasonevents3['start'] = date('Y-m-d', strtotime($eachInvoice->invoice_date . ' + ' . $eachInvoice->paymentTerm->no_of_days . ' days'));
                    $jasonevents3['id'] = $eachInvoice->id;
                    $jasonevents3['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                    $jasonevents3['description'] = "Invoice:" . $eachFile->file_title . '<br/>Customer:' . $eachFile->company->company_name;
                    $jasonevents3['allDay'] = false;
                    $jasonevents[] = $jasonevents3;
                }
            /* }
              foreach ($files as $i => $eachFile) { */
            if ((int) Yii::app()->user->havePermissionOn['show_purchase_requisition'] && $eachFile->current_process_status == "P_R" && (int) Yii::app()->user->havePermissionOn['purchase_requistion_view']) {
                $jasonevents4['type'] = "PRE";
                $jasonevents4['backgroundColor'] = '#A3FFA3'; //'#ce8e34';
                $jasonevents4['url'] = "#";
                $jasonevents4['date'] = $jasonevents1['start'] = date('Y-m-d', strtotime($eachFile->purchaserequisition->required_date));
                $jasonevents4['id'] = $eachFile->purchaserequisition->id;
                $jasonevents4['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents4['description'] = "Purchase Requisition:" . $eachFile->file_title . '<br/>Customer:' . $eachFile->company->company_name;
                $jasonevents4['allDay'] = false;
                $jasonevents[] = $jasonevents4;
            }
            if ((int) Yii::app()->user->havePermissionOn['show_purchase_enquiry'] && $eachFile->current_process_status == "P_E" && (int) Yii::app()->user->havePermissionOn['purchase_enquiry_view']) {
                $jasonevents5['type'] = "PEE";
                $jasonevents5['backgroundColor'] = '#5CE65C'; //'#f5ff57';
                $jasonevents5['url'] = "#";
                $jasonevents5['date'] = $jasonevents1['start'] = date('Y-m-d', strtotime($eachFile->purchaseenquiry->delivery_date));
                $jasonevents5['id'] = $eachFile->purchaseenquiry->id;
                $jasonevents5['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents5['description'] = "Purchase Enquiry:" . $eachFile->file_title . '<br/>Customer:' . $eachFile->company->company_name;
                $jasonevents5['allDay'] = false;
                $jasonevents[] = $jasonevents5;
            }
            if ((int) Yii::app()->user->havePermissionOn['show_purchase_orders'] && $eachFile->current_process_status == "P_O" && (int) Yii::app()->user->havePermissionOn['purchase_order_view']) {
                $jasonevents6['type'] = "POD";
                $jasonevents6['backgroundColor'] = '#00FF00'; //'#9de9e6';
                $jasonevents6['url'] = "#";
                $jasonevents6['date'] = $jasonevents1['start'] = date('Y-m-d', strtotime($eachFile->purchaseorder->required_date));
                $jasonevents6['id'] = $eachFile->purchaseorder->id;
                (int) Yii::app()->user->havePermissionOn['show_leads'] && $jasonevents6['title'] = $eachFile->id; //$type . " - " . $eachActivity->company->company_name;
                $jasonevents6['description'] = "Purchase Order:" . $eachFile->purchaseorder->projectname->project_title;
                $jasonevents6['allDay'] = false;
                $jasonevents[] = $jasonevents6;
            }
            //purchase invoice+no of days paymenmts terms '#711414'
            //'#003366' product date
        }
        echo CJSON::encode($jasonevents);
        Yii::app()->end();
    }

    public function actionCalenderUpdate() {
        if (isset($_POST['event_id']) && isset($_POST['dayDelta']) && isset($_POST['minuteDelta'])) {
            $activityModel = Activity::model()->findByPK((int) $_POST['event_id']);
            if ($activityModel != null) {
                $dateInStrtime = strtotime($activityModel->date_to_do);
                $afterDaysAdded = strtotime("+" . (int) $_POST['dayDelta'] . " day", $dateInStrtime);
                $afterMinutesAdded = strtotime("+" . (int) $_POST['minuteDelta'] . " minutes", $afterDaysAdded);
                $activityModel->date_to_do = date('Y-m-d h:i:s', $afterMinutesAdded);
                $activityModel->save();
                if ($activityModel->typ_of_activity == 'M') {
                    $modelMeeting = Meeting::model()->findByPK($activityModel->id);
                    $modelMeeting->end_date = date('Y-m-d h:m:s', strtotime($activityModel->date_to_do) + (strtotime($modelMeeting->end_date) - strtotime($modelMeeting->start_date)));
                    $modelMeeting->start_date = $activityModel->date_to_do;
                    $modelMeeting->save();
                }
            }
        }
    }

    /**
     * save lead
     */
    public function actionSaveLead() {
        $model = new Lead;
        if (isset($_POST['Lead'])) {
            //lead created person
            $model->crm_user_id = Yii::app()->user->id;
            $model->form_id = 1;
            if ((int) @$_POST['Lead']['id'] > 0) {
                $model->id = (int) $_POST['Lead']['id'];
                $model->scenario = 'update';
                $model = $model->findByPK($model->id);
            } else {
                unset($_POST['Lead']['id']);
                $model->scenario = 'add';
            }
            $model->attributes = $_POST['Lead'];
            if ($model->validate()) {
                $model->save();
                $model->refresh();
                $model->file_id = $this->masterFile($model->file_id, "L", 1, $model->title, $model->company_id, $model->lead_owner_id);
                $model->updateByPK($model->id, array('file_id' => $model->file_id));
                $this->documents($model->file_id, "L");
                Yii::app()->session['company_id'] = $model->company_id;
                $jsonData['file'] = $model->file;
                $jsonData['lead'] = $model;
                $jsonData['status'] = 'success';
                //((int) $_POST['Lead']['id'] == 0) ? $this->actionNotification($model, "Lead", false, "New Lead:" . $model->file_id . '/' . $model->id) : '';
                echo CJSON::encode($jsonData);
            } else {
                $error = CActiveForm::validate($model, '', false);
                if ($error != '[]')
                    echo $error;
            }
        }
        Yii::app()->end();
    }

    /**
     * get lead details
     */
    public function actionGetLead() {
        $jsonData['lead'] = Lead::model()->findByPk((int) $_POST['id']);
        $jsonData['file'] = $jsonData['lead']->file;
        $jsonData['company'] = $jsonData['lead']->company;
        $jsonData['paymenttermdetails'] = $jsonData['company']->paymentTerm->payment_code . ':' . $jsonData['company']->paymentTerm->payment_terms;
        $jsonData['contact'] = CompanyContact::model()->findByPK($jsonData['lead']->contact_id);
        $jsonData['user'] = User::model()->findByPK($jsonData['file']->lead_owner_id);
        $jsonData['username'] = $jsonData['user']->first_name . ' ' . $jsonData['user']->last_name;
        $documents = $jsonData['file']->documents;
        foreach ($documents as $eachDocument) {
            $temp[] = $eachDocument->document_name;
        }
        if (isset($temp) && is_array($temp))
            $jsonData['documents'] = implode(',', $temp);
        Yii::app()->session['file_id'] = $jsonData['lead']->file_id;
        $data = CHtml::listData($jsonData['company']->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        //Yii::app()->session['company_id'] = $jsonData['lead']->file->company_id;
        echo CJSON::encode($jsonData);
    }

    public function actionSaveQuotation($modelName = "Quotes", $from = "Q") {
        /* if (isset($_POST["Quotes"])) {
          $this->saveSopPurchase("Quotes", "Q");
          } */
        if (isset($_POST["Quotes"])) {
            $model = new $modelName;
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);

            // extra additions and deductions only in these section thts y
            $attributes_additions = @$_POST[$modelName . 'Addition'];
            $attributes_deductions = @$_POST[$modelName . 'Deduction'];

            $model->scenario = 'add';
            if ((int) @$attributes_main['id'] > 0)
                $model->scenario = 'update';

            $model->attributes = $attributes_main;
            $model->form_id = 3;
            $model->crm_user_id = Yii::app()->user->id;
            $itemModel = $modelName . 'Item';

            $other_errors = array();
            $total_quatity_picked = 0;
            $valid1 = true;
            $valid = true;

            //validating line item
            foreach ($attributes_items as $i => $item) {
                if (!empty($item['product_id'])) {
                    $modelItem[$i] = new $itemModel;
                    $modelItem[$i]->attributes = $attributes_items[$i];
                    $valid = $modelItem[$i]->validate() && $valid;
                    $thisProduct = Store::model()->findByPk($attributes_items[$i]['product_id']);
                }
            }


            $valid = $valid && is_array($modelItem) && $valid1;

            // extra additions and deductions only in these section thts y
            $itemAdditionModel = $modelName . 'Addition';
            $itemDeductionModel = $modelName . 'Deduction';

            //validating additions
            if (is_array($attributes_additions))
                foreach ($attributes_additions as $i => $item) {
                    $modelAdditionItem[$i] = new $itemAdditionModel;
                    $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
                    $valid = $modelAdditionItem[$i]->validate() && $valid;
                }

            //validationg deductions 
            if (is_array($attributes_deductions))
                foreach ($attributes_deductions as $i => $item) {
                    $modelDeductionItem[$i] = new $itemDeductionModel;
                    $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
                    $valid = $modelDeductionItem[$i]->validate() && $valid;
                }

            if ($model->validate() && $valid) { // after validation saving the whole data 
                $company_id = 0;
                if ((int) $model->file_id > 0) {
                    if ($model->hasAttribute('company_id') && (int) $model->company_id > 0)
                        $company_id = $model->company_id;
                    else if ($model->hasAttribute('vendor_id') && (int) $model->vendor_id > 0)
                        $company_id = $model->vendor_id;
                    else
                        $company_id = $model->file->company_id;
                }
                else if ($model->hasAttribute('company_id'))
                    $company_id = $model->company_id;
                else if ($model->hasAttribute('vendor_id'))
                    $company_id = $model->vendor_id;
                $model->file_id = $this->masterFile($model->file_id, $from,3, $model->title, $company_id, isset($model->lead_owner_id) ? (int) $model->lead_owner_id : 0);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
                $this->documents($model->file_id, $from);
                $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                $notification = false;
                $isEdit = true;
                if ((int) $model->id == 0) {// if id 0 means its a new record, otherwise needs to update the existing one
                    $notification = ($model->file->is_approved == "N");
                    $model->save();
                    $isEdit = false;
                } else {
                    $model->updateByPK($model->id, $model->attributes);
                    // extra additions and deductions only in these section and before updating needs to remove all other refernces
                    $itemModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemAdditionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemDeductionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $model->file_id));
                }

                $model->refresh();
                $grand_total = $picked_qty = $actual_qty = $invoiced_qty = 0;
                $jsonData['shoratage'] = "";

                //saving line item
                foreach ($modelItem as $eachItem) {

                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->net_amount;

                    if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                        $model->updateByPk($model->id, array('materials_allocated' => 'Y'));
                        $storeModel = Store::model()->findByPK($eachItem->product_id);
                        if ($storeModel->non_stock_item == "N") {
                            $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachItem->quantity;
                            if ($shoratge <= 0) {
                                $jsonData['shoratage'] .= "Item " . $eachItem->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                            }
                            else
                                $shoratge = 0;
                            $modelAllocatedMaterial = new AllocatedMaterial;
                            if (($t = AllocatedMaterial::model()->find('file_id=' . $model->file_id . ' AND product_id=' . $eachItem->product_id)) != null) {
                                $modelAllocatedMaterial = $t;
                            }
                            $modelAllocatedMaterial->product_id = $eachItem->product_id;
                            $modelAllocatedMaterial->file_id = $model->file_id;
                            $modelAllocatedMaterial->count = ($eachItem->quantity + $shoratge);
                            $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                            //$modelAllocatedMaterial->allocation_end_date = $modelName == "Order" ? $model->delivery_date : $model->qtn_validity;
                            $modelCustom = CustomChanges::model()->find();
                            $custom_changes = CJSON::decode($modelCustom->changes);
                            if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                if ($model->qtn_validity > $end_date)
                                    $modelAllocatedMaterial->allocation_end_date = $end_date;
                                else
                                    $modelAllocatedMaterial->allocation_end_date = $model->qtn_validity;
                                $modelAllocatedMaterial->save(false);
                            }
                            else
                                $modelAllocatedMaterial->allocation_end_date = $model->qtn_validity;
                            $modelAllocatedMaterial->allocated_from = "Q";
                            $modelAllocatedMaterial->save(false);
                        }
                    }
                }

                //saving additions
                if (is_array($modelAdditionItem))
                    foreach ($modelAdditionItem as $eachItem) {
                        $eachItem->{$refer_id} = $model->id;
                        $eachItem->save(false);
                        $grand_total += $eachItem->calculated_value;
                    }

                //saving deductions
                if (is_array($modelDeductionItem))
                    foreach ($modelDeductionItem as $eachItem) {
                        $eachItem->{$refer_id} = $model->id;
                        $eachItem->save(false);
                        $grand_total -= $eachItem->calculated_value;
                    }
                //updating grand total
                $model->updateByPk($model->id, array('grand_total' => $grand_total));

                $this->fileApproval($model->file, $isEdit, "Q");
                //approving quotation
                //$this->masterFile($model->file_id, $model->file->current_process_status, $model->file->file_title, $model->file->company_id, $model->file->lead_owner_id, "Y");

                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';

                //Findig pending files
                $files = MasterFile::model()->findAll(array('condition' => 'company_id=' . $company_id . ' AND(current_process_status="D" OR current_process_status="PD" OR current_process_status="I" OR current_process_status="PI") '));
                $amount_pending = 0;
                foreach ($files as $eachFile) {
                    $amount_pending += $eachFile->order->grand_total;
                    foreach ($eachFile->invoices as $eachInvoice)
                        $amount_pending += ($eachInvoice->grand_total - $eachInvoice->receivedAmount);
                }
                if ($amount_pending > $eachFile->company->credit_limit) {
                    $jsonData['creditlimit'] .= "A pending of " . $amount_pending . " need to collect from " . $eachFile->company->company_name;
                    //send a mail to branch head here
                }


                //Setting company in session
                Yii::app()->session['company_id'] = $model->company_id;

                //sending notification
                if ($notification) {
                    $model->refresh();
                    $this->actionNotification($model, "Quotes");
                }
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (is_array($modelItem))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);
                $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    /**
     * get quotation details
     */
    public function getOrderOrQuotation($modelName, $convertToOrder = false) {
        if ($modelName == "Quotes") {
            $quotesororder = "quotes";
            $jsonData['model'] = Quotes::model()->with('items')->findByPK((int) $_POST['id'], array('order' => 'items.id'));
        } else {
            $jsonData['model'] = Order::model()->with('items')->findByPK((int) $_POST['id'], array('order' => 'items.id'));
            $quotesororder = "order";
        }
        if ($convertToOrder)
            $quotesororder = "order";
        Yii::app()->session['file_id'] = $jsonData['model']->file_id;
        //Yii::app()->session['company_id'] = $jsonData['model']->file->company_id;
        $jsonData['file'] = $jsonData['model']->file;
        $jsonData['user'] = User::model()->findByPK($jsonData['file']->lead_owner_id);
        $jsonData['username'] = $jsonData['user']->first_name . ' ' . $jsonData['user']->last_name;
        $jsonData['salesgroup'] = MasSalesGroup::model()->findByPK($jsonData['model']->sales_group);
        $jsonData['shippingby'] = MasShipping::model()->findByPK($jsonData['model']->shipping_by);
        $jsonData['paymenttermdetails'] = MasPaymentTerm::model()->findByPK($jsonData['model']->payment_terms);
        $jsonData['payemntterm'] = $jsonData['paymenttermdetails']->payment_code . ':' . $jsonData['paymenttermdetails']->payment_terms;
        if (!empty($jsonData['model']->probability))
            $jsonData['probablity'] = MasProbability::model()->findByPK($jsonData['model']->probability);
        $jsonData['currency'] = MasCurrency::model()->findByPK($jsonData['model']->currency);
        $items = $jsonData['model']->items;
        $modelAdItems = $jsonData['model']->adItems;
        $modelDedItems = $jsonData['model']->dedItems;
        $contacts = $jsonData['model']->company->companyContacts;
        $jsonData['contacts'] = '';
        $data = CHtml::listData($contacts, 'id', 'fullname');
        foreach ($data as $value => $name)
            $jsonData['contacts'] .= CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['model_items'] = array();
        $jsonData['total'] = 0;
        foreach ($items as $i => $model) {

            if ($convertToOrder) {
                $temp = new OrderItem;
                $temp->attributes = $model->attributes;
                $model = $temp;
            }
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
            $jsonData['model_items'][] = '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array(
                        'class' => 'tooltipster description product-search',
                        'value' => $model->product->part_number,
                        'title' => 'Select product'
                    )) .
                    CHtml::error($model, "[$i]product_id") .
                    CHtml::activeHiddenField($model, "[$i]product_id") .
                    CHtml::link('<i class="icon-info-sign"><div class="triangle-right left quotation-helper"></div></i>', 'javascript:;', array('class' => 'quotation-helper-trigger', 'title' => 'Quotation Helper'))
                    . CHtml::link('<i class="icon-shopping-cart"><div class="triangle-right left stock-helper"></div></i>', 'javascript:;', array('class' => 'stock-helper-trigger', 'title' => 'Stock Helper')) . '
                    </td>
            <td>' . CHtml::activeTextArea($model, "[$i]description", array('class' => 'description description-textarea',
                        'style' => 'height:20px;width:90%;max-width:90%;',
                        'title' => 'Add Description here',
                        'onfocus' => 'this.style.height = "100px";this.style.width = "200px";', 'onblur' => 'this.style.height = "20px";this.style.width = "90%";'
                    )) .
                    CHtml::error($model, "[$i]description") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                        'class' => 'cell-center',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));'
                    )) .
                    CHtml::error($model, "[$i]quantity") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) .
                    CHtml::error($model, "[$i]unit") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]rate", array('class' => 'amount-field  cell-right to_be_calculated',
                        'onkeypress' => 'return isNumberKey(event)',
                        'readonly' => (($model->rate) > 0),
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]rate") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]amount", array('class' => 'amount-field cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'readonly' => true)) .
                    CHtml::error($model, "[$i]amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]addition_percentage", array('class' => 'cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]addition_percentage")
                    . ' ' . CHtml::activeTextField($model, "[$i]addition_amount", array('class' => 'cell-right additions', 'readonly' => true)) .
                    CHtml::error($model, "[$i]addition_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]deduction_percentage", array('class' => 'cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));')) .
                    CHtml::error($model, "[$i]deduction_percentage")
                    . ' ' . CHtml::activeTextField($model, "[$i]deduction_amount", array('class' => 'cell-right deductions', 'readonly' => true)) .
                    CHtml::error($model, "[$i]deduction_amount") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array('class' => 'amount-field cell-right', 'readonly' => true)) .
                    CHtml::error($model, "[$i]net_amount") . '</td>
            <td>' . CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                    CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#' . $quotesororder . '_item_table"), this);')) .
                    '</td>
        </tr>';
            $jsonData['total']+=$model->net_amount;
        }
        //$jsonData['grand_total']=$jsonData['total'];
        $jsonData['model_addition_items'] = "";
        foreach ($modelAdItems as $i => $model) {
            if ($convertToOrder) {
                $temp = new OrderAddition;
                $temp->attributes = $model->attributes;
                $model = $temp;
            }
            $jsonData['model_addition_items'].='<tr><td class="cell-right">Additions <span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#' . $quotesororder . '_final_add_table\'))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::activeTextField($model, "[$i]particular_value", array(
                        'onkeyup' => 'calculateValues($(\'#' . $quotesororder . '_item_table\'));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#' . $quotesororder . '_final_add_table\'), this)')) .
                    '</span></td></tr>';
            // $jsonData['grand_total'] +=$model->calculated_value;
        }
        $jsonData['model_deduction_items'] = "";

        foreach ($modelDedItems as $i => $model) {
            if ($convertToOrder) {
                $temp = new OrderDeduction;
                $temp->attributes = $model->attributes;
                $model = $temp;
            }
            $jsonData['model_deduction_items'].='<tr><td class="cell-right">Deductions <span>' .
                    CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($("#' . $quotesororder . '_final_ded_table"))', 'class' => 'btn')) . ' ' .
                    '</span>' . CHtml::activeTextField($model, "[$i]particular", array('placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                    CHtml::error($model, "[$i]paricular") .
                    CHtml::activeTextField($model, "[$i]particular_value", array('onkeyup' => 'calculateValues($("#' . $quotesororder . '_item_table"));',
                        'onkeypress' => 'return isNumberKey(event)',
                        'class' => 'value_rate',
                        'placeholder' => 'value')) . ' ' .
                    CHtml::activeTextField($model, "[$i]calculated_value", array('readonly' => true, 'class' => 'value_rate additions_value')) . ' ' .
                    '<span>' .
                    CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($("#' . $quotesororder . '_final_ded_table"), this)')) . ' ' .
                    '</span></td></tr>';
            //$jsonData['grand_total'] -=$model->calculated_value;
        }
        $jsonData['company'] = $jsonData['file']->company;
        $jsonData['company']['billing_address'] = str_replace("<br/>", "\n", $jsonData['company']->billingAddress);
        $jsonData['company']['shipping_address'] = str_replace("<br/>", "\n", $jsonData['company']->shippingAddress);
        echo CJSON::encode($jsonData);
        Yii::app()->end();
    }

    public function actionGetQuotation() {
        $this->getOrderOrQuotation("Quotes", $convertToOrder = false);
    }

    /**
     *  get order details retuning json
     */
    public function actionConvertToOrder() {
        $this->getOrderOrQuotation("Quotes", $convertToOrder = true);
    }

    /**
     * save order details
     */
    public function actionSaveOrder($modelName = "Order", $from = "O") {
        /* if (isset($_POST["Order"])) {
          $this->saveSopPurchase("Order", "O");
          if ((int) $_POST["Order"]["file_id"] != 0) {
          $quotation = Quotes::model()->find(array('condition' => 'file_id=' . (int) $_POST["Order"]["file_id"]));
          if ($quotation != null) {
          $quotation->status = "O";
          $quotation->updateByPK($quotation->id, $quotation->attributes);
          }
          }
          } */
        if (isset($_POST["Order"])) {
            $model = new $modelName;

            //fetching data from form
            $attributes_main = $_POST[$modelName];
            $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
            $attributes_additions = @$_POST[$modelName . 'Addition'];
            $attributes_deductions = @$_POST[$modelName . 'Deduction'];


            $model->scenario = 'add';
            if ((int) @$attributes_main['id'] > 0)
                $model->scenario = 'update';

            //assigning data to model
            $model->attributes = $attributes_main;
            $model->crm_user_id = Yii::app()->user->id;
            $itemModel = $modelName . 'Item';

            $other_errors = array();
            $total_quatity_picked = 0;
            $valid1 = true;
            $valid = true;

            //validating line items
            foreach ($attributes_items as $i => $item) {
                if (!empty($item['product_id'])) {
                    $modelItem[$i] = new $itemModel;
                    $modelItem[$i]->attributes = $attributes_items[$i];
                    $valid = $modelItem[$i]->validate() && $valid;
                    $thisProduct = Store::model()->findByPk($attributes_items[$i]['product_id']);
                }
            }

            $valid = $valid && is_array($modelItem) && $valid1;
            // extra additions and deductions only in these section thts y
            $itemAdditionModel = $modelName . 'Addition';
            $itemDeductionModel = $modelName . 'Deduction';

            //validating additions
            if (is_array($attributes_additions))
                foreach ($attributes_additions as $i => $item) {
                    $modelAdditionItem[$i] = new $itemAdditionModel;
                    $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
                    $valid = $modelAdditionItem[$i]->validate() && $valid;
                }
            //validationg deductions 
            if (is_array($attributes_deductions))
                foreach ($attributes_deductions as $i => $item) {
                    $modelDeductionItem[$i] = new $itemDeductionModel;
                    $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
                    $valid = $modelDeductionItem[$i]->validate() && $valid;
                }

            if ($model->validate() && $valid) { // after validation saving the whole data 
                $company_id = 0;
                if ((int) $model->file_id > 0) {
                    if ($model->hasAttribute('company_id') && (int) $model->company_id > 0)
                        $company_id = $model->company_id;
                    else if ($model->hasAttribute('vendor_id') && (int) $model->vendor_id > 0)
                        $company_id = $model->vendor_id;
                    else
                        $company_id = $model->file->company_id;
                }
                else if ($model->hasAttribute('company_id'))
                    $company_id = $model->company_id;
                else if ($model->hasAttribute('vendor_id'))
                    $company_id = $model->vendor_id;
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, $company_id, isset($model->lead_owner_id) ? (int) $model->lead_owner_id : 0);
                $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
                $this->documents($model->file_id, $from);
                $model->id = @$modelName::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
                $notification = false;
                $isEdit = true;
                if ((int) $model->id == 0) {// if id 0 means its a new record, otherwise needs to update the existing one
                    $notification = ($model->file->is_approved == "N");
                    $model->save();
                    $isEdit = false;
                } else {
                    $model->updateByPK($model->id, $model->attributes);
                    // extra additions and deductions only in these section and before updating needs to remove all other refernces
                    $itemModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemAdditionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    $itemDeductionModel::model()->deleteAll($refer_id . '=:refer_id', array(':refer_id' => $model->id));
                    AllocatedMaterial::model()->deleteAll('file_id=:file_id', array(':file_id' => $model->file_id));
                }

                $model->refresh();
                $grand_total = $picked_qty = $actual_qty = $invoiced_qty = 0;
                $jsonData['shoratage'] = "";
                foreach ($modelItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->net_amount;

                    //Allocate material
                    if (isset($_POST['allocate_materials']) && $_POST['allocate_materials'] == "Y") {
                        $model->updateByPk($model->id, array('materials_allocated' => 'Y'));
                        $storeModel = Store::model()->findByPK($eachItem->product_id);
                        if ($storeModel->non_stock_item == "N") {
                            $shoratge = $storeModel->total_quantity - $storeModel->total_allocated_quantity - $eachItem->quantity;
                            if ($shoratge <= 0) {
                                $jsonData['shoratage'] .= "Item " . $eachItem->product->part_number . " need extra " . abs($shoratge) . "No.s<br/>";
                            }
                            else
                                $shoratge = 0;
                            $modelAllocatedMaterial = new AllocatedMaterial;
                            if (($t = AllocatedMaterial::model()->find('file_id=' . $model->file_id . ' AND product_id=' . $eachItem->product_id)) != null) {
                                $modelAllocatedMaterial = $t;
                            }
                            $modelAllocatedMaterial->product_id = $eachItem->product_id;
                            $modelAllocatedMaterial->file_id = $model->file_id;
                            $modelAllocatedMaterial->count = ($eachItem->quantity + $shoratge);
                            $modelAllocatedMaterial->allocation_date = date('Y-m-d');
                            //$modelAllocatedMaterial->allocation_end_date = $modelName == "Order" ? $model->delivery_date : $model->qtn_validity;
                            $modelCustom = CustomChanges::model()->find();
                            $custom_changes = CJSON::decode($modelCustom->changes);
                            if ((int) $custom_changes['custom_material_allocation_end_date']) {
                                $end_date = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d") + 14, date("Y")));
                                $modelAllocatedMaterial->allocation_end_date = $end_date;
                                $modelAllocatedMaterial->save(false);
                            }
                            else
                                $modelAllocatedMaterial->allocation_end_date = $model->delivery_date;
                            $modelAllocatedMaterial->allocated_from = "O";
                            $modelAllocatedMaterial->save(false);
                        }
                    }
                }
                if (is_array($modelAdditionItem))
                    foreach ($modelAdditionItem as $eachItem) {
                        $eachItem->{$refer_id} = $model->id;
                        $eachItem->save(false);
                        $grand_total += $eachItem->calculated_value;
                    }
                if (is_array($modelDeductionItem))
                    foreach ($modelDeductionItem as $eachItem) {
                        $eachItem->{$refer_id} = $model->id;
                        $eachItem->save(false);
                        $grand_total -= $eachItem->calculated_value;
                    }
                $model->updateByPk($model->id, array('grand_total' => $grand_total));

                //master file updating
                //$this->masterFile($model->file_id, $model->file->current_process_status, $model->file->file_title, $model->file->company_id, $model->file->lead_owner_id, "Y");
                $this->fileApproval($model->file, $isEdit, "O");

                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';


                //calculating pending amount
                $files = MasterFile::model()->findAll(array('condition' => 'company_id=' . $company_id . ' AND(current_process_status="D" OR current_process_status="PD" OR current_process_status="I" OR current_process_status="PI") '));
                $amount_pending = 0;
                foreach ($files as $eachFile) {
                    $amount_pending += $eachFile->order->grand_total;
                    foreach ($eachFile->invoices as $eachInvoice)
                        $amount_pending += ($eachInvoice->grand_total - $eachInvoice->receivedAmount);
                }
                if ($amount_pending > $eachFile->company->credit_limit) {
                    $jsonData['creditlimit'] .= "A pending of " . $amount_pending . " need to collect from " . $eachFile->company->company_name;
                    //send a mail to branch head here
                }

                //setting selected company in session
                Yii::app()->session['company_id'] = $model->company_id;

                if ($notification) {
                    $model->refresh();
                    $this->actionNotification($model, "Order");
                }

                //changing status of quotation
                if ((int) $_POST["Order"]["file_id"] != 0) {
                    $quotation = Quotes::model()->find(array('condition' => 'file_id=' . (int) $_POST["Order"]["file_id"]));
                    if ($quotation != null) {
                        $quotation->status = "O";
                        $quotation->updateByPK($quotation->id, $quotation->attributes);
                    }
                }
                echo CJSON::encode($jsonData);
                //Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (is_array($modelItem))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);
                $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionGetOrder() {
        $this->getOrderOrQuotation("Order", $convertToOrder = false);
    }

    public function actionSetFile($file_id = 0) {
        Yii::app()->session['file_id'] = $file_id == 0 ? (int) $_POST['file_id'] : $file_id;

        if (isset($_POST['needed_model'])) {
            $jsonData = $this->getFileDetails(Yii::app()->session['file_id'], $_POST['needed_model']);

            echo CJSON::encode($jsonData);
        }
    }

    /**
     *
     * @param type $modelFile
     * @param type $deliveryNote
     */
    public function prepareDeliveryForm1($modelFile, $deliveryNote = null) {
        $this->actionSetFile($modelFile->id);
        $jsonData['file'] = $modelFile;
        if ($deliveryNote == null) {
            $jsonData['deliveryNote'] = $modelFile->order;
            $jsonData['delivery_note_id'] = "";
        } else {
            $jsonData['deliveryNote'] = $deliveryNote;
            $jsonData['delivery_note_id'] = $deliveryNote->id;
        }
        $jsonData['company'] = $modelFile->company;
        $data = CHtml::listData($modelFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        $items = $jsonData['deliveryNote']->items;
        $jsonData['model_items'] = '';
        $i = 0;
        foreach ($items as $j => $model) {
            if (!in_array($modelFile->current_process_status, array("PD", "PI"))) {
                $temp = new DeliveryNoteItem;
                $temp->attributes = $model->attributes;
            } else {
                $condition = 't.order_id=' . $modelFile->order->id . ' AND deliveryItems.product_id=' . $model->product_id;
                if ($deliveryNote != null)
                    $condition .= ' AND t.id <>' . $deliveryNote->id;
                $itemDelivered = Yii::app()->db->createCommand()
                        ->select('sum(deliveryItems.picked_qty) as deliverd_qty')
                        ->from('{{delivery_note}} t')
                        ->join('{{delivery_note_item}} deliveryItems', 't.id=deliveryItems.delivery_note_id')
                        ->where($condition)
                        ->queryRow();
                $temp = new DeliveryNoteItem;
                $temp->attributes = $model->attributes;
                $temp->quantity = abs($temp->quantity - $itemDelivered['deliverd_qty']);
            }
            if ($deliveryNote == null) {
                $country_code = $model->product->country0->id;
            }
            else
                $country_code = $model->country_of_origin;
            //if ($temp->quantity > 0) {
            $model = $temp;
            $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td class="cell-left">' . $model->product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array('class' => 'description', 'readonly' => 'true', 'value' => $model->product->part_number)) .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td  class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array('class' => 'description', 'readonly' => 'true', 'style' => 'width:275px;')) . '</td>
            <td class="cell-left">' . $model->quantity . CHtml::activeHiddenField($model, "[$i]quantity", array('class' => 'cell-center', 'readonly' => 'true',)) . '</td>
            <td>' . $model->product->unit->symbol . CHtml::activeHiddenField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'this.value = checkPickedQuantity(event,this.value,' . $model->quantity . ',' . floatval($model->product->weight) . ',' . floatval($model->product->volume) . ',"DeliveryNoteItem_' . $i . '_weight","DeliveryNoteItem_' . $i . '_volume")')) . '</td>
            
            <td>' . CHtml::activeDropDownList($model, "[$i]country_of_origin", MasCountry::getCountry(), array('options' => array($country_code => array('selected' => true)), 'style' => 'width:100px !important;')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]hsir_code", array('value' => $model->product->inventory->hsir_code, 'class' => 'cell-center')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]incomming_shipment_ref", array('class' => 'cell-center')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]weight", array('class' => 'cell-right')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]volume", array('class' => 'cell-right')) . '</td></tr>';
            $i++;
            // }
        }
        echo CJSON::encode($jsonData);
    }

    public function prepareDeliveryForm($modelFile, $deliveryNote = null) {
        $this->actionSetFile($modelFile->id);
        $jsonData['file'] = $modelFile;
        if ($deliveryNote == null) {
            $jsonData['deliveryNote'] = $modelFile->order;
            $jsonData['delivery_note_id'] = "";
            $items = $modelFile->order->items;
        } else { //delivery opening for editing
            $jsonData['deliveryNote'] = $deliveryNote;
            $jsonData['delivery_note_id'] = $deliveryNote->id;
            $items = $deliveryNote->items;
        }
        $jsonData['company'] = $modelFile->company;
        $data = CHtml::listData($modelFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        $jsonData['model_items'] = '';
        $i = 0;
        $j = 0;
        if ($deliveryNote == null)
            $dns = DeliveryNote::model()->with('items')->findAll(array('condition' => 'file_id=' . $modelFile->id, 'order' => 'items.id ASC'));
        foreach ($items as $j => $orderItem) {//may be from orderItems
            $model = new DeliveryNoteItem;
            $model->attributes = $orderItem->attributes;
            $totalPicked_qty = 0;
            if ($deliveryNote == null) {
                foreach ($dns as $eachDeliveryNote) {
                    if ($eachDeliveryNote->items[$j]->product_id == $orderItem->product_id)
                        $totalPicked_qty += $eachDeliveryNote->items[$j]->picked_qty;
                }
            }
            $model->picked_qty = $model->pickable_quantity = ($deliveryNote != null) ? $model->picked_qty : ($orderItem->quantity - $totalPicked_qty);
            $country_code = ($deliveryNote == null) ? $model->product->country0->id : $country_code = $model->country_of_origin;
            $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
            $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td class="cell-left">' . $model->product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array(
                        'class' => 'description',
                        'readonly' => 'true',
                        'value' => $model->product->part_number)) .
                    CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td  class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array('class' => 'description', 'readonly' => 'true', 'style' => 'width:275px;')) . '</td>
            <td class="cell-right">' . $model->quantity . CHtml::activeHiddenField($model, "[$i]quantity", array('class' => 'cell-center', 'readonly' => 'true',)) . '</td>
            <td>' . $model->product->unit->symbol . CHtml::activeHiddenField($model, "[$i]unit", array('readonly' => true, 'value' => $model->product->unit->symbol)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]picked_qty", array(
                        'class' => 'cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'this.value = checkPickedQuantity(event,this.value,' . $model->picked_qty . ',' . floatval($model->product->weight) . ',' . floatval($model->product->volume) . ',"DeliveryNoteItem_' . $i . '_weight","DeliveryNoteItem_' . $i . '_volume")')) .
                    CHtml::activeHiddenField($model, "[$i]pickable_quantity") . '</td>
            
            <td>' . CHtml::activeDropDownList($model, "[$i]country_of_origin", MasCountry::getCountry(), array('options' => array($country_code => array('selected' => true)), 'style' => 'width:100px !important;')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]hsir_code", array('value' => $model->product->inventory->hsir_code, 'class' => 'cell-center')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]incomming_shipment_ref", array('class' => 'cell-center')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]weight", array('class' => 'cell-right')) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]volume", array('class' => 'cell-right')) . '</td></tr>';
            $i++;
            //}
        }
        echo CJSON::encode($jsonData);
    }

    /* <td>' . CHtml::activeTextField($model, "[$i]country_of_origin", array('value' => $model->product->country0->country_name, 'class' => 'description cell-center')) . '</td> */

    public function actionDeliveredFiles() {
        $this->getFiles(array("D", "PD", "PI"));
    }

    public function actionOrderedFiles() {
        $this->getFiles(array("O", "PD", "PI", "C"), array('is_approved' => "Y"));
    }

    /**
     *
     * @param type $file_id
     */
    public function actionFetchFile() {
        $model = MasterFile::model()->findByPK((int) $_POST['file_id']);
        $this->prepareDeliveryForm($model);
    }

    public function actionFetchFilesByLeadowner() {
        $current_process_status = implode('","', array("Q", "O", "D", "PD", "I", "PI", "CN"));
        $condition = 'is_approved="Y" AND current_process_status in ("' . $current_process_status . '")';
        if ((int) $_POST['leadowner'] != 0)
            $condition .= ' AND t.lead_owner_id = ' . (int) $_POST['leadowner'];
        $condition .= ' ORDER BY t.id DESC';
        $model = MasterFile::model()->findAll(array('condition' => $condition));
        if ($model != null) {
            $data = CHtml::listData($model, 'id', 'id_with_status');
            foreach ($data as $value => $name)
                $jsonArrray['files'] .= CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        }
        else
            $jsonArrray['files'] = "";
        echo CJSON::encode($jsonArrray);
    }

    public function actionOrderData() {
        $model = MasterFile::model()->findByPK((int) $_POST['file_id']);
        $jsonData[file_no] = $model->id;
        $jsonData[order_no] = $model->order->id;
        $jsonData[order_date] = $model->order->order_date;
        $jsonData[delivery_date] = $model->order->delivery_date;
        $jsonData[company_name] = $model->order->company->company_name;
        $jsonData[lead_owner] = $model->leadowner->fullname;
        echo CJSON::encode($jsonData);
    }

    public function actionConvertToDeliveryNote() {
        $model = MasterFile::model()->with('order.items')->findByPK(Order::model()->findByPK((int) $_POST['id'])->file_id, array('order' => 'items.id ASC'));
        $this->prepareDeliveryForm($model);
    }

    public function actionEditDeliveryNote() {
        $modelDeliveryNote = DeliveryNote::model()->with('items')->findByPK((int) $_POST['id'], array('order' => 'items.id ASC'));
        $this->prepareDeliveryForm($modelDeliveryNote->file, $modelDeliveryNote);
    }

    public function actionSaveDelivery($modelName = "DeliveryNote", $from = "PD") {
        //$this->saveSopPurchase("DeliveryNote", "PD");
        $model = new $modelName;

        //fetching data from form
        $attributes_main = $_POST[$modelName];
        $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);

        $model->scenario = 'add';
        if ((int) @$attributes_main['id'] > 0)
            $model->scenario = 'update';

        $model->attributes = $attributes_main;
        $model->crm_user_id = Yii::app()->user->id;
        $itemModel = $modelName . 'Item';

        $other_errors = array();
        $total_quatity_picked = 0;
        $valid1 = true;
        $valid = true;

        foreach ($attributes_items as $i => $item) {
            if (!empty($item['product_id'])) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
                $thisProduct = Store::model()->findByPk($attributes_items[$i]['product_id']);
                $total_quatity_picked+=$modelItem[$i]->picked_qty;
                if ($thisProduct->non_stock_item == "N") {
                    if ((int) $_POST['DeliveryNote']['id'] != 0) { //if going to edit delivery note,then replace quantity in warehose first
                        $warehouse = ProductLocation::model()->find('stock_id=:stock_id', array(
                            ':stock_id' => $thisProduct->id,
                        ));
                        $savedItem = $itemModel::model()->findAll(array('condition' => 'product_id=' . $thisProduct->id . ' AND delivery_note_id=' . $_POST['DeliveryNote']['id'], 'order' => 't.id ASC'));
                        $warehouse->quantity += $savedItem[$i]->picked_qty;
                        $thisProduct->total_quantity +=$savedItem[$i]->picked_qty;
                        $thisProduct->total_quantity_in_default_ware_house+=$savedItem[$i]->picked_qty;
                    }
                    if ($thisProduct->total_quantity_in_default_ware_house < $attributes_items[$i]['picked_qty']) {
                        $other_errors[] = "Item " . $thisProduct->part_number . " - only " . $thisProduct->total_quantity_in_default_ware_house . " is available in default warehouse. A total of " . $thisProduct->total_quantity . " Quantity available in the branch";
                        $valid = $valid && false;
                    }
                    $allocatedQuantityForThis = @AllocatedMaterial::model()->find('file_id=:file_id AND product_id=:product_id', array(':file_id' => $model->file_id, ':product_id' => $thisProduct->id))->count;
                    $availableQty = ($thisProduct->total_quantity + floatval($allocatedQuantityForThis)) - $thisProduct->total_allocated_quantity;
                    if ($availableQty < $attributes_items[$i]['picked_qty']) {
                        $other_errors[] = "Item " . $thisProduct->part_number . " available only " . $availableQty . ' Nos. in all warehouses';
                        $valid = $valid && false;
                    }
                    if ((int) $_POST['DeliveryNote']['id'] != 0 && $valid) {
                        //$warehouse->quantity -= $attributes_items[$i]['picked_qty'];
                        $warehouse->save();
                    }
                }
            }
        }
        if ($modelName == "DeliveryNote" && $total_quatity_picked <= 0) {
            $valid = $valid && false;
            $modelItem = "";
        }

        $valid = $valid && is_array($modelItem) && $valid1;

        if ($model->validate() && $valid) { // after validation saving the whole data 
            $company_id = 0;
            if ((int) $model->file_id > 0) {
                if ($model->hasAttribute('company_id') && (int) $model->company_id > 0)
                    $company_id = $model->company_id;
                else if ($model->hasAttribute('vendor_id') && (int) $model->vendor_id > 0)
                    $company_id = $model->vendor_id;
                else
                    $company_id = $model->file->company_id;
            }
            else if ($model->hasAttribute('company_id'))
                $company_id = $model->company_id;
            else if ($model->hasAttribute('vendor_id'))
                $company_id = $model->vendor_id;
            $model->file_id = $this->masterFile($model->file_id, $from, $model->title, $company_id, isset($model->lead_owner_id) ? (int) $model->lead_owner_id : 0);
            $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
            $this->documents($model->file_id, $from);
            if ((int) $_POST['DeliveryNote']['id'] == 0)
                $model->order_id = Order::model()->find(array('condition' => 'file_id=' . $model->file_id))->id;
            else
                $model->id = $_POST['DeliveryNote']['id'];
            $notification = false;
            if ((int) $model->id == 0) {// if id 0 means its a new record, otherwise needs to update the existing one
                $notification = ($model->file->is_approved == "N");
                $model->save();
            } else {
                $model->updateByPK($model->id, $model->attributes);
                $itemModel::model()->deleteAll($refer_id . '=:id', array(':id' => $model->id));
            }

            $model->refresh();
            $grand_total = $picked_qty = $actual_qty = $invoiced_qty = 0;
            $jsonData['shoratage'] = "";
            foreach ($modelItem as $eachItem) {
                $eachItem->{$refer_id} = $model->id;
                $eachItem->save(false);
                if ($modelName == "DeliveryNote" && $eachItem->product->non_stock_item == "N") {
                    $warehouses = ProductLocation::model()->findAll('stock_id=:stock_id', array(':stock_id' => $eachItem->product_id));
                    foreach ($warehouses as $eachWareHouse) {
                        if ($eachItem->picked_qty <= $eachWareHouse->quantity) {
                            $eachWareHouse->quantity -= $eachItem->picked_qty;
                            $eachItem->picked_qty = 0;
                            $eachWareHouse->save(false);
                            break;
                        } else {
                            $eachItem->picked_qty-=$eachWareHouse->quantity;
                            $eachWareHouse->quantity = 0;
                            $eachWareHouse->save(false);
                        }
                    }
                    AllocatedMaterial::model()->deleteAll('file_id=:file_id AND product_id=:product_id', array(':file_id' => $model->file_id, ':product_id' => $eachItem->product_id));
                    //deduct items from product location
                }
            }
            if ($modelName == "DeliveryNote" && $model->file->deliveredQuantity >= $model->file->order->netQuantity) {
                $this->masterFile($model->file_id, "D"); ///need to check full delivey,status is not updating correctly 
            }

            $jsonData['file'] = $model->file;
            $jsonData['model'] = $model;
            $jsonData['status'] = 'success';

            Yii::app()->session['company_id'] = $model->company_id;

            echo CJSON::encode($jsonData);
            //Yii::app()->end();
        } else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if (is_array($modelItem))
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $other_errors));
            if ($error != '[]')
                echo $error;
        }
    }

    public function actionFetchDeliveryNotes() {
        if ((isset($_POST['delivery_note_ids']) && is_array($_POST['delivery_note_ids']) || (isset($_POST['dv_id'])))) {
            if (isset($_POST['delivery_note_ids']) && is_array($_POST['delivery_note_ids'])) {
                foreach ($_POST['delivery_note_ids'] as $eachDNote)
                    $selected_delivery_notes[] = $eachDNote['value'];
                //$selected_delivery_notes = implode(',', $delivery_note_ids);
            }
            else
                $selected_delivery_notes[] = Yii::app()->request->getParam('dv_id');
            $modelDeliveredItems = DeliveryNoteItem::model()->with('deliveryNote')->findAll(array('order' => 'deliveryNote.id ASC,t.id ASC', 'condition' => 'deliveryNote.id in (' . $selected_delivery_notes[0] . ')'));
            $jsonData = $this->getFileDetails($modelDeliveredItems[0]->deliveryNote->file->id, 'order');
            //$jsonData = array();
            $jsonData['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Product</th>
            <th>Description</th>
            <th>Qty</th> 
            <th>Unit</th>
            <th>Rate</th>
            <th>Amount</th>
            <th>Additions</th>
            <th>Deductions</th>
            <th>Net</th>
        </tr>';
            $jsonData['delivery_ids'] = $selected_delivery_notes;
            $total = 0;
            $k = 0;
            foreach ($selected_delivery_notes as $each_delivery_note_id) {
                $modelDeliveredItems = DeliveryNoteItem::model()->with('deliveryNote')->findAll(array('order' => 't.id ASC', 'condition' => 'deliveryNote.id =' . $each_delivery_note_id));
                $correspondingOrderItem = OrderItem::model()->findAll(array('condition' => 'order_id=' . $modelDeliveredItems[0]->deliveryNote->file->order->id, 'order' => 'id ASC'));
                foreach ($modelDeliveredItems as $i => $eachItem) {
                    if ($eachItem->picked_qty > 0) {

                        $model = new InvoiceItem;


                        $model->attributes = $correspondingOrderItem[$i]->attributes;
                        $model->quantity = $eachItem->picked_qty;
                        $model->quantity = $model->quantity > 0 ? $model->quantity : 0;

                        $orderedAmounntForThisItem = $correspondingOrderItem[$i]->amount;


                        $model->amount = number_format($model->rate * $model->quantity, 2, '.', '');
                        $model->addition_amount = $orderedAmounntForThisItem > 0 ? number_format(($model->addition_amount / $correspondingOrderItem[$i]->quantity) * $eachItem->picked_qty, 2, '.', '') : 0.00;
                        $model->addition_percentage = (!is_numeric($model->addition_percentage)) ? $model->addition_percentage : $model->addition_amount;
                        $model->deduction_amount = $orderedAmounntForThisItem > 0 ? number_format(($model->deduction_amount / $correspondingOrderItem[$i]->quantity) * $eachItem->picked_qty, 2, '.', '') : 0.00;
                        $model->deduction_percentage = (!is_numeric($model->deduction_percentage)) ? $model->deduction_percentage : $model->deduction_amount;
                        $model->net_amount = number_format($model->amount + $model->addition_amount - $model->deduction_amount, 2, '.', '');
                        $total += $model->net_amount;
                        $model->quantity = preg_replace('/\s\d+\.00/', '', floatval($model->quantity));
                        $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($k + 1) . '</label></td>
            <td class="cell-left">' . $model->product->part_number . CHtml::activeHiddenField($model, "[$k]product_name", array('class' => 'description', 'readonly' => 'true', 'value' => $model->product->part_number)) .
                                CHtml::activeHiddenField($model, "[$k]product_id") . '</td>
            <td class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$k]description", array('class' => 'description', 'readonly' => 'true')) . '</td>
            <td class="cell-right">' . $model->quantity . CHtml::activeHiddenField($model, "[$k]quantity", array('class' => 'cell-center', 'readonly' => 'true',)) . '</td>
            <td>' . $model->product->unit->unit_name . CHtml::activeHiddenField($model, "[$k]unit", array('readonly' => true, 'value' => $model->product->unit->unit_name)) . '</td>
            <td class="cell-right">' . $model->rate . CHtml::activeHiddenField($model, "[$k]rate", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td class="cell-right">' . $model->amount . CHtml::activeHiddenField($model, "[$k]amount", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td class="cell-right">' . CHtml::activeTextField($model, "[$k]addition_percentage", array(
                                    'class' => 'cell-right',
                                    'onkeypress' => 'return isNumberKey(event)',
                                    'onkeyup' => 'calculateValues($("#invoice_item_table"));',
                                    'readonly' => false)) .
                                CHtml::activeTextField($model, "[$k]addition_amount", array('class' => 'cell-right', 'readonly' => true)) . '</td>
            <td class="cell-right">' . CHtml::activeTextField($model, "[$k]deduction_percentage", array('class' => 'cell-right', 'onkeypress' => 'return isNumberKey(event)',
                                    'onkeyup' => 'calculateValues($("#invoice_item_table"));',
                                    'readonly' => false)) .
                                CHtml::activeTextField($model, "[$k]deduction_amount", array('class' => 'cell-right', 'readonly' => 'true')) . '</td>
            <td class="cell-right">' . CHtml::activeTextField($model, "[$k]net_amount", array('class' => 'cell-right amount-field', 'readonly' => 'true')) . '</td>
            </tr>'
                        ;
                        $k++;
                    }
                }
            }
//echo adItems
            $jsonData['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">' . $total . '</h2></td>
        </tr>';
            $addition = ($eachItem->deliveryNote->file->order->netAmount > 0) ? (number_format(($total / $eachItem->deliveryNote->file->order->netAmount) * $eachItem->deliveryNote->file->order->adTotal, 2, '.', '')) : 0;
            $deduction = ($eachItem->deliveryNote->file->order->netAmount > 0) ? (number_format(($total / $eachItem->deliveryNote->file->order->netAmount) * $eachItem->deliveryNote->file->order->dedTotal, 2, '.', '')) : 0;
            $jsonData['addition'] = '';
            $modelAddition = new InvoiceAddition;
            if (is_array($eachItem->deliveryNote->file->order->adItems))
                foreach ($eachItem->deliveryNote->file->order->adItems as $i => $eachAddition) {
                    $eachAddition->calculated_value = ($eachItem->deliveryNote->file->order->netAmount > 0) ? (number_format(($total / $eachItem->deliveryNote->file->order->netAmount) * $eachAddition->calculated_value, 2, '.', '')) : 0;
                    $eachAddition->particular_value = (!is_numeric($eachAddition->particular_value)) ? $eachAddition->particular_value : $eachAddition->calculated_value;
                    $jsonData['addition'].='<tr><td class="cell-right">Additions<span>' .
                            CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#invoice_final_add_table\'))', 'class' => 'btn')) . ' ' .
                            '</span>' . CHtml::activeTextField($modelAddition, "[$i]particular", array('value' => $eachAddition->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                            CHtml::activeTextField($modelAddition, "[$i]particular_value", array('value' => $eachAddition->particular_value,
                                'onkeyup' => 'calculateValues($(\'#invoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                            CHtml::activeTextField($modelAddition, "[$i]calculated_value", array(
                                'readonly' => true,
                                'value' => $eachAddition->calculated_value,
                                'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#invoice_final_add_table\'), this)')) .
                            '</span></td></tr>';
                }
            $jsonData['deduction'] = '';
            $modelDeduction = new InvoiceDeduction;
            if (is_array($eachItem->deliveryNote->file->order->dedItems))
                foreach ($eachItem->deliveryNote->file->order->dedItems as $i => $eachDeduction) {
                    $eachDeduction->calculated_value = ($eachItem->deliveryNote->file->order->netAmount > 0) ? (number_format(($total / $eachItem->deliveryNote->file->order->netAmount) * $eachDeduction->calculated_value, 2, '.', '')) : 0;
                    $eachDeduction->particular_value = (!is_numeric($eachDeduction->particular_value)) ? $eachDeduction->particular_value : $eachDeduction->calculated_value;
                    $jsonData['deduction'].='<tr><td class="cell-right">Deductions<span>' .
                            CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRow($(\'#invoice_final_ded_table\'))', 'class' => 'btn')) . ' ' .
                            '</span>' . CHtml::activeTextField($modelDeduction, "[0]particular", array('value' => $eachDeduction->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' ' .
                            CHtml::activeTextField($modelDeduction, "[0]particular_value", array('value' => $eachDeduction->particular_value,
                                'onkeyup' => 'calculateValues($(\'#invoice_item_table\'));', 'onkeypress' => 'return isNumberKey(event)', 'class' => 'value_rate', 'placeholder' => 'value')) . ' ' .
                            CHtml::activeTextField($modelDeduction, "[0]calculated_value", array(
                                'readonly' => true,
                                'value' => $eachDeduction->calculated_value,
                                'class' => 'value_rate additions_value')) . ' ' . '<span>' .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeExtrasRow($(\'#invoice_final_ded_table\'), this)')) .
                            '</span></td></tr>';
                }
            $gd_total = number_format($total + $addition - $deduction, 2, '.', '');
            $jsonData['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $gd_total . '</h1></td>
        </tr>';
        }
        else
            $jsonData['error'] = "Please choose DeliveryNotes from the list";
        echo CJSON::encode($jsonData);
    }

    public function actionSaveInvoice($modelName = "Invoice", $from = "PI") {
        //$this->saveSopPurchase("Invoice", "PI");
        $model = new $modelName;

        //fetching values from form
        $attributes_main = $_POST[$modelName];
        $attributes_items = isset($_POST[$modelName . 'Item']) ? $_POST[$modelName . 'Item'] : array(0);
        $attributes_additions = @$_POST[$modelName . 'Addition']; // extra additions and deductions only in these section thts y
        $attributes_deductions = @$_POST[$modelName . 'Deduction'];

        $model->scenario = 'add';
        if ((int) @$attributes_main['id'] > 0)
            $model->scenario = 'update';

        $model->attributes = $attributes_main;
        $model->crm_user_id = Yii::app()->user->id;

        $itemModel = $modelName . 'Item';
        $other_errors = array();
        $total_quatity_picked = 0;
        $valid1 = true;
        $valid = true;

        //validating line items
        foreach ($attributes_items as $i => $item) {
            if (!empty($item['product_id'])) {
                $modelItem[$i] = new $itemModel;
                $modelItem[$i]->attributes = $attributes_items[$i];
                $valid = $modelItem[$i]->validate() && $valid;
                $thisProduct = Store::model()->findByPk($attributes_items[$i]['product_id']);
            }
        }

        $valid = $valid && is_array($modelItem) && $valid1;

        // extra additions and deductions only in these section thts y
        $itemAdditionModel = $modelName . 'Addition';
        $itemDeductionModel = $modelName . 'Deduction';

        //validationg additions
        if (is_array($attributes_additions))
            foreach ($attributes_additions as $i => $item) {
                $modelAdditionItem[$i] = new $itemAdditionModel;
                $modelAdditionItem[$i]->attributes = $attributes_additions[$i];
                $valid = $modelAdditionItem[$i]->validate() && $valid;
            }

        //validationg deductions 
        if (is_array($attributes_deductions))
            foreach ($attributes_deductions as $i => $item) {
                $modelDeductionItem[$i] = new $itemDeductionModel;
                $modelDeductionItem[$i]->attributes = $attributes_deductions[$i];
                $valid = $modelDeductionItem[$i]->validate() && $valid;
            }

        if ($model->validate() && $valid) { // after validation saving the whole data 
            $company_id = 0;
            if ((int) $model->file_id > 0) {
                if ($model->hasAttribute('company_id') && (int) $model->company_id > 0)
                    $company_id = $model->company_id;
                else if ($model->hasAttribute('vendor_id') && (int) $model->vendor_id > 0)
                    $company_id = $model->vendor_id;
                else
                    $company_id = $model->file->company_id;
            }
            else if ($model->hasAttribute('company_id'))
                $company_id = $model->company_id;
            else if ($model->hasAttribute('vendor_id'))
                $company_id = $model->vendor_id;
            $model->file_id = $this->masterFile($model->file_id, $from, $model->title, $company_id, isset($model->lead_owner_id) ? (int) $model->lead_owner_id : 0);
            $refer_id = strtolower(preg_replace('/\B([A-Z])/', '_$1', $modelName)) . '_id'; //quotes_id,order_id,delivery_note_id etc.,
            $this->documents($model->file_id, $from);
            if ((int) $_POST['Invoice']['id'] != 0)
                $model->id = $_POST['Invoice']['id'];
            $notification = false;

            if ((int) $model->id == 0) {// if id 0 means its a new record, otherwise needs to update the existing one
                $notification = ($model->file->is_approved == "N");
                $model->save();
            }
            else
                $model->updateByPK($model->id, $model->attributes);
            //changing invoiced status of deliveynote
            DeliveryNote::model()->updateAll(array('invoiced' => 'Y'), 'id in (' . $model->delivery_ids . ')');

            $model->refresh();
            $grand_total = $picked_qty = $actual_qty = $invoiced_qty = 0;
            $jsonData['shoratage'] = "";

            //saving line item
            foreach ($modelItem as $eachItem) {
                $eachItem->{$refer_id} = $model->id;
                $eachItem->cost_rate = Store::model()->findByPk($eachItem->product_id)->rate;
                $eachItem->save(false);
                $grand_total += $eachItem->net_amount;
                $invoiced_qty+=$eachItem->quantity;
            }

            //saving additions
            if (is_array($modelAdditionItem))
                foreach ($modelAdditionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total += $eachItem->calculated_value;
                }

            //saving deductiond
            if (is_array($modelDeductionItem))
                foreach ($modelDeductionItem as $eachItem) {
                    $eachItem->{$refer_id} = $model->id;
                    $eachItem->save(false);
                    $grand_total -= $eachItem->calculated_value;
                }

            //checking wheather the order in invoiced completely
            $orderedQuantity = $model->file->order->netQuantity;
            $invoices = $model->file->invoices;
            $inoicedQantity = 0;
            foreach ($invoices as $eachInvoice)
                $inoicedQantity+=$eachInvoice->netQuantity;
            if ($orderedQuantity <= $inoicedQantity)
                $this->masterFile($model->file_id, "I");
            //* here we decides whether the file is i status I or something else *//


            $model->updateByPk($model->id, array('grand_total' => $grand_total));

            $jsonData['file'] = $model->file;
            $jsonData['model'] = $model;
            $jsonData['status'] = 'success';

            Yii::app()->session['company_id'] = $model->company_id;

            echo CJSON::encode($jsonData);
            //Yii::app()->end();
        } else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if (is_array($modelItem))
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);
            $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $error3, $error4, $other_errors));
            if ($error != '[]')
                echo $error;
        }
    }

    public function actionSaveReceipt() {
        if (isset($_POST['RcptOfPayment'])) {
            $modelRcptOfPayment = new RcptOfPayment();
            $modelRcptOfPayment->attributes = $_POST['RcptOfPayment'];
            $modelRcptOfPayment->own_company_id = Yii::app()->user->master_user_company_id;
            $modelRcptOfPayment->own_branch_id = Yii::app()->user->master_user_branch_id;
            $i = 0;
            $valid = 0;

            if (isset($_POST['received_amt'])) {
                $valid = $modelRcptOfPayment->validate();
                foreach ($_POST['received_amt'] as $invoice_id => $received_amt) {
                    if ($received_amt > 0) {
                        $modelReceivedInvoices[$i] = new ReceivedInvoices;
                        $modelReceivedInvoices[$i]->invoice_id = $invoice_id;
                        $modelReceivedInvoices[$i]->received_amt = $received_amt;
                        $valid = $valid && $modelReceivedInvoices[$i]->validate();
                        $i++;
                    }
                }
            }
            if ($valid && isset($modelReceivedInvoices)) {
                $modelRcptOfPayment->save();
                $modelRcptOfPayment->refresh();
                foreach ($modelReceivedInvoices as $eachReceivedInvoice) {
                    $eachReceivedInvoice->rcpt_id = $modelRcptOfPayment->id;
                    $eachReceivedInvoice->save();
                    $modelInvoice = Invoice::model()->findByPK($eachReceivedInvoice->invoice_id);
                    if ($eachReceivedInvoice->invoice->receivedAmount >= $modelInvoice->grand_total) {
                        $modelInvoice->paid = "Y";
                        $modelInvoice->save();
                    }
                }


                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($modelRcptOfPayment, '', false), true);
                if (!isset($modelReceivedInvoices))
                    $modelReceivedInvoices = new ReceivedInvoices;
                $error2 = json_decode(CActiveForm::validateTabular($modelReceivedInvoices, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionFetchPaymentHistory() {
        if (isset($_GET['invoice_id']) && (int) $_GET['invoice_id'] > 0) {
            $modelReceivedInvoices = ReceivedInvoices::model()->with('recpt')->findAll(array(
                'condition' => 'invoice_id=' . (int) $_GET['invoice_id'],
                'order' => 'recpt.received_date DESC',
                    //'limit'=>'5',
            ));
            $history = "<div style='height:100px; overflow:scroll;'>
                <table style='width:100%;' class='table-grid'><tr><th>Rcpt No.</th><th>Date.</th><th>Realisation Date.</th><th>Payment Mode.</th><th>Ref.No.</th><th>Rcvd Amt.</th><th>Notes.</th><th>Remarks.</th>";
            foreach ($modelReceivedInvoices as $eachReceivedInvoice) {
                $history .= "<tr><td>" . $eachReceivedInvoice->recpt->id . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->received_date . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->realisation_date . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->mode_of_payment . "</td>
                        <td class='cell-center'>" . $eachReceivedInvoice->recpt->ref_number . "</td>
                        <td class='cell-right'>" . Yii::app()->numberFormatter->formatCurrency($eachReceivedInvoice->received_amt, "") . "</td>
                        <td class='cell-left'>" . $eachReceivedInvoice->recpt->notes . "</td>
                        <td class='cell-left'>" . $eachReceivedInvoice->recpt->remarks . "</td></tr>";
            }
            $history .="</table></div>";

            echo json_encode(array('row' => '<tr class="toggle"><td   colspan="9">' . $history . '</td></tr>'));
        }
    }

    public function actionGraphInvoice() {
        $modelRcvdInvoices = Invoice::model()->findAll(/* array('condition' => 'paid="Y"') */);
        foreach ($modelRcvdInvoices as $eachInvoice) {
            $xAxis[] = $eachInvoice->id . ':Comp.Id' . $eachInvoice->company_id;
            $yAxis[$eachInvoice->id . ':Comp.Id' . $eachInvoice->company_id] = floatval($eachInvoice->receivedAmount);
            $yAxis2[$eachInvoice->id . ':Comp.Id' . $eachInvoice->company_id] = floatval($eachInvoice->grand_total);
        }
        $jsonData['xAxis'] = $xAxis;
        $jsonData['yAxis1'] = $yAxis;
        $jsonData['yAxis2'] = $yAxis2;
        echo CJSON::encode($jsonData);
    }

    /* ########################################## Arun's section ############################################## */

    /* ########################################## Toby's section ############################################## */
    /* Product search, param product name(partial) , returning json */

    public function actionSearchProduct() {
        $this->autocompleteData('Store', array('part_number', 'description'), $_GET['term'], false, Yii::app()->user->master_user_company_id, Yii::app()->user->master_user_branch_id);
    }

    /* get product details, param product_id, returning json */

    public function actionGetProduct() {
        $company_id = (int) Yii::app()->request->getParam('company_id');
        $product_id = (int) Yii::app()->request->getParam('product_id');

        $jsonData['store'] = Store::model()->with('unit')->findByPK($product_id);
        $jsonData['unit'] = $jsonData['store']->unit;
        $jsonData['tax'] = $jsonData['store']->taxCode;
        if ($company_id > 0) {
            $pricingGroupId = (int) CompanyPricingGroup::model()->find('company_id=' . $company_id . ' AND brand_id= ' . $jsonData['store']->product_class_id)->pricing_group_id;
            $jsonData['rate'] = floatval(PriceGroupProductRelation::model()->find(
                            ' store_id=' . $jsonData['store']->id .
                            ' AND price_group_id=' . $pricingGroupId .
                            ' AND pricing_product_class_id=' . $jsonData['store']->product_class_id)->rate
            );
            if ($jsonData['rate'] == 0)
                $jsonData['rate'] = floatval(PriceGroupProductRelation::model()->with('priceGrp')->find('priceGrp.default_pricing_group="Y" AND priceGrp.type="S" AND t.store_id=' . $jsonData['store']->id)->rate);
        }
        echo (CJSON::encode($jsonData));
        Yii::app()->end();
    }

    public function actionLoadcontacts() {
        $data = CompanyContact::model()->findAll('company_id=:c_id', array(':c_id' => (int) $_POST['company_id']));
        $data = CHtml::listData($data, 'id', 'person_name');
        foreach ($data as $value => $name)
            echo CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
    }

    public function actionFetchcontactdetails() {
        $data = CompanyContact::model()->find('id=:c_id', array(':c_id' => (int) $_POST['contact_id']));
        echo CJSON::encode($data);
    }

    public function actionAutoCompleteEmployee() {
        $this->autocompleteData('User', array('first_name', 'last_name'), $_GET['term'], 'fullname');
    }

    public function actionfetchEmployeeDetails() {
        $jsonArrray['employee'] = User::model()->findByPK((int) $_POST['employee_id']);
        echo CJSON::encode($jsonArrray);
    }

    public function actionPrintQuotes() {
        $model = new Quotes;
        $this->renderPartial('//printlayouts/quotation-list', array('model' => $model));
    }

    public function actionPrintQuote($id) {
        $model = Quotes::model()->findByPK($id);
        $product_items = "";
        foreach ($model->items as $i => $eachItem) {
            $class = $class == "odd" ? "even" : "odd";
            $product_items .= '<tr class="' . $class . '">
                                <td >' . ($i + 1) . '</td>
                                <td class="cell-center">' . $eachItem->product->part_number . '</td>
                                <td class="cell-left">' . $eachItem->description . '</td>
                                <td class="cell-center">' . $eachItem->quantity . '</td>
                                <td class="cell-center">' . $eachItem->product->unit->unit_name . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                                <td>' . $eachItem->addition_percentage . ' / ' . $eachItem->deduction_percentage . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, "") . '</td>
                            </tr>';
        }
        $additions = '';
        foreach ($model->adItems as $i => $eachItem) {
            if (!empty($eachItem->particular)) {
                $class = $class == "odd" ? "even" : "odd";
                $additions .= '<tr  class="' . $class . '">
                                <td colspan="7" class="cell-right" >' . $eachItem->particular . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
                            </tr>';
            }
        }
        $deductions = '';
        foreach ($model->dedItems as $i => $eachItem) {
            if (!empty($eachItem->particular)) {
                $class = $class == "odd" ? "even" : "odd";
                $deductions .= '<tr  class="' . $class . '">
                                <td colspan="7" class="cell-right" >' . $eachItem->particular . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
                            </tr>';
            }
        }
        $this->renderPartial('//printlayouts/quotation-single', array(
            'model' => $model,
            'product_items' => $product_items,
            'additions' => $additions,
            'deductions' => $deductions
        ));
    }

    public function actionPrintOrder($id) {
        $model = Order::model()->findByPK($id);
        $product_items = "";
        foreach ($model->items as $i => $eachItem) {
            $class = $class == "odd" ? "even" : "odd";
            $product_items .= '<tr class="' . $class . '">
                                <td >' . ($i + 1) . '</td>
                                <td class="cell-center">' . $eachItem->product->part_number . '</td>
                                <td class="cell-left">' . $eachItem->description . '</td>
                                <td class="cell-center">' . $eachItem->quantity . '</td>
                                <td class="cell-center">' . $eachItem->product->unit->unit_name . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->rate, "") . '</td>
                                <td>' . $eachItem->addition_percentage . ' / ' . $eachItem->deduction_percentage . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, "") . '</td>
                            </tr>';
        }
        $additions = '';
        foreach ($model->adItems as $i => $eachItem) {
            if (!empty($eachItem->particular)) {
                $class = $class == "odd" ? "even" : "odd";
                $additions .= '<tr  class="' . $class . '">
                                <td colspan="7" class="cell-right" >' . $eachItem->particular . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
                            </tr>';
            }
        }
        $deductions = '';
        foreach ($model->dedItems as $i => $eachItem) {
            if (!empty($eachItem->particular)) {
                $class = $class == "odd" ? "even" : "odd";
                $deductions .= '<tr  class="' . $class . '">
                                <td colspan="7" class="cell-right" >' . $eachItem->particular . '</td>
                                <td class="cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
                            </tr>';
            }
        }
        $this->renderPartial('//printlayouts/order-single', array(
            'model' => $model,
            'product_items' => $product_items,
            'additions' => $additions,
            'deductions' => $deductions
        ));
    }

    /* ^########################################### Remya's Section ############################################^ */

    public function actionSavecreditnote() {
        if (isset($_POST["Creditnote"])) {
            $from = "C";
            $model = new Creditnote;
            $attributes_main = $_POST["Creditnote"];
            $attributes_items = isset($_POST['CreditnoteItem']) ? $_POST['CreditnoteItem'] : array(0);
            $model->scenario = 'add';
            if ((int) @$attributes_main['id'] > 0)
                $model->scenario = 'update';
            $model->attributes = $attributes_main;
            $model->Iscreditnote_or_goodsreturn = $_POST['Creditnote']['Iscreditnote_or_goodsreturn'] == 'Y' ? 'Y' : 'N';
            $model->crm_user_id = Yii::app()->user->id;
            $valid = true;
            $error = array();
            $other_errors = array();
            $check_total = 0;
            if ($_POST['Creditnote']['Iscreditnote_or_goodsreturn'] == 'Y') {
                foreach ($attributes_items as $i => $item) {
                    $modelItem[$i] = new CreditnoteItem;
                    $modelItem[$i]->attributes = $attributes_items[$i];
                    $valid = $modelItem[$i]->validate() && $valid;
                    $check_total +=$attributes_items[$i]['net_amount'];
                }
                $error2 = json_decode(CActiveForm::validateTabular($modelItem, '', false), true);
                if (isset($_POST['CreditnoteAddition']))
                    foreach ($_POST['CreditnoteAddition'] as $i => $item) {
                        $modelAdditionItem[$i] = new CreditnoteAddition;
                        $modelAdditionItem[$i]->attributes = $_POST['CreditnoteAddition'][$i];
                        $valid = $modelAdditionItem[$i]->validate() && $valid;
                        $check_total += $_POST['CreditnoteAddition'][$i]['calculated_value'];
                    }
                $error3 = json_decode(CActiveForm::validateTabular($modelAdditionItem, '', false), true);

                if (isset($_POST['CreditnoteDeduction']))
                    foreach ($_POST['CreditnoteDeduction'] as $i => $item) {
                        $modelDeductionItem[$i] = new CreditnoteDeduction;
                        $modelDeductionItem[$i]->attributes = $_POST['CreditnoteDeduction'][$i];
                        $valid = $modelDeductionItem[$i]->validate() && $valid;
                        $check_total -= $_POST['CreditnoteDeduction'][$i]['calculated_value'];
                    }

                if ($check_total < 0) {
                    $other_errors[] = "Crediting Value less than zero not possible";
                    $valid = $valid && false;
                }
                $error4 = json_decode(CActiveForm::validateTabular($modelDeductionItem, '', false), true);
                $error = array_merge_recursive($error2, $error3, $error4);
            }
            if ($model->validate() && $valid) { // after validation saving the whole data
                $model->file_id = $this->masterFile($model->file_id, $from, $model->title, isset($model->company_id) ? $model->company_id : 0, isset($model->lead_owner_id) ? $model->lead_owner_id : 0);
                $this->documents($model->file_id, $from);
                if ($_POST['Creditnote']['id'] == 0)// if id 0 means its a new record, otherwise needs to update the existing one
                    $model->save();
                else {
                    $model->id = $_POST['Creditnote']['id'];
                    $model->updateByPK($model->id, $model->attributes);
                    $itemsAlreadySaved = CreditnoteItem::model()->findAll(array('condition' => 'creditnote_id=' . $model->id));
                    foreach ($itemsAlreadySaved as $eachItem) {
                        $warehouse = ProductLocation::model()->with('warehouse')->find(array('condition' => 'stock_id=' . $eachItem->product_id, 'order' => 'warehouse.isBaseWareHouse DESC'));
                        $warehouse->quantity-=$eachItem->returned_quantity;
                        $warehouse->save();
                    }
                    CreditnoteItem::model()->deleteAll('creditnote_id=:id', array(':id' => $model->id));
                    CreditnoteAddition::model()->deleteAll('creditnote_id=:id', array(':id' => $model->id));
                    CreditnoteDeduction::model()->deleteAll('creditnote_id=:id', array(':id' => $model->id));
                }
                $total = 0;
                if ($_POST['Creditnote']['Iscreditnote_or_goodsreturn'] == 'Y') {
                    foreach ($modelItem as $eachItem) {
                        $eachItem->creditnote_id = $model->id;
                        $eachItem->save(false);
                        $total+=$eachItem->net_amount;
                        $warehouse = ProductLocation::model()->with('warehouse')->find(array('condition' => 'stock_id=' . $eachItem->product_id, 'order' => 'warehouse.isBaseWareHouse DESC'));
                        $warehouse->quantity+=$eachItem->returned_quantity;
                        $warehouse->save();
                    }
                    if (isset($_POST['CreditnoteAddition']))
                        foreach ($modelAdditionItem as $eachItem) {
                            $eachItem->creditnote_id = $model->id;
                            $eachItem->save(false);
                            $total += $eachItem->calculated_value;
                        }
                    if (isset($_POST['CreditnoteDeduction']))
                        foreach ($modelDeductionItem as $eachItem) {
                            $eachItem->creditnote_id = $model->id;
                            $eachItem->save(false);
                            $total -= $eachItem->calculated_value;
                        }

                    $model->updateByPk($model->id, array('credited_amount' => $total));
                }
                $jsonData['file'] = $model->file;
                $jsonData['model'] = $model;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                Yii::app()->session['company_id'] = $model->file->company_id;
                Yii::app()->end();
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error, $other_errors));
                if ($error != '[]')
                    echo $error;
            }
        }
    }

    public function actionInvoicedFile() {
        //$this->autocompleteData('Invoice', array('file_id', 'id',), $_GET['term']);
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 'returned.id IS NULL AND t.isActive="Y" AND current_process_status in ("I", "PI","C") AND (	
            file.file_title like "%' . $_GET['term'] . '%" or 
            t.file_id like "%' . $_GET['term'] . '%" or 
            t.id like "%' . $_GET['term'] . '%")';
            $model = Invoice::model()->with('file', 'returned')->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i++]['label'] = $eachModel->file_id . '/' . $eachModel->id;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionGetcreditnote() {
        $jsonData['model'] = Creditnote::model()->findByPK((int) $_POST['id']);
        $jsonData['company'] = $jsonData['model']->file->company;
        $jsonData['salesgroup'] = $jsonData['model']->salesgroup;
        $items = $jsonData['model']->items;
        $jsonData['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Item</th>
            <th>Description</th>
            <th>Qty.(Picked)</th>
            <th>Qty.(Returning)</th>
            <th>Rate</th>
            <th>Amount</th>
        </tr>';
        foreach ($items as $i => $model) {
            $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td>' . CHtml::activeTextField($model, "[$i]product_name", array(
                        'value' => $model->product->part_number,
                        'class' => 'description',
                        'readonly' => true))
                    . CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]description", array(
                        'class' => 'description',
                        'readonly' => true)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]quantity", array(
                        'class' => 'amount-field cell-center',
                        'readonly' => true,)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]returned_quantity", array(
                        'style' => "color:red;",
                        'class' => 'amount-field cell-center',
                        'onkeypress' => 'return isNumberKey(event)',
                        'vlaue' => 0,
                        'onkeyup' => 'this.value=compareValues(event,' . $model->quantity . ',this.value); 
                            calculatecreditnoteamount();')) . '</td>
           <td>' . CHtml::activeTextField($model, "[$i]rate", array(
                        'class' => 'amount-field cell-right',
                        'onkeypress' => 'return isNumberKey(event)',
                        'readonly' => true
                    )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array(
                        'class' => 'amount-field cell-right',
                        'style' => "color:red;",
                        'readonly' => true
                    )) . '</td>            
            </tr>';
        }

        $jsonData['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">' . $jsonData['model']->netAmount . '</h2></td>
        </tr>';
        $jsonData['addition'] = '';
        $modelAddition = new CreditnoteAddition;
        foreach ($jsonData['model']->adItems as $i => $eachAddition) {
            $jsonData['addition'].='<tr><td colspan="10" class="cell-right">Additions '
                    . CHtml::activeTextField($modelAddition, "[$i]particular", array('value' => $eachAddition->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' '
                    . CHtml::activeTextField($modelAddition, "[$i]calculated_value", array(
                        'value' => $eachAddition->calculated_value,
                        'class' => 'value_rate additions_value',
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'this.value=compareValues(event,' . $eachAddition->calculated_value . ',this.value); 
                            calculatecreditnoteamount();'
                    ))
                    . '</td></tr>';
        }
        $jsonData['deduction'] = '';
        $modelDeduction = new CreditnoteDeduction;
        foreach ($jsonData['model']->dedItems as $i => $eachDeduction) {
            $jsonData['deduction'].='<tr><td colspan="10" class="cell-right">Deductions '
                    . CHtml::activeTextField($modelDeduction, "[0]particular", array('value' => $eachDeduction->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' '
                    . CHtml::activeTextField($modelDeduction, "[0]calculated_value", array(
                        'value' => $eachDeduction->calculated_value,
                        'onkeypress' => 'return isNumberKey(event)',
                        'onkeyup' => 'this.value=compareValues(event,' . $eachDeduction->calculated_value . ',this.value); 
                            calculatecreditnoteamount();',
                        'class' => 'value_rate additions_value'))
                    . '</td></tr>';
        }
        $jsonData['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $jsonData['model']->credited_amount . '</h1></td>
        </tr>';
        echo CJSON::encode($jsonData);

        Yii::app()->end();
    }

    public function actionGetInvoiceDetails() {
        if (isset($_POST['invoice_id'])) {
            $jsonData['invoice'] = Invoice::model()->with('items')->findByPK((int) $_POST['invoice_id'], array('order' => 'items.id ASC'));
            $jsonData['company'] = $jsonData['invoice']->file->company;
            $jsonData['salesgroup'] = $jsonData['invoice']->salesgroup;
            $items = $jsonData['invoice']->items;
            $jsonData['model_items'] = '<tr>
            <th>Sl No</th>
            <th>Item</th>
            <th>Description</th>
            <th>Qty.(Picked)</th>
            <th>Qty.(Returning)</th>
            <th>Rate</th>
            <th>Amount</th>
        </tr>';
            foreach ($items as $i => $temp) {
                $model = new CreditnoteItem;
                $model->attributes = $temp->attributes;
                $model->net_amount = $model->returned_quantity = 0;
                $model->rate = round((($temp->quantity > 0) ? ($temp->rate + ($temp->addition_amount / $temp->quantity) - ($temp->deduction_amount / $temp->quantity)) : 0), 2);
                $jsonData['model_items'] .= '
            <tr>
            <td><label>' . ($i + 1) . '</label></td>
            <td class="cell-left">' . $temp->product->part_number . CHtml::activeHiddenField($model, "[$i]product_name", array(
                            'value' => $temp->product->part_number,
                            'class' => 'description',
                            'readonly' => true))
                        . CHtml::activeHiddenField($model, "[$i]product_id") . '</td>
            <td class="cell-left">' . $model->description . CHtml::activeHiddenField($model, "[$i]description", array(
                            'class' => 'description',
                            'readonly' => true)) . '</td>
            <td class="cell-right">' . $model->quantity . CHtml::activeHiddenField($model, "[$i]quantity", array(
                            'class' => 'amount-field cell-right',
                            'readonly' => true,)) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]returned_quantity", array(
                            'style' => "color:red;",
                            'class' => 'amount-field cell-right',
                            'onkeypress' => 'return isNumberKey(event)',
                            'vlaue' => 0,
                            'onkeyup' => 'this.value=compareValues(event,' . $model->quantity . ',this.value); 
                            calculatecreditnoteamount();')) . '</td>
           <td class="cell-right">' . $model->rate . CHtml::activeHiddenField($model, "[$i]rate", array(
                            'class' => 'amount-field cell-right',
                            'onkeypress' => 'return isNumberKey(event)',
                            'readonly' => true
                        )) . '</td>
            <td>' . CHtml::activeTextField($model, "[$i]net_amount", array(
                            'class' => 'amount-field cell-right',
                            'style' => "color:red;",
                            'readonly' => true
                        )) . '</td>            
            </tr>';
            }

            $jsonData['total'] = '<tr>
            <td colspan="7" class="cell-right" ><h2>Total</h2></td>
            <td colspan="4" class="cell-right"><h2 class="total cell-right">0</h2></td>
        </tr>';
            $jsonData['addition'] = '';
            $modelAddition = new CreditnoteAddition;
            foreach ($temp->invoice->adItems as $i => $eachAddition) {
                $eachAddition->particular_value = (!is_numeric($eachAddition->particular_value)) ? $eachAddition->particular_value : $eachAddition->calculated_value;
                $jsonData['addition'].='<tr><td colspan="10" class="cell-right">Additions '
                        . CHtml::activeTextField($modelAddition, "[$i]particular", array('value' => $eachAddition->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' '
                        . CHtml::activeTextField($modelAddition, "[$i]calculated_value", array(
                            'value' => $eachAddition->calculated_value,
                            'class' => 'value_rate additions_value',
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'this.value=compareValues(event,' . $eachAddition->calculated_value . ',this.value); 
                            calculatecreditnoteamount();'
                        ))
                        . '</td></tr>';
            }
            $jsonData['deduction'] = '';
            $modelDeduction = new CreditnoteDeduction;
            foreach ($temp->invoice->dedItems as $i => $eachDeduction) {
                $eachDeduction->particular_value = (!is_numeric($eachDeduction->particular_value)) ? $eachDeduction->particular_value : $eachDeduction->calculated_value;
                $jsonData['deduction'].='<tr><td colspan="10" class="cell-right">Deductions '
                        . CHtml::activeTextField($modelDeduction, "[0]particular", array('value' => $eachDeduction->particular, 'placeholder' => 'Particulars', 'class' => 'paricular')) . ' '
                        . CHtml::activeTextField($modelDeduction, "[0]calculated_value", array(
                            'value' => $eachDeduction->calculated_value,
                            'onkeypress' => 'return isNumberKey(event)',
                            'onkeyup' => 'this.value=compareValues(event,' . $eachDeduction->calculated_value . ',this.value); 
                            calculatecreditnoteamount();',
                            'class' => 'value_rate additions_value'))
                        . '</td></tr>';
            }
            $gd_total = number_format(0, 2, '.', '');
            $jsonData['grand_total'] = '<tr class="summary_tr">
            <td colspan="7" class="cell-right"><h1>Grand Total</h1></td>
            <td colspan="5" class="cell-right"><h1 class="grandtotal cell-right">' . $gd_total . '</h1></td>
        </tr>';
            echo CJSON::encode($jsonData);
        }
    }

    public function actiongetindustry() {
        $this->autocompleteData('MasIndustry', array('name'), $_GET['term'], false, Yii::app()->user->master_user_company_id/* , Yii::app()->user->master_user_branch_id */);
    }

    public function actiongetpaymentterm() {
        $this->autocompletePaymentTerm('MasPaymentTerm', array('payment_code', 'payment_terms'), $_GET['term']);
    }

    public function actionGetfollowups() {
        $jsonData['activities'] = Activity::model()->findByPK((int) $_POST['id']);
        $jsonData['contact_person'] = $jsonData['activities']->contact;
        $jsonData['company'] = Company::model()->findByPk($jsonData['activities']->contact->company_id);
        $jsonData['meeting'] = Meeting::model()->findByPk($jsonData['activities']->id);
        $data = CHtml::listData($jsonData['company']->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        echo CJSON::encode($jsonData);
    }

    public function actionGetAllocatedProducts() {
        $data_array = array();
        if (isset($_GET['term'])) {
            $condition = 't.part_number  LIKE "%' . $_GET['term'] . '%" AND allocatedItems.id>0';
            //$model = AllocatedMaterial::model()->with(product)->findAll(array('condition' => $condition));
            $model = Store::model()->with('allocatedItems')->findAll(array('condition' => $condition));
            $i = 0;
            foreach ($model as $eachModel) {
                $data_array[$i]['value'] = $eachModel->id;
                $data_array[$i]['label'] = $eachModel->part_number;
                $i++;
            }
        }
        echo CJSON::encode($data_array);
        Yii::app()->end();
    }

    public function actionQuotesStatus() {
        /* if (isset($_POST['month_from']) && isset($_POST['month_to'])) 
          {
          Yii::app()->session['month_from']=$_POST['month_from'];
          Yii::app()->session['month_to']=$_POST['month_to'];
          }
          echo CJSON::encode($data_array=array("status"=>"success")); */
        /*
          $data_array = array();
          $data_array_new = array();
          if (isset($_POST['month_from']) && isset($_POST['month_to'])) {
          $users = Quotes::model()->with('file')->findAll(array('condition' => 'qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"', 'group' => 'file.lead_owner_id'));
          foreach ($users as $eachuser) {
          $data['total'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
          $data['order'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status <> "Q" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
          $data['lost'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "L" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
          $data['closed'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "C" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
          $data_array['cats'][] = $eachuser->file->leadowner->first_name;
          }
          } else {
          $users = Quotes::model()->with('file')->findAll(array('group' => 'file.lead_owner_id'));
          foreach ($users as $eachuser) {
          $data['total'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id));
          $data['order'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status <> "Q"'));
          $data['lost'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "L"'));
          $data['closed'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "C"'));
          $data_array['cats'][] = $eachuser->file->leadowner->first_name;
          }
          }
          $modelDashboard = new Dashboard;
          $data_array['x0'] = array('name' => 'Total', 'data' => $data['total'], 'color' => $modelDashboard->randomColor);
          $data_array['x1'] = array('name' => 'Order', 'data' => $data['order'], 'color' => $modelDashboard->randomColor);
          $data_array['x2'] = array('name' => 'Lost', 'data' => $data['lost'], 'color' => $modelDashboard->randomColor);
          $data_array['x3'] = array('name' => 'Closed', 'data' => $data['closed'], 'color' => $modelDashboard->randomColor);
          //$data_array_new['x'] = array($data_array['x0'], $data_array['x1'], $data_array['x2'], $data_array['x3']);
          // $data_array_new['cats'] = $data_array['cats'];
          echo CJSON::encode($data_array); */




        $data_array = array();
        if (isset($_POST['month_from']) && isset($_POST['month_to'])) {
            $users = Quotes::model()->with('file')->findAll(array('condition' => 'qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"', 'group' => 'file.lead_owner_id'));
            foreach ($users as $eachuser) {
                $data['quotation'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
                $data['order'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status <> "Q" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
                $data['lost'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "L" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
                $data['closed'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "C" AND qtn_start_date BETWEEN "' . $_POST['month_from'] . '" AND "' . $_POST['month_to'] . '"'));
                $data_array['cats'][] = $eachuser->file->leadowner->first_name;
            }
        } else {
            $users = Quotes::model()->with('file')->findAll(array('group' => 'file.lead_owner_id'));
            foreach ($users as $eachuser) {
                $data['total'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id));
                $data['order'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status <> "Q"'));
                $data['lost'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "L"'));
                $data['closed'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachuser->file->lead_owner_id . ' AND file.current_process_status = "Q" AND status = "C"'));
                $data_array['cats'][] = $eachuser->file->leadowner->first_name;
            }
        }
        $modelDashboard = new Dashboard;
        $data_array['x0'] = array('name' => 'Quotation', 'data' => $data['quotation'], 'color' => $modelDashboard->randomColor);
        $data_array['x1'] = array('name' => 'Order', 'data' => $data['order'], 'color' => $modelDashboard->randomColor);
        $data_array['x2'] = array('name' => 'Lost', 'data' => $data['lost'], 'color' => $modelDashboard->randomColor);
        $data_array['x3'] = array('name' => 'Closed', 'data' => $data['closed'], 'color' => $modelDashboard->randomColor);
        echo ' <div class="progress_outer" id="quotes-status-graph">' .
        $this->Widget('ext.highcharts.HighchartsWidget', array(
            'options' => array(
                'credits' => array(
                    'enabled' => false
                ),
                'chart' => array(
                    'renderTo' => 'quotes-status-graph',
                    /* 'plotBackgroundColor' => null,
                      'plotBorderWidth' => null,
                      'plotShadow' => false, */
                    'height' => 200,
                    'width' => 200,
                    'type' => 'bar'
                ),
                'xAxis' => array(
                    'title' => array(
                        'enabled' => true
                    ),
                    'categories' => $data_array['cats']
                ),
                'yAxis' => array(array(
                        'title' => array(
                            'enabled' => false
                        ))
                ),
                'plotOptions' => array(
                    'bar' => array(
                        'stacking' => 'normal',
                        'allowPointSelect' => true,
                        'cursor' => 'pointer',
                        'dataLabels' => array(
                            'enabled' => false,
                            'color' => '#000000',
                            'connectorColor' => '#000000',
                            'format' => '<b>{point.name}</b>: {point.percentage:.1f} %'
                        ),
                        'showInLegend' => true,
                        'events' => array(
                            'click' => 'js:function(event) {  
                                    var container   =  "#quotes-status-graph";
                                    chartClickEvent(container,event.point.name);
                                }'
                        ),
                    )
                ),
                'legend' => array(
                    //'align' => 'right',
                    //'x' => 70,
                    //'verticalAlign' => 'bottom',
                    //'y' => 30,
                    //'backgroundColor' => '(Highcharts.theme && Highcharts.theme.legendBackgroundColorSolid) || "white"',
                    //'floating' => true,
                    'itemStyle' => array(
                        'font' => '7pt Lucida',
                        'color' => '#A0A0A0'
                    ),
                    'itemWidth' => 50,
                    'symbolWidth' => 6,
                    'borderColor' => '#CCC',
                    'borderWidth' => 0,
                    'shadow' => false
                ),
                'tooltip' => array(
                    'formatter' => 'js:function() {
                    return \'<b>\'+ this.x +\'</b><br/>\'+
                        this.series.name +\': \'+ this.y +\'<br/>\'+
                        \'Total: \'+ this.point.stackTotal;
                }'),
                'title' => array('text' => ''),
                'series' => array($data_array['x0'], $data_array['x1'], $data_array['x2'], $data_array['x3'])
    ))) .
        '</div>';
    }

}