<?php

class SystemController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Reset', 'Install', 'UpdateInv','RecalcPricicing'),
                'expression' => '$user->isAdmin()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionReset() {
        $tables = array(
            'activity',
            'company_contact',
            'company_type_relation',
            'company',
            'lead',
            'quotes',
            'quotes_item',
            'quotes_deduction',
            'quotes_addition',
            'order',
            'order_item',
            'order_deduction',
            'order_addition',
            'invoice',
            'invoice_item',
            'invoice_addition',
            'invoice_deduction',
            'delivery_item_old',
            'delivery_note',
            'creditnote_item',
            'creditnote',
            'rcpt_of_payment',
            'master_file',
            'document',
            'purchasing_requisition_item',
            'purchasing_requisition',
            'purchasing_enquiry_item',
            'purchasing_enquiry',
            'purchasing_order_item',
            'purchasing_order_deduction',
            'purchasing_order_addition',
            'purchasing_order',
            'purchasing_material_receipt_item',
            'purchasing_material_receipt',
            'purchasinginvoice_item',
            'purchasing_invoice_addition',
            'purchasing_invoice_deduction',
            'purchasinginvoice',
            'paid_invoices',
            'purchasingcredit_item',
            'purchasingcredit',
            'allocated_materials',
            'goods_return_item',
            'goods_return',
            'inventory_transfer',
            'meeting',
            'received_invoices',
            'company_pricing_group',
            'pricing_group',
            'pricing_group_product_relation',
            'store',
            'inventory_items',
            'product_location',
            'form_ho_general',
'form_ho_delivery',
'form_ho_scope',
'form_ho_type',
'form_rfq_general',
'form_rfq_date',
'form_rfq_misc',
'form_rfq_ro',
'form_rfq_type',
'form_rfq_wtd',
'form_rfq_wwtp_stp',
'pre_quotation',
            'product_class',
            'production_order',
            'production_order_item',
            'creditnote_addition',
            'creditnote_deduction',
            'production_billofmaterial',
            'production_billofmaterial_item',
            'production_goods_issue',
            'production_goods_issue_item');

        foreach ($tables as $table) {
            echo 'cleared ' . $table . ' <br/>';
            Yii::app()->db->createCommand('DELETE FROM {{' . $table . '}}')->execute();
        }
        $tables_to_be_autoincremented = array(
            'master_file' => 140500,
            'company' => 1001,
            'lead' => 100001,
            'quotes' => 100001,
            'order' => 200001,
'form_ho_general' => 1025,
'form_rfq_general' => 100001,
'pre_quotation' => 1000001,
            'delivery_note' => 300001,
            'invoice' => 400001,
            'creditnote' => 500001,
            'purchasing_requisition' => 4500001,
            'purchasing_enquiry' => 500001,
            'purchasing_order' => 600001,
            'purchasing_material_receipt' => 700001,
            'purchasinginvoice' => 800001,
            'purchasingcredit' => 900001,
            'production_order' => 1000001,
            'production_billofmaterial' => 1001,
            'production_goods_receipt' => 100001,
            'production_goods_issue' => 100001,
            'inventory_goods_issue' => 100001,
            'inventory_goods_receipt' => 100001,
            'received_invoices' => 100001,
        );
        //$tables = Yii::app()->db->schema->getTableNames();
        //foreach ($tables as $table) {
        //echo $sql = 'ALTER TABLE ' . $table . ' ENGINE = MYISAM';
        //echo '<br/>';
        // Yii::app()->db->createCommand($sql)->execute();

        /* echo $sql = 'ALTER TABLE ' . $table . ' AUTO_INCREMENT = 1;';
          echo '<br/>';
          Yii::app()->db->createCommand($sql)->execute(); */
        //}
        foreach ($tables_to_be_autoincremented as $table => $autoinc) {
            echo $sql = 'ALTER TABLE {{' . $table . '}} AUTO_INCREMENT = ' . $autoinc . ';';
            echo '<br/>';
            Yii::app()->db->createCommand($sql)->execute();
        }
        echo 'success';
    }

    public function customers($csvfile, $customer_type = 1) {
        $customers = $this->readCSV("csvs/" . $csvfile);
        echo "<br/>Saving customers<br/>==============================<br/>";
        $customers = array_slice($customers, 1);
        foreach ($customers as $i => $eachCustomer) {
            $company_name = trim(iconv('UTF-8', 'ASCII//TRANSLIT', $eachCustomer[0]));
            $genral_phno = trim(iconv('UTF-8', 'ASCII//TRANSLIT', $eachCustomer[1]));
            $count = Company::model()->count('company_name="' . $company_name . '" AND genral_phno="' . $genral_phno . '"');
            //print_r($eachCustomer);
            if ($company_name != "" && $count == 0) {
                $industry_name = $eachCustomer[5];
                $industryModel = MasIndustry::model()->find('name="' . trim($industry_name) . '"');
                if ($industryModel == null) {
                    $industryModel = new MasIndustry;
                    $industryModel->name = $industry_name;
                    $industryModel->save(false);
                }
                $industry_id = $industryModel->id;

                $payment_term_code = $eachCustomer[7];
                $paymentModel = MasPaymentTerm::model()->find('payment_code="' . trim($payment_term_code) . '"');
                if ($paymentModel == null) {
                    //nothing now
                }
                $payment_term_id = $paymentModel->id;

                $country_code = $eachCustomer[13];
                $country_model = MasCountry::model()->find('country_code="' . trim($country_code) . '"');
                if ($country_model == null) {
                    //nothing now
                }
                $country_id = $country_model->id;

                $pricing_group_name = $eachCustomer[24];
                $pricegroup_model = PricingGroup::model()->find('pricing_group="' . trim($pricing_group_name) . '"');
                if ($pricegroup_model == null) {
                    //nothing now
                }
                $pricegroup_id = $pricegroup_model->id;

                $model = new Company;
                $model->own_company_id = Yii::app()->user->master_user_company_id;
                $model->own_branch_id = Yii::app()->user->master_user_branch_id;
                $model->crm_user_id = Yii::app()->user->id;

                $model->company_name = $company_name;
                $model->genral_phno = $genral_phno;
                $model->genral_fax = $eachCustomer[2];
                $model->genral_email = $eachCustomer[3];
                $model->genral_web = $eachCustomer[4];
                $model->genral_industry = $industry_id;
                $model->genral_location = $eachCustomer[6];
                $model->genral_payment_term = $payment_term_id;
                $model->genral_latitude = $eachCustomer[8];
                $model->genral_longitude = $eachCustomer[9];
                $model->billing_address = $eachCustomer[10];
                $model->billing_city = $eachCustomer[11];
                $model->billing_state = $eachCustomer[12];
                $model->billing_country = $country_id;
                $model->billing_postalcode = $eachCustomer[14];
                $model->billing_pinzip = $eachCustomer[15];
                $model->bank__name = "";
                $model->bank__branch = $eachCustomer[17];
                $model->bank_account_name = $eachCustomer[18];
                $model->bank_acno = $eachCustomer[19];
                $model->bank_iban = $eachCustomer[20];
                $model->bank__taxid = $eachCustomer[21];
                $model->bank_swift = $eachCustomer[22];
                $model->credit_limit = $eachCustomer[23];
                $model->pricing_group = $pricegroup_id;

                $model->shipping_address = $eachCustomer[26];
                $model->shipping_city = $eachCustomer[27];
                $countryModel = MasCountry::model()->find('country_code="' . trim($eachCustomer[28]) . '"');
                if ($countryModel == null) {
                    //nothing now
                }
                $model->shipping_country = $countryModel->id;
                $model->save(false);
                $model->refresh();

                $modelRelation = new CompanyTypeRelation;
                $modelRelation->company_id = $model->id;
                $modelRelation->type_id = $customer_type;
                $modelRelation->save();
                //die();

                $modelContact = new CompanyContact;
                $modelContact->person_name = 'Sales / Account';
                $modelContact->company_id = $model->id;
                $modelContact->crm_user_id = Yii::app()->user->id;
                $modelContact->save(false);
                echo $i . ")Saved " . $model->company_name . "<br/>";
            }
            else
                echo $i . ")Company name missing/Duplicate Entry<br/>";
        }
    }

    public function inventory($csvfile) {
        $items = $this->readCSV("csvs/" . $csvfile);
        //echo '<pre>';
        //print_r($items[0]);
        echo "<br/>Saving Inventory<br/>==============================<br/>";
        $items = array_slice($items, 1);
        $duplicates = 0;
        $duplicates_info = array();
        foreach ($items as $i => $eachItem) {
            $model = new Store;
            $model->company_id = Yii::app()->user->master_user_company_id;
            $model->company_branch_id = Yii::app()->user->master_user_branch_id;
            $model->crm_user_id = Yii::app()->user->id;
            $part_number = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[0])));
            $generic_name = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[18])));
            $model->part_number = $part_number;
            $rate = floatval(str_replace(',', '', $eachItem[8]));
            $quantity = floatval(str_replace(',', '', $eachItem[17]));
            $tax_code = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[4])));
            $unit = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[3])));
            $country = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[7])));
            //if ($rate != 0 && $quantity != 0) {
            $store = Store::model()->count(array('condition' => 'part_number="' . $part_number . '"'));
            if ($part_number != "" && $store == 0) {
                $model->description = trim(iconv('UTF-8', 'ASCII//TRANSLIT', $eachItem[1]));
                $product_class = trim(iconv('UTF-8', 'ASCII//TRANSLIT', $eachItem[2]));
                $modelProductClass = ProductClass::model()->find('product_class="' . $product_class . '"');
                if ($modelProductClass == null && strlen($product_class) > 0) {
                    $modelProductClass = new ProductClass;
                    $modelProductClass->product_class = $product_class;
                    $modelProductClass->save(false);
                    $modelProductClass->refresh();
                    echo "<br>Found new product class" . $product_class . ", added to the system";
                }
                if ($modelProductClass != null) {
                    $model->product_class_id = $modelProductClass->id;
                    if (empty($unit))
                        $unit = "EA";
                    $modelUnit = Unit::model()->find('symbol="' . $unit . '"');
                    if ($modelUnit == null) {
                        $modelUnit = new Unit;
                        $modelUnit->symbol = $unit;
                        $modelUnit->save(false);
                        $modelUnit->refresh();
                        echo "<br>Found new unit" . $unit . ", added to the system";
                    }
                    $model->unit_id = $modelUnit->id;
                    if (empty($tax_code))
                        $tax_code = 'T0';
                    $modelTax = MasInvTax::model()->find('tax_code="' . $tax_code . '"');
                    $model->tax_code = $modelTax->id;
                    $model->weight = $eachItem[5];
                    $model->volume = $eachItem[6];
                    $modelCountry = MasCountry::model()->find('country_code="' . $country . '"');
                    if ($modelCountry == null) {
                        //nothing now
                    }
                    $model->country = $modelCountry->id;
                    $model->rate = $rate;
                    $model->generic_name = $generic_name;
                    $model->save(false);
                    $model->refresh();
                    echo "<br>" . $i . ": " . trim($part_number) . " - Store data added";

                    $modelIn = new InventoryItems;
                    $modelIn->stock_id = $model->id;
                    $modelIn->re_order_level = $eachItem[9];
                    $modelIn->re_order_lot = $eachItem[10];
                    $modelIn->hsir_code = $eachItem[11];
                    $modelIn->batch_no = $eachItem[12];
                    $modelIn->notes = $eachItem[13];
                    $modelWarehouse = MasInvWarehouse::model()->find('name="' . trim($eachItem[14]) . '"');
                    $modelIn->default_warehouse_id = $modelWarehouse->id;
                    $modelIn->save(false);
                    echo "<br>" . trim($part_number) . " - Inventory details added";

                    $modelLocation = new ProductLocation;
                    $modelLocation->company_branch_id = Yii::app()->user->master_user_branch_id;
                    $modelLocation->stock_id = $model->id;
                    $modelLocation->warehouse_id = $modelWarehouse->id;
                    if (trim($eachItem[15]) != "") {
                        $modelRack = MasInvRack::model()->find('name="' . trim($eachItem[15]) . '"');
                        if ($modelRack == null) {
                            $modelRack = new MasInvRack;
                            $modelRack->name = trim($eachItem[15]);
                            $modelRack->company_id = Yii::app()->user->master_user_company_id;
                            $modelRack->company_branch_id = Yii::app()->user->master_user_branch_id;
                            $modelRack->save(false);
                            $modelRack->refresh();
                        }
                        $modelLocation->rack = $modelRack->id;
                        if (trim($eachItem[16]) != "") {
                            $modelBin = MasInvBin::model()->find('name="' . trim($eachItem[16]) . '" AND rack_id=' . $modelRack->id);
                            if ($modelBin == null) {
                                $modelBin = new MasInvBin;
                                $modelBin->name = trim($eachItem[16]);
                                $modelBin->rack_id = $modelRack->id;
                                $modelBin->company_id = Yii::app()->user->master_user_company_id;
                                $modelBin->company_branch_id = Yii::app()->user->master_user_branch_id;
                                $modelBin->save(false);
                                $modelBin->refresh();
                            }
                        }
                        $modelLocation->bin = $modelBin->id;
                    }

                    $modelLocation->quantity = $quantity;
                    $modelLocation->save(false);
                    echo "<br>" . trim($part_number) . " - Location details added<br/><br/>";
                    PricingGroup::reCalculatePricing($model->id);
                } else {
                    $duplicates++;
                    $duplicates_info[] = "<br><h3>Empty brand/Product class found, avoiding Item:" . $part_number . '</h3>';
                }
            } else {
                if ($eachItem[0] != "") {
                    $duplicates++;
                    $duplicates_info[] = '<h3>Duplicate found on line number ' . ($i + 1) . '. Item:' . $part_number . " - , avoiding!</h3>";
                }
            }
            /* }  else {
              $duplicates_info[] = "<br>Item with rate/quantity value O found, avoiding Item:" . $part_number;
              } */
        }
        echo '<br/>=======================List of duplicates================================<br/>';
        foreach ($duplicates_info as $eachInfo) {
            echo '<br/>' . $eachInfo;
        }
        echo '<br/>Successfully uploaded the inventory. Also Found ' . $duplicates . ' problems too..';
    }

    public function inventoryUpdate($csvfile) {
        $items = $this->readCSV("csvs/" . $csvfile);
        $items = array_slice($items, 1);
        $duplicates_info = array();
        foreach ($items as $i => $eachItem) {
            $part_number = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[0])));
            $model->part_number = $part_number;
            $rate = floatval(str_replace(',', '', $eachItem[8]));
            $store = Store::model()->find(array('condition' => 'part_number="' . $part_number . '"'));
            if ($part_number != "" && count($store) != 0) {
                if ($store->rate == 0) {
                    $store->rate = $rate;
                    $store->save(false);
                    //PricingGroup::reCalculatePricing($model->id);
                    $duplicates_info[] = "Saved Item " . $part_number;
                } else if ($store->rate != $rate) {
                    $duplicates_info[] = "Rate is different for Item " . $part_number;
                }
            }
        }
        echo '<br/>=======================================================<br/>';
        foreach ($duplicates_info as $eachInfo) {
            echo '<br/>' . $eachInfo;
        }
    }

    public function actionInstall() {
        //$this->customers('customer.csv', 1);
        //$this->customers('vendor.csv', 2);
        $this->inventoryUpdate('inventory.csv');
    }
    
    public function actionRecalcPricicing() {
        $stores = Store::model()->findAll();
        foreach ($stores as $i => $eachItem) {
        PricingGroup::reCalculatePricing($model->id);
        }
    }

    public function updateInv($csvfile) {

        $items = $this->readCSV("csvs/" . $csvfile);
        $items = array_slice($items, 1);
        foreach ($items as $i => $eachItem) {
            $part_number = trim(iconv('UTF-8', 'ASCII//TRANSLIT', trim($eachItem[0])));
            $rate = floatval(str_replace(',', '', $eachItem[2]));
            $store = Store::model()->find(array('condition' => 'part_number="' . $part_number . '"'));
            if (count($store) != 0) {
                $store->description = trim(iconv('UTF-8', 'ASCII//TRANSLIT', $eachItem[1]));
                $store->rate = $rate;
                $store->save(false);
                $store->refresh();
                echo "Updated Item " . $part_number . '<br/>';
                PricingGroup::reCalculatePricing($store->id);
            } else {
                echo "Item " . $part_number . ' not found in the system<br/>';
            }
        }
    }

    function actionUpdateInv() {
        $this->updateInv('store.csv', 1);
    }

}