<?php

/**
 * This is the model class for table "{{form_boq_general}}".
 *
 * The followings are the available columns in table '{{form_boq_general}}':
 * @property integer $id
 * @property string $contract_no
 * @property integer $company_id
 * @property string $project_name
 * @property string $plant_capacity
 * @property integer $sales_engr
 * @property string $file_received_date
 * @property string $plant_type
 * @property string $date_of_issue
 * @property integer $revision_no
 * @property integer $prepare_by
 * @property integer $checked_by
 * @property string $revision_date
 */
class FormBoqGeneral extends CActiveRecord
{
    public $company;
    /**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{form_boq_general}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('contract_no, project_name, plant_capacity, sales_engr, file_received_date, plant_type, date_of_issue, revision_no, prepare_by, checked_by, revision_date', 'required'),
			array('form_id,file_id,sales_engr, revision_no, prepare_by, checked_by', 'numerical', 'integerOnly'=>true),
			array('contract_no, project_name, plant_capacity, plant_type', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, contract_no, project_name, plant_capacity, sales_engr, file_received_date, plant_type, date_of_issue, revision_no, prepare_by, checked_by, revision_date', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'contract_no' => 'Contract No',
			
			'project_name' => 'Project Name',
			'plant_capacity' => 'Plant Capacity',
			'sales_engr' => 'Sales Egr',
			'file_received_date' => 'File Received Date',
			'plant_type' => 'Plant Type',
			'date_of_issue' => 'Date Of Issue',
			'revision_no' => 'Revision No',
			'prepare_by' => 'Prepare By',
			'checked_by' => 'Checked By',
			'revision_date' => 'Revision Date',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('contract_no',$this->contract_no,true);
		
		$criteria->compare('project_name',$this->project_name,true);
		$criteria->compare('plant_capacity',$this->plant_capacity,true);
		$criteria->compare('sales_engr',$this->sales_engr);
		$criteria->compare('file_received_date',$this->file_received_date,true);
		$criteria->compare('plant_type',$this->plant_type,true);
		$criteria->compare('date_of_issue',$this->date_of_issue,true);
		$criteria->compare('revision_no',$this->revision_no);
		$criteria->compare('prepare_by',$this->prepare_by);
		$criteria->compare('checked_by',$this->checked_by);
		$criteria->compare('revision_date',$this->revision_date,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return FormBoqGeneral the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
