<?php

/**
 * This is the model class for table "{{pact_department}}".
 *
 * The followings are the available columns in table '{{pact_department}}':
 * @property integer $id
 * @property string $department_name
 * @property string $user_ids
 */
class PactDepartment extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return '{{pact_department}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('department_name, user_ids', 'required'),
            array('department_name', 'length', 'max' => 255),
            array('updated_by,updated_on', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, department_name, user_ids', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'department_name' => 'Department Name',
            'user_ids' => 'User Ids',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('department_name', $this->department_name, true);
        $criteria->compare('user_ids', $this->user_ids, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return PactDepartment the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public function getUsersUnder() {
        $user_ids = unserialize($this->user_ids);
        if (is_array($user_ids)) {
            $user_ids = implode(',', $user_ids);
            $users = User::model()->findAll(array('condition' => 'id in (' . $user_ids . ')'));
            foreach ($users as $eachUser) {
                $u[] = $eachUser->fullname;
            }
            return implode(',', $u);
        }
        return '-';
    }

}
