<div class="rightbox-content-outer graph-container grid-container other-graph" id="leads-to-quotes-graph-container" style='display: none;'>
    <div class="form-title"> 
        Leads to Orders - <?php echo date('Y'); ?>
    </div>
    <div class="progress_outer" id="leads-to-quotes-graph">                  
        <?php
        $data_array = array();
        $modelFiles = MasterFile::model()->with('leadowner')->findAll(array(
            'select' => ' t.lead_owner_id,t.current_process_status',
            'condition' => 't.own_company_id =' . Yii::app()->user->master_user_company_id . ' AND 
                t.own_branch_id=' . Yii::app()->user->master_user_branch_id . ' AND 
                    (start_from="L" OR start_from="Q")',
            'order' => 'leadowner.first_name',
            'group' => 't.lead_owner_id'));

        foreach ($modelFiles as $eachFile) {
            $data['leads'][] = floatval(Lead::model()->with('file')->count('file.lead_owner_id=' . $eachFile->lead_owner_id . ' AND YEAR(enq_date)="' . date('Y') . '"'));
            $data['quotes'][] = floatval(Quotes::model()->with('file')->count('file.lead_owner_id=' . $eachFile->lead_owner_id . ' AND YEAR(qtn_start_date)="' . date('Y') . '"'));
            $data['orders'][] = floatval(Order::model()->with('file')->count('file.lead_owner_id=' . $eachFile->lead_owner_id . ' AND YEAR(order_date)="' . date('Y') . '"'));
            $data_array['cats'][] = $eachFile->leadowner->first_name;
        }
        $modelDashboard = new Dashboard;
        $data_array['x0'] = array('name' => 'Leads', 'data' => $data['leads'], 'color' => $modelDashboard->randomColor);
        $data_array['x1'] = array('name' => 'Quotes', 'data' => $data['quotes'], 'color' => $modelDashboard->randomColor);
        $data_array['x2'] = array('name' => 'Orders', 'data' => $data['orders'], 'color' => $modelDashboard->randomColor);
        $this->Widget('ext.highcharts.HighchartsWidget', array(
            'options' => array(
                'credits' => array(
                    'enabled' => false
                ),
                'chart' => array(
                    'renderTo' => 'leads-to-quotes-graph',
                    /* 'plotBackgroundColor' => null,
                      'plotBorderWidth' => null,
                      'plotShadow' => false, */
                    'height' => 200,
                    'width' => 200,
                    'type' => 'bar'
                ),
                'xAxis' => array(
                    'title' => array(
                        'enabled' => true
                    ),
                    'categories' => $data_array['cats']
                ),
                'yAxis' => array(
                    'stackLabels' => array(
                        'enabled' => true,
                        'style' => array(
                            'fontWeight' => 'bold',
                            'color' => '(Highcharts.theme && Highcharts.theme.textColor) || "gray"'
                        )
                    ),
                    'title' => array(
                        'enabled' => false
                    )
                ),
                'plotOptions' => array(
                    'bar' => array(
                        'stacking' => 'normal',
                        'allowPointSelect' => true,
                        'cursor' => 'pointer',
                        'dataLabels' => array(
                            'enabled' => false,
                            'color' => '#000000',
                            'connectorColor' => '#000000',
                            'format' => '<b>{point.name}</b>: {point.percentage:.1f} %'
                        ),
                        'showInLegend' => true,
                        'events' => array(
                            'click' => 'js:function(event) {  
                                    var container   =  "#leads-to-quotes-graph";
                                    chartClickEvent(container,event.point.name);
                                }'
                        ),
                    )
                ),
                'legend' => array(
                    //'align' => 'right',
                    //'x' => 70,
                    //'verticalAlign' => 'bottom',
                    //'y' => 30,
                    //'backgroundColor' => '(Highcharts.theme && Highcharts.theme.legendBackgroundColorSolid) || "white"',
                    //'floating' => true,
                    'itemStyle' => array(
                        'font' => '7pt Lucida',
                        'color' => '#A0A0A0'
                    ),
                    'itemWidth' => 50,
                    'symbolWidth' => 6,
                    'borderColor' => '#CCC',
                    'borderWidth' => 0,
                    'shadow' => false
                ),
                'tooltip' => array(
                    'formatter' => 'js:function() {
                    return \'<b>\'+ this.x +\'</b><br/>\'+
                        this.series.name +\': \'+ this.y +\'<br/>\'+
                        \'Total: \'+ this.point.stackTotal;
                }'
                ),
                'title' => array('text' => ''),
                'series' => array($data_array['x2'], $data_array['x1'], $data_array['x0'])
        )));
        ?>
    </div>
</div>
<?php
//Yii::app()->getClientScript()->registerScript("leadsToQuotesGraph", "function leadsToQuotesGraph() { jQuery.ajax({ 'type': 'POST', 'dataType':'json', 'url': '" . Yii::app()->createUrl('dashboard/leadsToQuotes') . "', 'success': function(data) { var chart = $('#leads-to-quotes-graph').highcharts(); chart.xAxis[0].setCategories(data.cats); chart.series[0].setData(data.x0); chart.series[1].setData(data.x1); chart.series[2].setData(data.x2); }, }); }", CClientScript::POS_HEAD); ?>