<div class="rightbox-content-outer graph-container grid-container sales-graph" id="order-graph-container" style='display: block;'>
    <div class="form-title"> Orders - <?php echo date('Y'); ?></br> Total- <span class="total_amount"></span></div>
    <div class="progress_outer" id="order-graph">
        <?php        
        $this->Widget('ext.highcharts.HighchartsWidget', array(
            'options' => array(
                'credits' => array(
                    'enabled' => false
                ),
                'chart' => array(
                    'renderTo' => 'order-graph',
                    'plotBackgroundColor' => null,
                    'plotBorderWidth' => null,
                    'plotShadow' => false,
                    'height' => 200,
                    'width' => 200,
                ),
                //'colors' => $colors,
                'plotOptions' => array(
                    'pie' => array(
                        'allowPointSelect' => true,
                        'cursor' => 'pointer',
                        'dataLabels' => array(
                            'enabled' => false,
                            'color' => '#000000',
                            'connectorColor' => '#000000',
                            'format' => '<b>{point.name}</b>: {point.percentage:.1f} %'
                        ),
                        'showInLegend' => false,
                        'events' => array(
                            'click' => ((int) Yii::app()->user->havePermissionOn['dashboard_drilldown_level1_view']) ? 'js:function(event) {  
                                    var month = event.point.id; 
                                    var container   =  "#order-graph";                                    
                                    $.fn.yiiGridView.update("order-drilldown-table", {type: "GET", data: {month: month}, });
                                    chartClickEvent(container,event.point.name);
                                }' :false
                        ),
                    )
                ),
                'tooltip' => array(
                    'shared' => true,
                    'pointFormat' => '<b>{point.y}</b><br/>',
                    'valueSuffix' => '',//put base currency code here
                    'valueDecimals' => 0
                ),
                'title' => array('text' => ''),
                'series' => array(array(
                        'type' => 'pie',
                        'name' => 'Order amount',
                        'data' => array(),
                    ))
        )));
        ?>
    </div>
    <div class="drilldowns">
        <div class="form-title" style="display: none;"> Orders - <?php echo date('Y'); ?> <span class="month"></span> </div>
        <?php
        $model = new Order;
        ((int) Yii::app()->user->havePermissionOn['dashboard_drilldown_level1_view']) ? $this->widget('zii.widgets.grid.CGridView', array(
                            'id' => 'order-drilldown-table',
                            'itemsCssClass' => 'rt cf drilldown-table',
                            'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' :false,
                            'dataProvider' => $model->search(),
                            'selectableRows' => 1, 'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                            'selectionChanged' => ((int) Yii::app()->user->havePermissionOn['dashboard_drilldown_level2_view']) ? 'function(id){ if($.fn.yiiGridView.getSelection(id)!=""){ $("#order-graph-container .order_no").text($.fn.yiiGridView.getSelection(id)); $("#order-graph-container .form-title:eq(2)").show(); $.fn.yiiGridView.update("order-drilldown-items-table", {type: "GET", data: {order_id: $.fn.yiiGridView.getSelection(id) }, }); }}' :'0',
                            'pager' => array(
                                'header' => '',
                                'firstPageLabel' => '&lt;&lt;',
                                'prevPageLabel' => 'Prev',
                                'nextPageLabel' => 'Next',
                                'lastPageLabel' => '&gt;&gt;',
                            ),
                            'columns' => array(
                                array(
                                    'header' => 'File',
                                    'value' => '$data->file->id."/".$data->id',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Company',
                                    'value' => '$data->company->id.":".$data->company->company_name',
                                    'htmlOptions' => array('style' => 'width: 20%;'),
                                ),
                                array(
                                    'header' => 'Value',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total*$data->exchange_rate, "")',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'name' => 'order_date',
                                    'value' => '$data->order_date',
                                    'htmlOptions' => array('style' => 'width: 5%;'),
                                ),
                                array(
                                    'header' => 'Status',
                                    'value' => '$data->file->status',
                                    'htmlOptions' => array('style' => 'width: 5%;'),
                                ),
                            ),
                        )) :false;
        ?>


        <div class="form-title" style="display: none;"> Ordered Items - <span class="order_no"></span> </div>
        <?php
        //invoice items
        $modelOrderItem = new OrderItem;
        ((int) Yii::app()->user->havePermissionOn['dashboard_drilldown_level2_view']) ? $this->widget('zii.widgets.grid.CGridView', array(
                            'id' => 'order-drilldown-items-table',
                            'itemsCssClass' => 'rt cf drilldown-table',
                            'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' :false,
                            'dataProvider' => $modelOrderItem->search(),
                            'selectableRows' => 1,
                            'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                            'pager' => array(
                                'header' => '',
                                'firstPageLabel' => '&lt;&lt;',
                                'prevPageLabel' => 'Prev',
                                'nextPageLabel' => 'Next',
                                'lastPageLabel' => '&gt;&gt;',
                            ),
                            'columns' => array(
                                /*array(
                                    'header' => 'Order No.',
                                    'value' => '$data->order_id',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-center'),
                                ),*/
                                array(
                                    'header' => 'Item',
                                    'value' => '$data->product->part_number',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-center'),
                                ),
                                array(
                                    'header' => 'Quantity',
                                    'value' => 'Yii::app()->format->formatNumber($data->quantity)',
                                    'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-center'),
                                ),
                                array(
                                    'header' => 'Rate',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->rate*$data->order->exchange_rate,"")',
                                    'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Net',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->amount*$data->order->exchange_rate, "")',
                                    'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Addition',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->addition_amount*$data->order->exchange_rate, "")',
                                    'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Deduction',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->deduction_amount*$data->order->exchange_rate, "")',
                                    'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Total',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->net_amount*$data->order->exchange_rate, "")',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-right'),
                                ),
                            ),
                        )) :false;
        ?>
    </div>
</div>
<?php Yii::app()->getClientScript()->registerScript("order-graph", "function loadOrderGraph() { jQuery.ajax({ 'type': 'POST', 'dataType':'json', 'url': '" . Yii::app()->createUrl('dashboard/order') . "', 'success': function(data) { var chart = $('#order-graph').highcharts(); chart.series[0].setData(data.graph_data); $('#order-graph-container .total_amount').text(data.total);  }, }); }", CClientScript::POS_HEAD); ?>
<?php //Yii::app()->getClientScript()->registerScript("repeat".rand(), "setInterval(function(){loadOrderGraph()},50000);", CClientScript::POS_END); ?>