<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("inventoryTramsferFillDetails", '
function inventoryTramsferFillDetails(data)
{
    $(".warning-message").show();
    var message =   data.stock.part_number+":A total of "+data.total_quantity+" items exist in";
    if(data.ware_house_name!=null)
        message =   message+" in "+data.ware_house_name;
    else
        message =   message+" all warehouses";
    message =   message+", A total of "+data.total_allocated_quantity+" items were allocated from all warehouses!"
    $(".warning-message").text(message);
    if(data.total_quantity>0)
        $("#InventoryTransfer_quantity").prop("readonly",false);
    else
        $("#InventoryTransfer_quantity").prop("readonly",true);
}', CClientScript::POS_END);
?>
<div class="popup_inner_element inventory-direct-transfer-form">
    <div class="form-title">
        <div class="form-title-box">
            <span class="warning-message"><a href="#"><i class="icon-warning"></i> </a>
            </span>
        </div>
        <span class="success-message"><a href="#"><i class="icon-right"></i> </a>
            Item transfered
        </span>
    </div>
    <?php
    $form = $this->beginWidget('CActiveForm', array(
        'id' => 'inventory-direct-transfer-form',
        'enableAjaxValidation' => false,
        'enableClientValidation' => false,
    ));
    $model = new InventoryTransfer;
    ?>
    <div class="form-wrap clearfix">
        <div class="forms-outer">
            <div class="box-1">
                <ul class="clearfix">
                    <li>
                        <?php echo $form->labelEx($model, 'stock_id'); ?>
                        <?php echo $form->textField($model, 'store_product_name', array('class' => 'store-product-search')); ?>
                        <?php echo $form->hiddenField($model, 'stock_id'); ?>
                        <?php echo $form->error($model, 'stock_id'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'item_description'); ?>
                        <?php echo $form->textField($model, 'item_description', array('readonly' => 'true')); ?>
                        <?php echo $form->error($model, 'item_description'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'from_warehouse_id'); ?>
                        <?php
                        echo $form->dropDownList($model, 'from_warehouse_id', MasInvWarehouse::getWarehouses(), array(
                            'title' => 'Select warehouse',
                            'class' => 'multiselect',
                            'prompt' => 'Select warehouse',
                            'options' => array()
                        ));
                        ?>
                        <?php echo $form->error($model, 'from_warehouse_id'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'to_warehouse_id'); ?>
                        <?php
                        echo $form->dropDownList($model, 'to_warehouse_id', MasInvWarehouse::getWarehouses(), array(
                            'title' => 'Select warehouse',
                            'class' => 'multiselect',
                            'prompt' => 'Select warehouse',
                            'options' => array()
                        ));
                        ?>
                        <?php echo $form->error($model, 'to_warehouse_id'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'quantity'); ?>
                        <?php echo $form->textField($model, 'quantity', array('readonly' => 'true', 'value' => 0)); ?>
                        <?php echo $form->error($model, 'quantity'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'reference'); ?>
                        <?php echo $form->textField($model, 'reference'); ?>
                        <?php echo $form->error($model, 'reference'); ?>
                    </li>
                    <li>
                        <?php echo $form->labelEx($model, 'description'); ?>
                        <?php echo $form->textArea($model, 'description'); ?>
                        <?php echo $form->error($model, 'description'); ?>
                    </li>
                </ul>
            </div>
        </div>
    </div>
    <?php
    $url = Yii::app()->createUrl('inventory/saveInventoryTransfer');
    echo CHtml::ajaxSubmitButton('Transfer', $url, array(
        'dataType' => 'json',
        'type' => 'post',
        'success' => 'function(data) {
                         $(".inventory-transfer-btn").removeClass("btn_loding").addClass("btn btn-primary");
                         $("#inventory-direct-transfer-form .btn").prop("disabled", false);
                        if(data.status=="success"){
                            $(".inventory-direct-transfer-form .success-message").slideDown();
                            $.fn.yiiGridView.update("inventory_items-table");
                            notification("Inventory Transfer Completed!","success");
                            unloadPopup("inventory-direct-transfer-form");
                         }
                         else
                         {
                            if(data.errorQ!=null)
                                notification(data.errorQ,"error");
                            else
                            $.each(data, function(key, val) {
                               $("#inventory-direct-transfer-form #"+key+"_em_").text(val).show();
                               notification(val,"error");
                            });
                         }
                    }',
        'beforeSend' => 'function(){
                            $("#inventory-direct-transfer-form .btn").prop("disabled", true);
                            $.pnotify_remove_all(); 
                            $(".inventory-transfer-btn").addClass("btn_loding").removeClass("btn btn-primary");

                      }'
            ), array('id' => 'mybtn' . rand(), 'class' => 'inventory-transfer-btn btn btn-primary'));
    ?>
    <?php $this->endWidget(); ?>
</div>
<?php $cs->registerScript("autocomplete-product-search-for-inventory-transfer", "
        $('.store-product-search').autocomplete({
                 minLength   : 1,
                source      : function (request, response) { autoCompleteSource(request, response, '" . Yii::app()->createUrl('site/SearchProduct') . "') },
                focus       :function( event, ui ) {
                    $(this).val( ui.item.label );
                     $('#InventoryTransfer_stock_id').val(ui.item.value);
                    return false; },
                change : function(event,ui){
                    $(this).val((ui.item ? ui.item.label : ''));
                      $('#InventoryTransfer_stock_id').val((ui.item ? ui.item.value : ''));
                },

             select          : function( event, ui ) {
             event.preventDefault();
                            jQuery.ajax({
                    'type': 'post',
                    'data': 'stock_id=' + ui.item.value+'&warehouse_id='+$('#InventoryTransfer_from_warehouse_id').val(),
                    'dataType': 'json',
                    'url': '" . Yii::app()->createUrl('inventory/storeData') . "',
                    'cache': false,
                    'success': function(data) {
                     $('#InventoryTransfer_store_product_name').val(ui.item.label);
                     $('#InventoryTransfer_stock_id').val(ui.item.value);
                     inventoryTramsferFillDetails(data);
                     $('#InventoryTransfer_item_description').val(data.stock.description);
                    }
                    });

             }
        });
    ", CClientScript::POS_READY); ?>
<?php /* $cs->registerScript("autocomplete-from-warehouse-search", "
  $('.from-warehouse-search').autocomplete({
  minLength   : 1,
  source: function (request, response) {
  $.ajax({
  type: 'GET',
  data: {
  term : request.term,
  product_id : $('#InventoryTransfer_stock_id').val()
  },
  url: '" . Yii::app()->createUrl('inventory/getwarehousefortransfer') . "',
  dataType: 'json',
  'success': function(data) {
  response($.map( data, function( n, i ) {
  return {
  label :  n.label,
  value : n.value,
  }
  }));
  }
  });
  },
  focus       :function( event, ui ) {
  $(this).val( ui.item.label );
  $('#InventoryTransfer_from_warehouse_id').val(ui.item.value);
  return false;
  },
  change : function(event,ui){
  $(this).val((ui.item ? ui.item.label : ''));
  $('#InventoryTransfer_from_warehouse_id').val((ui.item ? ui.item.value : ''));
  },
  select          : function( event, ui ) {
  event.preventDefault();
  jQuery.ajax({
  'type': 'post',
  'data': 'stock_id=' + $('#InventoryTransfer_stock_id').val()+'&warehouse_id='+ui.item.value,
  'dataType': 'json',
  'url': '" . CController::createUrl('inventory/storeData') . "',
  'cache': false,
  'success':function(data){
  $('#InventoryTransfer_from_warehouse_name').val(ui.item.label);
  $('#InventoryTransfer_from_warehouse_id').val(ui.item.value);
  inventoryTramsferFillDetails(data);
  }
  });

  }
  });
  ", CClientScript::POS_READY); */ ?>
<?php /*

  $cs->registerScript("autocomplete-to-warehouse-search", "
  $('.to-warehouse-search').autocomplete({
  minLength   : 1,
  source: function (request, response) {
  $.ajax({
  type: 'GET',
  data: {
  term : request.term,
  product_id : $('#InventoryTransfer_stock_id').val()
  },
  url: '" . Yii::app()->createUrl('inventory/getwarehousefortransfer') . "',
  dataType: 'json',
  'success': function(data) {
  response($.map( data, function( n, i ) {
  return {
  label :  n.label,
  value : n.value,
  }
  }));
  }
  });
  },
  focus       :function( event, ui ) {
  $(this).val( ui.item.label );
  $('#InventoryTransfer_to_warehouse_id').val(ui.item.value);
  return false;
  },
  change : function(event,ui){
  $(this).val((ui.item ? ui.item.label : ''));
  $('#InventoryTransfer_to_warehouse_id').val((ui.item ? ui.item.value : ''));
  },
  select          : function( event, ui ) {
  event.preventDefault();
  $('#InventoryTransfer_to_warehouse_name').val(ui.item.label);
  $('#InventoryTransfer_to_warehouse_id').val(ui.item.value);
  }
  });
  ", CClientScript::POS_READY); */ ?>

<?php /* $cs->registerScript("autocomplete-warehouse-bin-search", "
  $('.bin-search').autocomplete({
  minLength   : 1,
  source      : function (request, response) { autoCompleteSource(request, response,'" . Yii::app()->createUrl('inventory/getbin') . "') },
  focus       :function( event, ui ) {
  $(this).val( ui.item.label );
  $('#InventoryTransfer_to_bin_id').val(ui.item.value);
  return false;
  },
  change : function(event,ui){
  $(this).val((ui.item ? ui.item.label : ''));
  $('#InventoryTransfer_to_bin_id').val((ui.item ? ui.item.value : ''));
  },
  select          : function( event, ui ) {
  event.preventDefault();
  $('#InventoryTransfer_to_bin_name').val(ui.item.label);
  $('#InventoryTransfer_to_bin_id').val(ui.item.value);
  }
  });
  ", CClientScript::POS_READY);
  $cs->registerScript("autocomplete-warehouse-rack-search", "
  $('.rack-search').autocomplete({
  minLength   : 1,
  source      : function (request, response) { autoCompleteSource(request, response,'" . Yii::app()->createUrl('inventory/getrack') . "') },
  focus       :function( event, ui ) {
  $(this).val( ui.item.label );
  $('#InventoryTransfer_to_rack_id').val(ui.item.value);
  return false;
  },
  change : function(event,ui){
  $(this).val((ui.item ? ui.item.label : ''));
  $('#InventoryTransfer_to_rack_id').val((ui.item ? ui.item.value : ''));
  },
  select          : function( event, ui ) {
  event.preventDefault();
  $('#InventoryTransfer_to_rack_name').val(ui.item.label);
  $('#InventoryTransfer_to_rack_id').val(ui.item.value);
  }
  });
  ", CClientScript::POS_READY); */
?>