<div class="form-wrap clearfix">
    <div class="forms-outer">
        <div class="box-1">
            <?php
            $model_location = new ProductLocation;
            $this->widget('zii.widgets.grid.CGridView', array(
                'id' => 'product-warehouse-relation-table',
                'itemsCssClass' => 'rt cf product-warehouse-relation-table',
                'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
                'dataProvider' => $model_location->search(),
                'selectableRows' => 1,
                'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                'pager' => array(
                    'header' => '',
                    'firstPageLabel' => '&lt;&lt;',
                    'prevPageLabel' => 'Prev',
                    'nextPageLabel' => 'Next',
                    'lastPageLabel' => '&gt;&gt;',
                ),
                'columns' => array(
                    array(
                        'header' => 'Sl.No.',
                        'value' => '$this->grid->dataProvider->pagination->currentPage * $this->grid->dataProvider->pagination->pageSize + ($row+1)',
                        'htmlOptions' => array('width' => '5%'),
                    ),
                    array(
                        'header' => 'Warehouse',
                        'value' => '$data->warehouse->name',
                        'htmlOptions' => array('style' => 'width: 30%; cell-left'),
                    ),
                    array(
                        'header' => 'Rack',
                        'value' => '$data->rack0->name',
                        'htmlOptions' => array('style' => 'width: 20%;'),
                    ),
                    array(
                        'header' => 'Bin',
                        'value' => '$data->bin0->name',
                        'htmlOptions' => array('style' => 'width: 20%;'),
                    ),
                    array(
                        'header' => 'Quantity',
                        'value' => '$data->quantity',
                        'htmlOptions' => array('style' => 'width: 10%;','class'=>'cell-right'),
                    ),
                    array
                        (
                        'class' => 'CButtonColumn',
                        'header' => CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:;', array('class' => 'btn btn-mini',
                            'onclick' => '$(".location-elements").not("#ProductLocation_stock_id").val("");',
                            'title' => 'Add New')),
                        'template' => '{edit}',
                        'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-center'),
                        'deleteButtonImageUrl' => false,
                        'afterDelete' => 'function(link,success,data){ if(data=="fail") alert("Cannot delete, Quantity is not empty"); }',
                        'buttons' => array
                            (
                            /*'delete' => array
                                (
                                'label' => '<i class="icon-trash"></i>',
                                'url' => 'Yii::app()->createUrl("master/deleteLocationData", array("id"=>$data->id))',
                            ),*/
                            'edit' => array
                                (
                                'label' => '<i class="icon-edit"></i>',
                                'click' => 'function(){
                                    $( ".save-location-btn").show();
                                    var location_id  =   $(this).parents(":eq(1)").attr("id")
                                    jQuery.ajax({
                                        "type": "POST",
                                        "dataType":"json",
                                        "url": "' . Yii::app()->createUrl("inventory/getlocationdetails") . '",
                                        "success": function(data) { 
                                        $("#ProductLocation_warehouse_name").val(data.warehouse.name);
                                        $("#ProductLocation_rack_name").val(data.rack.name);
                                        $("#ProductLocation_bin_name").val(data.bin.name);
                                        
                                        $.each(data.location, function(key, val) { $("#inventory-form #ProductLocation_"+key).val(val); }); },
                                    "data": { "id": location_id, },
                                    "cache": false
                                    }); }
                                    ',
                            ),
                        ),
                    ),
                ),
            ));
            ?>
            <ul class="clearfix location-data-collection">
                <li>
                    <?php echo $form->labelEx($model, 'warehouse_id'); ?>                   
                    <?php echo $form->textField($model, 'warehouse_name', array('class' => 'warehouse-search location-elements')); ?>
                    <?php echo $form->hiddenField($model, 'warehouse_id', array('class' => 'location-elements')); ?>
                    <?php echo $form->error($model, 'warehouse_id'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'rack'); ?> 
                    <?php echo $form->textField($model, 'rack_name', array('class' => 'rack-search-warehouse location-elements')); ?>
                    <?php echo $form->hiddenField($model, 'rack', array('class' => 'location-elements')); ?>
                    <?php echo $form->error($model, 'rack'); ?>
                </li>
                <li>
                    <?php echo $form->hiddenField($model, 'id', array('class' => 'location-elements')); ?>
                    <?php echo $form->hiddenField($model, 'stock_id', array('class' => 'location-elements')); ?>
                    <?php echo $form->labelEx($model, 'bin'); ?> 
                    <?php echo $form->textField($model, 'bin_name', array('class' => 'bin-search-warehouse location-elements')); ?>                
                    <?php echo $form->hiddenField($model, 'bin', array('class' => 'location-elements')); ?> 
                    <?php echo $form->error($model, 'bin'); ?>
                </li>
                <li>
                    <?php echo $form->labelEx($model, 'total_value'); ?>
                    <?php //echo $form->textField($model, 'total_value', array('readonly'=>true, 'class' => 'location-elements cell-right','onkeypress'=>'return isNumberKey(event)','onblur'=>'rateFinder(this.value)')); ?>
                    <?php echo CHtml::label($model->total_value > 0 ? $model->total_value : 0.00, '', array('class' => 'total_value textlabel')); ?>
                    <?php echo $form->error($model, 'total_value'); ?>
                </li>

            </ul>            
        </div>
    </div>
</div>
<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("autocomplete-warehouse-search", "
        $('.warehouse-search').autocomplete({
                minLength   : 1,
                source      : function (request, response) { autoCompleteSource(request, response,'" . Yii::app()->createUrl('inventory/getwarehouse') . "') },
                focus       :function( event, ui ) {
                    $(this).val( ui.item.label );
                    $('#ProductLocation_warehouse_id').val(ui.item.value);
                    return false;
            },
            change : function(event,ui){
                $(this).val((ui.item ? ui.item.label : ''));
                $('#ProductLocation_warehouse_id').val((ui.item ? ui.item.value : ''));
            },
             select          : function( event, ui ) {
             event.preventDefault();
              $('#InventoryTransfer_warehouse_name').val(ui.item.label);
             $('#ProductLocation_warehouse_id').val(ui.item.value);
             }
        });
    ", CClientScript::POS_READY);
$cs->registerScript("autocomplete--bin-search", "
        $('.bin-search-warehouse').autocomplete({
                minLength   : 1,
              source: function (request, response) {  
              $.ajax({
                type: 'GET',              
                data: {
                   term : request.term,
                   rack_id : $('#ProductLocation_rack').val()
                },
                url: '" . Yii::app()->createUrl('inventory/getbinbyrackwise') . "',
                dataType: 'json',
                'success': function(data) {
               response($.map( data, function( n, i ) {                     
                return {                  
                   label :  n.label,
                    value : n.value,
                }
            }));
                }
            });
        }, 
            focus       :function( event, ui ) {
                    $(this).val( ui.item.label );
                    $('#ProductLocation_bin').val(ui.item.value);
                    return false;
            },
            change : function(event,ui){
                $(this).val((ui.item ? ui.item.label : ''));
                $('#ProductLocation_bin').val((ui.item ? ui.item.value : ''));
            },
             select          : function( event, ui ) {
             event.preventDefault();
              $('#InventoryTransfer_bin_name').val(ui.item.label);
             $('#ProductLocation_bin').val(ui.item.value);
             }
        });
    ", CClientScript::POS_READY);
$cs->registerScript("autocomplete--rack-search", "
        $('.rack-search-warehouse').autocomplete({
                minLength   : 1,
                source      : function (request, response) { autoCompleteSource(request, response,'" . Yii::app()->createUrl('inventory/getrack') . "') },
                focus       :function( event, ui ) {
                    $(this).val( ui.item.label );
                    $('#ProductLocation_rack').val(ui.item.value);
                    return false;
            },
            change : function(event,ui){
                $(this).val((ui.item ? ui.item.label : ''));
                $('#ProductLocation_rack').val((ui.item ? ui.item.value : ''));
            },
             select          : function( event, ui ) {
             event.preventDefault();
              $('#InventoryTransfer_rack_name').val(ui.item.label);
             $('#ProductLocation_rack').val(ui.item.value);
             }
        });
    ", CClientScript::POS_READY);
?>