<?php
$model = new PriceGroupProductRelation();
$modelpriceGroup = new MasPricingGroup();
?>
<div class="popup_inner_element price-list-form">  
    <div class="form-title">
        <div class="form-title-box">Price List</div>
        <span class="success-message"><a href="#"><i class="icon-right"></i> </a>
            Price list updated
        </span>
    </div>
    <div class="form-wrap clearfix">
        <?php
        $this->widget('zii.widgets.grid.CGridView', array(
            'id' => 'price-list-table',
            'itemsCssClass' => 'rt cf price-list-table',
            'template' => '{items}{pager}',
            'dataProvider' => $modelpriceGroup->search(),
            'selectableRows' => 1,
            'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
            'pager' => array(
                'header' => '',
                'firstPageLabel' => '&lt;&lt;',
                'prevPageLabel' => 'Prev',
                'nextPageLabel' => 'Next',
                'lastPageLabel' => '&gt;&gt;',
            ),
            'columns' => array(
                array(
                    'header' => 'Price Group',
                    'value' => '$data->pricing_group',
                    'htmlOptions' => array('style' => 'width: 20%;'),
                ),
                array(
                    'header' => 'Description',
                    'value' => '$data->description',
                    'htmlOptions' => array('style' => 'width: 20%;'),
                ),
                array(
                    'header' => 'Products',
                    'value' => 'count($data->products)."nos"',
                    'htmlOptions' => array('style' => 'width: 20%;'),
                ),
                array(
                    'class' => 'CButtonColumn',
                    'template' => '{export}',
                    'buttons' => array
                        (
                        'export' => array
                            (
                            'label' => 'Export to CSV',
                            'imageUrl' => Yii::app()->request->baseUrl . '/images/export.png',
                            'url' => 'Yii::app()->createUrl("site/exportPriceList", array("id"=>$data->id))',
                        ),
                    ),
                    'htmlOptions' => array('style' => 'width: 5%;'),
                ),
        )));
        ?>
        <div class="forms-outer">
            <div class="box-1">
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'price-list-form',
                    'enableAjaxValidation' => false,
                    'enableClientValidation' => true,
                ));
                ?>
                <ul class="clearfix">                                 

                    <li>  <?php echo $form->labelEx($model, 'price_list_file_name'); ?> 
                        <?php
                        $allowedExtensions = array("csv");
                        $this->widget('ext.EAjaxUpload.EAjaxUpload', array(
                            'id' => rand(),
                            'config' => array(
                                'action' => Yii::app()->createUrl(Yii::app()->controller->id . '/upload', array('folder' => 'pricelistfiles')),
                                'multiple' => false,
                                'allowedExtensions' => $allowedExtensions,
                                'sizeLimit' => 1 * 1024 * 1024,
                                'onStart' => "js:function(){}",
                                'onComplete' => "js:function(id, fileName, responseJSON){
                                $('#PriceGroupProductRelation_price_list_file_name').val(responseJSON.filename);
                                $('.qq-upload-list').children().empty(); }",
                            )
                        ));
                        ?>                    
                        <?php echo $form->hiddenField($model, 'price_list_file_name'); ?>
                        <?php echo $form->error($model, 'price_list_file_name'); ?>
                    </li>

                </ul>
                <div class="btn-wrap">                    
                    <?php
                    $url = Yii::app()->createUrl('master/PriceList');
                    echo CHtml::ajaxSubmitButton('Save', $url, array(
                        'dataType' => 'json',
                        'type' => 'post',
                        'success' => 'function(data) {
                         $(".price-list-add-btn").removeClass("btn_loding").addClass("btn_style");
                        if(data.status != ""){
                           resetForm("price-list-form"); 
                           $.fn.yiiGridView.update("price-list-table");
                           notification(data.status,"success");
                         }
                         else{
                            notification("No items are added","error");
                         }
                         if(data.errors!="")
                            notification(data.errors,"error");
                    }',
                        'beforeSend' => 'function(){  
                            $(".price-list-add-btn").addClass("btn_loding").removeClass("btn_style");
                      }'
                            ), array('id' => 'mybtn' . rand(), 'class' => 'price-list-add-btn btn_style'));
                    ?>
                    <div class="clear"></div>
                </div>
                <?php $this->endWidget(); ?>
            </div>
        </div>
    </div>
</div>