<div class="formsbox grid-container" id="sales-history-grid-container">
    <div class="form-title">
        <div class="form-title-box">Sales History</div>
        <div class="search-outer">
            <div class="input-append">
                <?php echo CHtml::textField('search' . rand(), '', array("onkeyup" => "$.fn.yiiGridView.update('sales-history-table', {type: 'POST', data: {search: this.value}});", "class" => "search-query", "placeholder" => "Search by Part no,generic name,description etc.,")); ?>                
            </div>
        </div>  
    </div>
    <div class="form-wrap clearfix">
        <div class="forms-outer">
            <div class="box-1">
                <?php
                $this->widget('zii.widgets.grid.CGridView', array(
                    'id' => 'sales-history-table',
                    'itemsCssClass' => 'rt cf sales-history-table',
                    'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
                    'dataProvider' => $model->salesHistory(),
                    'selectableRows' => 1,
                    'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                    'pager' => array(
                        'header' => '',
                        'firstPageLabel' => '&lt;&lt;',
                        'prevPageLabel' => 'Prev',
                        'nextPageLabel' => 'Next',
                        'lastPageLabel' => '&gt;&gt;',
                    ),
                    'columns' => array(
                        array(
                            'header' => 'No.',
                            'value' => '$this->grid->dataProvider->pagination->currentPage * $this->grid->dataProvider->pagination->pageSize + ($row+1)',
                            'htmlOptions' => array('width' => '1%', 'class' => 'cell-center'),
                        ),
                        array(
                            'header' => 'Part No',
                            'value' => '$data->part_number',
                            'htmlOptions' => array('style' => 'width: 10%;'),
                        ),
                        /* array(
                          'header' => 'Generic Name',
                          'value' => '$data->generic_name',
                          'htmlOptions' => array('style' => 'width: 30%;'),
                          ), */
                        array(
                            'header' => 'Description',
                            'value' => 'substr($data->description,0,50).".."',
                            'htmlOptions' => array('style' => 'width: 30%;'),
                        ),
                        array(
                            'header' => 'Ord.Qty',
                            'value' => array($model, 'renderOrderedQuantity'),
                            'htmlOptions' => array('width' => '2%', 'class' => 'cell-right'),
                        ),
                        array(
                            'header' => 'Dlvd.Qty',
                            'value' => array($model, 'renderDeliveredQuantity'),
                            'htmlOptions' => array('width' => '2%', 'class' => 'cell-right'),
                        ),
                        array(
                            'header' => 'Inv.Qty',
                            'value' => array($model, 'renderInvoicedQuantity'),
                            'htmlOptions' => array('width' => '2%', 'class' => 'cell-right'),
                        ),
                    ),
                ));
                ?>                
            </div>
        </div>
    </div>
</div>
<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("load-sales-history", "        
    $(document).on('click', '.sales-history-table tr', function( e ) {
    var part_no = $(this).closest('tr').find('td:eq(1)').text(); 
    $( '.sales-history-part-no').text(part_no);
        var store_id = $(this).attr('id');  
          $('#sales_history_product_id').val(store_id);
         $.fn.yiiGridView.update('sales-history-single-product-table', {complete: function(jqXHR, status) { adjustPopup(); },type: 'POST', data: { product_id: store_id}, });
         $('#sales_history_start_date,#sales_history_end_date').val('');
           openPopup('sales_history_form');
    });
    ", CClientScript::POS_END);
?>