<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <title>Quotations Report</title>
        <style type="text/css">
            body {
                margin: 0;
                padding: 0;
                background-color: #FAFAFA;
                font-family:tahoma;
            }
            * {
                box-sizing: border-box;
                -moz-box-sizing: border-box;
            }
            .page {
                width: 20cm;
                height: 28cm;
                padding: 1cm;
                margin: 0 auto;
                border: 1px #D3D3D3 solid;
                background: white;
                box-shadow: 0 0 5px rgba(0, 0, 0, 0.1);
            }
            .wrapper{
                width:100%;
                float:left;
            }
            .header{
                width:100%;
                float:left;
            } 
            .logo{
                width:30%;
                min-height:70px;
                float:left;	
            }
            .header-title{
                width:40%;
                float:left;
                min-height:50px;
                text-align:center;
                font-size:20px;
                text-align:center;
                line-height:20px;
                color:#000;
                vertical-align:middle;
                padding-top:20px;
            }
            .header-right{
                width:30%;
                float:right;
                min-height:70px;
            }
            .header-top, .header-bottom{
                width:100%;
                float:left;	
                color:#0e4194;
                font-size:13px;
            }
            .header .left{
                width:50%;
                float:left;
                text-align:left;
                padding:5px 0px;
            }
            .header .right{
                width:50%;
                float:right;
                text-align:right;
                padding:5px 0px;
            }
            .footer{
                width:100%;
                float:left;
                color:#0e4194;
                font-size:12px;
            }
            .footer .left{
                width:65%;
                float:left;
                text-align:left;
                padding:5px 0px;
            }
            .footer .right{
                width:35%;
                float:right;
                text-align:right;
                padding:5px 0px;
            }	
            .content{
                width:100%;
                float:left;
                padding:5px 0px;
            }
            .table_grid
            {
                font-family:"Trebuchet MS", Arial, Helvetica, sans-serif;
                width:100%;
                margin-left:auto;
                margin-right:auto;
                border-collapse:collapse;
                text-align:center
            }
            .table_grid td, .table_grid th 
            {
                font-size:11px;
                border:1px solid #dfdfdf;
                padding:2px 5px;
            }
            .table_grid th 
            {
                font-size:12px;
                text-align:center;
                padding:2px 0px;
                background:#999;
                color:#fff;
                border:1px solid #dfdfdf;
            }
            .table_grid tr.even td 
            {
                color:#000;
                background-color:#f5f5f5;
            }
            @page {
                size: A4;
                margin: 0;
            }
            @media print {
                .page {
                    margin: 0;
                    border: initial;
                    border-radius: initial;
                    width: initial;
                    min-height: initial;
                    box-shadow: initial;
                    background: initial;
                    page-break-after: always;
                    background:red;
                    height:20px;
                }
                .table_grid td:first-child {-webkit-print-color-adjust:exact; }

                .table_grid th {-webkit-print-color-adjust:exact;}
                .table_grid tr.even td  {-webkit-print-color-adjust:exact;}
            }
        </style>
    </head>
    <?php $baseCur = MasCurrency::model()->find("isBaseCurrency=:isBaseCurrency", array(':isBaseCurrency' => 'Y')); ?>
    <body onload="window.print();">
        <div class="book">
            <div class="page">
                <div class="wrapper">
                    <div class="header">
                        <div class="header-top">
                            <div class="logo">
                                <?php echo CHtml::image(Yii::app()->baseUrl . '/images/logo/100100_' . Yii::app()->user->company_logo); ?>
                            </div>
                            <div class="header-title"> List of Quotations  </div>
                            <div class="header-right">   </div>
                        </div>
                        <div class="header-bottom">
                            <div class="left"> From 31/10/2013  To 20/11/2013 </div>
                            <div class="right"> Mr. Dabison K. R., Sales Representative </div>
                        </div>
                    </div>
                    <div class="content">
                        <?php
                        $this->widget('zii.widgets.grid.CGridView', array(
                            'id' => 'quotations-print-table',
                            'itemsCssClass' => 'table_grid',
                            'template' => '{items}{pager}',
                            'dataProvider' => $model->printOut(),
                            'pager' => array(
                                'header' => '',
                                'firstPageLabel' => '&lt;&lt;',
                                'prevPageLabel' => 'Prev',
                                'nextPageLabel' => 'Next',
                                'lastPageLabel' => '&gt;&gt;',
                            ),
                            'columns' => array(
                                array(
                                    'header' => 'File No.',
                                    'value' => '$data->file->id',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Comp. ID',
                                    'value' => '$data->company_id',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Comp. Name',
                                    'value' => '$data->company->company_name',
                                    'htmlOptions' => array('style' => 'width: 30%;'),
                                ),
                                array(
                                    'header' => 'Qtn Dt',
                                    'value' => 'date("Y-m-d",strtotime($data->qtn_date))',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Cls Dt',
                                    'value' => '$data->qtn_close_date',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Currency',
                                    'value' => '$data->currency0->currency',
                                    'htmlOptions' => array('style' => 'width: 20%;'),
                                ),
                                array(
                                    'header' => 'Value',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total, $data->currency0->currency_code)',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Value In local Currency',
                                    'value' => 'Yii::app()->numberFormatter->formatCurrency(($data->grand_total*$data->currency0->exchange_rate),"INR")',
                                    'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-right'),
                                ),
                                array(
                                    'header' => 'Sales Grp',
                                    'value' => '$data->sales_group',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                                array(
                                    'header' => 'Probability',
                                    'value' => '$data->probability',
                                    'htmlOptions' => array('style' => 'width: 10%;'),
                                ),
                            ),
                        ));
                        ?>
                    </div>
                    <div class="footer">
                        <div class="left"> Copyright &copy; <?php echo date('Y'); ?> MasterMind | Powered by Cumulus Softwares Pvt. Ltd. </div>
                        <!--<div class="right"> List of quotations | Page1/2 </div>-->
                    </div>
                </div>
            </div>
        </div>
    </body>
</html>