<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("checkProfit", " function checkProfit(model,id,refresh_table_id) { 
       openPopup('profit-calculation-form');
       getFile_slash_ids('#profit_calculation_form #file_slash_id');
       jQuery.ajax({ 
            'type': 'POST', 
            'dataType': 'json', 
            'url': '" . Yii::app()->createUrl('ajax/getFile') . "', 
            'data':{'id':id,'model':model },
            'success': function(data) {  $.fn.yiiGridView.update(refresh_table_id);  }
       });
    }", CClientScript::POS_END);
?>
<div class="formsbox grid-container " id="quotations-grid-container">        
    <div class="form-title">
        <div class="form-title-box">Quotations <?php echo $this->getCompanyNameIfSessionSet(); ?> 
            <?php echo CHtml::link('<i class="icon-load-all"></i>', 'javascript:;', array('class' => 'btn btn-mini load-all', 'title' => 'Load all Quotations')); ?>
        </div>
        <?php if ((int) Yii::app()->user->havePermissionOn['sop_quote_add_edit'] || (int) Yii::app()->user->havePermissionOn['sop_quote_view'] || (int) Yii::app()->user->havePermissionOn['sop_order_add_edit'] || (int) Yii::app()->user->havePermissionOn['sop_quote_print']): ?>
            <div class="btns_wrap quotation-grid-buttons">            
                <?php
                echo ((int) Yii::app()->user->havePermissionOn['sop_quote_add_edit']) ?
                        CHtml::ajaxLink('<i class="icon-plus-sign"></i>', Yii::app()->createUrl('sop/quotation'), array(
                            'beforeSend' => 'js:function(xhr,opts){ showProgress(); $("#ajax_content").find(".quotes_form").remove(); }',
                            'success' => 'js:function(data){ hideProgress(); $("#ajax_content").append(data); openPopup("quotes_form"); } '), array(
                            'id' => 'form-' . uniqid(),
                            'title' => 'RFQ',
                            'class' => 'ajaxlink btn btn-mini'
                                )
                        ) : '';
                ?>
                <?php
                $headerbuttons = CHtml::link('<i class=" icon-shopping-cart"></i>', 'javascript:;', array(
                            'class' => 'show-after-select btn btn-mini missing-list-all',
                            'onclick' => 'missingitems(0,"Quotes");',
                            'title' => 'List of all materials that needs to be ordered against all quotations',));
                ?>
                <?php
                /* $headerbuttons .= ((int) Yii::app()->user->havePermissionOn['sop_quote_print']) ?
                  CHtml::link('<i class="icon-print"></i>', 'javascript:;', array('class' => 'btn btn-mini',
                  'onclick' => 'exportfunction($("#quotations-grid-container .search-query").val(),"Quotes","pdf.sopquotes-list");',
                  'title' => 'Print list')) : ''; */
                ?>
            </div>
        <?php endif; ?>
        <div class="search-outer">
            <div class="input-append">
                <?php
                echo CHtml::textField('search' . rand(), '', array(
                    "onkeyup" => "$.fn.yiiGridView.update('quotation-table', {type: 'GET', data: {quote_search: this.value}});",
                    "class" => "search-query", "placeholder" => "Search by Title,Lead owner,File/Qtn no etc.,"));
                ?>                                
            </div>
        </div>
    </div>
    <div class="form-wrap clearfix">
        <div class="forms-outer">
            <div class="box-1">                
                <?php
                $this->widget('zii.widgets.grid.CGridView', array(
                    'id' => 'quotation-table',
                    'rowCssClassExpression' => '$data->color',
                    'itemsCssClass' => 'rt cf quotation-table',
                    'template' => Yii::app()->request->getIsAjaxRequest() ? '{items}{pager}' : '',
                    //'template' => '{items}{pager}',
                    'dataProvider' => $model->search(),
                    'selectableRows' => 1,
                    'rowHtmlOptionsExpression' => 'array("id"=>$data->id)',
                    'pager' => array(
                        'header' => '',
                        'firstPageLabel' => '&lt;&lt;',
                        'prevPageLabel' => 'Prev',
                        'nextPageLabel' => 'Next',
                        'lastPageLabel' => '&gt;&gt;',
                    ),
                    'columns' => array(
                        array(
                            'header' => 'File/Qtn No.',
                            //'value' => '($data->file->id."/".$data->id.($data->is_approved=="N"?CHtml::image("images/inactive.png",""):"")',
                            'value' => '($data->file->id."/".$data->id)',
                            'htmlOptions' => array('style' => 'width: 10%;'),
                        ),
                        array(
                            'header' => 'Company',
                            'value' => '$data->file->company->company_name_short',
                            'htmlOptions' => array('style' => 'width: 20%;'),
                        ),
                        array(
                            'header' => 'Lead Owner',
                            //'value' => 'substr($data->title,0,15).".."',
                            'value' => '$data->file->leadowner->Fullname',
                            'htmlOptions' => array('style' => 'width: 15%;'),
                        ),
                        array(
                            'header' => 'Qtn. Dt.',
                            'value' => '$data->qtn_start_date',
                            'htmlOptions' => array('style' => 'width: 10%;', 'class' => 'cell-center'),
                        ),
                        array(
                            'header' => 'Value',
                            'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total,$data->currency0->currency_code)',
                            'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right', 'title' => 'Order value'),
                        ),
                        array(
                            'header' => 'Value(BC)',
                            'value' => 'Yii::app()->numberFormatter->formatCurrency($data->grand_total* $data->exchange_rate,"")',
                            'htmlOptions' => array('style' => 'width: 5%;', 'class' => 'cell-right', 'title' => 'Order value in Base Currency'),
                        ),
                        array(
                            'header' => 'Status',
                            'value' => '$data->file->status',
                            'htmlOptions' => array('style' => 'width: 5%;'),
                            'type' => 'raw'
                        ),
                        array(
                            'class' => 'CButtonColumn',
                            'header' => $headerbuttons,
                           'template' => '<i title="Actions" class="icon-cog"><div style="display:none;" class="triangle-right left">{edit}  {monitor} {send_for_approval} {approval} {print}</div></i>',
                            'htmlOptions' => array(
                                'style' => 'width: 1%;',
                                'class' => 'cell-center',
                                'title' => "Actions",
                                'onmouseover' => '$(this).find(\'.triangle-right\').show();',
                                'onmouseout' => '$(this).find(\'.triangle-right\').hide();'
                            ),
                            'buttons' => array(
                                'edit' => array(
                                    'label' => '<i class="icon-white icon-edit"></i>',
                                    'options' => array('title' => 'Edit Quotation'),
                                    'url' => 'Yii::app()->controller->createUrl("sop/quotation",array("id"=>$data->primaryKey))',
                                    'click' => 'js:function(){ openFormForEdit($(this).attr(\'href\'),\'quotes_form\'); return false;}',
                                    'visible' => '(int) Yii::app()->user->havePermissionOn[\'sop_quote_add_edit\'] && Yii::app()->controller->getcheckEdit($data->form_id,$data->file_id,Q)'
                                ),
                                'monitor' => array(
                                   'label' => '<i class="icon-white icon-eye-open"></i>',
                                    'options' => array('title' => 'View'),
                                    'url' => 'Yii::app()->controller->createUrl("sop/quotation",array("id"=>$data->primaryKey,"flag"=>1))',
                                    'click' => 'js:function(){ openFormForEdit($(this).attr(\'href\'),\'quotes_form\'); return false;}',
                                    'visible' => '(int) Yii::app()->user->havePermissionOn[\'sop_quote_view\']',
                                ),
                                'print' => array(
                                    'label' => '<i class="icon-white icon-print"></i>',
                                    'options' => array('title' => 'Print'),
                                    //'visible' => '((int) Yii::app()->user->havePermissionOn[\'sop_quote_print\']) && ($data->file->is_approved=="Y")',
                                    'visible' => '((int) Yii::app()->user->havePermissionOn[\'sop_quote_print\']) && Yii::app()->controller->getApprovalStatus($data->form_id,$data->file_id) ',
                                    'id' => '$data->id',
                                    'click' => 'function(){  exportfunction("","Quotes","pdf.sopquotes-single",$(this).parents("tr").attr("id")); }',
                                ),
                               
                                'send_for_approval' => array(
                                    'label' => '<i class="icon-white icon-bullhorn"></i>',
                                    'options' => array('title' => 'Send for Approval'),
                                    'url' => 'Yii::app()->controller->createUrl("pact/Permissions",array("form_id"=>$data->form_id,"file_id"=>$data->file_id,"refresh_grid"=>"quotation-table"))',
                                    'click' => 'js:function(){ openPermissionForm($(this).attr(\'href\')); return false;}',
                                    //'visible' => 'Yii::app()->controller->getcheckVisible($data->file->lead_owner_id) && $data->file->status =="Quote"?1:0',
                                    //'visible' => '$data->file->status =="Quote"?1:0',
                                    'visible' => 'Yii::app()->controller->getcheckVisible($data->file->lead_owner_id) && $data->file->status=="Quote"?1:0',
                                ),
                                'approval' => array(
                                    'label' => '<i class="icon-white icon-thumbs-up"></i>',
                                    'options' => array('title' => 'Approval'),
                                    'url' => 'Yii::app()->controller->createUrl("permission/ApproveForm",array("form_id"=>$data->form_id,"file_id"=>$data->file_id,"refresh_grid"=>"quotation-table"))',
                                    'click' => 'js:function(){ openApprovalForm($(this).attr(\'href\')); return false;}',
                                    'visible' => 'Yii::app()->controller->getcheckApproval($data->form_id,$data->file_id) && $data->file->status =="Quote"?1:0',
                                ),
                               
                            ),
                        ),
                    ),
                ));
                ?> 
            </div>
        </div>
    </div>
</div>