<?php

class PactController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout', 'Forgotpassword', 'Recover'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('manageForm', 'saveForm', 'savePermissions', 'editPermission', 'getLevels', 'FormReposition', 'Rfq', 'Jo', 'Ho', 'boq', 'upload',
                    'FetchFile', 'deleteperm', 'printho', 'printRfq', 'test', 'Permissions', 'ManageDepartment', 'formHistory', 'FetchHistoryOfaFile','saveDepartmentNotifications',
                    'editDepartmentNotification','deleteNotification','preQuotation','PrintPerformaInvoice','boqSchedule', 'editSchedule', 'saveScheduleName', 'saveScheduleCategory', 'saveSchedule', 'FetchHorFile','saveScheduleName', 'GetBoqItemDetails', 'GetBoqitems', 'SaveselectedColors','deleteColor','editColorSelection'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array('accessControl'); // perform access control for CRUD operations
    }

    public function actionFetchFile() {
        $file_id = (int) $_POST['file_id'];
        $masterFile = MasterFile::model()->findByPK($file_id);
        $rfqGeneral = FormRfqGeneral::model()->find(array('condition' => 'file_id=' . $file_id));
        $jsonData['quotes'] = $masterFile->quote;
        $jsonData['leads'] = $masterFile->lead;
        $jsonData['rfq'] = $masterFile->rfq;
        $jsonData['general'] = $masterFile;
        $jsonData['company'] = $masterFile->company;
        $jsonData['rfqDate'] = $rfqGeneral->formRfqDate;
        $data = CHtml::listData($masterFile->company->companyContacts, 'id', 'person_name');
        foreach ($data as $value => $name)
            $jsonData['contacts'][] = CHtml::tag('option', array('value' => $value), CHtml::encode($name), true);
        $jsonData['contacts'] = implode('', $jsonData['contacts']);
        echo CJSON::encode($jsonData);
    }
 public function actionFetchHorFile() {
        unset(Yii::app()->session['boq_File_id']);
        unset(Yii::app()->session['schedule_edited']);
        $file_id = (int) $_POST['file_id'];
        Yii::app()->session['boq_File_id'] = $file_id;

        $masterFile = MasterFile::model()->findByPK($file_id);
        $horGeneral = FormHoGeneral::model()->find(array('condition' => 'file_id=' . $file_id));
        $rfqGeneral = FormRfqGeneral::model()->find(array('condition' => 'file_id=' . $file_id));
        $jsonData['file_id'] = $file_id;
        $jsonData['hor'] = $horGeneral;
        $jsonData['formRfqMisc'] = $rfqGeneral->formRfqMisc;
        $jsonData['formRfqWtd'] = $rfqGeneral->formRfqWtd;
        $jsonData['formRfqWwtpStp'] = $rfqGeneral->formRfqWwtpStp;
        echo CJSON::encode($jsonData);
    }
    public function actionManageForm() {
        $model = new Form;
        $modelFormPermission = new FormPermission;
        $modelFormDepartmentNotification = new FormDepartmentNotification;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/_forms', array('model' => $model, 'modelFormPermission' => $modelFormPermission, 'modelFormDepartmentNotification' => $modelFormDepartmentNotification), false, true);
    }

    public function actionEditPermission() {
        $id = (int) $_GET['id'];
        $modelPerm = FormPermission::model()->findByPK($id);
        $modelPerm->user_id = unserialize($modelPerm->user_id);
        $levels_count = FormPermission::model()->count('form_id=' . $modelPerm->form_id);

        $data['model'] = $modelPerm;
        $data['levels'] = "";
        for ($i = 0; $i <= $levels_count; $i++) {
            $data['levels'] .=CHtml::tag('option', array('value' => $i, 'selected' => ($i == $modelPerm->level)), CHtml::encode($i), true);
        }


        echo CJSON::encode($data);
        Yii::app()->end();
    }

    public function actioneditDepartmentNotification() {
        $id = (int) $_GET['id'];
        $modelPerm = FormDepartmentNotification::model()->findByPK($id);
        $modelPerm->department_id = unserialize($modelPerm->department_id);
        //$levels_count = FormDepartmentNotification::model()->count('form_id=' . $modelPerm->form_id);

        $data['model'] = $modelPerm;
       /* $data['levels'] = "";
        for ($i = 0; $i <= $levels_count; $i++) {
            $data['levels'] .=CHtml::tag('option', array('value' => $i, 'selected' => ($i == $modelPerm->level)), CHtml::encode($i), true);
        }*/


        echo CJSON::encode($data);
        Yii::app()->end();
    }
    
    public function actionSaveForm() {
        $model = $this->commonSave('Form');
    }

    public function actionGetLevels() {
        $levels_count = FormPermission::model()->count('form_id=' . (int) $_POST['FormPermission']['form_id']);
        for ($i = 0; $i <= $levels_count; $i++) {
            echo CHtml::tag('option', array('value' => $i), CHtml::encode($i), true);
        }
    }

    public function actionSavePermissions() {
        $_POST['FormPermission']['user_id'] = serialize($_POST['FormPermission']['user_id']);
        $_POST['FormPermission']['id'] = (int) FormPermission::model()->find('level=' . (int) $_POST['FormPermission']['level'] . ' AND form_id=' . (int) $_POST['FormPermission']['form_id'])->id;

        $model = $this->commonSave('FormPermission');
    }
    public function actionsaveDepartmentNotifications() {
        $_POST['FormDepartmentNotification']['department_id'] = serialize($_POST['FormDepartmentNotification']['department_id']);
        $_POST['FormDepartmentNotification']['id'] = (int) FormDepartmentNotification::model()->find('form_id=' . (int) $_POST['FormDepartmentNotification']['form_id'])->id;

        $model = $this->commonSave('FormDepartmentNotification');
    }

    public function actionDeleteperm() {
        $id = (int) $_GET['id'];
        $model = FormPermission::model()->findByPK($id);
        $levelsOfForms = FormPermission::model()->findAll(array('condition' => 'level >' . $model->level . ' AND form_id=' . $model->form_id));
        $model->delete();
        foreach ($levelsOfForms as $eachLevel) {
            $eachLevel->level = $eachLevel->level - 1;
            $eachLevel->save(false);
        }
    }
    
    public function actiondeleteNotification() {
        $id = (int) $_GET['id'];
        $model = FormDepartmentNotification::model()->findByPK($id);
        //$levelsOfForms = FormPermission::model()->findAll(array('condition' => 'level >' . $model->level . ' AND form_id=' . $model->form_id));
        $model->delete();
        
    }

    public function actionFormReposition() {
        $id = $_GET['id'];
        $direction = $_GET['direction'];
        $fromModel = Form::model()->findByPK($id);
        switch ($direction) {
            case 'up':
                $formToBeSwapped = Form::model()->find('form_order=' . ($fromModel->form_order - 1));
                break;
            case 'down':
                $formToBeSwapped = Form::model()->find('form_order=' . ($fromModel->form_order + 1));
                break;
        }
        if ($formToBeSwapped != null) {
            $temp = $formToBeSwapped->form_order;
            $formToBeSwapped->form_order = $fromModel->form_order;
            $fromModel->form_order = $temp;
            $formToBeSwapped->save();
            $fromModel->save();
        }
    }

    public function actionRfq() {

        $model0 = new FormRfqGeneral;
        $model1 = new FormRfqDate;
        $model2 = new FormRfqType;
        $model3 = new FormRfqRo;
        $model4 = new FormRfqWwtpStp;
        $model5 = new FormRfqMisc;
        $model6 = new FormRfqWtd;
        $id = $_POST['FormRfqGeneral']['id'];
        $rfq_id = (int) Yii::app()->request->getParam('id');
        $flag = (int) Yii::app()->request->getParam('flag');
        $model0->sales_engr = Yii::app()->user->id;
        if ($rfq_id) {
            $model0 = $model0->findByPK($rfq_id);
            $model0->company = $model0->file->company->company_name;
            $model1 = count($model0->formRfqDate) > 0 ? $model0->formRfqDate : $model1;
            $model2 = count($model0->formRfqType) > 0 ? $model0->formRfqType : $model2;
            $model3 = count($model0->formRfqRo) > 0 ? $model0->formRfqRo : $model3;
            $model4 = count($model0->formRfqWwtpStp) > 0 ? $model0->formRfqWwtpStp : $model4;
            $model5 = count($model0->formRfqMisc) > 0 ? $model0->formRfqMisc : $model5;
            $model6 = count($model0->formRfqWtd) > 0 ? $model0->formRfqWtd : $model6;
        }
        if (isset($_POST['FormRfqGeneral'])) {
            if ((int) $_POST['FormRfqGeneral']['id'] > 0) {
                $model0 = $model0->findByPK($_POST['FormRfqGeneral']['id']);
                $model0->scenario = 'update';
                $model0->company = $model0->file->company->company_name;
                $model1 = count($model0->formRfqDate) > 0 ? $model0->formRfqDate : $model1;
                $model2 = count($model0->formRfqType) > 0 ? $model0->formRfqType : $model2;
                $model3 = count($model0->formRfqRo) > 0 ? $model0->formRfqRo : $model3;
                $model4 = count($model0->formRfqWwtpStp) > 0 ? $model0->formRfqWwtpStp : $model4;
                $model5 = count($model0->formRfqMisc) > 0 ? $model0->formRfqMisc : $model5;
                $model6 = count($model0->formRfqWtd) > 0 ? $model0->formRfqWtd : $model6;
            }
            $model0->attributes = $_POST['FormRfqGeneral'];
            $model0->form_id = 2;
            $model0->created_date = date('Y-m-d H:i:s a', time());
            $model0->crm_user_id = Yii::app()->user->id;
            $model1->attributes = $_POST['FormRfqDate'];
            $model2->attributes = $_POST['FormRfqType'];
            $model5->attributes = $_POST['FormRfqMisc'];

            $validate = $model0->validate() && $model1->validate() && $model2->validate() && $model5->validate() && $model6->validate();
            $modelsToBeValidated = array($model0, $model1, $model2, $model5, $model6);
            //if ($model2->sea_water_ro || $model2->blackish_water_ro) {
            if ($model2->desalination ||  $model2->river_water_treatment_plant_wtp || $model2->filteration_system || $model2->softner || $model2->demin_system) {
                $model3->attributes = $_POST['FormRfqRo'];
                $validate = $validate && $model3->validate();
                $modelsToBeValidated[] = $model3;
            }
            if ($model2->municipal || $model2->industrial) {
                $model4->attributes = $_POST['FormRfqWwtpStp'];
                $validate = $validate && $model4->validate();
                $modelsToBeValidated[] = $model4;
            }
            if ($model2->desalination || $model2->river_water_treatment_plant_wtp || $model2->filteration_system || $model2->softner || $model2->demin_system) {
                $model6->attributes = $_POST['FormRfqWtd'];
                $validate = $validate && $model6->validate();
                $modelsToBeValidated[] = $model6;
            }

            if ($validate) {
                $form_rfq_id = 0;
                foreach ($modelsToBeValidated as $eachModel) {
                    if (get_class($eachModel) == 'FormRfqGeneral') {
                        $eachModel->save();
                        $eachModel->refresh();
                        $form_rfq_id = $eachModel->id;
                    } else if ($form_rfq_id > 0) {
                        $eachModel->form_rfq_id = $form_rfq_id;
                        $eachModel->save();
                    }
                }
                 if(!$id)
           MasterFile::model()->updateByPK($model0->file_id, array('current_form_id' => 2, 'current_process_status' => "RFQ",'is_approved'=>"N",'created_date'=>date('Y-m-d H:i:s a', time())));
                $this->documents($model0->file_id, 'RFQ');
                $jsonData['file'] = $model0->file;
                $jsonData['rfq'] = $model0;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($modelsToBeValidated, '', false);
                if ($error != '[]')
                    echo $error;
            }
           
           
            Yii::app()->end();
        }
        if ($model0->file_id > 0)
            Yii::app()->session['file_id'] = $model0->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/rfq/_forms_rfq', array(
            'rfq_id' => $rfq_id,'flag' => $flag,
            'current_form_id' => 1,
            'model0' => $model0,
            'model1' => $model1,
            'model2' => $model2,
            'model3' => $model3,
            'model4' => $model4,
            'model5' => $model5,
            'model6' => $model6,
                ), false, true);
    }

    public function actionJo() {
        $model0 = new FormJoGeneral;

        $jo_id = (int) Yii::app()->request->getParam('id');
        if ($jo_id) {
            $model0 = $model0->findByPK($jo_id);
            $model0->company = $model0->file->company->company_name;
        }
        if (isset($_POST['FormJoGeneral'])) {
            $model0->attributes = $_POST['FormJoGeneral'];
            $model0->form_id = 12;

            $validate = $model0->validate();
            $modelsToBeValidated = array($model0);

            if ($validate) {
                $form_jo_id = 0;
                foreach ($modelsToBeValidated as $eachModel) {
                    if (get_class($eachModel) == 'FormJoGeneral') {
                        $eachModel->save();
                        $eachModel->refresh();
                        $form_jo_id = $eachModel->id;
                    } else if ($form_jo_id > 0) {
                        $eachModel->form_jo_id = $form_jo_id;
                        $eachModel->save();
                    }
                }
                echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($modelsToBeValidated, '', false);
                if ($error != '[]')
                    echo $error;
            }
            Yii::app()->end();
        }
        if ($model0->file_id > 0)
            Yii::app()->session['file_id'] = $model0->file_id;
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/jo/_forms_jo', array(
            'jo_id' => $jo_id,
            'model' => $model0,
                ), false, true);
    }

    public function actionHo() {
        $model0 = new FormHoGeneral;
        $model2 = new FormHoType;
        $model3 = new FormHoScope;
        $model4 = new FormHoDelivery;
        $ho_id = (int) Yii::app()->request->getParam('id');
        $flag = (int) Yii::app()->request->getParam('flag');
        $id = $_POST['FormHoGeneral']['id'];
        if ($ho_id) {
            $model0 = $model0->findByPK($ho_id);
            $model0->company = $model0->file->company->company_name;
            $model0->contact_id = $model0->contact->person_name;
            $model2 = count($model0->formHoType) > 0 ? $model0->formHoType : $model2;
            $model3 = count($model0->formHoScope) > 0 ? $model0->formHoScope : $model3;
            $model4 = count($model0->formHoDelivery) > 0 ? $model0->formHoDelivery : $model4;
        }
        if (isset($_POST['FormHoGeneral'])) {
            if ((int) $_POST['FormHoGeneral']['id'] > 0) {
                $model0 = $model0->findByPK($_POST['FormHoGeneral']['id']);
                $model0->scenario = 'update';
                $model0->company = $model0->file->company->company_name;
                $model0->contact_id = $model0->contact->person_name;
                $model2 = count($model0->formHoType) > 0 ? $model0->formHoType : $model2;
                $model3 = count($model0->formHoScope) > 0 ? $model0->formHoScope : $model3;
                $model4 = count($model0->formHoDelivery) > 0 ? $model0->formHoDelivery : $model4;
            }
            $model0->attributes = $_POST['FormHoGeneral'];
            $model0->form_id = 11;
            $model0->crm_user_id = Yii::app()->user->id;
             $model0->created_date = date('Y-m-d H:i:s a', time());
            $model2->attributes = $_POST['FormHoType'];
            $validate = $model0->validate() && $model2->validate();
            $modelsToBeValidated = array($model0, $model2);
            $model3->attributes = $_POST['FormHoScope'];
            $validate = $validate && $model3->validate();
            $modelsToBeValidated[] = $model3;
            $model4->attributes = $_POST['FormHoDelivery'];
            $validate = $validate && $model4->validate();
            $modelsToBeValidated[] = $model4;

            if ($validate) {
                $form_ho_id = 0;
                foreach ($modelsToBeValidated as $eachModel) {
                    if (get_class($eachModel) == 'FormHoGeneral') {
                        $eachModel->save();
                        $eachModel->refresh();
                        $form_ho_id = $eachModel->id;
                    } else if ($form_ho_id > 0) {
                        $eachModel->form_ho_id = $form_ho_id;
                        $eachModel->save();
                    }
                }
                $this->documents($model0->file_id, 'HO');
                if(!$id)
                MasterFile::model()->updateByPK($_POST['FormHoGeneral']['file_id'], array('current_form_id' => 11, 'current_process_status' => "HOR",'is_approved'=>"N",'created_date'=>date('Y-m-d H:i:s a', time())));
                $jsonData['file'] = $model0->file;
                $jsonData['hor'] = $model0;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
                //echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($modelsToBeValidated, '', false);
                if ($error != '[]')
                    echo $error;
            }

            Yii::app()->end();
        }
        if ($model0->file_id > 0)
            Yii::app()->session['file_id'] = $model0->file_id;
        
            /*$userid = PactDepartment::model()->findAll(array('condition' => 'id  IN(2,6,7)'));
            foreach()
            if (in_array(Yii::app()->user->id, $userid))
                    $result = 1;
            else*/
                    $result = 0;
  
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/ho/_forms_ho', array(
            'ho_id' => $ho_id,'flag' => $flag,
            'current_form_id' => 3,
            'model0' => $model0,
            'model2' => $model2,
            'model3' => $model3,
            'model4' => $model4,
            'result' => $result,
                ), false, true);
    }

    /* public function actionBoq() {
      $model0 = new FormBoqGeneral;

      $boq_id = (int) Yii::app()->request->getParam('id');
      if ($boq_id) {
      $model0 = $model0->findByPK($boq_id);
      $model0->company = $model0->file->company->company_name;
      }
      if (isset($_POST['FormBoqGeneral'])) {
      $model0->attributes = $_POST['FormBoqGeneral'];
      $model0->form_id = 11;

      $validate = $model0->validate();
      $modelsToBeValidated = array($model0);


      if ($validate) {
      $form_boq_id = 0;
      foreach ($modelsToBeValidated as $eachModel) {
      if (get_class($eachModel) == 'FormBoqGeneral') {
      $eachModel->save();
      $eachModel->refresh();
      $form_boq_id = $eachModel->id;
      } else if ($form_boq_id > 0) {
      $eachModel->form_boq_id = $form_boq_id;
      $eachModel->save();
      }
      }
      echo CJSON::encode(array('status' => 'success'));
      } else {
      $error = CActiveForm::validate($modelsToBeValidated, '', false);
      if ($error != '[]')
      echo $error;
      }
      Yii::app()->end();
      }
      if ($model0->file_id > 0)
      Yii::app()->session['file_id'] = $model0->file_id;
      else
      unset(Yii::app()->session['file_id']);
      Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
      $this->renderPartial('//pact/boq/_forms_boq', array(
      'boq_id' => $boq_id,
      'model0' => $model0,
      ), false, true);
      } */

    public function actionPreQuotation() {
        $model0 = new PreQuotation;
        $id = $_POST['PreQuotation']['id'];
        $pre_quote_id = (int) Yii::app()->request->getParam('id');
        $flag = (int) Yii::app()->request->getParam('flag');
        if ($pre_quote_id) {
            $model0 = $model0->findByPK($pre_quote_id);
            //$model0->company = $model0->file->company->company_name;
        }
        if (isset($_POST['PreQuotation'])) {
            if ((int) $_POST['PreQuotation']['id'] > 0) {
                $model0 = $model0->findByPK($_POST['PreQuotation']['id']);
                $model0->scenario = 'update';
            }
            $model0->attributes = $_POST['PreQuotation'];
            $model0->form_id = 15;
            $model0->creator_id = Yii::app()->user->id;
            $model0->created_date = date('Y-m-d H:i:s a', time());
            $validate = $model0->validate();
            $modelsToBeValidated = array($model0);
 

            if ($validate) {
                $pre_quote_id = 0;
                foreach ($modelsToBeValidated as $eachModel) {
                    if (get_class($eachModel) == 'PreQuotation') {
                        $eachModel->save();
                        $eachModel->refresh();
                        $pre_quote_id = $eachModel->id;
                    } else if ($pre_quote_id > 0) {
                        $eachModel->pre_quote_id = $pre_quote_id;
                        $eachModel->save();
                    }
                }
                $this->documents($model0->file_id, 'PQ');
               
                if(!$id)
                MasterFile::model()->updateByPK($model0->file_id, array('current_form_id' => 15, 'current_process_status' => "PQ",'is_approved'=>"N",'created_date'=>date('Y-m-d H:i:s a', time())));
                echo CJSON::encode(array('status' => 'success'));
            } else {
                $error = CActiveForm::validate($modelsToBeValidated, '', false);
                if ($error != '[]')
                    echo $error;
            }

            Yii::app()->end();
        }
        if ($model0->file_id > 0)
            Yii::app()->session['file_id'] = $model0->file_id;
       /* else
            unset(Yii::app()->session['file_id']);*/
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/prequote/_forms_pre_quote', array(
            'pre_quote_id' => $pre_quote_id,'flag' => $flag,
            'current_form_id' => 2,
            'model0' => $model0,
                ), false, true);
    }

    public function actionPrintho() {
        $id = Yii::app()->request->getParam('id');
        $model = FormHoGeneral::model()->findByPK($id);
        $approval = FormApproval::model()->findAll(array('condition' => 'form_id=' . $model->form_id . ' AND file_id=' . $model->file_id . ' AND is_approved="Y" '));

        foreach ($approval as $eachApproval) {
            $permission[] = FormPermission::model()->findAll(array('condition' => 'form_id=' . $eachApproval->form_id . ' AND level=' . $eachApproval->level));
            foreach ($permission as $data) {
                foreach ($data as $value) {
                    $notes[] = $eachApproval->notes;
                }
            }
        }
        if ($notes)
            $notes = array_values(array_unique($notes));
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.hor', array('model' => $model, 'permission' => $permission, 'notes' => $notes), true));
        $mPDF1->Output('HOR', 'I');
    }

    public function actionPrintRfq() {
        $id = Yii::app()->request->getParam('id');
        $user_id = array();
        $model = FormRfqGeneral::model()->findByPK($id);
        $department = PactDepartment::model()->findAll(array('condition' => ' id in(2,6,7)'));
        foreach($department as $eachdepartment){
            $user_ids = unserialize($eachdepartment->user_ids);
                        $user_id = array_merge($user_id, array_unique($user_ids));

        }
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.rfq', array('model' => $model,'user_id' => $user_id), true));
        $mPDF1->Output('RFQ', 'I');
    }
    
    public function actionPrintPerformaInvoice() {
        $file_id = Yii::app()->request->getParam('file_id');
        $modelName = Yii::app()->request->getParam('model');
        $view = Yii::app()->request->getParam('view');
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $this->pageTitle = 'print-' . $modelName;
        $model = new $modelName;
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->SetWatermarkImage(Yii::app()->baseUrl . '/images/logo/200150_' . MasCompany::model()->findbyPK(Yii::app()->user->master_user_company_id)->company_logo);
        $mPDF1->showWatermarkImage = true;
        $mPDF1->watermarkImageAlpha = 0.09;
        $mPDF1->SetDisplayMode('fullpage');
                    $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
                    $mPDF1->WriteHTML($stylesheet, 1);
                    if (in_array($modelName, array(
                                "Order",
                               ))) {
                        $model = $modelName::model()->with('items')->find( array('condition' => 'file_id='.$file_id,'order' => 'items.id ASC'));
                        $modelHor = FormHoGeneral::model()->find(array('condition' => 'file_id='.$file_id));
                        $product_items = "";
                        $k = 0;
                        foreach ($model->items as $i => $eachItem) {
                            if ($eachItem->quantity != 0) {
                                if (in_array($modelName, array( "Order"))) {
                                    if (in_array($modelName, array( "Order"))) {
                                        $eachItem->rate+=($eachItem->addition_amount / $eachItem->quantity);
                                        $eachItem->rate-=($eachItem->deduction_amount / $eachItem->quantity);
                                        $eachItem->net_amount = $eachItem->rate * $eachItem->quantity;
                                    }
                                    $class = $class == "odd" ? "even" : "odd";
                                    $product_items .= '<tr class = "' . $class . '">
            <td >' . (++$k) . '</td>
            <td class = "cell-left">' . $eachItem->product->part_number . '</td>';

                                    $product_items .= '<td class = "cell-left">' . nl2br($eachItem->description) . '</td>';

                                    if ((int) $custom_changes['need_brand_in_sop_print_out'] && in_array($modelName, array( "Order"))) {
                                        $product_items .= '<td class = "cell-center">' . $eachItem->product->productclass->brand . '</td>';
                                    }
                                    $product_items .= '<td class = "cell-right">' . preg_replace('/\s\d+\.00/', '', floatval($eachItem->quantity)) . '</td>
            <td class = "cell-center">' . $eachItem->product->unit->symbol . '</td>';
                                  
                                       //  $product_items .= '<td class = "cell-right">' . sprintf("%2.2f", $eachItem->rate) . '</td>
                           $product_items .= '<td class = "cell-right">' . sprintf( Yii::app()->numberFormatter->formatCurrency($eachItem->rate,"")) . '</td>
            <td class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, "") . '</td>
            </tr>';
                                    
                                } 
                            }
                        }
                        if (in_array($modelName, array("Quotes")))
                            $additions = '';
                        $colspan = in_array($modelName, array("PurchasingOrder", "PurchasingInvoice")) ? 6 : (in_array($modelName, array("Quotes")) ? 7 : 7);
                        if (!(int) $custom_changes['need_brand_in_sop_print_out'] && in_array($modelName, array("Quotes", "Order", "Invoice", "PurchasingInvoice")))
                            $colspan-=1;
                        foreach ($model->adItems as $i => $eachItem) {
                            if (($eachItem->calculated_value) > 0) {
                                $additions .= '<tr>
            <td colspan = "' . $colspan . '" class = "cell-right" >' . (!empty($eachItem->particular) ? $eachItem->particular : "Additions") . '</td>
            <td colspan = "1" class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
            </tr>';
                            }
                        }
                        $deductions = '';
                        foreach ($model->dedItems as $i => $eachItem) {
                            if ($eachItem->calculated_value > 0) {
                                $deductions .= '<tr>
            <td colspan = "' . $colspan . '" class = "cell-right" >' . (!empty($eachItem->particular) ? $eachItem->particular : 'Deduction') . '</td>
            <td colspan = "1" class = "cell-right">' . Yii::app()->numberFormatter->formatCurrency($eachItem->calculated_value, "") . '</td>
            </tr>';
                            }
                        }
                        $mPDF1->WriteHTML($this->renderPartial('application.views.front.' . $view, array('model' => $model, 'product_items' => $product_items, 'additions' => $additions, 'deductions' => $deductions, 'custom_changes' => $custom_changes,'modelHor' => $modelHor), true));
                    }
                    $mPDF1->Output($view, 'I');
          
    }

    public function actionTest() {
        $url = parse_url($url, PHP_URL_HOST);
        $url_domain = parse_url(Yii::app()->getBaseUrl(true), PHP_URL_HOST);
        return($url == $url_domain);
    }

    public function actionPermissions() {
        ////////////////////////
        $form_id = $_GET['form_id'];
        $file_id = $_GET['file_id'];
        $refresh_grid = $_REQUEST['refresh_grid'];
        $critera = new cdbCriteria;
        $critera->select = 'name,level';
        $critera->order = 'level ASC';
        $critera->condition = 'form_id=' . $form_id;
        $model = FormPermission::model()->findAll($critera);

        $history = FormApproval::model()->findAll(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id));
        $approvals = FormApproval::model()->findAll(array('condition' => 'form_id=' . $form_id . ' AND file_id=' . $file_id . ' AND arrived_req_for_approval<>"N"'));
        $levels = array();
        foreach ($approvals as $eachItem) {
            $levels[] = $eachItem->level;
        }
        if ($model != null) {
            $html = '<b><u>Send for Approval</u></b><br/>';
            foreach ($model as $eachModel) {
                //$html.= FormApproval::model()->find(array('condition' => 'level1=' . $eachModel->level . ' AND form_id=' . $form_id . ' AND arrived_req_for_approval<>"N" AND arrived_req_for_approval<>"Y"', 'order' => 'id DESC', 'limit' => 1))->is_approved;
                $rejeceted = FormApproval::model()->count(array('condition' => 'file_id=' . $file_id . ' AND level=' . $eachModel->level . ' AND form_id=' . $form_id . ' AND arrived_req_for_approval="A" AND is_approved<>"Y"'));
                $class = (in_array($eachModel->level, $levels) && !$rejeceted) ? "btn-success" : ($rejeceted ? "btn-danger" : "btn-primary");
                //$on_click = !in_array($eachModel->level, $levels) || $rejeceted ? 'if(confirm("This will generate a mail to the authorities that are in ' . $eachModel->name . ' approval,are you sure to send?")) sendNotification($(this).attr(\'href\'),this); return false;' : 'alert("You already send for ' . $eachModel->name . ' permission"); return false; ';
                $html.='  ' . CHtml::ajaxLink('Send to ' . $eachModel->name . '<i class="icon-white icon-share-alt"></i>', Yii::app()->createUrl('permission/approvalNotification', array('file_id' => $file_id, 'form_id' => $form_id, 'level' => $eachModel->level)), array(
                            'dataType' => 'json',
                            'type' => 'post',
                            'success' => 'function(data) { 
                                if(data.status=="success"){
                                $.fn.yiiGridView.update(\'' . $refresh_grid . '\');
                                notification("Approval request has been sent","success");
                                        } 
                                   }',
                                ), array(
                            'class' => 'btn ' . $class . ' btn-small', 'id' => uniqid(), 'style' => 'margin:2px;',
                            //'onclick' => 'js: ' . $on_click
                            'onclick' => !in_array($eachModel->level, $levels) || $rejeceted ? 'if(!confirm("This will generate a mail to the authorities that are in ' . $eachModel->name . ' approval,are you sure to send?")) return  ' : 'alert("You already send for ' . $eachModel->name . ' permission");return false; '
                ));
            }
        }
        $html.='<br/><b><u>Notification to Departments</u></b><br/>';
        /*$userGroups = PactDepartment::model()->findAll(array('order' => 'department_name ASC'));
        foreach ($userGroups as $eachUserGroup) {
            $notified = Notification::model()->count(array('condition' => 'file_id=' . $file_id . ' AND level=' . $eachUserGroup->id . ' AND form_id=' . (int) $form_id, 'order' => 'id DESC'));
            $class = $notified ? "btn-success" : "btn-primary";
            //$on_click = 'if(confirm("This will generate a notification mail to the ' . $eachUserGroup->department_name . ' ,are you sure to send?")) sendNotification($(this).attr(\'href\'),this); return false';
            $html.='  ' . CHtml::ajaxLink((($notified) ? 'Notified ' : 'Notify ') . $eachUserGroup->department_name . '<i class="icon-white icon-share-alt"></i>', Yii::app()->createUrl('permission/notificationForDepartments', array('department_id' => $eachUserGroup->id, 'file_id' => $file_id, 'form_id' => $form_id, 'level' => $eachModel->level)), array(
                        'dataType' => 'json',
                        'type' => 'post',
                        'success' => 'function(data) { 
                                if(data.status=="success"){
                                $.fn.yiiGridView.update(\'' . $refresh_grid . '\');
                                notification("Notification has been sent","success");
                                   } 
                              }',
                            ), array(
                        'class' => 'btn btn-small ' . $class, 'id' => uniqid(), 'style' => 'margin:2px;',
                        'onclick' => 'if(!confirm("This will generate a notification mail to the ' . $eachUserGroup->department_name . ' ,are you sure to send?")) return '
            ));
        }$html = '<ul style="width:auto;">  
              ' . $html . '
              </ul>';*/
        $modelName = new FormDepartmentNotification;
        $userid = unserialize(FormDepartmentNotification::model()->find(array('condition' => 'form_id=' . $form_id))->department_id);
        if($userid){
            foreach($userid as $eachuserid){
            $notified = Notification::model()->count(array('condition' => 'file_id=' . $file_id . ' AND level='.$eachuserid.'  AND form_id=' . (int) $form_id, 'order' => 'id DESC'));
            $class = $notified ? "btn-success" : "btn-primary";
            //$on_click = 'if(confirm("This will generate a notification mail to the ' . $eachUserGroup->department_name . ' ,are you sure to send?")) sendNotification($(this).attr(\'href\'),this); return false';
            $html.='  ' . CHtml::ajaxLink((($notified) ? 'Notified ' : 'Notify ') . $modelName->getdepartmentname($eachuserid) . '<i class="icon-white icon-share-alt"></i>', 
                        Yii::app()->createUrl('permission/notificationForDepartments', array('department_id' => $eachuserid, 'file_id' => $file_id, 'form_id' => $form_id, 'level' => $eachModel->level)), array(
                        'dataType' => 'json',
                        'type' => 'post',
                        'success' => 'function(data) { 
                                if(data.status=="success"){
                                $.fn.yiiGridView.update(\'' . $refresh_grid . '\');
                                notification("Notification has been sent","success");
                                   } 
                              }',
                            ), array(
                        'class' => 'btn btn-small ' . $class, 'id' => uniqid(), 'style' => 'margin:2px;',
                        'onclick' => 'if(!confirm("This will generate a notification mail to the ' . $modelName->getdepartmentname($eachuserid) . ' ,are you sure to send?")) return '
            )); 
            }
        } 
           
        $html = '<ul style="width:auto;">  
              ' . $html . '
              </ul>';
        ////////////////////////
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/_buttons_permissions', array('html' => $html, 'history' => $history, 'file_id' => $file_id, 'refresh_grid' => $refresh_grid), false, true);
    }

    public function actionManageDepartment() {
        $model = new PactDepartment;
        $dpt_id = (int) Yii::app()->request->getParam('id');
        if ($dpt_id) {
            $model = $model->findByPK($dpt_id);
            $model->scenario = 'update';
            $model->user_ids = unserialize($model->user_ids);
        }

        if (isset($_POST['PactDepartment'])) {
            $model->attributes = $_POST['PactDepartment'];
            $model->user_ids = serialize($model->user_ids);
            $model->updated_by = Yii::app()->user->id;
            $valid = $model->validate();
            if ($valid) {

                $model->save();
                $model->refresh();
                $dpt_id = $model->id;

                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error = CActiveForm::validate($model, '', false);
                if ($error != '[]')
                    echo $error;
            }
            Yii::app()->end();
        }

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/_department_form', array(
            'model' => $model,
            'dpt_id' => (int) $dpt_id
                ), false, true);
    }

    public function actionFormHistory() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        echo $this->renderPartial('//pact/_file_history', array(), false, true);
    }

    public function actionFetchHistoryOfaFile() {
        Yii::app()->session['history_file_id'] = (int) $_POST['file_id'] > 0 ? $_POST['file_id'] : Yii::app()->session['history_file_id'];
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $criteria = new CDbCriteria;
        // $criteria->order = "id DESC,level DESC";
        $criteria->order = "id DESC,level DESC";
        $criteria->condition = 'file_id=' . Yii::app()->session['history_file_id'];
        //$criteria->pagination = false;
        $history0 = FormApproval::model()->findAll($criteria);
        $history1 = Notification::model()->findAll($criteria);
        $history2 = Invoice::model()->findAll((array('condition' => 'file_id=' .Yii::app()->session['history_file_id'] )));
        $history3 = DeliveryNote::model()->findAll((array('condition' => 'file_id=' .Yii::app()->session['history_file_id'] )));
        

        $query = "DROP TABLE if exists fileHistory;";
        $query .= "CREATE TEMPORARY TABLE fileHistory ( file_id int(11),form_name char(200),status char(200),by0 char(200),dpt char(200),date0 datetime,color char(50),notes varchar(1000))";
        $color = 'colorGreen';
       
        $notes = '-';
        $eachItem = MasterFile::model()->findByPK(Yii::app()->session['history_file_id']);
       /* $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->file_title . "','File Created','" . $eachItem->fileCreator->fullname . "','-','" . $eachItem->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->lead) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->lead->id . "','PRE-RFQ Created','" . $eachItem->lead->crmUser->fullname . "','-','" . $eachItem->lead->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->rfq) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->rfq->id . "','RFQ Created','" . $eachItem->rfq->crmUser->fullname . "','-','" . $eachItem->rfq->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->preQuote) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->preQuote->id . "','Pre.Quote Created','" . $eachItem->preQuote->crmUser->fullname . "','-','" . $eachItem->preQuote->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->quote) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->quote->id . "','Quotation Created','" . $eachItem->quote->crmUser->fullname . "','-','" . $eachItem->quote->qtn_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->order) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->order->id . "','Order Created','" . $eachItem->order->crmUser->fullname . "','-','" . $eachItem->order->created_date . "','" . $color . "','" . $notes . "')";*/

        
        // $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/' . $eachItem->file_title . "','File Created','" . $eachItem->fileCreator->fullname . "','-','" . $eachItem->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->lead) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/PRE-RFQ'. "','PRE-RFQ Created','" . $eachItem->lead->crmUser->fullname . "','-','" . $eachItem->lead->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->rfq) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/RFQ' . "','RFQ Created','" . $eachItem->rfq->crmUser->fullname . "','-','" . $eachItem->rfq->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->preQuote) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/Pre.Quote'  . "','Pre.Quote Created','" . $eachItem->preQuote->crmUser->fullname . "','-','" . $eachItem->preQuote->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->quote) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/Quotation' . "','Quotation Created','" . $eachItem->quote->crmUser->fullname . "','-','" . $eachItem->quote->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->order) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/Order' . "','Order Created','" . $eachItem->order->crmUser->fullname . "','-','" . $eachItem->order->created_date . "','" . $color . "','" . $notes . "')";
        if (count($eachItem->hor) > 0)
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->id . '/HOR' . "','HOR Created','" . $eachItem->hor->crmUser->fullname . "','-','" . $eachItem->hor->created_date . "','" . $color . "','" . $notes . "')";   
            foreach($history2 as $eachhistory2){
             $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachhistory2->file_id . '/Invoice' . "','Invoice Created','" . $eachhistory2->crmUser->fullname . "','-','" . $eachhistory2->created_date . "','" . $color . "','" . $notes . "')";   
            }
            foreach($history3 as $eachhistory3){
             $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachhistory3->file_id . '/Delivery' . "','Delivery Created','" . $eachhistory3->crmUser->fullname . "','-','" . $eachhistory3->created_date . "','" . $color . "','" . $notes . "')";   
            }
            
        foreach ($history0 as $eachItem) {
            $notes = $eachItem->notes;
            $color = $eachItem->is_approved == "Y" ? "colorGreen" : (($eachItem->arrived_req_for_approval == "Y") ? "-noColor-" : "colorGrey");
           
            $date0 = (!empty($eachItem->date_send_for_approval) && ($eachItem->date_send_for_approval != "0000-00-00 00:00:00")) ? $eachItem->date_send_for_approval : $eachItem->date_of_approval;
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->form->name . "','" . $eachItem->status . "','" . $eachItem->user->fullname . "','" . $eachItem->levelAndname . "','" . $date0 . "','" . $color . "','" . $notes . "')";
        }
        $notes = '-';
        foreach ($history1 as $eachItem) {
            $color = 'colorBlue';
           
            $query .= "; INSERT INTO fileHistory VALUES(" . Yii::app()->session['history_file_id'] . ", '" . $eachItem->form->name . "','" . $eachItem->status . "','" . $eachItem->user->fullname . "','" . $eachItem->levelAndname . "','" . $eachItem->date_send_for_notification . "','" . $color . "','" . $notes . "')";
        }

        Yii::app()->db->createCommand($query)->execute();
        $query = "select * from fileHistory where file_id=" . Yii::app()->session['history_file_id'] . " order by date0 DESC";
        $result = new CArrayDataProvider(Yii::app()->db->createCommand($query)->queryAll());


        $this->renderPartial('//pact/_permission_history_grid', array('history' => $result), false, true);
        Yii::app()->end();
    }
    
     public function actionBoq() {


        $model = new FormBoqSchedule;
        $modelBoqGeneral = new FormBoqGeneral;
        $modelBoqGeneralItem = array(new FormBoqGeneralItem);
        $colors = FormColorSelection::model()->findAll();
        $boq_items = "";
        $value = "";
        $defaultSchedule = 0;
        $boq_id = (int) Yii::app()->request->getParam('id');
        $flag = (int) Yii::app()->request->getParam('flag');
        $id = $_POST['FormBoqGeneral']['id'];

        if ($boq_id) {
            $modelBoqGeneral = $modelBoqGeneral->findByPK($boq_id);
            $editStatus = 1;
            $boq_file_id = $modelBoqGeneral->file_id;
            $modelItemSchedule = FormBoqItemSchedule::model()->findAll(array('condition' => 'file_no=' . $boq_file_id));

            if (!$modelItemSchedule) {
                $defaultSchedule = 1;
            }
            //$boqItems = $this->getBoqitems($boq_id, $modelBoqGeneral->category_id);
            //$category_value = $modelBoqGeneral->category_id;
        }
        if (isset($_POST['FormBoqGeneral']) && isset($_POST['FormBoqGeneralItem'])) {

            if ((int) $_POST['FormBoqGeneral']['id'] > 0) {
                $modelBoqGeneral = $modelBoqGeneral->findByPK($_POST['FormBoqGeneral']['id']);
                $modelBoqGeneral->scenario = 'update';
            }
            if ($id) {
                $modelBoqGeneral->attributes = $_POST['FormBoqGeneral'];
                $modelBoqGeneral->form_id = 5;
                $modelBoqGeneral->crm_user_id = Yii::app()->user->id;
                $modelBoqGeneral->created_date = date('Y-m-d H:i:s a', time());
                $valid = $modelBoqGeneral->validate();
            } else {
                if ($_POST['FormBoqGeneral']['file_id']) {
                    $BoqGeneral = FormBoqGeneral::model()->find(array('condition' => 'file_id=' . $_POST['FormBoqGeneral']['file_id']));
                    $valid = 1;
                    $Boq_id = $BoqGeneral->id;
                    if (!$BoqGeneral->file_id) {
                        $modelBoqGeneral->attributes = $_POST['FormBoqGeneral'];
                        $modelBoqGeneral->form_id = 5;
                        $modelBoqGeneral->crm_user_id = Yii::app()->user->id;
                        $modelBoqGeneral->created_date = date('Y-m-d H:i:s a', time());
                        $valid = $modelBoqGeneral->validate();
                    }
                } else {
                    $valid = 0;
                }
                // $valid = "true";
            }
            if (is_array($_POST['FormBoqGeneralItem'])) {
                if ($id) {
                    $form_boq_id = $_POST['FormBoqGeneralItem'][0]['id'];
                    foreach ($_POST['FormBoqGeneralItem'] as $i => $item) {
                        $model = $this->loadModel($_POST['FormBoqGeneralItem'][$i]['id']);
                        if (empty($model)) {
                            $item_no = $_POST['FormBoqGeneralItem'][$i]['item_no'];
                            if ($item_no) {
                                for ($count = 0; $count <= 1; $count+=0.1) {
                                    $previous_item_no = $item_no - $count;
                                    $model = FormBoqGeneralItem::model()->find(array('condition' => 'item_no=' . $previous_item_no . '  AND form_boq_id=' . $form_boq_id . ' AND category_id=' . $_POST['FormBoqSchedule']['id']));
                                    if (!empty($model)) {
                                        FormBoqGeneralItem::model()->updateByPk($model->id, array('revision' => 1));
                                        break;
                                    }
                                }
                            }
                            $modelBoqGeneralItem[$i] = new FormBoqGeneralItem;
                            $modelBoqGeneralItem[$i]->attributes = $_POST['FormBoqGeneralItem'][$i];
                            if (!$_POST['FormBoqGeneralItem'][$i]['item_no']) {
                                $modelBoqGeneralItem[$i]->item_no = $i;
                            }
                            $modelBoqGeneralItem[$i]->category_id = $_POST['FormBoqSchedule']['id'];
                            $modelBoqGeneralItem[$i]->revision = 0;
                            $valid = $modelBoqGeneralItem[$i]->validate() && $valid;
                        } else {
                            $result = array_diff($_POST['FormBoqGeneralItem'][$i], $model->attributes);
                            if (!empty($result)) {

                                if ((count($result) == 1) && (array_key_exists('picked_color', $result))) {
                                    FormBoqGeneralItem::model()->updateByPk($_POST['FormBoqGeneralItem'][$i]['id'], array('picked_color' => $_POST['FormBoqGeneralItem'][$i]['picked_color']));
                                } else {
                                    $modelBoqGeneralItem[$i] = new FormBoqGeneralItem;
                                    FormBoqGeneralItem::model()->updateByPk($_POST['FormBoqGeneralItem'][$i]['id'], array('revision' => 1));
                                    $modelBoqGeneralItem[$i]->attributes = $_POST['FormBoqGeneralItem'][$i];
                                    $modelBoqGeneralItem[$i]->category_id = $_POST['FormBoqSchedule']['id'];
                                    $modelBoqGeneralItem[$i]->revision = 0;
                                    if ($model->item_no == $_POST['FormBoqGeneralItem'][$i]['item_no']) {
                                        for ($count = 0.1; $count <= 1; $count+=0.1) {
                                            $new_ItemNo = $_POST['FormBoqGeneralItem'][$i]['item_no'] + $count;
                                            $modelGetItem_no = FormBoqGeneralItem::model()->find(array('condition' => 'item_no=' . $new_ItemNo));
                                            if (!$modelGetItem_no) {
                                                $modelBoqGeneralItem[$i]->item_no = $new_ItemNo;
                                                break;
                                            }
                                        }
                                    } else
                                        $modelBoqGeneralItem[$i]->item_no = $_POST['FormBoqGeneralItem'][$i]['item_no'];
                                    $valid = $modelBoqGeneralItem[$i]->validate() && $valid;
                                }
                            }
                        }
                    }
                    $modelBoqGeneralItem = array_slice($modelBoqGeneralItem, 1);
                }
                else {
                    foreach ($_POST['FormBoqGeneralItem'] as $i => $item) {
                        $modelBoqGeneralItem[$i] = new FormBoqGeneralItem;
                        $modelBoqGeneralItem[$i]->attributes = $_POST['FormBoqGeneralItem'][$i];
                        $modelBoqGeneralItem[$i]->item_no = $i;
                        $modelBoqGeneralItem[$i]->category_id = $_POST['FormBoqSchedule']['id'];

                        $valid = $modelBoqGeneralItem[$i]->validate() && $valid;
                    }
                    $modelBoqGeneralItem = array_slice($modelBoqGeneralItem, 1);
                }
            }
            $valid = $valid && is_array($modelBoqGeneralItem);
            $modelsToBeValidated = array($modelBoqGeneral, $modelBoqGeneralItem);
            if ($valid) {
                $formBoq_id = 0;
                $modelBoqGeneral->save();
                $modelBoqGeneral->refresh();
                $formBoq_id = Yii::app()->db->getLastInsertID();
                if ($formBoq_id) {
                    $formBoq_id = $formBoq_id;
                } else {
                    $formBoq_id = $Boq_id;
                }
                if ($id)
                    $formBoq_id = $id;
                foreach ($modelBoqGeneralItem as $eachModel) {
                    $eachModel->form_boq_id = $formBoq_id;
                    $eachModel->created_date = date('Y-m-d H:i:s a', time());
                    $eachModel->save();
                }
                if (!$id)
                    MasterFile::model()->updateByPK($_POST['FormBoqGeneral']['file_id'], array('current_form_id' => 5, 'current_process_status' => "BOQ", 'is_approved' => "N", 'created_date' => date('Y-m-d H:i:s a', time())));
                $this->documents($modelBoqGeneral->file_id, 'BOQ');
                $jsonData['file'] = $modelBoqGeneral->file;
                $jsonData['boq'] = $modelBoqGeneral;
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($modelBoqGeneral, '', false), true);
                $error2 = json_decode(CActiveForm::validateTabular($modelBoqGeneralItem, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1, $error2));
                if ($error != '[]')
                    echo $error;
            }
            Yii::app()->end();
        }
        if ($modelBoqGeneral->file_id > 0)
            $result = 0;

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->renderPartial('//pact/boq/_forms_boq', array(
            'ho_id' => $ho_id, 'flag' => $flag,
            'current_form_id' => 11,
            'model' => $model,
            'model0' => $modelBoqGeneral,
            'model1' => $modelBoqGeneralItem,
            'boqItems' => $boqItems, 'value' => $category_value,
            'result' => $result, 'editStatus' => $editStatus, 'boq_file_id' => $boq_file_id, 'defaultSchedule' => $defaultSchedule,'colors'=>$colors
                ), false, true);
    }
public function loadModel($id = null) {
        if ($id) {
            $condition = "id=$id";
        } else {
            $condition = "id='' ";
        }
        $model = FormBoqGeneralItem::model()->find(array('condition' => $condition));

        return $model;
    }
     public function actionGetBoqitems() {
        $boq_id = Yii::app()->request->getParam('boq_id');
        $id = Yii::app()->request->getParam('id');
        $flag = Yii::app()->request->getParam('flag');
        if ($flag) {
            $category_id = FormBoqSchedule::model()->findByPk($id);
            $category_id = $category_id->id;
        } else {
            $category_id = FormBoqItemSchedule::model()->findByPk($id);
            $category_id = $category_id->category_id;
        }

        $modelBoqItems = FormBoqGeneralItem::model()->findAll(array('condition' => 'form_boq_id=' . $boq_id . ' AND category_id=' . $category_id, 'order' => 'item_no ASC',));
        // $boq_items[] = "";
        switch ($category_id) {
            case '1':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 1;
                    $jsonData['item'] .='<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>MODEL</th>
                <th>CAPACITY/DIMENSION</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>POWER SUPPLY</th>
                <th>REMARKS</th>
                <th>ACCESSORIES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr class="' . $i . '">
                           <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                            if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_model").val(data.boqitem.model);
                          $("#FormBoqGeneralItem_"+data.num+"_capacity_dimension").val(data.boqitem.capacity_dimension);
                          $("#FormBoqGeneralItem_"+data.num+"_material").val(data.boqitem.material);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_make").val(data.boqitem.make);
                          $("#FormBoqGeneralItem_"+data.num+"_power_supply").val(data.boqitem.power_supply);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks1").val(data.boqitem.remarks1);
                          $("#FormBoqGeneralItem_"+data.num+"_accessories").val(data.boqitem.accessories);
                          $("#FormBoqGeneralItem_"+data.num+"_motor_specs").val(data.boqitem.motor_specs);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) .
                                CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";',
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]model", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]capacity_dimension", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]material", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]make", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks1", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]accessories", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            
                <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               
                <td>'.          CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 1;
                    $jsonData['item'] = '<tr>
                <th >ITEM NO.</th>
                <th>TAG NO.</th>
                <th >EQUIPMENT DESCRIPTION</th>
                <th >MODEL</th>
                <th>CAPACITY/DIMENSION</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>POWER SUPPLY</th>
                <th>REMARKS</th>
                <th>ACCESSORIES</th>
               
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
                
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]model", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]capacity_dimension", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]material", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]make", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks1", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]accessories", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
            
                <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }


            case '2':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 2;
                    $jsonData['item'] .='<tr>
                
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>CONNECTIONS</th>
                <th>POWER SUPPLY</th>
                <th>OUTPUT - DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>LINE MATERIAL</th>
                <th>DISPLAY LOCAL/ PANEL</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr class="' . $i . '">
            
                 
                 <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_connections").val(data.boqitem.connections);
                          $("#FormBoqGeneralItem_"+data.num+"_power_supply").val(data.boqitem.power_supply);
                          $("#FormBoqGeneralItem_"+data.num+"_output_digital_analog").val(data.boqitem.output_digital_analog);
                          $("#FormBoqGeneralItem_"+data.num+"_wetted_parts").val(data.boqitem.wetted_parts);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_make").val(data.boqitem.make);
                          $("#FormBoqGeneralItem_"+data.num+"_range_min_max").val(data.boqitem.range_min_max);
                          $("#FormBoqGeneralItem_"+data.num+"_measuring_unit").val(data.boqitem.measuring_unit);
                          $("#FormBoqGeneralItem_"+data.num+"_line_material").val(data.boqitem.line_material);
                          $("#FormBoqGeneralItem_"+data.num+"_display_local_panel").val(data.boqitem.display_local_panel);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]connections", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]make", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]line_material", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                <td>'
                                . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                <td>'.          CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 2;
                    $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>CONNECTIONS</th>
                <th>POWER SUPPLY</th>
                <th>OUTPUT - DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>LINE MATERIAL</th>
                <th>DISPLAY LOCAL/ PANEL</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]connections", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]make", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]line_material", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                <td>'
                            . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }


            case '3':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 3;
                    $jsonData['item'] .='<tr>
                
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PIPE DIAMETER</th>
                <th>POWER SUPPLY</th>
                <th>DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>DISPLAY LOCAL/ PANEL</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .='<tr class="' . $i . '">
        
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_pipe_diameter").val(data.boqitem.pipe_diameter);
                          $("#FormBoqGeneralItem_"+data.num+"_power_supply").val(data.boqitem.power_supply);
                          $("#FormBoqGeneralItem_"+data.num+"_output_digital_analog").val(data.boqitem.output_digital_analog);
                          $("#FormBoqGeneralItem_"+data.num+"_wetted_parts").val(data.boqitem.wetted_parts);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_make").val(data.boqitem.make);
                          $("#FormBoqGeneralItem_"+data.num+"_range_min_max").val(data.boqitem.range_min_max);
                          $("#FormBoqGeneralItem_"+data.num+"_measuring_unit").val(data.boqitem.measuring_unit);
                          $("#FormBoqGeneralItem_"+data.num+"_display_local_panel").val(data.boqitem.display_local_panel);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]pipe_diameter", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]make", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 3;
                    $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PIPE DIAMETER</th>
                <th>POWER SUPPLY</th>
                <th>DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>DISPLAY LOCAL/ PANEL</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]pipe_diameter", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]make", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                               
                <td>'.      CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }

            case '4':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 4;
                    $jsonData['item'] .='<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>VOLUME</th>
                <th>CYLINDRICAL OR RECTANGULAR</th>
                <th>HORIZONTAL OR VERTICAL</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>MODEL</th>
                <th>SERVICE LIQUID</th>
                <th>GRADUATION SCALE</th>
                <th>ACCESSORIES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr class="' . $i . '">
            
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_volume").val(data.boqitem.volume);
                          $("#FormBoqGeneralItem_"+data.num+"_cylindrical_or_rectangular").val(data.boqitem.cylindrical_or_rectangular);
                          $("#FormBoqGeneralItem_"+data.num+"_horizontal_or_vertical").val(data.boqitem.horizontal_or_vertical);
                          $("#FormBoqGeneralItem_"+data.num+"_material").val(data.boqitem.material);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_make").val(data.boqitem.make);
                          $("#FormBoqGeneralItem_"+data.num+"_model").val(data.boqitem.model);
                          $("#FormBoqGeneralItem_"+data.num+"_service_liquid").val(data.boqitem.service_liquid);
                          $("#FormBoqGeneralItem_"+data.num+"_graduation_scale").val(data.boqitem.graduation_scale);
                          $("#FormBoqGeneralItem_"+data.num+"_accessories").val(data.boqitem.accessories);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]volume", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]cylindrical_or_rectangular", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]horizontal_or_vertical", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]material", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]make", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]model", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]graduation_scale", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]accessories", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                <td>'.          CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 4;
                    $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>VOLUME</th>
                <th>CYLINDRICAL OR RECTANGULAR</th>
                <th>HORIZONTAL OR VERTICAL</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>MODEL</th>
                <th>SERVICE LIQUID</th>
                <th>GRADUATION SCALE</th>
                <th>ACCESSORIES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i ) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]volume", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]cylindrical_or_rectangular", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]horizontal_or_vertical", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]material", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]make", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]model", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]graduation_scale", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]accessories", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }

            case '5':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 5;
                    $jsonData['item'] .='<tr>
                
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>FLOW & PRESSURE</th>
                <th>IMPELLER/DIAPHRAGM MOC</th>
                <th>CASING MOC</th>
                <th>END CONNECTION</th>
                <th>MAKE</th>
                <th>QUANTITY</th>
                <th>PUMP TYPE</th>
                <th>POWER SUPPLY</th>
                <th>MOTOR SPECS</th>
                <th>ACCESSORIES</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr class="' . $i . '">
            
               <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) {  if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                                            
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_flow_and_pressure").val(data.boqitem.flow_and_pressure);
                          $("#FormBoqGeneralItem_"+data.num+"_impeller_diaphragm_moc").val(data.boqitem.impeller_diaphragm_moc);
                          $("#FormBoqGeneralItem_"+data.num+"_casing_moc").val(data.boqitem.casing_moc);
                          $("#FormBoqGeneralItem_"+data.num+"_end_conection").val(data.boqitem.end_conection);
                          $("#FormBoqGeneralItem_"+data.num+"_make").val(data.boqitem.make);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_pump_type").val(data.boqitem.pump_type);
                          $("#FormBoqGeneralItem_"+data.num+"_power_supply").val(data.boqitem.power_supply);
                          $("#FormBoqGeneralItem_"+data.num+"_motor_specs").val(data.boqitem.motor_specs);
                          $("#FormBoqGeneralItem_"+data.num+"_accessories").val(data.boqitem.accessories);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]flow_and_pressure", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]impeller_diaphragm_moc", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]casing_moc", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]end_conection", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]make", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]pump_type", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]motor_specs", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]accessories", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
              
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 5;
                    $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>FLOW & PRESSURE</th>
                <th>IMPELLER/DIAPHRAGM MOC</th>
                <th>CASING MOC</th>
                <th>END CONNECTION</th>
                <th>MAKE</th>
                <th>QUANTITY</th>
                <th>PUMP TYPE</th>
                <th>POWER SUPPLY</th>
                <th>MOTOR SPECS</th>
                <th>ACCESSORIES</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]flow_and_pressure", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]impeller_diaphragm_moc", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]casing_moc", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]end_conection", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]make", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]pump_type", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]power_supply", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]motor_specs", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]accessories", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
              
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }

            case '6':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 6;
                    $jsonData['item'] .='<tr class="' . $i . '">
                 
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE</th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>ACTUATOR TYPE</th>
                <th>MOT ACTUATOR - NOR OPEN/ NOR CLOSE</th>
                <th>PNEU ACTUATOR - SING OR DOUB ACTING</th>
                <th>QUANTITY</th>
                <th>MOC - BODY /INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr>
            
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_valve_size").val(data.boqitem.valve_size);
                          $("#FormBoqGeneralItem_"+data.num+"_valve_end_connection").val(data.boqitem.valve_end_connection);
                          $("#FormBoqGeneralItem_"+data.num+"_service_liquid").val(data.boqitem.service_liquid);
                          $("#FormBoqGeneralItem_"+data.num+"_actuator_type").val(data.boqitem.actuator_type);
                          $("#FormBoqGeneralItem_"+data.num+"_mot_actuator_nor_open_nor_close").val(data.boqitem.mot_actuator_nor_open_nor_close);
                          $("#FormBoqGeneralItem_"+data.num+"_pneu_actuator_sing_or_doub_acting").val(data.boqitem.pneu_actuator_sing_or_doub_acting);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_moc_body_internal").val(data.boqitem.moc_body_internal);
                          $("#FormBoqGeneralItem_"+data.num+"_pressure_rating").val(data.boqitem.pressure_rating);
                          $("#FormBoqGeneralItem_"+data.num+"_limit_switches").val(data.boqitem.limit_switches);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]valve_size", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]actuator_type", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]mot_actuator_nor_open_nor_close", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]pneu_actuator_sing_or_doub_acting", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 6;
                    $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE</th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>ACTUATOR TYPE</th>
                <th>MOT ACTUATOR - NOR OPEN/ NOR CLOSE</th>
                <th>PNEU ACTUATOR - SING OR DOUB ACTING</th>
                <th>QUANTITY</th>
                <th>MOC - BODY /INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]valve_size", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]actuator_type", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]mot_actuator_nor_open_nor_close", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]pneu_actuator_sing_or_doub_acting", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }
            case '7':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 7;
                    $jsonData['item'] .='<tr class="' . $i . '">
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE </th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>MANUAL</th>
                <th>QUANTITY</th>
                <th>MOC BODY/INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr>
            
               <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_valve_size").val(data.boqitem.valve_size);
                          $("#FormBoqGeneralItem_"+data.num+"_valve_end_connection").val(data.boqitem.valve_end_connection);
                          $("#FormBoqGeneralItem_"+data.num+"_service_liquid").val(data.boqitem.service_liquid);
                          $("#FormBoqGeneralItem_"+data.num+"_manual").val(data.boqitem.manual);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_moc_body_internal").val(data.boqitem.moc_body_internal);
                          $("#FormBoqGeneralItem_"+data.num+"_pressure_rating").val(data.boqitem.pressure_rating);
                          $("#FormBoqGeneralItem_"+data.num+"_limit_switches").val(data.boqitem.limit_switches);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]valve_size", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]manual", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 7;
                    $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE </th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>MANUAL</th>
                <th>QUANTITY</th>
                <th>MOC BODY/INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]valve_size", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]manual", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }
            case '8':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 8;
                    $jsonData['item'] .='<tr class="' . $i . '">
                 
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PANEL</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>NOTES</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr>
            
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_panel").val(data.boqitem.panel);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_limit_switches").val(data.boqitem.limit_switches);
                          $("#FormBoqGeneralItem_"+data.num+"_notes").val(data.boqitem.notes);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]panel", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]notes", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 8;
                    $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PANEL</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>NOTES</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]panel", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]notes", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td> '.    CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
        </tr>';
                    break;
                }

            case '9':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 9;
                    $jsonData['item'] .='<tr class="' . $i . '">
               
               <th>ITEM NO.</th>
                <th>CONSUMABLES</th>
                <th>QUANTITY AS PER PO</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr>
            
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) { 
                                             if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_consumables").val(data.boqitem.consumables);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity_per_po").val(data.boqitem.quantity_per_po);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]consumables", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity_per_po", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                 <td>'.         CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
               
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 9;
                    $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>CONSUMABLES</th>
                <th>QUANTITY AS PER PO</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]consumables", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity_per_po", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                  <td> '.   CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
               
        </tr>';
                    break;
                }
            case '10':
                if (!empty($modelBoqItems)) {
                    $jsonData['id'] = 10;
                    $jsonData['item'] .='<tr class="' . $i . '">
                
                <th>ITEM NO.</th>
                <th>TAG. NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>SPARE DESCRIPTION</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addNewTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>';
                    foreach ($modelBoqItems as $i => $model) {
                        $jsonData['item'] .=' <tr>
            
                <td>'
                                . CHtml::activeTextField($model, "[$i]item_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'background-color:' . $model->picked_color,
                                    'onchange' => CHtml::ajax(array(
                                        'type' => 'POST',
                                        'dataType' => 'json',
                                        'url' => CController::createUrl('pact/getBoqItemDetails'),
                                        'data' => array('form_boq_id' => "js:$('#FormBoqGeneralItem_" . $i . "_form_boq_id').val()",
                                            'item_no' => "js:this.value",
                                            'category_id' => "js:$('#FormBoqSchedule_id').val()",
                                            'id' => "js:this.id"),
                                        'success' => 'function(data) {  if(data.status=="failed"){
                                            notification("Item number already exist!","failed"); 
                                            }
                                            
                        if(data.status=="success"){
                        
                                              /*  $.each(data, function(key, val) {    
                         $("#FormBoqGeneralItem_' . ($i + 1) . '_"+key+"").text(val); 
                       
                            });*/

                          $("#FormBoqGeneralItem_"+data.num+"_tag_no").val(data.boqitem.tag_no);
                          $("#FormBoqGeneralItem_"+data.num+"_equipment_description").val(data.boqitem.equipment_description);
                          $("#FormBoqGeneralItem_"+data.num+"_spare_description").val(data.boqitem.spare_description);
                          $("#FormBoqGeneralItem_"+data.num+"_quantity").val(data.boqitem.quantity);
                          $("#FormBoqGeneralItem_"+data.num+"_remarks").val(data.boqitem.remarks);
                         }
                         
                    }',
                                    )),)) . CHtml::activeHiddenField($model, "[$i]id", array()) . CHtml::activeHiddenField($model, "[$i]form_boq_id", array()) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
            <td>'
                                . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]spare_description", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]quantity", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
               <td>'
                                . CHtml::activeTextArea($model, "[$i]remarks", array(
                                    'class' => 'pickedcolor',
                                    'style' => 'height:20px;width:170px;max-width:95%;background-color:' . $model->picked_color,
                                    'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                                )) .
                                '</td>
                  <td>'.        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                                CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                                CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                                CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                                '</td>
               
        </tr>';
                    }
                    break;
                } else {
                    $model = new FormBoqGeneralItem;
                    $i = 1;
                    $jsonData['id'] = 10;
                    $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG. NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>SPARE DESCRIPTION</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                            '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]tag_no", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                            '</td>
            <td>'
                            . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]spare_description", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]quantity", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
               <td>'
                            . CHtml::activeTextArea($model, "[$i]remarks", array(
                                'class' => 'pickedcolor',
                                'style' => 'height:20px;width:170px;max-width:95%;',
                                'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                            )) .
                            '</td>
                 <td>'.     CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                            CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                            CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                            CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                            '</td>
               
        </tr>';
                    break;
                }
        }
        echo CJSON::encode($jsonData);
    }
     public function actionboqSchedule() {
        $model = new FormBoqGeneralItem;
        $colors = FormColorSelection::model()->findAll();
        $id = $_POST['id'];
        if (!Yii::app()->session['schedule_edited']) {
            $category_id = FormBoqSchedule::model()->findByPk($id);
            $category_id = $category_id->id;
        } else {
            $category_id = FormBoqItemSchedule::model()->findByPk($id);
            $category_id = $category_id->category_id;
        }
        $i = 1;
        switch ($category_id) {
            case '1':
                $jsonData['id'] = 1;
                $jsonData['item'] = '<tr>
                <th >ITEM NO.</th>
                <th>TAG NO.</th>
                <th >EQUIPMENT DESCRIPTION</th>
                <th >MODEL</th>
                <th>CAPACITY/DIMENSION</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>POWER SUPPLY</th>
                <th>REMARKS</th>
                <th>ACCESSORIES</th>
               
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
                
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]model", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]capacity_dimension", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]material", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]make", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]power_supply", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks1", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]accessories", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
            
                <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                <td>'. 
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '2':
                $jsonData['id'] = 2;
                $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>CONNECTIONS</th>
                <th>POWER SUPPLY</th>
                <th>OUTPUT - DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>LINE MATERIAL</th>
                <th>DISPLAY LOCAL/ PANEL</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]connections", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]power_supply", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]make", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]line_material", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                <td>'
                        . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                        <td> ' .
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '3':
                $jsonData['id'] = 3;
                $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PIPE DIAMETER</th>
                <th>POWER SUPPLY</th>
                <th>DIGITAL/ANALOG</th>
                <th>WETTED PARTS</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>RANGE-MIN/MAX</th>
                <th>MEASURING UNIT</th>
                <th>DISPLAY LOCAL/ PANEL</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]pipe_diameter", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]power_supply", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]output_digital_analog", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]wetted_parts", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]make", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]range_min_max", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]measuring_unit", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]display_local_panel", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                           <td>'. 
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '4':
                $jsonData['id'] = 4;
                $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>VOLUME</th>
                <th>CYLINDRICAL OR RECTANGULAR</th>
                <th>HORIZONTAL OR VERTICAL</th>
                <th>MATERIAL</th>
                <th>QUANTITY</th>
                <th>MAKE</th>
                <th>MODEL</th>
                <th>SERVICE LIQUID</th>
                <th>GRADUATION SCALE</th>
                <th>ACCESSORIES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i ) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]volume", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]cylindrical_or_rectangular", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]horizontal_or_vertical", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]material", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]make", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]model", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]graduation_scale", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]accessories", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td> '.
                
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '5':
                $jsonData['id'] = 5;
                $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>FLOW & PRESSURE</th>
                <th>IMPELLER/DIAPHRAGM MOC</th>
                <th>CASING MOC</th>
                <th>END CONNECTION</th>
                <th>MAKE</th>
                <th>QUANTITY</th>
                <th>PUMP TYPE</th>
                <th>POWER SUPPLY</th>
                <th>MOTOR SPECS</th>
                <th>ACCESSORIES</th>

                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]flow_and_pressure", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]impeller_diaphragm_moc", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]casing_moc", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]end_conection", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]make", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]pump_type", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]power_supply", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]motor_specs", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]accessories", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
              
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
              <td> '.
                
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '6':
                $jsonData['id'] = 6;
                $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE</th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>ACTUATOR TYPE</th>
                <th>MOT ACTUATOR - NOR OPEN/ NOR CLOSE</th>
                <th>PNEU ACTUATOR - SING OR DOUB ACTING</th>
                <th>QUANTITY</th>
                <th>MOC - BODY /INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]valve_size", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]actuator_type", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]mot_actuator_nor_open_nor_close", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]pneu_actuator_sing_or_doub_acting", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'. 
                
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '7':
                $jsonData['id'] = 7;
                $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>VALVE SIZE </th>
                <th>VALVE END CONNECTION</th>
                <th>SERVICE LIQUID</th>
                <th>MANUAL</th>
                <th>QUANTITY</th>
                <th>MOC BODY/INTERNAL</th>
                <th>PRESSURE RATING</th>
                <th>LIMIT SWITCHES</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]valve_size", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]valve_end_connection", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]service_liquid", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]manual", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]moc_body_internal", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]pressure_rating", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                        <td> '.
                
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;
            case '8':
                $jsonData['id'] = 8;
                $jsonData['item'] = '<tr>
                 <th>ITEM NO.</th>
                <th>TAG NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>PANEL</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>NOTES</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]panel", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]limit_switches", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]notes", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                      <td> '.
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
        </tr>';
                break;

            case '9':
                $jsonData['id'] = 9;
                $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>CONSUMABLES</th>
                <th>QUANTITY AS PER PO</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]consumables", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity_per_po", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "230px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
                  <td> '.
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
               
        </tr>';
                break;

            case '10':
                $jsonData['id'] = 10;
                $jsonData['item'] = '<tr>
                <th>ITEM NO.</th>
                <th>TAG. NO.</th>
                <th>EQUIPMENT DESCRIPTION</th>
                <th>SPARE DESCRIPTION</th>
                <th>QUANTITY</th>
                <th>REMARKS</th>
                <th>ACTIONS ' . CHtml::link('<i class="icon-plus-sign"></i>', 'javascript:void(0);', array('onclick' => 'addTableRowColor($(\'#item_schedule_table\'))', 'class' => 'btn')) . ' ' .
                        '</th></tr>
            <tr class="' . $i . '">
            <td><label>' . ($i) . '</label></td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]tag_no", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) . CHtml::activeHiddenField($model, "[$i]picked_color", array()) .
                        '</td>
            <td>'
                        . CHtml::activeTextArea($model, "[$i]equipment_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]spare_description", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]quantity", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
               <td>'
                        . CHtml::activeTextArea($model, "[$i]remarks", array(
                            'class' => 'pickedcolor',
                            'style' => 'height:20px;width:170px;max-width:95%;',
                            'onfocus' => 'this.style.height = "100px";this.style.width = "170px";', 'onblur' => 'this.style.height = "20px";this.style.width = "170px";'
                        )) .
                        '</td>
         <td> '.
                
                        CHtml::link('<i class="icon-dashboard"></i>', 'javascript:void(0);', array('title'=>'Choose Color','onclick' => 'selectcolor($(this).parents(\'tr\').attr(\'class\'));', 'class' => 'btn')) . ' ' .
                        CHtml::link('<i class="icon-arrow-up"></i>', 'javascript:void(0);', array('class' => 'up', 'title' => 'Move to Up')) .
                        CHtml::link('<i class="icon-arrow-down"></i>', 'javascript:void(0);', array('class' => 'down', 'title' => 'Move to Down')) .
                        CHtml::link('<i class="icon-remove"></i>', 'javascript:void(0);', array('onclick' => 'removeTableRow($("#item_schedule_table"), this)')) .
                        '</td>
               
        </tr>';
                break;
        }
        echo CJSON::encode($jsonData);
    }
    public function actionGetBoqItemDetails() {
        $item_no = Yii::app()->request->getParam('item_no');
        $form_boq_id = Yii::app()->request->getParam('form_boq_id');
        $category_id = Yii::app()->request->getParam('category_id');
        $id = Yii::app()->request->getParam('id');
        preg_match('/\d+/', $id, $numMatch);
        $num = $numMatch[0];
        $modelBoqGeneralItem = FormBoqGeneralItem::model()->find(array('condition' => 'item_no="' . $item_no . '" AND form_boq_id=' . $form_boq_id . ' AND category_id=' . $category_id));
        if (!$modelBoqGeneralItem->item_no) {
            for ($i = 0; $i <= 1; $i+=0.1) {
                $previous_item_no = $item_no - $i;
                $model = FormBoqGeneralItem::model()->find(array('condition' => 'item_no=' . $previous_item_no . '  AND form_boq_id=' . $form_boq_id . ' AND category_id=' . $category_id));
                if (!empty($model)) {
                    break;
                }
            }
            $jsonData['status'] = 'success';
            $jsonData['boqitem'] = $model;
            $jsonData['num'] = $num;
        } else {
            $jsonData['status'] = 'failed';
        }

        echo CJSON::encode($jsonData);
    }
public function actionPrintBoq() {
        $id = Yii::app()->request->getParam('id');
        $user_id = array();
        $model = FormRfqGeneral::model()->findByPK($id);
        $department = PactDepartment::model()->findAll(array('condition' => ' id in(2,6,7)'));
        foreach ($department as $eachdepartment) {
            $user_ids = unserialize($eachdepartment->user_ids);
            $user_id = array_merge($user_id, array_unique($user_ids));
        }
        ini_set("memory_limit", "128G");
        ini_set('max_execution_time', 1000);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_for_single.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.boq', array('model' => $model, 'user_id' => $user_id), true));
        $mPDF1->Output('RFQ', 'I');
    }
    
    public function actionsaveSchedule() {
        //print_r($_POST['FormBoqSchedule']);die();
        $_POST['FormBoqSchedule']['schedule_name'] = $_POST['FormBoqSchedule'][0]['schedule_name'];
        $model = $this->commonSave('FormBoqSchedule');
    }

    public function actionsaveScheduleCategory() {

        $field = $_POST['name'];
        ($_POST['file_id']) ? $file_id = $_POST['file_id'] : $file_id = Yii::app()->session['boq_File_id'];
        Yii::app()->session['schedule_edited'] = 1;
        $model = new FormBoqSchedule;
        /* $model->updateByPk($_POST['pk'], array($field => $_POST['value'])); */
        $modelItemSchedule = new FormBoqItemSchedule;
        $modelItemSchedule->schedule_name = $_POST['value'];
        $modelItemSchedule->file_no = $file_id;
        $modelItemSchedule->category_id = $_POST['pk'];
        $modelItemSchedule->save();
        $modelItemSchedule->refresh();
        $jsonData['value'] = '
         <li style="width: 100%">'
                . CHtml::activeLabelEx($modelItemSchedule, "schedule_name") .
                CHtml::activedropDownList($modelItemSchedule, "schedule_name", FormBoqItemSchedule::getSchedule($file_id), array('class' => 'tooltipster',
                    'options' => array($value => array('selected' => true)),
                    'title' => 'Choose contat person',
                    'prompt' => "Select Category",
                    'onchange' => 'js:$(".boqsave").trigger( "click" )',
                    'ajax' => array(
                        'type' => 'POST',
                        'url' => ($editStatus) ? $this->createUrl('pact/getBoqitems') : $this->createUrl('pact/boqSchedule'),
                        'success' => 'function(data) { 
                            $("#FormBoqSchedule_id").val(data.id);
                            $("#item_schedule_table tr:gt(0)").remove();
                            $("#item_schedule_table").html(data.item);
                            adjustPopup();
                                }',
                        'data' => array('id' => 'js:this.value', 'boq_id' => 'js:$("#FormBoqGeneral_id").val()', 'flag' => '1'),
                        'dataType' => 'json',
                    ), 'class' => 'tooltipster boqcategory', 'title' => 'Choose file', 'id' => uniqid())
                ) .
                '</li>';

        /* $model = FormBoqItemSchedule::model()->findAll(array('condition'=>'file_no='.$file_id));
          foreach($model as $item):
          $jsonData['value'] .= '<option value="'.$item->id.'">'.$item->schedule_name.'</option>';
          endforeach;
          $jsonData['status'] = "success"; */
        echo $jsonData['value'];
    }

    public function actionsaveScheduleName() {
        if (isset($_POST['value'])) {
            FormBoqItemSchedule::model()->updateByPk($_POST['pk'], array('schedule_name' => $_POST['value']));
        }
    }

    public function actioneditSchedule() {
        $id = (int) $_GET['id'];
        $i = 0;
        $model = new FormBoqSchedule;
        $modelBoqSchedule = FormBoqSchedule::model()->findByPK($id);
        $data['schedule'] = CHtml::activeHiddenField($model, "id", array('value' => $modelBoqSchedule->id)) . '
         <li style="width: 100%">'
                . CHtml::activeLabelEx($model, "[$i]schedule_name") .
                CHtml::activeTextField($model, "[$i]schedule_name", array('value' => $modelBoqSchedule->schedule_name)) .
                '</li>';

        echo CJSON::encode($data);
        Yii::app()->end();
    }

}